package com.csc.library.databean;

import java.util.Iterator;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Mbus_late1 extends RecordCmp{
	
	private DbRecord rec = null;
	private DbInquiry inqEmp = null;
	private DbInquiry inqTime = null; 
	private DbInquiry inqTemp = null; 

    public Mbus_late1() {
    	super("Mbus_late1", "Mbus_late1 Table");
    }

    protected void postInsertTrigger() throws Exception {
    	super.postInsertTrigger();
    	//this.saveTimeData();
    }
    
    protected void postUpdateTrigger() throws Exception {
    	super.postInsertTrigger();
    	//this.deleteTimeData();
    	//this.saveTimeData();
    }
    
    protected void postDeleteTrigger() throws Exception {
    	super.postDeleteTrigger();
    	//this.deleteTimeData();
    }
    
    private CscCalendar getWorkingDateTime() {
    	try {    
    		CscCalendar csc = new CscCalendar(this.getString("datelate"));
    		
    		if (this.inqEmp == null) {
		    	this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
		    	this.inqEmp.setParam(this.param);
		    	this.inqEmp.setSchemaName(this.userPro.getSchemaName());
		    	this.inqEmp.initMyTable("Memployee", "", "");
		    	this.inqEmp.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level, workarea," +
				"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid, status, startdate, resigndate");			    		
    		}
    		this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
    		this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				DbRecord empRec = this.inqEmp.getCurrentDbRecord();
				
				Mtime0 timeRec = null;
				if (this.inqTime == null) {
			    	this.inqTime = new InitialInquiry(this.userPro).getDbInquiry();
			    	this.inqTime.setParam(this.param);
			    	this.inqTime.setSchemaName(this.userPro.getSchemaName());
			    	this.inqTime.initMyTable("Mtime0", "", "");
			    	this.inqTime.setColumn("*");
	    		}
				this.inqTime.setFilter("time0id='" + empRec.getString("time0") + "'");				
				this.inqTime.refresh();
				while (this.inqTime.next()) {
					timeRec = (Mtime0) this.inqTime.getCurrentDbRecord();
				}
				
				timeRec.setEmpRec(empRec);				
				
				CscCalendar cs1 = new CscCalendar(this.getString("datelate"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("datelate"));
				cs2.incDate();
				WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(cs1	.getTimestamp()), new CscCalendar(cs2.getTimestamp()), "true");
				ws.setUProfile(this.userPro);
				ws.setEmployeeid(empRec.getString("employeeid"));				
				//ws.adjust();
				MyLog.debug("Working Shift of :> "+empRec.getString("employeeid"));
				MyLog.debug(ws.toString());
				
				Iterator it = ws.keySet().iterator();
				while (it.hasNext()) {
					String code = (String) it.next();
					DayShift ds = (DayShift) ws.get(code);
					Iterator it2 = ds.keySet().iterator();
					while (it2.hasNext()) {
						String code2 = (String) it2.next();
						Shift sh = (Shift) ds.get(code2);
						if (csc.equalsDate(sh.get_c_dt_in())) {
							return sh.get_c_dt_in();
						}
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
		return null;
    }
    
    private void saveTimeData() {
    	try {
    		CscCalendar csc = this.getWorkingDateTime();
    		if (csc!=null) {    		
		    	if (this.rec == null) {
		    		this.rec = new InitialRecord(this.userPro).getDbRecord("TTIMETEMP");
		    	}
		    	this.rec.clearField();
				this.rec.set("EMPLOYEEID", this.getString("employeeid"));
				this.rec.set("COMPANYID", (String) this.userPro.get("companyid"));
				this.rec.set("SWIPEDATE", csc.getYYYYMMDD());	
				this.rec.set("SWIPETIME", csc.getCSCTime());
				this.rec.set("SOURCE", "6");
				this.rec.save();
    		}
    	} catch (Exception e) {
    		MyLog.error(this, e);
    	}
    }
    
    private void deleteTimeData() {
    	try {
    		if (this.inqTemp == null) {
		    	this.inqTemp = new InitialInquiry(this.userPro).getDbInquiry();
		    	this.inqTemp.setParam(this.param);
		    	this.inqTemp.setSchemaName(this.userPro.getSchemaName());
		    	this.inqTemp.initMyTable("Ttimetemp", "", "");
		    	this.inqTemp.setColumn("*");
    		}
    		CscCalendar csc = new CscCalendar(this.pRemote.getString("datelate"));
			this.inqTemp.setFilter("employeeid='" + this.pRemote.getString("employeeid") + "' " +
					"and swipedate='"+csc.getYYYYMMDD()+"' and source='6'");
			this.inqTemp.refresh();
			while (this.inqTemp.next()) {
				DbRecord recTemp = this.inqTemp.getCurrentDbRecord().cloneRecord(true);
				recTemp.delete();
			}
    	} catch (Exception e) {
    		MyLog.error(this, e);
    	}
    }
}
