package com.csc.library.databean;

import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

public class Mempl_leave_summary extends Memployee {
	
	boolean flag=false;
	MyHashMap hmHeader = null;
	MyHashMap hmDayType = null; //纻ѹ
	MyHashMap hmDataMonth = new MyHashMap();
	MyHashMap hmDataYear = new MyHashMap();
	MyHashMap hmDataMonth_DHM = new MyHashMap();
	MyHashMap hmDataYear_DHM = new MyHashMap();
	
	private String eventType = ""; //ѹ
	private String eventName = ""; //ͻѹ
	private double hour = 8; //ӹǹ  ӧҹѹ
	private MyHashMap hmHoliday = new MyHashMap();
	private int workDay = 0; //ӹǹѹӧҹ
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			if (this.flag==false) {				
				this.hmHeader = new MyHashMap();
				this.hmDayType = new MyHashMap();
				this.initLeaveColumn();
				
				String result = "";
				try {
					result = (String) StaticConfig.getConfigCompany(this.userPro, "ta1007");
				} catch (Exception e) {
					e.printStackTrace();
				}
				this.hmHoliday = this.getHoliday(result);
				
				CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
				CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
				while (cscEnd.after(cscStart)) {
					if (!this.hmHoliday.containsKey(cscStart.getYYYYMMDD()) && (cscStart.getDOW()!=1 && cscStart.getDOW()!=7)) {
						workDay++;
					}
					cscStart.incDate();
				}
				
				this.flag=true;
				
				System.out.println("HEADER DATA==="+this.hmHeader);
				System.out.println("DAYTYPE DATA==="+this.hmDayType);
			}	
			
			//this.initLeaveColumn();
			this.initDataColunm("md", this.hmDataMonth, 'F'); //ӹǹ 㹧Ǵ
			this.initDataColunm("mc", this.hmDataMonth, 'F'); //ӹǹ 㹧Ǵ
			
			this.initDataColunm("yd", this.hmDataYear, 'F'); //ӹǹ ҷ駻	
			this.initDataColunm("yc", this.hmDataYear, 'F'); //ӹǹ ҷ駻	
			
			this.initDataColunm("ml", this.hmDataMonth, 'F'); //ӹǹѹѹ 㹧Ǵ
			this.initDataColunm("yl", this.hmDataYear, 'F'); //ӹǹѹѹ ҷ駻
			
			this.initDataColunm("mlv", this.hmDataMonth_DHM, 'S'); //ӹǹѹ::ҷ 㹧Ǵ
			this.initDataColunm("ylv", this.hmDataYear_DHM, 'S'); //ӹǹѹ::ҷ ҷ駻
			
			this.hmHeader.put("day_work", workDay);
			this.hmDataMonth.put("day_count", 0);
			
			try {
				this.setData("ttime_current1");
				this.setData("ttime_history1");
				this.hour = this.getHour_Day();
				this.hmHeader.put("hour", this.hour);
				
				this.setData_DHM(this.hmDataMonth, this.hmDataMonth_DHM, 'M');
				this.setData_DHM(this.hmDataYear, this.hmDataYear_DHM, 'Y');
			} catch (Exception e) {
				MyLog.error(this, e);
			}
						
			MyLog.debug(this, "MONTH DATA==="+this.hmDataMonth);
			MyLog.debug(this, "MONTH DATA==="+this.hmDataMonth_DHM);
			MyLog.debug(this, "YEAR DATA==="+this.hmDataYear);
			MyLog.debug(this, "YEAR DATA==="+this.hmDataYear_DHM);
		}
		return temp;
    }
	
	private void setData_DHM(MyHashMap hm, MyHashMap hm_dhm, char ch) {
		FormulaString fs = new FormulaString();
		DecimalFormat df = new DecimalFormat("00");
		String mkey="", mtmp="";
		double tm=0, d_lv=0;
		Iterator itm = hm_dhm.keySet().iterator();
		while (itm.hasNext()) {
			mkey = (String) itm.next();
			mtmp = mkey.substring(3, mkey.length());
			if (ch=='M') { 
				tm = Double.parseDouble(String.valueOf(hm.getFloat("md"+mtmp)));
			} else if (ch=='Y') {
				tm = Double.parseDouble(String.valueOf(hm.getFloat("yd"+mtmp)));
			}
			
			String dhm = fs.MTODhm(fs.Tm_To_Min(tm), this.hour);
			MyLog.debug(this, "mkey="+mkey+" : tm="+tm+" : dhm="+dhm);	
			if (ch=='M') { 
				d_lv = Double.parseDouble(dhm.substring(0,2))+hm.getFloat("ml"+mtmp);
			} else if (ch=='Y') {
				d_lv = Double.parseDouble(dhm.substring(0,2))+hm.getFloat("yl"+mtmp);
			}			
			hm_dhm.put(mkey, df.format(d_lv)+dhm.substring(2, dhm.length()));
			//hm_dhm.put(mkey, dhm);
		}
	}
	
	/**
	 * ˹ͧҧ §ҹ 㹡͡§ҹ
	 * Ѻ parameter Ҩҡ˹Ҩ ǡ͡§ҹẺ˹
	 * */
	private void initDataColunm(String name, MyHashMap hm, char type) {
		for (int i=1;i<=10;i++) {
			String id = "col"+String.valueOf(i);
			if (i<=9) {
				id = "col0"+i;	
			}
			if (type=='S') {
				hm.put(name+"_"+id, "00:00:00");
			} else if (type=='F') { 
				hm.put(name+"_"+id, new Float(0));
			}
		 }
	}
	
	private void setDayEventType(String code) {
		this.eventType = "";
		this.eventName = "";
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Meventgrp", "eventgrpid='"+code+"'", "");
			inq.setColumn("*");
			inq.refresh();
			if (inq.next()) {
				this.eventType = inq.getString("daytype");
				this.eventName = inq.getString("tdesc");
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void  initLeaveColumn() {
		if (this.param.containsKey("LEAVECOLUMN")) {
			String columnCode = (String) this.param.get("LEAVECOLUMN");
			try {
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
				inq.setSchemaName(this.userPro.getSchemaName());						
				inq.initMyTable("Mleave_report", "codeid='"+columnCode+"'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord rec = inq.getCurrentDbRecord();
					for (int i=1;i<=10;i++) {
						String id = "col"+String.valueOf(i);
						if (i<=9) {
							id = "col0"+i;	
						}
						
						if (!rec.getString(id).equals("")) {
							this.setDayEventType(rec.getString(id));
						}
						
						this.hmHeader.put(id, this.eventName);	//ʴЪͧ
						
						if (!rec.getString(id).equals("")) {
							this.hmHeader.put(rec.getString(id), id);						
							if (rec.getString(id).equalsIgnoreCase("LT")) {
								this.hmDayType.put("LT", id);
								this.hmDayType.put(id, "LT");
							} if (rec.getString(id).equalsIgnoreCase("OT")) {
								this.hmDayType.put("OT", id);
								this.hmDayType.put(id, "OT");
							} if (rec.getString(id).equalsIgnoreCase("LE")) {
								this.hmDayType.put("LE", id);
								this.hmDayType.put(id, "LE");
							} else {								
								if (!this.eventType.equals("")) {
									this.hmDayType.put(this.eventType, id);
									this.hmDayType.put(id, this.eventType);
								}
							}
						}
					}
				}
			} catch (Exception e) { 
				MyLog.error(this, e);
			}
		 }
	}
	
	private void setData(String tableName) {
		try {
			/*
			 * DayType = 7		Vacation
			 * DayType = LT		Late
			 * DayType other 	Leave  
			 */
			
			/*CscCalendar cscStart = new CscCalendar("01-08-2005");
			CscCalendar cscEnd = new CscCalendar("30-08-2005");
			
			CscCalendar cscLeaveStart = new CscCalendar("01-11-2004");
			CscCalendar cscLeaveEnd = new CscCalendar("31-10-2005");
			CscCalendar cscVacationStart = new CscCalendar("01-01-2005");
			CscCalendar cscVacationEnd = new CscCalendar("31-12-2005");*/
			
						
			CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
			
			CscCalendar cscLeaveStart = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1001"));
			CscCalendar cscLeaveEnd = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1002"));
			CscCalendar cscVacationStart = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1003"));
			CscCalendar cscVacationEnd = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1004"));
								
			/*String filter = "employeeid='"+this.getString("employeeid")+"'" +
					" and ((monthid>="+Integer.parseInt(cscLeaveStart.getMM())+" " +
							"and yearid>="+cscLeaveStart.getYear()+") " +
					" or (monthid<="+Integer.parseInt(cscVacationEnd.getMM())+" " +
							"and yearid<="+cscVacationEnd.getYear()+"))";*/
			String lv_type = "";
			String filter = "";
			if (tableName.equalsIgnoreCase("ttime_current1")) {
				filter = "employeeid='"+this.getString("employeeid")+"'" + 
					" and (dateid between '" + cscStart.getYYYYMMDD() + "' " +
					" and '" + cscEnd.getYYYYMMDD() + "')" +
					"";
			} else if (tableName.equalsIgnoreCase("ttime_history1")) {
				filter = "employeeid='"+this.getString("employeeid")+"'" + 
				" and (dateid between '" + cscLeaveStart.getYYYYMMDD() + "' " +
				" and '" + cscVacationEnd.getYYYYMMDD() + "')" +
				"";
			}
			
			//filter = "employeeid='"+this.getString("employeeid")+"'" + 
			//	" and (dateid between '" + cscStart.getYYYYMMDD() + "' " +
			//	" and '" + cscEnd.getYYYYMMDD() + "')" +
			//	"";
				
			/*String filter = "employeeid='"+this.getString("employeeid")+"'" + 
			" and (dateid between '2006-10-01' " +
			" and '2006-10-31')" +
			" and lv_ty='L04'";*/
			int recCount=0;
			String tmp_date = "";
			System.out.println("==== filter : "+filter);
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable(tableName, filter, "");
			inq.setColumn("employeeid, companyid, dateid, lv_ty, m_lv, lt, hour_s, eventgrp");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				if (rec.getFloat("lt") > 0 ) {
					lv_type = "LT";
				} else lv_type = rec.getString("lv_ty").toUpperCase();
				//CscCalendar date = new CscCalendar("01"+"-"+rec.getString("monthid")+"-"+rec.getString("yearid"));
				CscCalendar date = new CscCalendar(rec.getString("dateid"));
				if (this.hmHeader.containsKey(lv_type)) {					
					String id = this.hmHeader.getString(lv_type);
					String daytype = this.hmDayType.getString(id);		
					if (daytype.equals("7")) {					
						if (date.afterEqualsDate(cscVacationStart) && date.beforeEqualsDate(cscVacationEnd)) {
							
							if (rec.getFloat("m_lv")/rec.getFloat("hour_s") >= 1) {
								float l_count = this.hmDataYear.getFloat("yl_"+id);
								this.hmDataYear.put("yl_"+id, ++l_count);								
							} else {							
								float value = this.hmDataYear.getFloat("yd_"+id);
								CscTime ct = new CscTime(value);							
								if (lv_type.equals("LT")) {
									ct.add(rec.getFloat("lt"));
								} else ct.add(rec.getFloat("m_lv"));
								this.hmDataYear.put("yd_"+id, ct.getFloat());
							}
							
							float count = this.hmDataYear.getFloat("yc_"+id);
							this.hmDataYear.put("yc_"+id, ++count);
						}
					} else {
						if (date.afterEqualsDate(cscLeaveStart) && date.beforeEqualsDate(cscLeaveEnd)) {
							if (rec.getFloat("m_lv")/rec.getFloat("hour_s") >= 1) {
								float l_count = this.hmDataYear.getFloat("yl_"+id);
								this.hmDataYear.put("yl_"+id, ++l_count);								
							} else {
								float value = this.hmDataYear.getFloat("yd_"+id);
								CscTime ct = new CscTime(value);
								if (lv_type.equals("LT")) {
									ct.add(rec.getFloat("lt"));
								} else ct.add(rec.getFloat("m_lv"));
								this.hmDataYear.put("yd_"+id, ct.getFloat());
							}
							
							float count = this.hmDataYear.getFloat("yc_"+id);
							this.hmDataYear.put("yc_"+id, ++count);
						}
					}
					
					if (date.afterEqualsDate(cscStart) && date.beforeEqualsDate(cscEnd)) {
						if (rec.getFloat("m_lv")/rec.getFloat("hour_s") >= 1) {
							float l_count = this.hmDataMonth.getFloat("ml_"+id);
							this.hmDataMonth.put("ml_"+id, ++l_count);								
						} else {
							float value = this.hmDataMonth.getFloat("md_"+id);
							CscTime ct = new CscTime(value);
							if (lv_type.equals("LT")) {
								ct.add(rec.getFloat("lt"));
							} else ct.add(rec.getFloat("m_lv"));
							this.hmDataMonth.put("md_"+id, ct.getFloat());
						}
						
						float count = this.hmDataMonth.getFloat("mc_"+id);
						this.hmDataMonth.put("mc_"+id, ++count);
					}
				}
				
				if (tableName.equalsIgnoreCase("ttime_current1")) {
					if (recCount==0) {
						tmp_date = rec.getString("dateid");
						recCount++;
						//System.out.println("plus : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
					} else {					
						if (!tmp_date.equals(rec.getString("dateid")) &&
								(!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O"))) {
							recCount++;
							//System.out.println("plus : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
						}
					}					
					tmp_date = rec.getString("dateid");
				}				
			}	
			
			
			if (tableName.equalsIgnoreCase("ttime_current1")) {
				this.hmDataMonth.put("day_count", recCount);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private double getHour_Day() {
		double h = 8;
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");			
            this.putChild(inq1);
            this.refreshChild("mtime0");
			h = inq1.getCurrentDbRecord().getDouble("hour_d");
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return h;
	}
	
	private MyHashMap getHoliday(String code) {
		MyHashMap hm = new MyHashMap();
		try {
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.initMyTable("mholiday1", "holidayid='"+code+"'", "");
			inq.setColumn("*");		
			inq.refresh();
			while (inq.next()) {
				CscCalendar csc = new CscCalendar(inq.getString("hdate"));
				hm.put(csc.getYYYYMMDD(), csc.getYYYYMMDD());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return hm;
	}
	
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") >= 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmDataYear.get(fName) != null) {
				return this.hmDataYear.getString(fName);
			} else if (this.hmDataMonth.get(fName) != null) {
				return this.hmDataMonth.getString(fName);
			} else if (this.hmHeader.get(fName) != null) {
				return this.hmHeader.getString(fName);
			} else if (this.hmDataMonth_DHM.get(fName) != null) {
				return this.hmDataMonth_DHM.getString(fName);
			} else if (this.hmDataYear_DHM.get(fName) != null) {
				return this.hmDataYear_DHM.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}
