package com.csc.library.databean;

import java.util.Vector;

import com.csc.library.database.FieldManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Memployee_absent extends Memployee {
	
	private DbInquiry inqTime = null;
	private int absent = 0;
	private String sDate = "";
	private String eDate = ""; 
	private int max_absent = 7; //ӹǹ駷ҴҹԴ͡ѹҡش
	private Vector vAbsent = null;

	public boolean foundData() {
		this.absent = 0;
		this.sDate = "";
		this.eDate = "";
		this.vAbsent = new Vector();
		try {
			if (this.param.containsKey("DAYABSENT")) { //Ҩҡ˹Ҩաèӹǹ駷Ҵҹҡش¹ҡ 7 繨ӹǹ
				String d = (String) this.param.get("DAYABSENT");
				if (d!=null && !d.equals("")) {
					this.max_absent = Integer.parseInt(d);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		boolean flag = super.foundData();	
		this.absent = this.countAbsent();
		//System.out.println("Absent --------------------> "+this.absent);
		if (this.absent < this.max_absent) {
			return false;
		}
		return flag;
	}
			
	/*
	 * ӡùѺӹǹҴҹԴ͡ѹ
	 * Ũҡ ttime_current
	 */
	private int countAbsent() {
		int result = 0;		
		CscCalendar c1 = null;
		CscCalendar c2 = null;
		if (this.param.containsKey("__start_date") && this.param.containsKey("__end_date")) { //ѹҨҡ˹Ҩ
			c1 = new CscCalendar((String) this.param.get("__start_date"));
			c2 = new CscCalendar((String) this.param.get("__end_date"));
		} else {
			c1 = new CscCalendar((String) this.param.get("STARTDATE"));
			c2 = new CscCalendar((String) this.param.get("ENDDATE"));
		}
		//CscCalendar c1 = new CscCalendar("2007-07-01");
		//CscCalendar c2 = new CscCalendar("2007-07-30");
		String filter = "employeeid='"+this.getString("employeeid")+"' " +
				"and (dateid between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"') ";
				//"and (absent>0 or (eventgrp='H' or eventgrp='I'))";
		try {
			int count = 1;
			CscCalendar cs = new CscCalendar();
			if (this.inqTime == null) {
				this.inqTime = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime.setParam(this.param);
				this.inqTime.setSchemaName(this.userPro.getSchemaName());	
				this.inqTime.initMyTable("Ttime_current", "", "employeeid, dateid");
				this.inqTime.setColumn("*");
			}	
			this.inqTime.setFilter(filter);
			this.inqTime.refresh();
			while (this.inqTime.next()) {
				DbRecord rec = this.inqTime.getCurrentDbRecord();
				if (count==1) {
					cs = new CscCalendar(rec.getString("dateid"));
					this.sDate = cs.getDDMMYYYY();
					this.eDate = cs.getDDMMYYYY();
				}
				
				CscCalendar csDate = new CscCalendar(rec.getString("dateid"));
				if (rec.getDouble("hour_d")==0 && rec.getDouble("lt")==0 && rec.getDouble("absent")==0) {					
					cs = new CscCalendar(rec.getString("dateid"));					
				} else {
					if (csDate.subForDay(cs) <= 1) { 
						if (rec.getDouble("absent") == rec.getDouble("hour_s")) {
							result++;		
							this.vAbsent.add(rec.getString("dateid"));
							if (result==1) {
								this.sDate = csDate.getDDMMYYYY();
							}
							this.eDate = csDate.getDDMMYYYY();
						} else {
							if (result>=this.max_absent) 
								break;
							result = 0;
							this.vAbsent.clear();
							this.sDate = csDate.getDDMMYYYY();
							this.eDate = csDate.getDDMMYYYY();
						}
						cs = new CscCalendar(rec.getString("dateid"));
					} else {
						if (result>=this.max_absent) 
							break;
						result = 0;
						this.vAbsent.clear();
						this.sDate = csDate.getDDMMYYYY();
						this.eDate = csDate.getDDMMYYYY();
					}
				}				
				count++;
			}
			MyLog.debug("max --->"+this.max_absent+" absent --->"+this.vAbsent.size()+" : vAbsent="+this.vAbsent);
			MyLog.debug("sDate="+this.sDate+" : eDate="+this.eDate);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		
		return result;
	}
	
	public FieldManager getField(String fieldName) {
		String Lang =(this.param.containsKey("__language"))?(String)this.param.get("__language"):this.getUProfile().get("lang");
		FieldManager fm = super.getField(fieldName);
		if (fieldName.equalsIgnoreCase("absentcount")) { //ӹǹѹҴҹԴ͡ѹ
			fm = this.initField("String", "absentcount", 10, 0, "Absent Count");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			try {
				fm.set(this.absent);
				if (Lang.equalsIgnoreCase("eng")) {						
					fm.setDescription("Absent Count");
				} else {
					fm.setDescription("ӹǹѹҴҹ");
				}
			} catch (Exception ex) {
				MyLog.error(this, ex);				
			}
		} 
		return fm;
	}
	
	public String getString(String fieldName) {		
		if (fieldName.equalsIgnoreCase("sDate")) {
			return this.sDate;
		} else if (fieldName.equalsIgnoreCase("eDate")) {
			return this.eDate;			
		} else if (fieldName.indexOf("absent_")>-1) {
			int id = Integer.parseInt(fieldName.substring(7, fieldName.length()));
			if (id <= this.vAbsent.size()) {
				CscCalendar c = new CscCalendar((String) this.vAbsent.get(id-1));
				return c.getDDMMYYYY();
			} else return "";
		}
		return super.getString(fieldName);		
	}
}

