package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * Ѻ͡§ҹ ػ÷ӧҹШ͹ͧ KKB
 * ¢Ź鹨еͧӡûż ʹ͹ҡ͹
 * 觨 Tworking_summary
 */
public class Memployee_working_avg_of_year extends Memployee {

	private MyHashMap hm = null;
	private MyHashMap hmTotal = null;
	private DbInquiry inqWorking = null;
	private DecimalFormat df = new DecimalFormat("0.00"); 
	private boolean result = false; 
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {		
			//this.param.put("year", "2007");
			this.initialColumn();
			this.result = this.setData();
		}
		return temp;
	}
	
	public boolean foundData() { //Ҿ ¡鹡ŧ Tworking_summary ׷ӡâ
		if (this.result==false) {
			return false;
		} else return super.foundData();
	}
	
	private void initialColumn() {
		if (this.hm==null) {
			this.hm = new MyHashMap();
		}		
		for (int i=1;i<=12;i++) {
			this.hm.put(String.valueOf(i), "0.00");			
		}
		this.hm.put("total", "0.00");
	}
	
	private void initialColumnTotal() {
		if (this.hmTotal==null) {
			this.hmTotal = new MyHashMap();
		}		
		for (int i=1;i<=12;i++) {
			this.hmTotal.put("office_"+i, "0.00");
			this.hmTotal.put("emp_"+i, "0");
			this.hmTotal.put("office_total_"+i, "0.00");
		}
		this.hmTotal.put("office_total", "0.00");
	}
	
	private int getMonthWorking() {
		int i = 12;
		int year = Integer.parseInt((String) this.param.get("YEAR"));
		CscCalendar startDate = new CscCalendar(this.getString("startdate"));
		CscCalendar resignDate = new CscCalendar(this.getString("resigndate"));
		resignDate.decDate();
		if (startDate.getYear()<year && resignDate.getYear()>year) { //ѧ㹻շҧҹ͡
			i = 12;
		} else if (startDate.getYear()==year && resignDate.getYear()>year) { //ҧҹ㹻չ
			i = Integer.parseInt(startDate.getMM());
		} else if (startDate.getYear()>year && resignDate.getYear()==year) { //͡㹻չ
			i = Integer.parseInt(resignDate.getMM());
		} else if (startDate.getYear()==year && resignDate.getYear()==year) { //ҧҹ͡չ
			i = Integer.parseInt(resignDate.getMM()) - Integer.parseInt(startDate.getMM());
		}
		return i;		
	}
	
	private boolean setData() {
		boolean data = false;
		try {
			String year = (String) this.param.get("YEAR");
			double total = 0;
			int month = 0;
			if (this.inqWorking == null) {
				this.inqWorking = new InitialInquiry(this.getUProfile()).getDbInquiry();
				this.inqWorking.setSchemaName(this.getUProfile().getSchemaName());
				this.inqWorking.initMyTable("Tworking_summary","", "employeeid,yearid,monthid");
				this.inqWorking.setColumn("*");
			}
			this.inqWorking.setFilter("employeeid='"+this.getString("employeeid")+"' and " +
					"yearid="+year+"");
			this.inqWorking.refresh();
			while (this.inqWorking.next()) {
				DbRecord rec = this.inqWorking.getCurrentDbRecord();
				if (!rec.getString("swipetype").equalsIgnoreCase("N")) { // N=¡鹡ŧҤԴ 
					this.hm.put(rec.getString("monthid"), this.df.format(rec.getDouble("working_avg")));
					total += rec.getDouble("working_avg");
					if ((rec.getDouble("working_avg"))>0) { //͹ա÷ӧҹѺ ͹价ӡ
						month++;
					}
					data = true;
				} else data = false;				
			}
			//this.hm.put("total", this.df.format(total/12));
			if (data) {
				//this.hm.put("total", this.df.format(total/this.getMonthWorking()));
				if (month==0) {
					this.hm.put("total", "0.00");
				} else this.hm.put("total", this.df.format(total/month));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return data;
	}
	
	private void summaryTotal() {
		String year = (String) this.param.get("YEAR");
		try {
			String filter = "yearid="+year+" and swipetype<>'N'";
			if (this.param.containsKey("BRANCH") && !((String)this.param.get("BRANCH")).equals("")) {
				filter += " and branch="+(String)this.param.get("BRANCH");
			} 
			DbInquiry inqTotal = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inqTotal.setSchemaName(this.getUProfile().getSchemaName());
			inqTotal.initMyTable("Tworking_summary",filter, "");
			inqTotal.setColumn("*");
			inqTotal.refresh();
			while (inqTotal.next()) {
				DbRecord rec = inqTotal.getCurrentDbRecord();
				
				String m = rec.getString("monthid");
				String old_work = this.hmTotal.getString("office_"+m);
				
				if (rec.getDouble("working_avg")>0) {
					double work = rec.getDouble("working_avg") + Double.parseDouble(old_work);
					
					String old_emp = this.hmTotal.getString("emp_"+m);
					int emp = Integer.parseInt(old_emp);
					emp++;
					
					this.hmTotal.put("office_"+m, work);
					this.hmTotal.put("emp_"+m, emp);
				}				
			}
			
			double data = 0;
			for (int i=1;i<=12;i++) {
				String working_avg = this.hmTotal.getString("office_"+i);
				String emp = this.hmTotal.getString("emp_"+i);
				double result = 0;
				if (!emp.equals("0")) {
					result = Double.parseDouble(working_avg)/Integer.parseInt(emp);
				}
				this.hmTotal.put("office_total_"+i, this.df.format(result));
				data += result;
			}
			//this.hmTotal.put("office_total", this.df.format(data/12));
			if(this.getMonthWorking()>0)
				this.hmTotal.put("office_total", this.df.format(data/this.getMonthWorking()));
			else
				this.hmTotal.put("office_total", this.df.format(0.00));
		} catch (Exception e) {
			MyLog.error(this, e);
		}				
	}
	
	public String getString(String fieldName) {
		if (fieldName.indexOf("$") > -1) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}

	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > -1) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());		
			if (this.hm.get(fName) != null) {				
				return String.valueOf(this.hm.get(fName));				
			} 
			
			if (fName.indexOf("office")>-1) {
				if (this.hmTotal == null) {
					this.initialColumnTotal();
					this.summaryTotal();
				}
				if (this.hmTotal.get(fName) != null) {				
					return String.valueOf(this.hmTotal.get(fName));			
				}
			}
		}
		return super.getString(fieldName);
	}

}
