package com.csc.library.databean;

import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

public class Memployee_working_manhour extends Memployee {
	
	private boolean flag = false;
	private Vector vCode;
	private DbInquiry inqCurrent = null;
	private DbInquiry inqHistory = null;
	private DbInquiry inqLeave = null;
	private CscCalendar cscStart = null;
	private CscCalendar cscEnd = null;
	private CscTime working;
	private CscTime leave;
	
public int assignField(DataSet rs) {
		
		this.cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		this.cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		/*
		this.cscStart = new CscCalendar("01-01-2007");
		this.cscEnd = new CscCalendar("31-12-2007");
		*/	
		int temp = super.assignField(rs);
		
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			if (this.flag==false) {		
				this.vCode = this.getEventgrpVacation();
				this.flag=true;
			} 
			this.working = new CscTime(0);
			this.leave = new CscTime(0);
			this.getData();
		}		
		return temp;
	}
	
	//һѹ繻Ҿѡ͹ ͨ仺ǡ㹡
	private Vector getEventgrpVacation() {
		Vector v = new Vector();
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Meventgrp", "daytype='7'","");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				v.add(inq.getString("eventgrpid"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return v;
	}
	
	private void getData() {
		// . ӧҹͧӧҹ
		try {
			if (this.inqCurrent==null) {
				this.inqCurrent = new InitialInquiry(this.userPro).getDbInquiry();	
				this.inqCurrent.initMyTable("Ttime_current", "", "dateid");
				this.inqCurrent.setColumn("*");
			}								
			this.inqCurrent.setFilter("employeeid='"+this.getString("employeeid")+"' " +
					"and hour_d>0 and ot<>hour_d " +
					"and (dateid between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqCurrent.refresh();			
			while (this.inqCurrent.next()) {
				this.working.add(this.inqCurrent.getCurrentDbRecord().getFloat("hour_s"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		
		try {
			if (this.inqHistory==null) {
				this.inqHistory = new InitialInquiry(this.userPro).getDbInquiry();	
				this.inqHistory.initMyTable("Ttime_history", "", "dateid");
				this.inqHistory.setColumn("*");
			}								
			this.inqHistory.setFilter("employeeid='"+this.getString("employeeid")+"' " +
					"and hour_d>0 and ot<>hour_d "+
					"and (dateid between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqHistory.refresh();		
			while (inqHistory.next()) {
				this.working.add(inqHistory.getCurrentDbRecord().getFloat("hour_s"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		
		// .ӡҷ ¡Ҿѡ͹
		try {
			String lv_type = "";
			float m_lv  = 0;						
			if (this.inqLeave==null) {
				this.inqLeave = new InitialInquiry(this.userPro).getDbInquiry();	
				this.inqLeave.initMyTable("Tleave_summary", "", "dateid");
				this.inqLeave.setColumn("*");
			}								
			this.inqLeave.setFilter("employeeid='"+this.getString("employeeid")+"' " +
				"and (doctype='A' or doctype='S') " +
				"and (dateid between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqLeave.refresh();		
			while (this.inqLeave.next()) {
				lv_type = this.inqLeave.getCurrentDbRecord().getString("lv_type");
				m_lv = this.inqLeave.getCurrentDbRecord().getFloat("m_lv");
				if (this.vCode!=null && !this.vCode.contains(lv_type)) {
					this.leave.add(m_lv);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		
		System.out.println("===> working : "+this.working.getFloat());
		System.out.println("===> leave : "+this.leave.getFloat());
	}
	
	public String getString(String fieldName) {		
		if (fieldName.equalsIgnoreCase("working_result")) {
			return String.valueOf(this.working.getFloat());
		} else if (fieldName.equalsIgnoreCase("leave_result")) {
			return String.valueOf(this.leave.getFloat());
		} else {	
			return super.getString(fieldName);
		}
	}
	
	/** 
	 * for test
	 */
	private String getManHour(){
		String manHour ="1.11";
		return manHour; 
	}//end method getManHour
}
