package com.csc.library.databean;

import java.text.DecimalFormat;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

public class Memployee_working_summarize extends Simmemployee_statisticleave {
	
	private boolean flag = false;
	protected double hourwork = 8;
	protected MyHashMap hmHeader = null;
	private MyHashMap hmEventgrp = null;
	private Vector vReport = null;
	private DbInquiry inqTimeC = null;
	private DbInquiry inqTimeH = null;
	private DecimalFormat df = new DecimalFormat("#0.00");
	private FormulaString fs = new FormulaString();
	
	public int assignField(DataSet rs) {
		
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		//CscCalendar cscStart = new CscCalendar("01-01-2007");
		//CscCalendar cscEnd = new CscCalendar("31-12-2007");
		this.param.put("__date_start", cscStart.getDDMMYYYY());		
		this.param.put("__date_end", cscEnd.getDDMMYYYY());
		
		int temp = super.assignField(rs);
		
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			if (this.flag==false) {				
				this.hmHeader = new MyHashMap();
				this.hmEventgrp = new MyHashMap();
				this.vReport = new Vector();
				this.loadEventgrp();		
				this.initReportColumn();
				
				this.flag=true;
			} 
			this.initLeaveColumn();
			this.setWorkingData();
			this.setWarning();
			System.out.println("hmHeader="+hmHeader);
		}		
		return temp;
	}
	
	/*
	 * Ҩӹǹ駷ӼԴ 㹢ŤդԴ
	 */
	private void setWarning() {
		try {
			CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Mempl_merit", "employeeid='"+this.getString("employeeid")+"' and " +
					"(effectivedate between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')", "");
			inq.setColumn("*");
			inq.refresh();
			int result = inq.recCount();
			
			String column = this.hmHeader.getString("WARN");
			this.hmHeader.put(column+"_value", result);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void loadEventgrp() {
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Meventgrp", "", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				this.hmEventgrp.put(inq.getString("eventgrpid"), inq.getString("eventgrpid"));
				this.hmEventgrp.put(inq.getString("eventgrpid")+"_code", inq.getString("eventgrpid"));
				this.hmEventgrp.put(inq.getString("eventgrpid")+"_desc", inq.getString("tdesc"));
				this.hmEventgrp.put(inq.getString("eventgrpid")+"_limit", inq.getString("limit"));
				this.hmEventgrp.put(inq.getString("eventgrpid")+"_daytype", inq.getString("daytype"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void  initReportColumn() {			
		if (this.param.containsKey("LEAVECOLUMN")) {
			String columnCode = (String) this.param.get("LEAVECOLUMN");
			//String columnCode = "TEST2";
			try {
				Vector v = new Vector();
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
				inq.setSchemaName(this.userPro.getSchemaName());						
				inq.initMyTable("Mleave_report", "codeid='"+columnCode+"'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord rec = inq.getCurrentDbRecord();
					for (int i=1;i<=25;i++) {
						String id = "";
						if (i<=9) {
							id = "col0"+i;	
						}else{
							id = "col"+String.valueOf(i);
						}//end if
						
						String code = rec.getString(id);
						this.vReport.add(code);
					}
				}
			} catch (Exception e) {
				MyLog.error(this, e);
			}
		}
	}
	
	private void  initLeaveColumn() {
		this.hourwork = Double.parseDouble(super.getString("Simmemployee_statisticleave$hourwork"));
		this.hmHeader.put("hourwork", hourwork);	
		
		try {
			Vector v = new Vector();
			for (int j=0;j<this.vReport.size();j++) {
				int i = j+1;				
				String id = "col"+String.valueOf(i);
				if (i<=9) {
					id = "col0"+i;	
				}
						
				String code = (String) this.vReport.elementAt(j);
					
				this.hmHeader.put(id+"_code", code);
				this.hmHeader.put(code, id);		
				if (this.hmEventgrp.containsKey(code+"_code")) {
					this.hmHeader.put(id+"_desc", this.hmEventgrp.getString(code+"_desc"));	//ʴЪͧ
					this.hmHeader.put(id+"_value", "");		
					MyHashMap hmLeave = new MyHashMap();							
					if (!this.getString("Simmemployee_statisticleave$"+code+"_limit").equals("")) {
						hmLeave.put(id+"_limit", this.getString("Simmemployee_statisticleave$"+code+"_limit"));
					} else {
						hmLeave.put(id+"_limit", "00:00:00");
					}
						
					if (!this.getString("Simmemployee_statisticleave$"+code+"_used").equals("")) {
						hmLeave.put(id+"_used", this.getString("Simmemployee_statisticleave$"+code+"_used"));
					} else {
						hmLeave.put(id+"_used", "00:00:00");	
					}
						
					if (!this.getString("Simmemployee_statisticleave$"+code+"_remain").equals("")) {
						hmLeave.put(id+"_remain", this.getString("Simmemployee_statisticleave$"+code+"_remain"));
					} else {
						hmLeave.put(id+"_remain", "00:00:00");	
					}
					this.hmHeader.put(id, hmLeave);
					v.add(code);
				} else {
					MyHashMap hm = new MyHashMap();		
					hm.put(id+"_limit", "00:00:00");
					hm.put(id+"_used", "00:00:00");	
					hm.put(id+"_remain", "00:00:00");	
					this.hmHeader.put(id, hm);
							
					if (code.equalsIgnoreCase("LT")) { //ӹǹ駷
						if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
							this.hmHeader.put(id+"_desc", "");		
						} else this.hmHeader.put(id+"_desc", "Late");		
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("LT_H")) { //ҷ
						if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
							this.hmHeader.put(id+"_desc", "ҷ");		
						} else this.hmHeader.put(id+"_desc", "Late Hour");		
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OT")) { //ҷͷ
						this.hmHeader.put(id+"_desc", "OT");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OT1")) { //ӹǹͷ 1 
						this.hmHeader.put(id+"_desc", "OT1");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OT5")) { //ӹǹͷ 1.5 
						this.hmHeader.put(id+"_desc", "OT5");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OT2")) { //ӹǹͷ 2 
						this.hmHeader.put(id+"_desc", "OT2");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OT3")) { //ӹǹͷ 3 
						this.hmHeader.put(id+"_desc", "OT3");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("OTALL")) { //ӹǹͷ [OT 1+5+2+3]
						this.hmHeader.put(id+"_desc", "OTALL");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("W_DAY")) { //ӹǹѹͧӧҹ
						this.hmHeader.put(id+"_desc", "Work Day");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("W_WOR")) { //ӹǹѹӧҹ
						this.hmHeader.put(id+"_desc", "Working Day");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("H_DAY")) { //ӹǹ  ͧӧҹ
						this.hmHeader.put(id+"_desc", "Work Day");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("H_WOR")) { //ӹǹ  ӧҹ
						this.hmHeader.put(id+"_desc", "Working Day");	
						this.hmHeader.put(id+"_value", "");
					} else if (code.equalsIgnoreCase("MLV")) {
						if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
							this.hmHeader.put(id+"_desc", "ػ");
						} else this.hmHeader.put(id+"_desc", "Enter Monkhood Leave");	
						this.hmHeader.put(id+"_value", "");
						MyHashMap hmLeave = new MyHashMap();	
					
						FormulaString fs = new FormulaString();
						int m_limit = fs.DhmToM(this.getString("Simmemployee_statisticleave$L11_limit"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L12_limit"));
						int m_used = fs.DhmToM(this.getString("Simmemployee_statisticleave$L11_used"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L12_used"));
						int m_remain = fs.DhmToM(this.getString("Simmemployee_statisticleave$L11_remain"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L12_remain"));
						
						hmLeave.put(id+"_limit", fs.MTODhm(m_limit));
						hmLeave.put(id+"_used", fs.MTODhm(m_used));
						hmLeave.put(id+"_remain", fs.MTODhm(m_remain));
						this.hmHeader.put(id, hmLeave);								
					} else if (code.equalsIgnoreCase("ALV")) {
						if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
							this.hmHeader.put(id+"_desc", "ѺҪ÷");
						} else this.hmHeader.put(id+"_desc", "Military Leave");	
						this.hmHeader.put(id+"_value", "");
						MyHashMap hmLeave = new MyHashMap();	
						
						FormulaString fs = new FormulaString();
						int m_limit = fs.DhmToM(this.getString("Simmemployee_statisticleave$L06_limit"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L07_limit"));
						int m_used = fs.DhmToM(this.getString("Simmemployee_statisticleave$L06_used"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L07_used"));
						int m_remain = fs.DhmToM(this.getString("Simmemployee_statisticleave$L06_remain"))+fs.DhmToM(this.getString("Simmemployee_statisticleave$L07_remain"));
						
						hmLeave.put(id+"_limit", fs.MTODhm(m_limit));
						hmLeave.put(id+"_used", fs.MTODhm(m_used));
						hmLeave.put(id+"_remain", fs.MTODhm(m_remain));
						this.hmHeader.put(id, hmLeave);
					} else if (code.equalsIgnoreCase("UN1")) { 
						this.hmHeader.put(id+"_desc", "Unused 1");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("UN2")) { 
						this.hmHeader.put(id+"_desc", "Unused 2");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("UN3")) { 
						this.hmHeader.put(id+"_desc", "Unused 3");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("UN4")) { 
						this.hmHeader.put(id+"_desc", "Unused 4");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("UN5")) { 
						this.hmHeader.put(id+"_desc", "Unused 5");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("WARN")) {  //ӹǹ駷ⴹ͹
						this.hmHeader.put(id+"_desc", "Warning");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("OUT")) {  //ӹǹ駷͡͹
						this.hmHeader.put(id+"_desc", "Out Before");	
						this.hmHeader.put(id+"_value", "0");
					} else if (code.equalsIgnoreCase("L_OTH")) {
						this.hmHeader.put(id+"_desc", "Leave Other"); //
						this.hmHeader.put(id+"_value", "0");
						
						int limit = 0;
						int used = 0;
						int remain = 0;
						Iterator it = this.hmEventgrp.keySet().iterator();
						while (it.hasNext()) {
							String key = (String) it.next();
							if (key.indexOf("_")==-1 && !key.equals("T") && !key.equals("O") && !key.equals("H") && !key.equals("I") && !key.equals("J")) {
								if (!v.contains(key)) {
									//System.out.println("-----> "+key+ " ----> "+this.getString("Simmemployee_statisticleave$"+key+"_used"));
									limit += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_limit"), hourwork);
									used += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_used"), hourwork);
									remain += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_remain"), hourwork);
								}
							}									
						}
						MyHashMap hmLeave = new MyHashMap();							
						hmLeave.put(id+"_limit", fs.MTODhm(limit, hourwork));
						hmLeave.put(id+"_used", fs.MTODhm(used, hourwork));
						hmLeave.put(id+"_remain", fs.MTODhm(remain, hourwork));
						this.hmHeader.put(id, hmLeave);
					} else if (code.equalsIgnoreCase("L_ALL")) {
						this.hmHeader.put(id+"_desc", "Leave All"); //
						this.hmHeader.put(id+"_value", "0");
						
						int limit = 0;
						int used = 0;
						int remain = 0;
						Iterator it = this.hmEventgrp.keySet().iterator();
						while (it.hasNext()) {
							String key = (String) it.next();
							if (key.indexOf("_")==-1 && !key.equals("T") && !key.equals("O") && !key.equals("H") && !key.equals("I") && !key.equals("J")) {
								//System.out.println("-----> "+key+ " ----> "+this.getString("Simmemployee_statisticleave$"+key+"_limit"));
								limit += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_limit"), hourwork);
								used += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_used"), hourwork);
								remain += fs.DhmToM(this.getString("Simmemployee_statisticleave$"+key+"_remain"), hourwork);										
							}									
						}
						MyHashMap hmLeave = new MyHashMap();							
						hmLeave.put(id+"_limit", fs.MTODhm(limit, hourwork));
						hmLeave.put(id+"_used", fs.MTODhm(used, hourwork));
						hmLeave.put(id+"_remain", fs.MTODhm(remain, hourwork));
						this.hmHeader.put(id, hmLeave);
					}
				}						
			}
		} catch (Exception e) { 
			MyLog.error(this, e);
		}
	}
	
	private void setWorkingData() {
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		//CscCalendar cscStart = new CscCalendar("01-01-2007");
		//CscCalendar cscEnd = new CscCalendar("31-12-2007");
		CscTime ct_lt = new CscTime(0f);
		CscTime ct_ot = new CscTime(0f);
		CscTime ct_ot1 = new CscTime(0f);
		CscTime ct_ot5 = new CscTime(0f);
		CscTime ct_ot2 = new CscTime(0f);
		CscTime ct_ot3 = new CscTime(0f);
		CscTime ct_ottotal = new CscTime(0f);
		CscTime ct_un1 = new CscTime(0f);
		CscTime ct_un2 = new CscTime(0f);
		CscTime ct_un3 = new CscTime(0f);
		CscTime ct_un4 = new CscTime(0f);
		CscTime ct_un5 = new CscTime(0f);
		int late = 0;
		int workday = 0;
		int working = 0;
		int out = 0;
		try {
			String date = "";
			if (this.inqTimeC==null) {
				this.inqTimeC = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeC.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeC.initMyTable("Ttime_current1", "", "employeeid, dateid, sequence");
				this.inqTimeC.setColumn("*");
			}
			this.inqTimeC.setFilter("employeeid='"+this.getString("employeeid")+"' " +
					"and (dateid between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')");
			this.inqTimeC.refresh();
			while (this.inqTimeC.next()) {
				DbRecord rec = this.inqTimeC.getCurrentDbRecord();
				if (rec.getFloat("lt")>0) {
					ct_lt.add(rec.getFloat("lt"));
					late++;
				}
				
				if (rec.getFloat("ac_ot")>0) {
					ct_ot.add(rec.getFloat("ac_ot"));	
				}				
				if (rec.getFloat("ot1")>0) {
					ct_ot1.add(rec.getFloat("ot1"));			
					ct_ottotal.add(rec.getFloat("ot1"));	
				}				
				if (rec.getFloat("ot5")>0) {
					ct_ot5.add(rec.getFloat("ot5"));	
					ct_ottotal.add(rec.getFloat("ot5"));	
				}				
				if (rec.getFloat("ot2")>0) {
					ct_ot2.add(rec.getFloat("ot2"));		
					ct_ottotal.add(rec.getFloat("ot2"));	
				}				
				if (rec.getFloat("ot3")>0) {
					ct_ot3.add(rec.getFloat("ot3"));			
					ct_ottotal.add(rec.getFloat("ot3"));	
				}
				
				try {
					if (rec.getFloat("unused1")>0) {
						ct_un1.add(rec.getFloat("unused1"));					
					}
					if (rec.getFloat("unused2")>0) {
						ct_un2.add(rec.getFloat("unused2"));					
					}
					if (rec.getFloat("unused3")>0) {
						ct_un3.add(rec.getFloat("unused3"));					
					}
					if (rec.getFloat("unused4")>0) {
						ct_un4.add(rec.getFloat("unused4"));					
					}
					if (rec.getFloat("unused5")>0) {
						ct_un5.add(rec.getFloat("unused5S"));					
					}
				} catch (Exception e) {}
				
				if (rec.getString("eventgrp").equals("T")) {
					CscCalendar com = new CscCalendar(rec.getString("c_dt_en"));
					com.setCSCTime(rec.getFloat("c_tm_en"));
					CscCalendar  emp= new CscCalendar(rec.getString("m_dt_en"));
					emp.setCSCTime(rec.getFloat("m_tm_en"));
					if (emp.after(emp)) {
						out++;
					}
				}
				
				if (workday==0) {
					if (!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) {
						date = rec.getString("dateid");
						workday++;						
					} 
					
					if (rec.getString("eventgrp").equals("T") || rec.getString("eventgrp").equals("O")) {
						working++;
					}
				} else {					
					if (!date.equals(rec.getString("dateid")) &&
							(!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O"))) {
						workday++;						
					}
					
					if (rec.getString("eventgrp").equals("T") || rec.getString("eventgrp").equals("O")) {
						working++;
					}					
				}					
				//System.out.println("C dateid == >"+date +" : workday ===> "+workday+" : working ===> "+working);
				date = rec.getString("dateid");								
			}
		} catch (Exception e) {}
		
		try {
			String date = "";
			if (this.inqTimeH==null) {
				this.inqTimeH = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeH.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeH.initMyTable("Ttime_history1", "", "employeeid, dateid, sequence");
				this.inqTimeH.setColumn("*");
			}
			this.inqTimeH.setFilter("employeeid='"+this.getString("employeeid")+"' " +
					"and (dateid between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')");
			this.inqTimeH.refresh();
			while (this.inqTimeH.next()) {
				DbRecord rec = this.inqTimeH.getCurrentDbRecord();
				if (rec.getFloat("lt")>0) {
					ct_lt.add(rec.getFloat("lt"));
					late++;
				}
				
				if (rec.getFloat("ac_ot")>0) {
					ct_ot.add(rec.getFloat("ac_ot"));		
				}				
				if (rec.getFloat("ot1")>0) {
					ct_ot1.add(rec.getFloat("ot1"));			
					ct_ottotal.add(rec.getFloat("ot1"));	
				}				
				if (rec.getFloat("ot5")>0) {
					ct_ot5.add(rec.getFloat("ot5"));	
					ct_ottotal.add(rec.getFloat("ot5"));	
				}				
				if (rec.getFloat("ot2")>0) {
					ct_ot2.add(rec.getFloat("ot2"));		
					ct_ottotal.add(rec.getFloat("ot2"));	
				}				
				if (rec.getFloat("ot3")>0) {
					ct_ot3.add(rec.getFloat("ot3"));			
					ct_ottotal.add(rec.getFloat("ot3"));	
				}
				
				try {
					if (rec.getFloat("unused1")>0) {
						ct_un1.add(rec.getFloat("unused1"));					
					}
					if (rec.getFloat("unused2")>0) {
						ct_un2.add(rec.getFloat("unused2"));					
					}
					if (rec.getFloat("unused3")>0) {
						ct_un3.add(rec.getFloat("unused3"));					
					}
					if (rec.getFloat("unused4")>0) {
						ct_un4.add(rec.getFloat("unused4"));					
					}
					if (rec.getFloat("unused5")>0) {
						ct_un5.add(rec.getFloat("unused5S"));					
					}
				} catch (Exception e) {}
				
				if (workday==0) {
					if (!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) {
						date = rec.getString("dateid");
						workday++;
					}
					
					if (rec.getString("eventgrp").equals("T") || rec.getString("eventgrp").equals("O")) {
						working++;
					}
				} else {					
					if (!date.equals(rec.getString("dateid")) &&
							(!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O"))) {
						workday++;						
					}
					
					if (rec.getString("eventgrp").equals("T") || rec.getString("eventgrp").equals("O")) {
						working++;
					}					
				}						
				//System.out.println("H dateid == >"+date +" : workday ===> "+workday+" : working ===> "+working);
				date = rec.getString("dateid");								
			}
		} catch (Exception e) {}
		
		String column = this.hmHeader.getString("LT");
		this.hmHeader.put(column+"_value", late);
		this.hmHeader.put(column+"_used", late);
		column = this.hmHeader.getString("LT_H");
		this.hmHeader.put(column+"_value", df.format(ct_lt.getFloat()));		
		this.hmHeader.put(column+"_used", df.format(ct_lt.getFloat()));		
		
		column = this.hmHeader.getString("OT");
		this.hmHeader.put(column+"_value", df.format(ct_ot.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_ot.getFloat()));	
		column = this.hmHeader.getString("OT1");
		this.hmHeader.put(column+"_value", df.format(ct_ot1.getFloat()));		
		this.hmHeader.put(column+"_used", df.format(ct_ot1.getFloat()));	
		column = this.hmHeader.getString("OT5");
		this.hmHeader.put(column+"_value", df.format(ct_ot5.getFloat()));	
		this.hmHeader.put(column+"_used", df.format(ct_ot5.getFloat()));	
		column = this.hmHeader.getString("OT2");
		this.hmHeader.put(column+"_value", df.format(ct_ot2.getFloat()));	
		this.hmHeader.put(column+"_used", df.format(ct_ot2.getFloat()));	
		column = this.hmHeader.getString("OT3");
		this.hmHeader.put(column+"_value", df.format(ct_ot3.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_ot3.getFloat()));	
		column = this.hmHeader.getString("OTALL");
		this.hmHeader.put(column+"_value", df.format(ct_ottotal.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_ottotal.getFloat()));	
		
		column = this.hmHeader.getString("W_DAY");
		this.hmHeader.put(column+"_value", workday);
		this.hmHeader.put(column+"_used", workday);
		column = this.hmHeader.getString("W_WOR");
		this.hmHeader.put(column+"_value", working);
		this.hmHeader.put(column+"_used", working);
		
		double hourwork = this.hmHeader.getDouble("hourwork");
		column = this.hmHeader.getString("H_DAY");
		this.hmHeader.put(column+"_value", workday*hourwork);
		this.hmHeader.put(column+"_used", workday*hourwork);		
		column = this.hmHeader.getString("H_WOR");
		this.hmHeader.put(column+"_value", working*hourwork);
		this.hmHeader.put(column+"_used", working*hourwork);
		
		column = this.hmHeader.getString("UN1");
		this.hmHeader.put(column+"_value", df.format(ct_un1.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_un1.getFloat()));
		column = this.hmHeader.getString("UN2");
		this.hmHeader.put(column+"_value", df.format(ct_un2.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_un2.getFloat()));
		column = this.hmHeader.getString("UN3");
		this.hmHeader.put(column+"_value", df.format(ct_un3.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_un3.getFloat()));
		column = this.hmHeader.getString("UN4");
		this.hmHeader.put(column+"_value", df.format(ct_un4.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_un4.getFloat()));
		column = this.hmHeader.getString("UN5");
		this.hmHeader.put(column+"_value", df.format(ct_un5.getFloat()));
		this.hmHeader.put(column+"_used", df.format(ct_un5.getFloat()));
	}
		
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") >= 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmHeader.containsKey(fName)) {			
				return this.hmHeader.getString(fName);
			} else if (fName.indexOf("col")>-1 && this.hmHeader.containsKey(fName.substring(0, fName.indexOf("_")))) {
				MyHashMap hm = (MyHashMap) this.hmHeader.get(fName.substring(0, fName.indexOf("_")));
				return hm.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}
