package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.Iterator;

import com.csc.library.database.DataSet;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;

public class Memployee_worktime extends Memployee {

	WorkingShift wShift = new WorkingShift();

	public Memployee_worktime() {
		super();
	}

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (temp != 0) {
			if (this.param.containsKey("__beginDate")) {
				if (this.param.containsKey("__endDate")) {
					if (this.param.get("__endDate").toString().trim().equals("")) {
						this.wShift = this.genWorkTime(this.param.get("__beginDate").toString());
					} else {
						this.wShift = this.genWorkTime(this.param.get("__beginDate").toString(), 
								this.param.get("__endDate").toString());
					}
				} else {
					this.wShift = this.genWorkTime(this.param.get("__beginDate").toString());
				}
				// this.displayWorkingShift(this.wShift);
			}
		}
		return temp;
	}

	private void displayWorkingShift(WorkingShift ws) {
		if (!ws.isEmpty()) {
			MyLog.debug(	this,"\n<<<<<<<<<<<<<<<<<<<<<<<<<< Display WorkingShift  >>>>>>>>>>>>>>>>>>>>>>>>>>>>");
			for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {
				String key = (String) IT.next();
				DayShift dShift = (DayShift) ws.get(key);
				for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {
					String key1 = (String) IT1.next();
					Shift sh = (Shift) dShift.get(key1);
					MyLog.debug(this, "**** Date=" + key + " **** Time=" + key1
							+ " **** Shift " + " >>> Begin="
							+ sh.get_c_dt_in().getCSCTime() + " >>> End="
							+ sh.get_c_dt_out().getCSCTime()
							+ " >>> Time Code=" + sh.getTimeCode()
							+ " >>> Type=" + sh.getTR_Type().substring(0, 1)
							+ " >>> Leave=" + sh.getLv() + " >>> Leave Type="
							+ sh.getLV_Type());
				}
				MyLog.debug(this,"--------------------------------------------------------------------------------------------------------------------------------");
			}
		} else
			MyLog.debug(this,"++++++++++++++++++++++++ WorkingShift is Empty +++++++++++++++++++++++++");
	}

	private WorkingShift genWorkTime(String beginDate) {
		WorkingShift ws = null;
		try {
			boolean adjust = false; // param value -----> 1=adjust is true, 0=adjust is false
			if (this.param.containsKey("__adjust")) {
				if (((String) this.param.get("__adjust")).equalsIgnoreCase("1")) {
					adjust = true;
				}
			}

			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Mtime0", "time0id='" + this.getString("time0") + "'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				Mtime0 rec = (Mtime0) inq.getCurrentDbRecord();
				ws = rec.genWorkingShift(new CscCalendar(beginDate));
				if (!ws.isEmpty()) {
					ws.setUProfile(this.userPro);
					ws.adjust();
					ws.overlapChecking();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		MyLog.debug(this, ">>>>>>>>>>> WORKING SHIFT=" + ws);
		return ws;
	}

	private WorkingShift genWorkTime(String beginDate, String endDate) {
		WorkingShift ws = null;
		try {
			boolean adjust = false; // param value -----> 1=adjust is true,  0=adjust is false
			if (this.param.containsKey("__adjust")) {
				if (((String) this.param.get("__adjust")).equalsIgnoreCase("1")) {
					adjust = true;
				}
			}

			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Mtime0", "time0id='" + this.getString("time0") + "'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				Mtime0 rec = (Mtime0) inq.getCurrentDbRecord();
				CscCalendar cs1 = new CscCalendar(beginDate);
				CscCalendar cs2 = new CscCalendar(endDate);
				ws = rec.genWorkingShift(cs1, cs2);
				if (!ws.isEmpty() && adjust == true) {
					ws.setUProfile(this.userPro);
					ws.adjust();
					ws.overlapChecking();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return ws;
	}

	public WorkingShift getWorkingShift() {
		return this.wShift;
	}

	public int search() {
		try {
			super.search();
			if (this.param.containsKey("__beginDate")) {
				if (this.param.containsKey("__endDate")) {
					if (this.param.get("__endDate").toString().trim().equals("")) {
						this.wShift = this.genWorkTime(this.param.get("__beginDate").toString());
					} else {						
						this.wShift = this.genWorkTime(this.param.get("__beginDate").toString(), 
								this.param.get("__endDate").toString());
					}
				} else {
					this.wShift = this.genWorkTime(this.param.get("__beginDate").toString());
				}
				// this.displayWorkingShift(this.wShift);
			}
			return 1;
		} catch (Exception e) {
			MyLog.error(this, e);
			return 0;
		}
	}

}