package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

import java.text.DecimalFormat;
import java.util.HashMap;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeinterface.GenDayShift;
import com.csc.library.utilities.CscCalendar;


public class Mtime2 extends RecordCmp implements GenDayShift, DbRecord {
	
	private DbInquiry inqTime1 = null;
    private DbInquiry inqTime0 = null;

	public Mtime2() {
		super("Mtime2", "Mtime2 Table");
	}
    
   private  MyHashMap hm = new MyHashMap();

	private String getTimeShiftCode(int d, int id) {
		if (String.valueOf(d).length() == 1) {
			return this.getString("time0" + d + id);
		} else {
			return this.getString("time" + d + id);
		}
	}	
	
	private String getWorkareCode(int d, int id) {
		if (String.valueOf(d).length() == 1) {
			return this.getString("workarea0" + d + id);
		} else {
			return this.getString("workarea" + d + id);
		}
	}	
	
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, Shift lastShift, String type, HashMap hmData1, String workarea, CscCalendar sDate, CscCalendar eDate) {		
		return new DayShift(date);
	}
	
	/*
	 * ӡҧἹ÷ӧҹͧѡҹ 
	 */
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, String type, HashMap hmData1, String workarea, CscCalendar sDate, CscCalendar eDate) {		
		Shift lastShift = null;
		String keyShift = "";
		DayShift dShift = new DayShift();
		String time0tmp, workareatmp;
		
		time0tmp = this.getTimeShiftCode(date.getDate(), 1); //ʵҧ÷ӧҹ㹡з 1
		workareatmp = this.getWorkareCode(date.getDate(), 1);
		if (!time0tmp.equalsIgnoreCase("null") && !time0tmp.equalsIgnoreCase("")) {			
			try {
				if (!hmData1.containsKey(time0tmp)) { 
					hmData1 = this.loadTime1Data(time0tmp, hmData1); //Ŵ㹵ҧ÷ӧҹ
				} 
				DbRecord recTime = (DbRecord) ((HashMap) hmData1.get(time0tmp)).get(String.valueOf(date.getCSCDOW()));
								
				GenDayShift rec = (GenDayShift) recTime; //ӡҧἹ÷ӧҹ
				dShift = rec.generateDayShift(time0tmp, new CscCalendar(date.getDDMMYYYY()), holidayHM, type, hmData1, workareatmp, sDate, eDate);	
				if (dShift!=null&&!dShift.isEmpty()) {
					keyShift = (String) dShift.lastKey();
					lastShift  = (Shift) dShift.get(keyShift);
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}

		time0tmp = this.getTimeShiftCode(date.getDate(), 2); //ʵҧ÷ӧҹ㹡з 2
		workareatmp = this.getWorkareCode(date.getDate(), 2);
		if (!time0tmp.equalsIgnoreCase("null") && !time0tmp.equalsIgnoreCase("")) {			
			try {				
				if (!hmData1.containsKey(time0tmp)) {
					hmData1 = this.loadTime1Data(time0tmp, hmData1);
				} 
				DbRecord recTime = (DbRecord) ((HashMap) hmData1.get(time0tmp)).get(String.valueOf(date.getCSCDOW()));
								
				GenDayShift rec = (GenDayShift) recTime;
				DayShift ds2 = rec.generateDayShift(time0tmp, new CscCalendar(date.getDDMMYYYY()), holidayHM, lastShift, type, hmData1, workareatmp, sDate, eDate);					
				dShift.addShift(dShift, ds2);
				if (dShift!=null&&!dShift.isEmpty()) {
					keyShift = (String) dShift.lastKey();
					lastShift  = (Shift) dShift.get(keyShift);
				}
				if (ds2.getShiftDate().before(dShift.getShiftDate())) {
					dShift.setShiftDate(ds2.getShiftDate());
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}

		time0tmp = this.getTimeShiftCode(date.getDate(), 3); //ʵҧ÷ӧҹ㹡з 3
		workareatmp = this.getWorkareCode(date.getDate(), 3);
		if (!time0tmp.equalsIgnoreCase("null") && !time0tmp.equalsIgnoreCase("")) {			
			try {
				if (!hmData1.containsKey(time0tmp)) {
					hmData1 = this.loadTime1Data(time0tmp, hmData1);
				} 
				DbRecord recTime = (DbRecord) ((HashMap) hmData1.get(time0tmp)).get(String.valueOf(date.getCSCDOW()));
								
				GenDayShift rec = (GenDayShift) recTime;
				DayShift ds3 = rec.generateDayShift(time0tmp, new CscCalendar(date.getDDMMYYYY()), holidayHM, lastShift, type, hmData1, workareatmp, sDate, eDate);	
				dShift.addShift(dShift, ds3);
				if (dShift!=null&&!dShift.isEmpty()) {
					keyShift = (String) dShift.lastKey();
					lastShift  = (Shift) dShift.get(keyShift);
				}
				if (ds3.getShiftDate().before(dShift.getShiftDate())) {
					dShift.setShiftDate(ds3.getShiftDate());
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}
		//MyLog.debug(this, "---->dShift in Mtime2=" + dShift.keySet());
		return dShift;
	}
	
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, String type, HashMap hmData1, 
			String workarea, CscCalendar sDate, CscCalendar eDate, MyTreeMap trSwipe) {
		//this.trEmpSwipe = trSwipe;
		return this.generateDayShift(time0id, date, holidayHM, type, hmData1, workarea, sDate, eDate);
	}
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, Shift lastShift, String type, HashMap hmData1, 
			String workarea, CscCalendar sDate, CscCalendar eDate, MyTreeMap trSwipe) {		
		//this.lastShift = lastShift;
		//this.trEmpSwipe = trSwipe;
		return this.generateDayShift(time0id, date, holidayHM, type, hmData1,workarea, sDate, eDate);
	}

	/*
	 * Ŵ㹵ҧ÷ӧҹ
	 */
	private HashMap loadTime1Data(String timeCode, HashMap hm){	
		try {			 			
			HashMap hmDay = new HashMap();
			if (this.inqTime1 == null) {
				this.inqTime1 = new InitialInquiry(this.userPro)	.getDbInquiry();
				this.inqTime1.setParam(this.param);
				this.inqTime1.setSchemaName(this.userPro.getSchemaName());
				this.inqTime1.initMyTable("Mtime1", "", "");
				this.inqTime1.setColumn("*");
			}
			this.inqTime1.setFilter("time0id='"+timeCode+"'");
			this.inqTime1.refresh();
			while (this.inqTime1.next()) {				
				hmDay.put(this.inqTime1.getString("dayweekid"), this.inqTime1.getCurrentDbRecord().cloneRecord(false));
			}
			hm.put(timeCode, hmDay);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
    
    public FieldManager getField(String fieldName) {
        String Lang =(this.param.containsKey("__language"))?(String)this.param.get("__language"):this.getUProfile().get("lang");
        FieldManager fm = super.getField(fieldName);
        if (fieldName.toLowerCase().indexOf("desc") > -1) { //ʴ´ͧ͡  lang
            String time0 = fieldName.substring(0,fieldName.toLowerCase().indexOf("desc"));
            fm = this.initField("String", fieldName, 100, 0, "Description");
            fm.setWorking(true);
            fm.setUProfile(this.userPro);
            try {
                if(!hm.containsKey(this.getString(time0))){
                    if (this.inqTime0 == null) {
                        this.inqTime0 = new InitialInquiry(this.userPro).getDbInquiry();
                        this.inqTime0.setParam(this.param);
                        this.inqTime0.setSchemaName(this.userPro.getSchemaName());
                        this.inqTime0.initMyTable("Mtime0", "", "");
                        this.inqTime0.setColumn("time0id,companyid,tdesc,edesc");
                    }
                    this.inqTime0.setFilter("time0id='"+this.getString(time0)+"'");
                    this.inqTime0.refresh();
                    while (this.inqTime0.next()) {
                        if (Lang.equalsIgnoreCase("eng")) {
                            hm.put(this.getString(time0), inqTime0.getString("edesc"));
                        } else {
                            hm.put(this.getString(time0), inqTime0.getString("tdesc"));
                        }
                    }
                }
                fm.set(hm.getString(this.getString(time0)));
            } catch (Exception ex) {
                MyLog.error(this, ex);                
            }
        } return fm;
    }
    
    private void chkInqTime(){
        try{
            if (inqTime0 == null){
                inqTime0 = new InitialInquiry(this.userPro).getDbInquiry();
                inqTime0.setParam(this.param);
                inqTime0.setSchemaName(this.userPro.getSchemaName());
                inqTime0.initMyTable("Mtime0","","");
                inqTime0.setColumn("time0id,companyid,tdesc,edesc");
            }
        }catch (Exception e) {
            MyLog.debug(this, e);
        }
    }
    
    @Override
    protected boolean preInsertTrigger() throws Exception {
        boolean result = super.preInsertTrigger();
        result = this.beforeSave();
        return result;
    }
    
    @Override
    protected boolean preUpdateTrigger() throws Exception {
        boolean result = super.preUpdateTrigger();
        result = this.beforeSave();
        return result;
    }
    
    /*
     * ӡõǨͺ 
     * ʵҧ÷ӧҹ͡ŧ㹵ҧù
     * 㹵ҧ÷ӧҹ Ҿ return false ͡
     */
    private boolean beforeSave(){
        boolean result = true;
        try{
            String fieldName = "";
            String fieldValue = "";
            DecimalFormat df = new DecimalFormat("00");
            HashMap hmTime0 = new HashMap();
            for(int i=1; i<4; i++){
                for(int j = 1; j<32; j++){
                    fieldName = "time"+df.format(j)+i;
                    fieldValue = this.getString(fieldName);
                    if(!hmTime0.containsKey(fieldValue) && !fieldValue.equals("")){
                        this.chkInqTime();
                        this.inqTime0.setFilter("time0id = '"+fieldValue+"'");
                        this.inqTime0.refresh();
                        if (this.inqTime0.next()){
                        	//ӡʵҧ÷ӧҹŧ HashMap 
                        	//ͷҡ  HashMap ᷹ ͧ㹰ҹա
                            hmTime0.put(fieldValue, this.inqTime0.getString("tdesc"));                            
                        }else{
                            String error = "Time code in "+new CscCalendar(j+"-"+this.getString("monthid")+"-"+this.getString("yearid")).getDDMMYYYY() + " is wrong.";
                            MyLog.error(this, error);
                            MyLog.debug(this, error);
                            return false;
                        }
                    }
                }
            }
        } catch (Exception e){
            MyLog.debug(this, e);
        }
        return result;
    }
    
    /* ҡз§Ѻǧҷ */
    public String getActualTime0(CscCalendar cs){
		String tmp = "";	// time0 default
    	try {
    		String time01 = this.getString("time" + cs.getDD() + "1");
    		String time02 = this.getString("time" + cs.getDD() + "2");
    		String time03 = this.getString("time" + cs.getDD() + "3");

    		
    		HashMap hm1 = getPeriodTime(time01, cs);
    		HashMap hm2 = getPeriodTime(time02, cs);
    		HashMap hm3 = getPeriodTime(time03, cs);
    		
    		CscCalendar st = null;
    		CscCalendar en = null;    		
    		
    		/* 礡Ѻз 1 */
    		if(hm1.containsKey("start") && hm1.containsKey("end")){
    			st = new CscCalendar(cs.getYYYYMMDD());
        		en = new CscCalendar(cs.getYYYYMMDD());
    			if((Float)hm1.get("start") > (Float)hm1.get("end")){
    				en.incDate();
    			}
    			st.setCSCTime((Float)hm1.get("start"));
    			en.setCSCTime((Float)hm1.get("end"));
    			
    			if(cs.afterEqualsDateTime(st) && cs.beforeEqualsDateTime(en)){
    				return time01;
    			}else{	// set default
    				tmp = time01;
    			}
    		}
    		
    		/* 礡Ѻз 2 */
    		if(hm2.containsKey("start") && hm2.containsKey("end")){
    			st = new CscCalendar(cs.getYYYYMMDD());
        		en = new CscCalendar(cs.getYYYYMMDD());
    			if((Float)hm2.get("start") > (Float)hm2.get("end")){
    				en.incDate();
    			}
    			st.setCSCTime((Float)hm2.get("start"));
    			en.setCSCTime((Float)hm2.get("end"));
    			
    			if(cs.afterEqualsDateTime(st) && cs.beforeEqualsDateTime(en)){
    				return time02;
    			}else{	// set default
    				tmp = time02;
    			}
    		}
    		
    		/* 礡Ѻз 3 */
    		if(hm3.containsKey("start") && hm3.containsKey("end")){
    			st = new CscCalendar(cs.getYYYYMMDD());
        		en = new CscCalendar(cs.getYYYYMMDD());
    			if((Float)hm3.get("start") > (Float)hm3.get("end")){
    				en.incDate();
    			}
    			st.setCSCTime((Float)hm3.get("start"));
    			en.setCSCTime((Float)hm3.get("end"));
    			
    			if(cs.afterEqualsDateTime(st) && cs.beforeEqualsDateTime(en)){
    				return time03;
    			}else{	// set default
    				tmp = time03;
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return tmp;
    }
    
    /* ҪǧҢͧ */
    private HashMap getPeriodTime(String time0id, CscCalendar cs){
    	HashMap hm = new HashMap();
    	try {
    		DbRecord db = new InitialRecord(this.userPro).getDbRecord("MTIME1");
    		db.setColumn("*");
    		db.set("time0id", time0id);
    		db.set("line_no", 0);
    		db.set("companyid", this.userPro.get("compnayid"));
    		db.set("dayweekid", cs.getDayOfWeek());
    		if(db.search()==1){
    			hm.put("start", db.getFloat("timein1"));
    			hm.put("end", db.getFloat("timeoud2"));
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return hm;
    }
}