package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.formula.FormulaString;
import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

public class Simmemployee_tadjtime0 extends Memployee {

	private String employeeid="";
	MyHashMap hm_Col = new MyHashMap();
	MyHashMap hm_mevent = new MyHashMap();
	MyHashMap hm_hour_d = new MyHashMap();
	double hr_mtime0 = 0;

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		this.hm_Col.clear();
        MyLog.debug(this, "<<<<<<<<<<<<<<-- Simmemployee_tadjtime0 -->>>>>>>>>>>>>>");
        
		if(!this.getString("employeeid").equals("")){
			if (this.param.isEmpty()) {
				this.employeeid = this.getString("employeeid");
			} else {
				if (this.param.containsKey("__runno")	&& this.param.containsKey("wf_id")) {
		            MyLog.debug(this, "<-----------workflow-------------->");
					try {
						String table = (String) this.param.get("wf_id");
						String runno = (String) this.param.get("__runno");
						if (table.equals("5"))
							table = "TABSENTDATE0";
						else if (table.equals("6"))
							table = "TABSENT_M_DATE";
						DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
						inq.initMyTable(table, "runno=" + runno, "");
						inq.setColumn("employeeid,companyid,runno");
						inq.refresh();
						if (inq.next())
							this.employeeid = inq.getString("employeeid");
					} catch (Exception e) {
						MyLog.error(this, e);

						
					}
				} else {
					if (this.param.get("__employeeid")!=null) {
						this.employeeid = (String) this.param.get("__employeeid");
					} else this.employeeid = this.getString("employeeid");
				}
			} 
			
			this.selectEvent();
			this.sumTime();
		}
		//MyLog.debug(this, "-->hm_Col="+hm_Col);
		//MyLog.debug(this, "-->hm_mevent="+hm_mevent);
		//MyLog.debug(this, "-->hm_hour_d="+hm_hour_d);
		return temp;
	}

	private void selectEvent() {
		try {
			String limit = "";
			FormulaString fs = new FormulaString();
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable("meventgrp","daytype!='1' and daytype !='5' and daytype !='6' and daytype !='9' ","");
			inq.setColumn("eventgrpid,companyid,edesc,tdesc,daytype,limit");
			inq.refresh();
			this.getHour_Day();
			while (inq.next()) {
				if (inq.getString("daytype").equalsIgnoreCase("7")) {
					//MyLog.debug(this, "<------------vacation------------>");
					DbInquiry inqEmp = new InitialInquiry(this.getUProfile()).getDbInquiry();
					inqEmp.initMyTable("memployee", "", "");
					inqEmp.setColumn("employeeid,companyid,vacation0,vacation1,vacationcode");
					inqEmp.setFilter("employeeid='" + this.employeeid + "'");
					inqEmp.refresh();
					int i=0;
					if (inqEmp.next()) {		
						//MyLog.debug(this, " >>>>>>>>>> vacation0="+inqEmp.getString("vacation0"));
						//MyLog.debug(this, " >>>>>>>>>> vacation1="+inqEmp.getString("vacation1"));
						i = fs.DhmToM(inqEmp.getString("vacation0")) + fs.DhmToM(inqEmp.getString("vacation1"));
						limit = fs.MTODhm(i);
					}
				} else {
					limit = inq.getString("limit")+":0:0";
				}
				
				this.hm_Col.put(inq.getString("eventgrpid"), inq.getString("eventgrpid"));
                this.hm_Col.put(inq.getString("eventgrpid") + "1", limit);//limit leave
				this.hm_Col.put(inq.getString("eventgrpid") + "4", inq.getString("edesc"));//desc leave
				this.hm_Col.put(inq.getString("eventgrpid") + "2", "0:0:0");//time leave
				this.hm_Col.put(inq.getString("eventgrpid") + "3", limit);//ans of leave
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void sumTime() {
		try {			
			// ### comment by pae 8-2-2005 ####
			CscCalendar cs = new CscCalendar();
			String DateS = "", DateE = "";
			String pDateStart = "";
			String pDateEnd = "";
			// MyLog.debug(this, "StartDate -->> "+this.param.get("__date_start"));
			// MyLog.debug(this, "EndDate -->> "+this.param.get("__date_end"));
			if (this.param.containsKey("__date_start")
					&& this.param.containsKey("__date_end")) {
				pDateStart = (String) this.param.get("__date_start");
				pDateEnd = (String) this.param.get("__date_end");
				// MyLog.debug(this, "param__date--->" + pDateStart + " <->" + pDateEnd);
				if (!pDateEnd.trim().equals("")) {
					DateE = pDateEnd;
				}
				if (!pDateStart.trim().equals("")) {
					DateS = pDateStart;
				}
				if (pDateStart.trim().equals("") && pDateEnd.trim().equals("")) {
					MyLog.debug(this, "Date from screen is Empty !!!");
					CscCalendar date = new CscCalendar();
					DateS = date.getYear() + "-01-01";
					DateE = date.getYYYYMMDD();
					CscCalendar cs1 = new CscCalendar(DateS);
					CscCalendar cs2 = new CscCalendar(DateE);
					DateS = cs1.getYYYYMMDD();
					DateE = cs2.getYYYYMMDD();
					this.hm_Col.put("DateStart", cs1.getDDMMYYYY());
					this.hm_Col.put("DateEnd", cs2.getDDMMYYYY());
				}
			} else {
				System.out	.println("Date from screen is Empty <param is null> !!!");
				CscCalendar date = new CscCalendar();
				DateS = date.getYear() + "-01-01";
				DateE = date.getYYYYMMDD();
				CscCalendar cs1 = new CscCalendar(DateS);
				CscCalendar cs2 = new CscCalendar(DateE);
				DateS = cs1.getYYYYMMDD();
				DateE = cs2.getYYYYMMDD();
				this.hm_Col.put("DateStart", cs1.getDDMMYYYY());
				this.hm_Col.put("DateEnd", cs2.getDDMMYYYY());
			}

			String sql = "employeeid= '" + this.employeeid + "'";
			if (!DateS.equals("") && !DateE.equals("")) {
				sql = sql + " and (m_dt_bg between'" + DateS + "' and '" + DateE + " ')";
			}
			MyLog.debug(this, "SQL >>>>>>>>>>>>>" + sql);
			CscTime late = new CscTime(0);
			int late_count=0;
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.initMyTable("ttime_current1", "", "");
			inq.setColumn("employeeid,companyid,dateid,doctype,lv_ty,m_lv,tr_type,eventgrp,lt");
			inq.setFilter(sql);
			inq.refresh();
			FormulaString fs = new FormulaString();
			while (inq.next()) {
				int a = 0;
				String d = "", e = "";
				if (inq.getString("eventgrp").equals(this.hm_Col.get(inq.getString("eventgrp")))) {
					double s1 = 0f;
					double h = 0f;
					s1 = inq.getCurrentDbRecord().getDouble("m_lv");
					if (this.hm_Col.containsKey(inq.getString("eventgrp") + "2")) {
						e = this.hm_Col.get(inq.getString("eventgrp") + "2").toString();
						a = fs.DhmToM(e) + fs.Tm_To_Min(s1);
					} else {
						a = fs.Tm_To_Min(s1);
					}
					d = fs.MTODhm(a, this.hr_mtime0);
					this.hm_Col.put(inq.getString("eventgrp") + "2", d);
					this.subTime(inq.getString("eventgrp"));
				}
				
				if (inq.getCurrentDbRecord().getFloat("lt")>0) {
					late_count++;			
					late.add(inq.getCurrentDbRecord().getFloat("lt"));
				}
			}
			this.hm_Col.put("late_count", late_count);			
			this.hm_Col.put("late_time", late.getFloat());
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void subTime(String a) {
		FormulaString fs = new FormulaString();
		String x = this.hm_Col.get(a + "1").toString();
		String y = this.hm_Col.get(a + "2").toString();
		int b = fs.DhmToM(x) - fs.DhmToM(y);
		String z = fs.MTODhm(b,this.hr_mtime0);
		this.hm_Col.put(a + "3", z);
	}

	private void getHour_Day() {
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");			
            this.putChild(inq1);
            this.refreshChild();
			this.hr_mtime0 = Double.valueOf(inq1.getString("hour_d")).doubleValue();
			MyLog.debug(this, "hour_d in mtime0 ------->>>" + this.hr_mtime0);
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	public String getString(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}

	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hm_Col.get(fName) != null) {
				return String.valueOf(this.hm_Col.get(fName));
			}
		}
		return super.getString(fieldName);
	}
}