package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.DataSet;
import com.csc.library.formula.FormulaString;

public class Simttime_currentsum extends Ttime_current {
	MyHashMap hm_data = new MyHashMap();

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		this.hm_data.clear();
		String employeeid;
		employeeid= this.getString("employeeid");     
        if(!this.getString("employeeid").trim().equals("")){
        	this.sumData();
        }
		return temp;
	}

	public void sumData() {
		try {
			FormulaString fs = new FormulaString();
			int lv = 0, lt = 0, ot = 0, hr = 0, sumH = 0;
			double hw = 0, avg = 0,md=0;
			lv = fs.Tm_To_Min(Double.valueOf(this.getString("lv")).doubleValue());
			lt = fs.Tm_To_Min(Double.valueOf(this.getString("lt")).doubleValue());
			ot = fs.Tm_To_Min(Double.valueOf(this.getString("ot")).doubleValue());
			hr = fs.Tm_To_Min(Double.valueOf(this.getString("hour_d")).doubleValue());
			if(hr>0){			
				sumH = hr - lv - lt + ot;
			}			
			hw = Double.valueOf(fs.Min_to_tm(sumH)).doubleValue();
			this.hm_data.put("hw", new Double(hw));
			if(this.getDouble("hour_d")>0){
				md=(double)hw/(double)this.getDouble("hour_d");	
			}
			this.hm_data.put("md", new Double(md));
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public String getString(String field) {
		if (this.hm_data.containsKey(field)) {
			return this.hm_data.get(field).toString();
		} else {
			return super.getString(field);
		}
	}

}