package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.formula.FormulaString;
import com.csc.library.process.CalDocument;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

/*
 * NOT USED 2008/09/15
 */
public class Tabsent_m_date extends RecordCmp {
	
	private AdjustResult result=null;	
	private float hour_s=0;
	private MyTreeMap hmResult = new MyTreeMap();
	private DbInquiry inqEmp = null;
	private DbInquiry inqTime1 = null;
	
	public Tabsent_m_date() {
		super("Tabsent_m_date", "Tabsent_m_date Table");
	}	
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TABSENT_M_DATE");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("absentid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void chkEmpInq() {
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTime1Inq() {
		try {
			if (this.inqTime1 ==null) {
				this.inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime1.setParam(this.param);
				this.inqTime1.setSchemaName(this.userPro.getSchemaName());
				this.inqTime1.initMyTable("Mtime1", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private boolean chkLeaveSameDay() {
        boolean result = false;
        try {
            CscCalendar csc1 = new CscCalendar(this.getString("start_date"));
            CscCalendar csc2 = new CscCalendar(this.getString("end_date"));                 
            
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setParam(this.param);
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("Tadjtime0", "employeeid='"+this.getString("employeeid")+"' and (doctype='S' or doctype='A') and " +
                    "(docdate between '"+csc1.getYYYYMMDD()+"' and '"+csc2.getYYYYMMDD()+"')", "");
            inq.setColumn("*");
            inq.refresh();
            if (inq.next()) {
                return true;
            }
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return result;
    }
		
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
		
	private double getHour_Day(String timeCode) {
		double value = 8;
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "time0id='"+timeCode+"'", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");			
            inq1.refresh();
            if (inq1.next()) {
            	value = inq1.getCurrentDbRecord().getDouble("hour_d");            
			} 
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return value;
	}
	
	private boolean calulateLeaveRemain() {
		boolean result = true;		
		try {
			
			if (this.chkLeaveSameDay()) {
				return false;
			}
			 
			CscCalendar startWorkingDate = null;
			String limit = "";
			int limit_times = 0;
			int service_year = 0;
			double hour_d = 0;
			String lv_type = "";
			FormulaString fs = new FormulaString();
			DbInquiry inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inqEvent.setSchemaName(this.getUProfile().getSchemaName());
			inqEvent.initMyTable("meventgrp","eventgrpid='"+this.getString("type_absent")+"'","");
			inqEvent.setColumn("*");
			inqEvent.refresh();
			if (inqEvent.next()) {
				DbRecord rec = inqEvent.getCurrentDbRecord();

				this.chkEmpInq();				
				this.inqEmp.setColumn("employeeid,companyid,vacation0,vacation1,time0,startdate,resigndate");
				this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
				this.inqEmp.refresh();
				if (this.inqEmp.next()) {				
					hour_d = this.getHour_Day(this.inqEmp.getCurrentDbRecord().getString("time0"));
					if (rec.getString("daytype").equalsIgnoreCase("7")) {
						try {
							int i = fs.DhmToM(this.inqEmp.getString("vacation0"), hour_d) + fs.DhmToM(this.inqEmp.getString("vacation1"), hour_d);
							limit = fs.MTODhm(i, hour_d);
						} catch (Exception e) {
							MyLog.error(this, e);

							limit = "00:00:00";
						}
					} else limit = rec.getString("limit")+":00:00";
					startWorkingDate = new CscCalendar(this.inqEmp.getString("startdate"));
					
				} else limit = rec.getString("limit")+":00:00";
								
				limit_times = rec.getInt("limit_times");
				service_year = rec.getInt("service_year");
			}			
							
			int used = 0;
			CscTime ct= new CscTime();
			
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1001"));
			CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1002"));
			CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1003"));
			CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1004"));
			
			String filter = "";
			if (lv_type.equals("7")) {
				filter = "employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+cscVacationStart.getYYYYMMDD()+"' " +
					"and '"+cscVacationEnd.getYYYYMMDD()+"') and lv_type='"+this.getString("type_absent")+"'";
			} else {
				filter = "employeeid='"+this.getString("employeeid")+"' and " +
				"(dateid between '"+cscLeaveStart.getYYYYMMDD()+"' " +
				"and '"+cscLeaveEnd.getYYYYMMDD()+"') and lv_type='"+this.getString("type_absent")+"'";
			}
			
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable("tleave_summary",filter,"");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				ct.add(inq.getCurrentDbRecord().getFloat("m_lv"));
				used++;
			}			
			
			//For this leave
			/*CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
			CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
			int day_lv = cs2.subForDay(cs1)+1;*/
			int day_lv = this.getDayLeave();
			
			if (day_lv==-1) {
				return false; //No WorkingShift
			}
			
			CscCalendar csc = new CscCalendar(this.getString("start_date"));
			
			if (csc.subForDay(startWorkingDate) < service_year) {
				return false;
			} else if (((ct.getFloat()*60)+(day_lv*hour_d*60))>fs.DhmToM(limit)) {
				return false; 
			} else if (limit_times>0 && limit_times<used) {
				return false;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
		return result;
	}
	
	private int getDayLeave() {
		int day_leave = 0;		
		AdjustResult adj = null;
		Vector vAdjust = new Vector();
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"	+ this.getString("employeeid") + "'");
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				
				rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
								+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
				WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()), this.getDayType());				
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					//ws.adjustLeave();
					ws.adjust();
					ws.overlapChecking();
					ws.createLink();
					
					//WorkingShift for check is Null;
					WorkingShift wsCheck = (WorkingShift) ws.clone();
					Shift shCheck=null;
					CscCalendar cscStart=new CscCalendar(this.getString("start_date"));
					CscCalendar cscEnd=new CscCalendar(this.getString("end_date"));					
					while (cscEnd.afterEquals(cscStart)) {
						shCheck = null;
						Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
						if (itDS.hasNext()) {
							DayShift dsCheck = (DayShift) wsCheck.get(cscStart.getYYYYMMDD());
							if (!dsCheck.isEmpty()) {
								Iterator itSH = (Iterator) dsCheck.keySet().iterator();
								if (itSH.hasNext()) {
									shCheck = (Shift) dsCheck.get((String) itSH.next());
								}
							}
						}					
						
						try {
							if (shCheck!=null) {
								vAdjust = ws.genSubShiftTrans(this.getDocTimeZone(shCheck));
								MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
								Iterator it = vAdjust.iterator();			
								while (it.hasNext()) {
									//AdjustResult result = (AdjustResult) it.next();
									adj = (AdjustResult) it.next();	
									MyLog.debug(this, adj.toString());
									if (adj.getType().equalsIgnoreCase("A")) {
										//hour_leave += this.getHourDAdjust(adj.getTimeCode(), adj.get_DT_BG().getYYYYMMDD());
										day_leave++;
									}								
								}
							}
						} catch (Exception e1) {
							MyLog.error(this, e1);							
						}						
						cscStart.incDate();						
					}
				} else return -1;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		return day_leave;
	}
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();
		this.hmResult.clear();
		String flag = "0";
		try {
			 flag = (String) StaticConfig.getConfigCompany(this.userPro, "ta1006");
		} catch (Exception e) {
			MyLog.error(this, e);				
		}
			
		try {
			//ԹԷ return false ͡
			//if (this.getString("wf_status").equals("6") && !this.calulateLeaveRemain()) {
			if (flag.equals("1")) {
				if (!this.calulateLeaveRemain()) {
					this.param.put("error_msg",	"Error You Not Have Remain For Leave");
					MyLog.debug(this, "NOT REQUEST LEAVE !!!");
					this.saveStatus = 99;
					return false;
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);				
		}
			
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
			
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
			
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.setWFOff();
		}
			
	    if (!this.getString("wf_status").equalsIgnoreCase("9")) {
	        this.preProcessWf();
	    }
	    
	    this.genRecord(false);
		if (this.hmResult.isEmpty()) {
			this.param.put("error_msg",	"No Data For This Request Absent");
			MyLog.error(this, "No Data For This Request Absent");
			return false; //ӡâͷբ㹡â
		}
	    return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		this.hmResult.clear();
		/*String flag = "0";
		try {
			 flag = (String) StaticConfig.getConfigCompany(this.userPro, "ta1006");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		//if (this.getString("wf_status").equals("6") && !this.calulateLeaveRemain()) {
		if (flag.equals("1")) {
			if (!this.calulateLeaveRemain()) {
				this.param.put("error_msg",	"Error You Not Have Remain For Leave");
				MyLog.debug(this, "NOT REQUEST LEAVE !!!");
				this.saveStatus = 99;
				return false;
			}
		}*/
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
            
            /*this.genRecord(false);
    		if (this.hmResult.isEmpty()) {
    			this.param.put("error_msg",	"No Data For This Request Absent");
    			MyLog.error(this, "No Data For This Request Absent");
    			return false; //ӡâͷբ㹡â
    		}*/          
        }
		
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			//this.saveHashMapData("TADJTIME0", this.hmResult);
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8")||this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
				this.getString("wf_status").equalsIgnoreCase("7") || 
				this.getString("wf_status").equalsIgnoreCase("B")) {			
			this.setColumn(this.getListKey()+",wf_status");
		}		
		
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		return result;
	}
	
	public void genAdjustTime() {
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8")) {
			this.delDataAdjTime0();
		}
	}
	
	public Mtime0 getTimeRecord(String id, UProfile up) {			
		Mtime0 rec = null;
		try {
			DbInquiry inq = new InitialInquiry(up).getDbInquiry();
			inq.setSchemaName(up.getSchemaName());
			inq.initMyTable("Mtime0", "time0id='" + id + "'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				rec = (Mtime0) inq.getCurrentDbRecord();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
		return rec;
	}

	protected void postInsertTrigger() throws Exception {
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();
				
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.saveHashMapData("TADJTIME0", this.hmResult);
			//this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}		
	}

	protected void postUpdateTrigger() throws Exception {
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			//this.saveHashMapData("TADJTIME0", this.hmResult);
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8")||this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}
	
	protected boolean preDeleteTrigger() throws Exception {		
		boolean result = super.preDeleteTrigger();
		this.delDataAdjTime0();
		return result;
	}
	
	/*protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}*/

	private void delDataAdjTime0() {
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", "docid='"+this.getString("absentid")+"' and doctype='S'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public MyTreeMap getDWRData() {
		return this.genRecord(false);
	}

	private MyTreeMap genRecord(boolean isSave) {
		MyTreeMap hm = new MyTreeMap();
		int count = 1;
		Vector vAdjust = new Vector();
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"	+ this.getString("employeeid") + "'");
			this.inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				
				rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
								+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
				WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()), this.getDayType());				
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					ws.adjustLeave();
					//ws.adjust();
					ws.overlapChecking();
					ws.createLink();
					
					//WorkingShift for check is Null;
					WorkingShift wsCheck = (WorkingShift) ws.clone();
					Shift shCheck=null;
					CscCalendar cscStart=new CscCalendar(this.getString("start_date"));
					CscCalendar cscEnd=new CscCalendar(this.getString("end_date"));					
					while (cscEnd.afterEquals(cscStart)) {
						Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
						if (itDS.hasNext()) {
							shCheck = null;
							DayShift dsCheck = (DayShift) wsCheck.get(cscStart.getYYYYMMDD());
							if (!dsCheck.isEmpty()) {
								Iterator itSH = (Iterator) dsCheck.keySet().iterator();
								shCheck = null;
								while (itSH.hasNext()) {
									shCheck = null;
									shCheck = (Shift) dsCheck.get((String) itSH.next());
									if (shCheck!=null && shCheck.getTR_Type().indexOf("T")>-1) {
										break;
									}
								}
							}
						}					
						
						try {
							//if (shCheck!=null && shCheck.getTR_Type().indexOf("A")==-1) {
							DbRecord recADJ = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
							recADJ.setColumn("*");
							
							if (shCheck!=null) {
								vAdjust = ws.genSubShiftTrans(this.getDocTimeZone(shCheck));
								MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
								Iterator it = vAdjust.iterator();			
								while (it.hasNext()) {
									//AdjustResult result = (AdjustResult) it.next();
									result = (AdjustResult) it.next();	
									
									if (!result.getEventGroup().substring(0,1).equalsIgnoreCase("O")) {
										MyLog.debug(this, result.toString());
										if (isSave) {
											recADJ.clearField();
											recADJ.set("COMPANYID", this.getString("companyid"));
											recADJ.set("DOCID", this.getString("absentid"));
											recADJ.set("DOCTYPE", "S");
											recADJ.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
											recADJ.set("TM_BG", result.get_DT_BG().getCSCTime());
											recADJ.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
											recADJ.set("TM_EN", result.get_DT_EN().getCSCTime());
											recADJ.set("UPDTYPE", result.getType());
											recADJ.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
											recADJ.set("EMPLOYEEID", this.getString("employeeid"));
											recADJ.set("TIME0ID", result.getTimeCode());
											recADJ.set("EVENTGRP", this.getString("type_absent"));
											recADJ.set("OLDTIME0ID", "");
											recADJ.set("OLDEVENTGRP", "");
											recADJ.set("LV_TY", this.getString("type_absent"));
											recADJ.set("LV", this.getHourDAdjust(result.getTimeCode(), recADJ.getString("DT_BG")));
											//recADJ.set("LV", result.get_LV());
											recADJ.set("TR_TYPE", result.getEventGroup());
											recADJ.set("STATUS", this.getString("status"));
											recADJ.set("PRIORITY", "1");
											recADJ.set("HOUR_S", this.hour_s);
											recADJ.set("OT_WORKAREA", result.getWorkarea());
											recADJ.save();
										} else {
											if (result.getType().equalsIgnoreCase("A")) {
												MyHashMap hmData = new MyHashMap();
												hmData.put("DOCID", this.getString("absentid"));
												hmData.put("DOCTYPE", "S");
												hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
												hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
												hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
												hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
												hmData.put("UPDTYPE", result.getType());
												hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
												hmData.put("EMPLOYEEID", this.getString("employeeid"));
												hmData.put("TIME0ID", result.getTimeCode());
												hmData.put("EVENTGRP", this.getString("type_absent"));
												hmData.put("OLDTIME0ID", "");
												hmData.put("OLDEVENTGRP", "");
												hmData.put("LV_TY", this.getString("type_absent"));
												hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), result.get_DT_BG().getYYYYMMDD()));
												hmData.put("TR_TYPE", result.getEventGroup());
												hmData.put("STATUS", this.getString("status"));
												hmData.put("PRIORITY", "1");
												hmData.put("HOUR_S", this.hour_s);
												hmData.put("OT_WORKAREA", result.getWorkarea());
												hm.put(String.valueOf(count),hmData);
												this.hmResult.put(String.valueOf(count),hmData);
												count++;
											}
										}
									}
								}
							}
						} catch (Exception e1) {
							MyLog.error(this, e1);							
						}						
						cscStart.incDate();						
					}
					//vAdjust = ws.genSubShiftTrans(this.getDocTimeZone());
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return hm;
	}
		
	private float getHourDAdjust(String timeCode, String date) {
		float hour = 0; 
		try {			
			CscCalendar cs = new CscCalendar(date);
			this.chkTime1Inq();
			this.inqTime1.setFilter("time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'");
			this.inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
			this.inqTime1.refresh();
			if (this.inqTime1.next()) {
				DbRecord rec = this.inqTime1.getCurrentDbRecord();	
				hour = rec.getFloat("hour_d");
				this.hour_s = rec.getFloat("hour_d");
			}			
 		} catch (Exception e) {
			MyLog.error(this, e);			
		} 		
		return hour;
	}
	
	private TimeZone getDocTimeZone(Shift shCheck) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(shCheck.get_c_dt_in().getYYYYMMDD());
		CscCalendar cs2 = new CscCalendar(shCheck.get_c_dt_out().getYYYYMMDD());		
		try {
			cs1.setCSCTime(shCheck.get_c_dt_in().getCSCTime());
			cs2.setCSCTime(shCheck.get_c_dt_out().getCSCTime());
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
		return tz;
	}

	// Day Type 繡ҷѺ - 
	private String getDayType() {
		String result="";
		try {			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Meventgrp", "EVENTGRPID='"+this.getString("TYPE_ABSENT")+"'", "");
			inq.setColumn("eventgrpid, companyid, daytype");
			inq.refresh();
			while (inq.next()) {
				result = inq.getCurrentDbRecord().getString("daytype");
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);						
		}
		return result;
	}	

}