package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;

/*
 * NOT USED 2008/09/15
 */
public class Tabsentdate0 extends RecordCmp {
	
	private DbTable dbChild=null;
	private float hour_s = 0;
	private MyTreeMap hmResult = new MyTreeMap();
	private DbInquiry inqEmp = null;
	private DbInquiry inqTabsent1 = null;	
	private DbTable dbTabsent1 = null; 
	
	public Tabsentdate0() {
		super("Tabsentdate0", "Tabsentdate0 Table");
	}	
	
	private void chkEmpInq() {
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTabsent1Inq() {
		try {
			if (this.inqTabsent1 ==null) {
				this.inqTabsent1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTabsent1.setParam(this.param);
				this.inqTabsent1.setSchemaName(this.userPro.getSchemaName());
				this.inqTabsent1.initMyTable("Tabsentdate1", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTabsent1Db() {
		try {
			if (this.dbTabsent1 == null) {
				this.dbTabsent1 = new InitialTable(this.userPro).getDbTable("Tabsentdate1");
				this.dbTabsent1.setColumn("*");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}	
	}
	
	private String calulateLeaveRemain() {
		String result = "";		
		
		MyHashMap hm = this.getHourLeave();		
		if (hm==null) {
			return "0"; //No WorkingShift
		}
		
		Iterator it = hm.keySet().iterator();
		while (it.hasNext()) {
			String lv_type = (String) it.next();
			float lv = Float.parseFloat((String) hm.get(lv_type));
			
			/*if (lv<2.00) {
				return "2";
			}*/
			
			try {
				String limit = "";
				int limit_times = 0;
				int service_year = 0;
				double hour_d = 0;
				CscCalendar startWorkingDate = null;
				FormulaString fs = new FormulaString();
				DbInquiry inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
				inqEvent.setSchemaName(this.getUProfile().getSchemaName());
				inqEvent.initMyTable("meventgrp","eventgrpid='"+lv_type+"'","");
				inqEvent.setColumn("*");
				inqEvent.refresh();
				while (inqEvent.next()) {
					DbRecord rec = inqEvent.getCurrentDbRecord();
					
					this.chkEmpInq();
					this.inqEmp.setColumn("employeeid,companyid,vacation0,vacation1,time0, startdate, resigndate");
					this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
					this.inqEmp.refresh();
					if (this.inqEmp.next()) {				
						hour_d = this.getHour_Day(this.inqEmp.getCurrentDbRecord().getString("time0"));
						if (rec.getString("daytype").equalsIgnoreCase("7")) {
							try {
								int i = fs.DhmToM(this.inqEmp.getString("vacation0"), hour_d) + fs.DhmToM(this.inqEmp.getString("vacation1"), hour_d);
								limit = fs.MTODhm(i, hour_d);
							} catch (Exception e) {
								MyLog.error(this, e);

								limit = "00:00:00";
							}
						} else limit = rec.getString("limit")+":00:00";
						
						startWorkingDate = new CscCalendar(this.inqEmp.getString("startdate"));
					} else limit = rec.getString("limit")+":00:00";		 	
					limit_times = rec.getInt("limit_times");
					service_year = rec.getInt("service_year");
				}
				
				int used = 0;
				CscTime ct= new CscTime();
				
				/*CscCalendar cscLeaveStart = new CscCalendar("01-01-2007");
				CscCalendar cscLeaveEnd = new CscCalendar("31-12-2007");
				CscCalendar cscVacationStart = new CscCalendar("01-01-2007");
				CscCalendar cscVacationEnd = new CscCalendar("31-12-2007");*/
				
				CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1001"));
				CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1002"));
				CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1003"));
				CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro, "ta1004"));
				
				String filter = "";
				if (lv_type.equals("7")) {
					filter = "employeeid='"+this.getString("employeeid")+"' and " +
						"(dateid between '"+cscVacationStart.getYYYYMMDD()+"' " +
						"and '"+cscVacationEnd.getYYYYMMDD()+"') and lv_type='"+lv_type+"'";
				} else {
					filter = "employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+cscLeaveStart.getYYYYMMDD()+"' " +
					"and '"+cscLeaveEnd.getYYYYMMDD()+"') and lv_type='"+lv_type+"'";
				}
				
				DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
				inq.setSchemaName(this.getUProfile().getSchemaName());
				inq.initMyTable("tleave_summary",filter,"");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					ct.add(inq.getCurrentDbRecord().getFloat("m_lv"));
					used++;
				}
				
				
				//For this leave
				/*CscCalendar cs1 = new CscCalendar(lv_date);
				cs1.setCSCTime(startTime);
				CscCalendar cs2 = new CscCalendar(lv_date);
				cs2.setCSCTime(endTime);
				float day_lv = cs2.subForHour(cs1);*/
				
				CscCalendar csc = new CscCalendar(this.getString("absent_date"));
				
				if (csc.subForDay(startWorkingDate) < service_year) {
					return "3";
				} else if (((ct.getFloat()*60)+(lv*60))>fs.DhmToM(limit)) {
					return "1";
				} else if (limit_times>0 && limit_times<used) {
					return "1";
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			} 			
		}	
		
		return result;
	}
	
	private MyHashMap getHourLeave() {
		MyHashMap hm = new MyHashMap();
		Vector vAdjust = new Vector();
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", this.inqEmp.getString("time0"));
				recTime.set("companyid", this.userPro.get("companyid"));
				recTime.search();

				CscCalendar cs1 = new CscCalendar(this.getString("absent_date"));
				cs1.decDate(2);
				CscCalendar cs2 = new CscCalendar(this.getString("absent_date"));
				cs2.incDate(2);
				
				recTime.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()),"true");
												
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					ws.adjust();
					//ws.adjustLeave();
					
					//WorkingShift for check is Null;
					WorkingShift wsCheck = (WorkingShift) ws.clone();

					DbTable dt;					
					if (this.getChild("Tabsentdate1")!=null) {
						dt = (DbTable) this.getChild("Tabsentdate1");			
					} else {
						this.chkTabsent1Db();
						this.putChild(this.dbTabsent1);
						this.refreshChild("Tabsentdate1");
						dt = (DbTable) this.getChild("Tabsentdate1");
					}
					dt.first();
					while (!dt.eof()) {
						ws.overlapChecking();
						ws.createLink();
						
						//Check Shift is Null;
						Shift shCheck=null;
						CscCalendar csc=new CscCalendar(this.getString("absent_date"));
						Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
						if (itDS.hasNext()) {
							DayShift dsCheck = (DayShift) wsCheck.get(csc.getYYYYMMDD());
							if (!dsCheck.isEmpty()) {
								Iterator itSH = (Iterator) dsCheck.keySet().iterator();
								if (itSH.hasNext()) {
									shCheck = (Shift) dsCheck.get((String) itSH.next());									
								}
							}
						}												
						
						Vector vt = new Vector();
						if (shCheck!=null) {
							vt = ws.genSubShiftTrans(this.getDocTimeZone(shCheck, dt.getFloat("start_time"), dt.getFloat("end_time")));
						} 
						
						Iterator it = vt.iterator();						
						while (it.hasNext()) {
							AdjustResult result = (AdjustResult) it.next();
							MyLog.debug(this, result.toString());
							vAdjust.add(result);
							ws.adjust(result);
							
							if (result.getType().equalsIgnoreCase("A")) {
								float lv = this.getHourDAdjust(result.getTimeCode(), 
										result.get_DT_BG().getYYYYMMDD(), result.get_DT_EN().getYYYYMMDD(),
										result.get_DT_BG().getCSCTime(), result.get_DT_EN().getCSCTime());
								if (hm.containsKey(dt.getString("type_absent"))) {
									CscTime ct = new CscTime(Float.parseFloat(hm.getString(dt.getString("type_absent"))));
									ct.add(lv);
									hm.put(dt.getString("type_absent"), String.valueOf(lv));
								} else {
									hm.put(dt.getString("type_absent"), String.valueOf(lv));
								}									
							}
						}
						dt.next();						
					}
				} else return null;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
	
	private double getHour_Day(String timeCode) {
		double value = 8;
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "time0id='"+timeCode+"'", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");			
            inq1.refresh();
            if (inq1.next()) {
            	value = inq1.getCurrentDbRecord().getDouble("hour_d");            
			} 
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return value;
	}
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TABSENTDATE0");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("absentid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();
		this.hmResult.clear();
		String flag = "0";
		try {
			 flag = (String) StaticConfig.getConfigCompany(this.userPro, "ta1006");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		try {
			//if (this.getString("wf_status").equals("6") && b==false) {
			//flag="1";
			/*if (chkLeaveSameDay()) {
				this.param.put("error_msg",	this.getError("1"));
				MyLog.debug(this, "NOT REQUEST LEAVE !!!");
				this.saveStatus = 99;
				return false;
			}*/
			
			if (flag.equals("1")) {
				String error_type=this.calulateLeaveRemain();
				if (!error_type.equals("")) {
					this.param.put("error_msg",	this.getError(error_type));
					MyLog.debug(this, "NOT REQUEST LEAVE !!!");
					this.saveStatus = 99;
					return false;			
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		
		this.updateWFChild(this.getString("wf_status"));
		
		this.genRecord(false);
		if (this.hmResult.isEmpty()) {
			this.param.put("error_msg",	"No Data For This Request Absent");
			MyLog.error(this, "No Data For This Request Absent");
			return false; //ӡâͷբ㹡â
		}
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		this.hmResult.clear();
		String flag = "0";
		try {
			 flag = (String) StaticConfig.getConfigCompany(this.userPro, "ta1006");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		try {
			//flag="1";
			if (flag.equals("1")) {
				String error_type=this.calulateLeaveRemain();
				if (!error_type.equals("")) {
					this.param.put("error_msg",	this.getError(error_type));
					MyLog.debug(this, "NOT REQUEST LEAVE !!!");
					this.saveStatus = 99;
					return false;			
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
            /*this.genRecord(false);
    		if (this.hmResult.isEmpty()) {
    			MyLog.error(this, "No Data For This Request Absent");
    			return false; //ӡâͷբ㹡â
    		}*/
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }	
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
				this.getString("wf_status").equalsIgnoreCase("7") || 
				this.getString("wf_status").equalsIgnoreCase("B")) {		
			this.setColumn(this.getListKey()+",wf_status");
			dbChild = (DbTable) this.getChild("Tabsentdate1");
			this.removeChild("Tabsentdate1");
		}		
		
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	protected void postInsertTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.saveHashMapData("TADJTIME0", this.hmResult);
			//this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
		
	}

	protected void postUpdateTrigger() throws Exception {	
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}		
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			//this.saveHashMapData("TADJTIME0", this.hmResult);
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8")||this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
		
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}
	
	private void updateWFChild(String wf) {
		try {
			if (this.dbChild != null) {
				this.putChild(this.dbChild);
			}
			if (this.getChild("Tabsentdate1")!=null) {
				DbTable db = (DbTable) this.getChild("Tabsentdate1");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					db.next();				
				} while (!db.eof());		
				//db.save();
			} else {			
				this.chkTabsent1Inq();
				this.inqTabsent1.setColumn("ABSENTID, COMPANYID, LINE_NO, WF_STATUS");			
				this.putChild(this.inqTabsent1);
				this.refreshChild("Tabsentdate1");
				DbInquiry child = (DbInquiry) this.getChild("Tabsentdate1");				
				do{	
					DbRecord rec = child.getCurrentDbRecord().cloneRecord(true);
					rec.set("wf_status",wf);
					rec.save();
				} while (child.next());	
				this.removeChild("Tabsentdate1");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private void delDataAdjTime0() {
		try {
			CscCalendar cs = new CscCalendar(this.getString("absent_date"));

			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0","docid='"+this.getString("absentid")+"' and doctype='A'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private TimeZone getDocTimeZone(Shift shCheck, float startTime, float endTime) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(this.getString("absent_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("absent_date"));
		/*if (cs1.subForDay(shCheck.get_c_dt_in())!=0 && startTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs1.incDate();
		}*/
		/*if (cs2.subForDay(shCheck.get_c_dt_in())!=0 && endTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs2.incDate();
		}*/
		if (startTime!=0.0 && cs1.subForDay(shCheck.get_c_dt_in())!=0 && startTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs1.incDate();
		}
		
		if (startTime!=0.0 && cs1.subForDay(shCheck.get_c_dt_in())!=0 && endTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs2.incDate();
		} else if (endTime!=0.0 && endTime < startTime) {
			cs2.incDate();
		}
		
		
		if (startTime!=0.0 && endTime==0.0) {
			cs2.incDate();
		}
		
		try {
			cs1.setCSCTime(startTime);
			cs2.setCSCTime(endTime);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
		return tz;
	}

	public MyTreeMap getDWRData() {
		return this.genRecord(false);
	}
	
	private MyTreeMap genRecord(boolean isSave) {
		MyTreeMap hm = new MyTreeMap();
		int count = 1, line = 1;;
		Vector vAdjust = new Vector();
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", inqEmp.getString("time0"));
				recTime.set("companyid", this.userPro.get("companyid"));
				recTime.search();

				CscCalendar cs1 = new CscCalendar(this.getString("absent_date"));
				cs1.decDate(2);
				CscCalendar cs2 = new CscCalendar(this.getString("absent_date"));
				cs2.incDate(2);
				
				recTime.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()));						
				
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					//ws.adjust();
					ws.adjustLeave();
					
					//WorkingShift for check is Null;
					WorkingShift wsCheck = (WorkingShift) ws.clone();

					DbTable dt;					
					if (this.getChild("Tabsentdate1")!=null) {
						dt = (DbTable) this.getChild("Tabsentdate1");			
					} else {
						this.chkTabsent1Db();
						this.putChild(this.dbTabsent1);
						this.refreshChild("Tabsentdate1");
						dt = (DbTable) this.getChild("Tabsentdate1");
					}
					dt.first();
					while (!dt.eof()) {
						ws.overlapChecking();
						ws.createLink();
						
						//Check Shift is Null;
						Shift shCheck=null;
						CscCalendar csc=new CscCalendar(this.getString("absent_date"));
						if (dt.getFloat("start_time")==0) {
							csc.decDate();
						}
						Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
						if (itDS.hasNext()) {
							shCheck = null;
							DayShift dsCheck = (DayShift) wsCheck.get(csc.getYYYYMMDD());
							if (!dsCheck.isEmpty()) {
								Iterator itSH = (Iterator) dsCheck.keySet().iterator();
								shCheck = null;
								while (itSH.hasNext()) {
									shCheck = null;
									shCheck = (Shift) dsCheck.get((String) itSH.next());
									if (shCheck!=null && shCheck.getTR_Type().indexOf("T")>-1) {
										break;
									}
								}
							}
						}
						
						Vector vt = new Vector();
						if (shCheck!=null) {
							vt = ws.genSubShiftTrans(this.getDocTimeZone(shCheck, dt.getFloat("start_time"), dt.getFloat("end_time")));
						}
						
						Iterator it = vt.iterator();						
						while (it.hasNext()) {
							AdjustResult result = (AdjustResult) it.next();
							MyLog.debug(this, result.toString());
							vAdjust.add(result);
							ws.adjust(result);
							
							if (!result.getEventGroup().substring(0,1).equalsIgnoreCase("O")) {
								if (isSave) {
									DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
									rec.setColumn("*");
									rec.set("COMPANYID", this.getString("companyid"));
									rec.set("DOCID", this.getString("absentid"));
									rec.set("DOCTYPE", "A");
									rec.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
									rec.set("TM_BG", result.get_DT_BG().getCSCTime());
									rec.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
									rec.set("TM_EN", result.get_DT_EN().getCSCTime());
									rec.set("UPDTYPE", result.getType());
									rec.set("DOCDATE", result.getAdjDate()	.getYYYYMMDD());
									//rec.set("DOCDATE", result.get_DT_BG()	.getYYYYMMDD());
									rec.set("EMPLOYEEID", this.getString("employeeid"));
									rec.set("TIME0ID", result.getTimeCode());
									if (result.getType().equalsIgnoreCase("A")) {
										rec.set("EVENTGRP", dt.getString("type_absent"));
									} else rec.set("EVENTGRP", "T");
									rec.set("OLDTIME0ID", "");
									rec.set("OLDEVENTGRP", "");
									rec.set("LV_TY", dt.getString("type_absent"));
									rec.set("LV", this.getHourDAdjust(result.getTimeCode(), 
											result.get_DT_BG().getYYYYMMDD(), result.get_DT_EN().getYYYYMMDD(),
											result.get_DT_BG().getCSCTime(), result.get_DT_EN().getCSCTime()));
									rec.set("TR_TYPE", result.getEventGroup());
									rec.set("PRIORITY", "1");	
									rec.set("hour_s", this.hour_s);
									rec.save();
								} else {									
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID", this.getString("companyid"));
									hmData.put("DOCID", this.getString("absentid"));
									hmData.put("DOCTYPE", "A");
									hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
									hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
									hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
									hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
									hmData.put("UPDTYPE", result.getType());
									hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
									//hmData.put("DOCDATE", result.get_DT_BG()	.getYYYYMMDD());
									hmData.put("EMPLOYEEID", this.getString("employeeid"));
									hmData.put("TIME0ID", result.getTimeCode());
									if (result.getType().equalsIgnoreCase("A")) {
										hmData.put("EVENTGRP", dt.getString("type_absent"));
									} else hmData.put("EVENTGRP", "T");
									hmData.put("OLDTIME0ID", "");
									hmData.put("OLDEVENTGRP", "");
									hmData.put("LV_TY", dt.getString("type_absent"));
									hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
											result.get_DT_BG().getYYYYMMDD(), result.get_DT_EN().getYYYYMMDD(),
											result.get_DT_BG().getCSCTime(), result.get_DT_EN().getCSCTime()));
									hmData.put("TR_TYPE", result.getEventGroup());
									hmData.put("PRIORITY", "1");	
									hmData.put("hour_s", this.hour_s);
									if (result.getType().equalsIgnoreCase("A")) {
										hm.put(String.valueOf(count), hmData);
										count++;
									}
									this.hmResult.put(String.valueOf(line), hmData);
									line++;
								}
							}
						}
						dt.next();
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}		
	
	private boolean chkLeaveSameDay() {
        boolean result = false;
        try {
        	DbTable dt;					
			if (this.getChild("Tabsentdate1")!=null) {
				dt = (DbTable) this.getChild("Tabsentdate1");			
			} else {
				this.chkTabsent1Db();
				this.putChild(this.dbTabsent1);
				this.refreshChild("Tabsentdate1");
				dt = (DbTable) this.getChild("Tabsentdate1");
			}
			dt.first();
			while (!dt.eof()) {
				CscCalendar csc = new CscCalendar(this.getString("absent_date"));            
	            
	            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
	            inq.setParam(this.param);
	            inq.setSchemaName(this.userPro.getSchemaName());
	            inq.initMyTable("Tadjtime0", "employeeid='"+this.getString("employeeid")+"' and doctype='A' and " +
	                    "(docdate = '"+csc.getYYYYMMDD()+"') and (tm_bg>="+dt.getFloat("start_time") +" and tm_en<="+dt.getFloat("end_time")+")", "");
	            inq.setColumn("*");
	            inq.refresh();
	            if (inq.next()) {
	                return true;
	            }
	            dt.next();
			}            
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return result;
    }
	
	private float getHourDAdjust(String timeCode, String date1, String date2, float time1, float time2) {
		float hour = 0; 
		try {			
			float break_hour = 0;
			CscCalendar cs1=null, cs2=null;
			CscCalendar cs = new CscCalendar(date1);
			String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
			DbInquiry inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
			inqTime1.setParam(this.param);
			inqTime1.setSchemaName(this.userPro.getSchemaName());
			inqTime1.initMyTable("Mtime1", filter, "");
			inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
			inqTime1.refresh();
			if (inqTime1.next()) {
				DbRecord rec = inqTime1.getCurrentDbRecord();
				
				this.hour_s = rec.getFloat("hour_d");
				
				//Break Hour
				cs1 = new CscCalendar(date1);
				cs1.setCSCTime(rec.getFloat("timeout1"));
				cs2 = new CscCalendar(date2);
				cs2.setCSCTime(rec.getFloat("timein2"));
				if (rec.getFloat("timein2") < rec.getFloat("timeout1")) {
					cs2.incDate();
				}
				//MyLog.debug(this, ">>> BREAK HOUR >>> cs1="+cs1.getTimestamp()+" >>> cs2="+cs2.getTimestamp());
				break_hour = cs2.subForHour(cs1);
				//Working Hour
				CscCalendar cs3 = new CscCalendar(date1);
				cs3.setCSCTime(rec.getFloat("timein1"));
				CscCalendar cs4 = new CscCalendar(date2);
				cs4.setCSCTime(rec.getFloat("timeout2"));
				if (rec.getFloat("timeout2") < rec.getFloat("timein1")) {
					cs4.incDate();
				}
				//MyLog.debug(this, ">>> WORKING HOUR >>> cs3="+cs3.getTimestamp()+" >>> cs4="+cs4.getTimestamp());
				//MyLog.debug(this, ">>> WORKING >>> "+cs4.subForHour(cs3));
				//MyLog.debug(this, ">>> BREAK >>> "+break_hour);
				//hour = cs4.subForHour(cs3) - break_hour;				
				CscTime c = new CscTime(cs4.subForHour(cs3));
				c.sub(break_hour);
				hour = c.getFloat();				
			}
			
			CscCalendar c_dt_in = new CscCalendar(date1);
			c_dt_in.setCSCTime(time1);
			CscCalendar c_dt_out = new CscCalendar(date2);
			c_dt_out.setCSCTime(time2);
			float hourCom = c_dt_out.subForHour(c_dt_in);
			
			if (cs1!=null&&cs2!=null) {
				if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
					CscTime c = new CscTime(hourCom);
					c.sub(break_hour);
					hourCom = c.getFloat();
				}
			}		
			
			if (hourCom<hour) {
				hour=hourCom;
			}
			
 		} catch (Exception e) {
			MyLog.error(this, e);
		} 		
		return hour;
	}

	//	 Day Type 繡ҷѺ - 
	private String getDayType() {
		String result="";
		try {			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Meventgrp", "EVENTGRPID='"+this.getString("TYPE_ABSENT")+"'", "");
			inq.setColumn("eventgrpid, companyid, day_type");
			inq.refresh();
			while (inq.next()) {
				result = inq.getCurrentDbRecord().getString("day_type");
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);						
		}
		return result;
	}
	
	private String getError(String type) {
		String error = "";
		if (type.equals("0")) {
			error = "Error!!! Please set shift too...";
		} else if (type.equals("1")) {
			error = "Error!!! You not have remain for this leave...";
		} else if (type.equals("2")) {
			error = "Error!!! Please request leave is more 2 hours...";
		} else if (type.equals("3")) {
			error = "Error!!! You not have service year to request this leave...";
		}
		return error;
	}
}