package com.csc.library.databean;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;


public class Tchholiday0 extends RecordCmp{

    private DbInquiry inqEmp = null;
    private MyTreeMap hmResult_Add = new MyTreeMap();
    private MyTreeMap hmResult_Sub = new MyTreeMap();
    private DbTable dbHoliday1 = null;
    private CscCalendar date1 = new CscCalendar();
    private CscCalendar date2 = new CscCalendar();
    private String empid = "";
    
    public CscCalendar getDate1() {
        return date1;
    }

    public void setDate1(CscCalendar date1) {
        this.date1 = date1;
    }

    public CscCalendar getDate2() {
        return date2;
    }

    public void setDate2(CscCalendar date2) {
        this.date2 = date2;
    }

    public String getEmpid() {
        return empid;
    }

    public void setEmpid(String empid) {
        this.empid = empid;
    }

    public Tchholiday0() {
        super("Tchholiday0","Tchholiday0 Table");
    }

    private void chkEmpInq() {
        try {
            if (this.inqEmp ==null) {
                this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
                this.inqEmp.setParam(this.param);
                this.inqEmp.setSchemaName(this.userPro.getSchemaName());
                this.inqEmp.initMyTable("Memployee", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this, e);
        }
    }
    
    private void chkHoliday1(){
        try{
            if(this.dbHoliday1 == null){
                this.dbHoliday1 = (DbTable) this.getChild("Tchholiday1");
            }
        } catch (Exception e){
            MyLog.debug(this, e);
        }
    }
    
    /*private void setEmployeeDetail(){
        try {
            this.chkEmpInq();
            this.chkHoliday1();
            this.inqEmp.setFilter("employeeid='"+this.dbHoliday1.getString("employeeid")+"'");
            this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
                    "salatype, workarea,  emp_position, emp_group, companyid");  
            this.inqEmp.refresh();
            while (this.inqEmp.next()) {
                this.set("bu1", this.inqEmp.getString("bu1"));
                this.set("bu2", this.inqEmp.getString("bu2"));
                this.set("bu3", this.inqEmp.getString("bu3"));
                this.set("bu4", this.inqEmp.getString("bu4"));
                this.set("bu5", this.inqEmp.getString("bu5"));
                this.set("job", this.inqEmp.getString("job"));
                this.set("emp_group", this.inqEmp.getString("emp_group"));
                this.set("emp_position", this.inqEmp.getString("emp_position"));
                this.set("branch", this.inqEmp.getString("branch"));
                this.set("bossid", this.inqEmp.getString("bossid"));
                this.set("salatype", this.inqEmp.getString("salatype"));
                this.set("workarea", this.inqEmp.getString("workarea"));            
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }       
    }   */
    
    protected boolean preInsertTrigger() throws Exception {
        MyLog.debug(this, "******** PRE INSERT TCHHOLIDAY ********");
        this.hmResult_Add.clear();
        boolean result = super.preInsertTrigger();
        
        this.chkHoliday1();
        dbHoliday1.first();
        while(!this.dbHoliday1.eof()){
            DbRecord recHoliday = dbHoliday1.getCurrentRecordManager();
            this.setEmpid(recHoliday.getString("employeeid"));
            this.setDate1(recHoliday.getCscCalendar("change_date1"));
            this.setDate2(recHoliday.getCscCalendar("change_date2"));
            if (this.chkForChangeHoliday(this.getEmpid(), this.getDate1(), this.getDate2()) == false) {
                this.param.put("error_msg", "Error Because This Day is Request Leave or OT");
                MyLog.debug(this, "NOT CHANGE HOLIDAY !!!");
                this.saveStatus = 99;
                return false;
            } else {
                if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
                        || this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
                    this.setWFOff();
                }
                
                if (!this.getString("wf_status").equalsIgnoreCase("9")) {
                    this.preProcessWf();
                }
                
                this.genRecord(this.getEmpid(), this.getDate1(), this.getDate2(), false);
                MyLog.debug("this.hmResult_Add="+this.hmResult_Add);
                MyLog.debug("this.hmResult_Sub="+this.hmResult_Sub);
                
                if (this.hmResult_Add.isEmpty() || this.hmResult_Sub.isEmpty()) {
                    this.param.put("error_msg", "No Data For This Change Holiday");
                    MyLog.error(this, "No Data For This Change Holiday");
                    return false; //ӡâͷբ㹡â
                }
            }
            this.dbHoliday1.next();
        }
        return result;
    }

    protected boolean preUpdateTrigger() throws Exception {
        MyLog.debug(this, "******** PRE UPDATE TCHHOLIDAY ********");
        this.hmResult_Sub.clear();
        /*if (this.chkForChangeHoliday() == false) {
            this.param.put("error_msg", "Error Because This Day is Request Leave or OT");
            MyLog.debug(this, "NOT CHANGE HOLIDAY !!!");
            this.saveStatus = 99;
            return false;
        } else */{
            boolean result = super.preUpdateTrigger();  
            this.param.put("error_msg", "No Error");    
            
            if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
                    || this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
                this.setWFOff();
            }
            
            if (!this.getString("wf_status").equalsIgnoreCase("9")) {
                this.preProcessWf();
            }
            if (this.getString("wf_status").equalsIgnoreCase("8") || 
                    this.getString("wf_status").equalsIgnoreCase("7") || 
                    this.getString("wf_status").equalsIgnoreCase("B")) {            
                this.setColumn(this.getListKey()+",wf_status");
            }       
            
//            if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
//                this.setEmployeeDetail();
//            } 
            return result;
        }
    }

    protected void postInsertTrigger() throws Exception {
        MyLog.debug(this, "******** POST INSERT TCHHOLIDAY ********");
        if (this.param.containsKey("__wfcmd")) {
            if (this.param.get("__wfcmd").equals("true")) {
                this.setWFOn();         
            } else this.setWFOff();
        }
        super.postInsertTrigger();      
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
            this.delDataAdjTime0();
            this.saveHashMapData("TADJTIME0", this.hmResult_Sub);
            this.saveHashMapData("TADJTIME0", this.hmResult_Add);
            //this.genRecord(true);
        } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.delDataAdjTime0();
        }
    }

    protected void postUpdateTrigger() throws Exception {
        MyLog.debug(this, "******** POST UPDATE TCHHOLIDAY ********");
        String empid = "";
        this.chkHoliday1();
        dbHoliday1.first();        
        while(!this.dbHoliday1.eof()){
            DbRecord recHol = this.dbHoliday1.getCurrentRecordManager();
            this.setEmpid(recHol.getString("employeeid"));
            this.setDate1(recHol.getCscCalendar("change_date1"));
            this.setDate2(recHol.getCscCalendar("change_date2"));
            if (this.param.containsKey("__wfcmd")) {
                if (this.param.get("__wfcmd").equals("true")) {
                    this.setWFOn();         
                } else this.setWFOff();
            }
            super.postUpdateTrigger();      
            if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
                this.delDataAdjTime0();
                //this.saveHashMapData("TADJTIME0", this.hmResult_Sub);
                //this.saveHashMapData("TADJTIME0", this.hmResult_Add);
                this.genRecord(this.getEmpid(), this.getDate1(), this.getDate2(), false);
                this.saveHashMapData("TADJTIME0", this.hmResult_Sub);
                this.saveHashMapData("TADJTIME0", this.hmResult_Add);
            } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
                this.delDataAdjTime0();
            }
            dbHoliday1.next();
        }
    }   
    
    protected void postDeleteTrigger() throws Exception {
        MyLog.debug(this, "******** POST DELETE TCHHOLIDAY ********");
        super.postDeleteTrigger();
        this.delDataAdjTime0();
    }

    private void delDataAdjTime0() {
        try {
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setParam(this.param);
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("Tadjtime0", "docid='"+this.getString("chholidayid")+"' and doctype='CH' ", "");
            inq.setColumn("*");
            inq.refresh();
            while (inq.next()) {
                DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
                rec.delete();
            }
        } catch (Exception e) {
            MyLog.error(this, e);       
        }
    }
    
    private boolean chkForChangeHoliday(String empid, CscCalendar cs1, CscCalendar cs2) {
        boolean status = true;
        try {
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setParam(this.param);
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("Tadjtime0", " (dt_bg='"
                    + cs1.getYYYYMMDD() + "' or dt_bg='" + cs2.getYYYYMMDD()
                    + "') and employeeid='" + empid + "'", "");
            inq.setColumn("*");
            inq.refresh();
            while (inq.next()) {
                status = false;
                break;
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return status;
    }
    
    private TimeZone getDocTimeZone(Shift shCheck) {
        TimeZone tz = new TimeZone();       
        CscCalendar cs1 = new CscCalendar(shCheck.get_c_dt_in().getYYYYMMDD());
        CscCalendar cs2 = new CscCalendar(shCheck.get_c_dt_out().getYYYYMMDD());        
        try {
            cs1.setCSCTime(shCheck.get_c_dt_in().getCSCTime());
            cs2.setCSCTime(shCheck.get_c_dt_out().getCSCTime());
        } catch (Exception e) {
            e.printStackTrace();
        }
        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
        System.out.println(">>> RESULT TIMEZONE="+tz);
        return tz;
    }
    
    private void genRecord(String empid, CscCalendar cs1, CscCalendar cs2, boolean isSave) {
        try {           
            DbRecord recADJ = new InitialRecord(this.userPro).getDbRecord("TADJTIME0");
            recADJ.setColumn("*");

            this.chkEmpInq();
            this.inqEmp.setFilter("employeeid='" + empid + "'");
            this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
            this.inqEmp.refresh();
            while (this.inqEmp.next()) {
                //Start Sub Transaction
                Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("MTIME0");
                rec.set("time0id", this.inqEmp.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                rec.search();
                
                rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
                
                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                        new CscCalendar(cs1.getYYYYMMDD()));
                if (!ws.isEmpty()) {
                    MyLog.debug(this, "<<< WORKINGSHIFT OLD >>>");
                    MyLog.debug(this, this.getUProfile(), ws.toString());                   
                    ws.setUProfile(this.userPro);
                    ws.adjust();
                    ws.setEmployeeid(this.inqEmp.getString("employeeid"));
                    ws.overlapChecking();
                    ws.createLink();
                    Vector vAdjustSub = new Vector();
                    
                    WorkingShift wsCheck = (WorkingShift) ws.clone();
                    Shift shCheck=null;          
                    Iterator itDS = (Iterator) wsCheck.keySet().iterator(); 
                    if (itDS.hasNext()) {
                        shCheck = null;
                        DayShift dsCheck = (DayShift) wsCheck.get(cs1.getYYYYMMDD());
                        if (!dsCheck.isEmpty()) {
                            Iterator itSH = (Iterator) dsCheck.keySet().iterator();
                            shCheck = null;
                            if (itSH.hasNext()) {
                                shCheck = null;
                                shCheck = (Shift) dsCheck.get((String) itSH.next());
                            } else shCheck = null;
                        }
                    }                   
                    
                    MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
                    if (shCheck!=null) {
                        vAdjustSub = ws.genSubShiftTrans(this.getDocTimeZone(shCheck));
                    }
                    
                    int count=1;
                    Iterator it = vAdjustSub.iterator();
                    MyLog.debug(this, "SUB Transaction");
                    while (it.hasNext()) {
                        AdjustResult result = (AdjustResult) it.next();
                        MyLog.debug(this, result.toString());
                        if (isSave) {
                            recADJ.clearField();                        
                            recADJ.set("COMPANYID",this.getString("companyid"));
                            recADJ.set("DOCID",this.getString("chholidayid"));
                            recADJ.set("DOCTYPE","CH");
                            recADJ.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
                            recADJ.set("TM_BG",result.get_DT_BG().getCSCTime());
                            recADJ.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
                            recADJ.set("TM_EN",result.get_DT_EN().getCSCTime());
                            if (result.getType().equals("A")) {
                                recADJ.set("UPDTYPE", "H");
                                recADJ.set("EVENTGRP", "H");
                            } else {
                                recADJ.set("UPDTYPE",result.getType()); 
                                recADJ.set("EVENTGRP", result.getEventGroup().substring(0,1));
                            }
                            recADJ.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
                            recADJ.set("EMPLOYEEID",this.inqEmp.getString("employeeid"));
                            recADJ.set("TIME0ID",result.getTimeCode());
                            recADJ.set("OLDTIME0ID", result.getOldTime0());
                            recADJ.set("OLDEVENTGRP", result.getOldEventGroup());
                            recADJ.set("LV_TY",result.get_LV_TY());
                            recADJ.set("LV","0");
                            recADJ.set("TR_TYPE",result.getEventGroup()); 
                            recADJ.save();
                        } else {
                            MyHashMap hmData = new MyHashMap();
                            hmData.put("COMPANYID",this.getString("companyid"));
                            hmData.put("DOCID",this.getString("chholidayid"));
                            hmData.put("DOCTYPE","CH");
                            hmData.put("DT_BG",result.get_DT_BG().getYYYYMMDD());
                            hmData.put("TM_BG",result.get_DT_BG().getCSCTime());
                            hmData.put("DT_EN",result.get_DT_EN().getYYYYMMDD());
                            hmData.put("TM_EN",result.get_DT_EN().getCSCTime());
                            if (result.getType().equals("A")) {
                                hmData.put("UPDTYPE", "H");
                                hmData.put("EVENTGRP", "H");
                            } else {
                                hmData.put("UPDTYPE",result.getType());     
                                hmData.put("EVENTGRP", result.getEventGroup().substring(0,1));
                            }
                            hmData.put("DOCDATE",result.getAdjDate().getYYYYMMDD());
                            hmData.put("EMPLOYEEID",this.inqEmp.getString("employeeid"));
                            hmData.put("TIME0ID",result.getTimeCode());
                            hmData.put("OLDTIME0ID", result.getOldTime0());
                            hmData.put("OLDEVENTGRP", result.getOldEventGroup());
                            hmData.put("LV_TY",result.get_LV_TY());
                            hmData.put("LV","0");
                            hmData.put("TR_TYPE",result.getEventGroup()); 
                            this.hmResult_Sub.put(String.valueOf(count),hmData);
                            count++;
                        }   
                    } //End While Save Sub Transaction      
                } 
                
                int count2=1;
                WorkingShift wsAdd = rec.genWorkingShift(new CscCalendar(cs2.getYYYYMMDD()), 
                        new CscCalendar(cs2.getYYYYMMDD()), "true");
                if (!wsAdd.isEmpty()) {                 
                    MyLog.debug(this, "<<< WORKINGSHIFT ADD >>>");
                    MyLog.debug(this, this.getUProfile(), wsAdd.toString());                    
                    wsAdd.setUProfile(this.userPro);
                    wsAdd.adjust();
                    wsAdd.setEmployeeid(this.inqEmp.getString("employeeid"));
                    wsAdd.overlapChecking();
                    wsAdd.createLink();
                    Vector vAdjustAdd = new Vector();
                    
                    WorkingShift wsCheck = (WorkingShift) wsAdd.clone();
                    Shift shCheck=null;         
                    Iterator itDS = (Iterator) wsCheck.keySet().iterator(); 
                    if (itDS.hasNext()) {
                        shCheck = null;
                        DayShift dsCheck = (DayShift) wsCheck.get(cs2.getYYYYMMDD());
                        if (!dsCheck.isEmpty()) {
                            Iterator itSH = (Iterator) dsCheck.keySet().iterator();
                            shCheck = null;
                            if (itSH.hasNext()) {
                                shCheck = null;
                                shCheck = (Shift) dsCheck.get((String) itSH.next());
                            } else shCheck = null;
                        }
                    }                   
                    
                    MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
                    if (shCheck!=null && (shCheck.getEventGroup().equals("H") || shCheck.getEventGroup().equals("I"))) {
                        vAdjustAdd = wsAdd.genSubShiftTrans(this.getDocTimeZone(shCheck));
                    }
                    
                    Iterator it = vAdjustAdd.iterator();
                    MyLog.debug(this, "ADD Transaction");
                    while (it.hasNext()) {
                        AdjustResult result = (AdjustResult) it.next();
                        MyLog.debug(this, result.toString());
                        if (isSave) {
                            recADJ.clearField();                        
                            recADJ.set("COMPANYID",this.getString("companyid"));
                            recADJ.set("DOCID",this.getString("chholidayid"));
                            recADJ.set("DOCTYPE","CH");
                            recADJ.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
                            recADJ.set("TM_BG",result.get_DT_BG().getCSCTime());
                            recADJ.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
                            recADJ.set("TM_EN",result.get_DT_EN().getCSCTime());
                            if (result.getType().equals("A")) {
                                recADJ.set("UPDTYPE", "T");
                                recADJ.set("EVENTGRP", "T");
                            } else {
                                recADJ.set("UPDTYPE",result.getType()); 
                                recADJ.set("EVENTGRP", result.getEventGroup().substring(0,1));
                            }
                            recADJ.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
                            recADJ.set("EMPLOYEEID",this.inqEmp.getString("employeeid"));
                            recADJ.set("TIME0ID",result.getTimeCode());
                            recADJ.set("OLDTIME0ID", result.getOldTime0());
                            recADJ.set("OLDEVENTGRP", result.getOldEventGroup());
                            recADJ.set("LV_TY",result.get_LV_TY());
                            recADJ.set("LV","0");
                            recADJ.set("TR_TYPE",result.getEventGroup()); 
                            recADJ.save();
                        } else {
                            MyHashMap hmData = new MyHashMap();
                            hmData.put("COMPANYID",this.getString("companyid"));
                            hmData.put("DOCID",this.getString("chholidayid"));
                            hmData.put("DOCTYPE","CH");
                            hmData.put("DT_BG",result.get_DT_BG().getYYYYMMDD());
                            hmData.put("TM_BG",result.get_DT_BG().getCSCTime());
                            hmData.put("DT_EN",result.get_DT_EN().getYYYYMMDD());
                            hmData.put("TM_EN",result.get_DT_EN().getCSCTime());
                            if (result.getType().equals("A")) {
                                hmData.put("UPDTYPE", "T");
                                hmData.put("EVENTGRP", "T");
                            } else {
                                hmData.put("UPDTYPE",result.getType());     
                                hmData.put("EVENTGRP", result.getEventGroup().substring(0,1));
                            }
                            hmData.put("DOCDATE",result.getAdjDate().getYYYYMMDD());
                            hmData.put("EMPLOYEEID",this.inqEmp.getString("employeeid"));
                            hmData.put("TIME0ID",result.getTimeCode());
                            hmData.put("OLDTIME0ID", result.getOldTime0());
                            hmData.put("OLDEVENTGRP", result.getOldEventGroup());
                            hmData.put("LV_TY",result.get_LV_TY());
                            hmData.put("LV","0");
                            hmData.put("TR_TYPE",result.getEventGroup()); 
                            this.hmResult_Add.put(String.valueOf(count2),hmData);
                            count2++;
                        }
                    }
                } //End While Save Add Transaction  
                
                //Change Time Data and Shift
                float w_in=0 , w_out=0;
                float h_in=0 , h_out=0;
                String tw="", th="";
                String kw="", kh="";
                Iterator it = this.hmResult_Add.keySet().iterator();
                while (it.hasNext()) {
                    String key = (String) it.next();
                    MyHashMap hm = (MyHashMap) this.hmResult_Add.get(key);
                    if (hm.getString("UPDTYPE").equals("T")) {
                        w_in = hm.getFloat("TM_BG");
                        w_out = hm.getFloat("TM_EN");
                        tw = hm.getString("TIME0ID");
                        kw = key;
                        break;
                    }
                }
                
                it = this.hmResult_Sub.keySet().iterator();
                while (it.hasNext()) {
                    String key = (String) it.next();
                    MyHashMap hm = (MyHashMap) this.hmResult_Sub.get(key);
                    if (hm.getString("UPDTYPE").equals("H")) {
                        h_in = hm.getFloat("TM_BG");
                        h_out = hm.getFloat("TM_EN");
                        th = hm.getString("TIME0ID");
                        kh = key;
                        break;
                    }
                }
                
                MyHashMap hm = (MyHashMap) this.hmResult_Add.get(kw);
                if(hm != null){
                    hm.put("TM_BG", Float.valueOf(h_in));
                    hm.put("TM_EN", Float.valueOf(h_out));
                    hm.put("TIME0ID", th);
                    this.hmResult_Add.put(kw, hm);
                }
                
                MyHashMap hm2 = (MyHashMap) this.hmResult_Sub.get(kh);
                if(hm2 != null){
                    hm2.put("TM_BG", Float.valueOf(w_in));
                    hm2.put("TM_EN", Float.valueOf(w_out));
                    hm2.put("TIME0ID", tw);
                    this.hmResult_Sub.put(kh, hm2);
                }
            }
        } catch (Exception e) {
            MyLog.error(this, e);
        }
    }
    
    public boolean chkChHoliday(String empid, CscCalendar chdate1, CscCalendar chdate2){
        boolean result = true;
        try{
            this.hmResult_Add.clear();
            this.setEmpid(empid);
            this.setDate1(chdate1);
            this.setDate2(chdate2);
            if (this.chkForChangeHoliday(this.getEmpid(), this.getDate1(), this.getDate2()) == false) {
                this.param.put("error_msg", "Error Because This Day is Request Leave or OT");
                MyLog.debug(this, "NOT CHANGE HOLIDAY !!!");
                return false;
            } else {
                this.genRecord(this.getEmpid(), this.getDate1(), this.getDate2(), false);
                MyLog.debug("this.hmResult_Add="+this.hmResult_Add);
                MyLog.debug("this.hmResult_Sub="+this.hmResult_Sub);
                
                if (this.hmResult_Add.isEmpty() || this.hmResult_Sub.isEmpty()) {
                    this.param.put("error_msg", "No Data For This Change Holiday");
                    MyLog.error(this, "No Data For This Change Holiday");
                    return false; //ӡâͷբ㹡â
                }
            }
        } catch (Exception e){
            MyLog.debug(this, e);
        }
        return result;
    }
}
