package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;

public class Tchshift extends RecordCmp {

	private String date = "";
	private Vector vt = new Vector();
	private MyHashMap hmResult_Add = new MyHashMap();
	private MyHashMap hmResult_Sub = new MyHashMap();
	private DbInquiry inqEmp = null;

	public Tchshift() {
		super("Tchshift", "Tchshift Table");
	}

	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TCHSHIFT");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("shiftid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void chkEmpInq() {
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	private boolean chkForChangeShift() {
		boolean status = true;
		try {
			CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
			CscCalendar cs2 = new CscCalendar(this.getString("end_date"));

			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", " (dt_bg between '"
					+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
					+ "') and employeeid='" + this.getString("employeeid") + "' and doctype<>'C'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				HashMap tmp = new HashMap();
				tmp.put("docid", inq.getString("docid"));
				tmp.put("dt_bg", inq.getString("dt_bg"));
				tmp.put("tm_bg", inq.getString("tm_bg"));
				tmp.put("tm_en", inq.getString("tm_en"));
				vt.addElement(tmp);
				status = false;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return status;
	}

	protected boolean preInsertTrigger() throws Exception {
		MyLog.debug(this, "******** PRE INSERT TCHSHIFT ********");
		this.hmResult_Add.clear();
		this.hmResult_Sub.clear();
		/**
		 * 13/11/2551
		 *  SKI ͧ 
		 * ͧ¹ ͧત    OT ?
		 * ¹Ѻ׹ 
		 */
		//MyLog.debug(this, "******** NUISS DEBUG :>>>  not call method chkForChangeShift() ********");
		if (this.chkForChangeShift() == false) {
			this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
			MyLog.debug(this, "NOT CHANGESHIFT !!!");
			this.saveStatus = 99;
			return false;
		} else {
			boolean result = super.preInsertTrigger();	
			if (!this.getString("employeeid").equals("")) {
				this.setEmployeeDetail();
			}
			
			this.param.put("error_msg", "No Error");	
			if (this.param.containsKey("__oldWF")) {
				if (((String) this.param.get("__oldWF")).equals("7")) {
					this.updateReturnDocument();
				}
			}
			
			if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
					|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
	            this.setWFOff();
	        }
			
			if (!this.getString("wf_status").equalsIgnoreCase("9")) {
	            this.preProcessWf();
	        }
			
			this.genRecord(false);
			if (this.hmResult_Add.isEmpty() || this.hmResult_Sub.isEmpty()) {
				this.param.put("error_msg",	"No Data For This Change Shift");
				MyLog.error(this, "No Data For This Change Shift");
				return false; //ӡâͷբ㹡â
			}         
			return result;
		}//end if 
	}//end method

	protected boolean preUpdateTrigger() throws Exception {
		MyLog.debug(this, "******** PRE UPDATE TCHSHIFT ********");
		this.hmResult_Add.clear();
		this.hmResult_Sub.clear();
		/*if (this.chkForChangeShift() == false) {
			this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
			MyLog.debug(this, "NOT CHANGESHIFT !!!");
			this.saveStatus = 99;
			return false;
		} else {*/
			boolean result = super.preUpdateTrigger();	
			this.param.put("error_msg", "No Error");	
			
			if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
					|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
	            this.setWFOff();
	        }
			
			if (!this.getString("wf_status").equalsIgnoreCase("9")) {
	            this.preProcessWf();
	        }
			if (this.getString("wf_status").equalsIgnoreCase("8") || 
					this.getString("wf_status").equalsIgnoreCase("7") || 
					this.getString("wf_status").equalsIgnoreCase("B")) {			
				this.setColumn(this.getListKey()+",wf_status");
			}		
			
			if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
				this.setEmployeeDetail();
			} 
			return result;
		//}
	}

	protected void postInsertTrigger() throws Exception {
		MyLog.debug(this, "******** POST INSERT TCHSHIFT ********");
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.saveHashMapData("TADJTIME0", this.hmResult_Sub);
			this.saveHashMapData("TADJTIME0", this.hmResult_Add);
			//this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}

	protected void postUpdateTrigger() throws Exception {
		MyLog.debug(this, "******** POST UPDATE TCHSHIFT ********");
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postUpdateTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			//this.saveHashMapData("TADJTIME0", this.hmResult_Sub);
			//this.saveHashMapData("TADJTIME0", this.hmResult_Add);
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}	
	
	protected void postDeleteTrigger() throws Exception {
		MyLog.debug(this, "******** POST DELETE TCHSHIFT ********");
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}

	private void delDataAdjTime0() {
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", "docid='"+this.getString("shiftid")+"' and doctype='C' ", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	
	public MyHashMap getDWRData() {
		return this.genRecord(false);
	}

	private MyHashMap genRecord(boolean isSave) {
		MyHashMap hm = new MyHashMap();
		MyHashMap hmSub = new MyHashMap();
		MyHashMap hmAdd = new MyHashMap();
		MyHashMap hmOldShift = new MyHashMap();
		Vector vAdjustSub = new Vector();
		Vector vAdjustAdd = new Vector();		
		
		try {			
			DbRecord recADJ = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
			recADJ.setColumn("*");
			
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {

				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				
				//Start Sub Transaction
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();
				
				rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
				MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
								+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
				WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()));
				if (!ws.isEmpty()) {
					MyLog.debug(this, "<<< WORKINGSHIFT OLD >>>");
					MyLog.debug(this, this.getUProfile(), ws.toString());					
					ws.setUProfile(this.userPro);
					ws.adjust();
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					ws.overlapChecking();
					ws.createLink();
					vAdjustSub = ws.genSubShiftTrans(this.getDocTimeZone(ws));
					
					MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
					
					int count=1;
					Iterator it = vAdjustSub.iterator();
					MyLog.debug(this, "SUB Transaction");
					while (it.hasNext()) {
						AdjustResult result = (AdjustResult) it.next();
						MyLog.debug(this, result.toString());
							
						if  (result.getType().equals("D")) {		
							if (isSave) {
								recADJ.clearField();						
								recADJ.set("COMPANYID",this.getString("companyid"));
								recADJ.set("DOCID",this.getString("shiftid"));
								recADJ.set("DOCTYPE","C");
								recADJ.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
								recADJ.set("TM_BG",result.get_DT_BG().getCSCTime());
								recADJ.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
								recADJ.set("TM_EN",result.get_DT_EN().getCSCTime());
								recADJ.set("UPDTYPE",result.getType());
								recADJ.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
								recADJ.set("EMPLOYEEID",this.getString("employeeid"));
								recADJ.set("TIME0ID",result.getTimeCode());
								recADJ.set("EVENTGRP", result.getEventGroup().substring(0,1));
								recADJ.set("OLDTIME0ID", result.getOldTime0());
								recADJ.set("OLDEVENTGRP", result.getOldEventGroup());
								recADJ.set("LV_TY",result.get_LV_TY());
								recADJ.set("LV","0");
								recADJ.set("TR_TYPE",result.getEventGroup()); 
								recADJ.set("HOUR_S",result.getHour_s()); 
								recADJ.save();
								
								hmOldShift.put(result.get_DT_BG().getYYYYMMDD(), result.getTimeCode());
							} else {
								MyHashMap hmData = new MyHashMap();
								hmData.put("COMPANYID",this.getString("companyid"));
								hmData.put("DOCID",this.getString("shiftid"));
								hmData.put("DOCTYPE","C");
								hmData.put("DT_BG",result.get_DT_BG().getYYYYMMDD());
								hmData.put("TM_BG",result.get_DT_BG().getCSCTime());
								hmData.put("DT_EN",result.get_DT_EN().getYYYYMMDD());
								hmData.put("TM_EN",result.get_DT_EN().getCSCTime());
								hmData.put("UPDTYPE",result.getType());
								hmData.put("DOCDATE",result.getAdjDate().getYYYYMMDD());
								hmData.put("EMPLOYEEID",this.getString("employeeid"));
								hmData.put("TIME0ID",result.getTimeCode());
								hmData.put("EVENTGRP", result.getEventGroup().substring(0,1));
								hmData.put("OLDTIME0ID", result.getOldTime0());
								hmData.put("OLDEVENTGRP", result.getOldEventGroup());
								hmData.put("LV_TY",result.get_LV_TY());
								hmData.put("LV","0");
								hmData.put("TR_TYPE",result.getEventGroup()); 
								hmData.put("HOUR_S",result.getHour_s()); 
								hmSub.put(String.valueOf(count),hmData);
								this.hmResult_Sub.put(String.valueOf(count),hmData);
								count++;
								
								hmOldShift.put(result.get_DT_BG().getYYYYMMDD(), result.getTimeCode());
							}
						}
						
						/*if (!result.getTimeCode().equalsIgnoreCase(this.getString("SHIFT_OLD"))) {
							return new MyHashMap();
						}*/
					} //End While Save Sub Transaction 		
				} 
				
				//Start Add Transaction
				Mtime0 recAdd = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recAdd.set("time0id", this.getString("shift_new"));
				recAdd.set("companyid", this.userPro.get("companyid"));
				recAdd.search();
				recAdd.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
				MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
								+ cs1.getYYYYMMDD() + ", end_date="	+ cs2.getYYYYMMDD());
				WorkingShift wsAdd = recAdd.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()));
				if (!wsAdd.isEmpty()) {					
					MyLog.debug(this, "<<< WORKINGSHIFT ADD >>>");
					cs1.incDate(); //cs2.decDate();
					int count2=1;
					Iterator it = wsAdd.keySet().iterator();
					while (it.hasNext()) {
						DayShift ds = (DayShift) wsAdd.get(it.next());
						Iterator it2 = ds.keySet().iterator();
						while (it2.hasNext()) {
							Shift sh = (Shift) ds.get(it2.next());
							
							MyLog.debug(this, "sh="+sh.getShiftDate()+" cs1="+cs1+" c2="+cs2);
							if (sh.getShiftDate().afterEquals(cs1)&&sh.getShiftDate().beforeEquals(cs2)) {							
								MyLog.debug(this, this.getUProfile(), sh.toString());
								if (isSave) {
									recADJ.clearField();
									recADJ.set("COMPANYID",this.getString("companyid"));
									recADJ.set("DOCID",this.getString("shiftid"));
									recADJ.set("DOCTYPE","C");
									recADJ.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									recADJ.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									recADJ.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									recADJ.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									recADJ.set("UPDTYPE","T");
									recADJ.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									recADJ.set("EMPLOYEEID",this.getString("employeeid"));
									recADJ.set("TIME0ID", sh.getTimeCode());
									recADJ.set("EVENTGRP", sh.getEventGroup());
									//recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
									if (hmOldShift.containsKey(sh.get_c_dt_in().getYYYYMMDD())) {
										recADJ.set("OLDTIME0ID", hmOldShift.getString(sh.get_c_dt_in().getYYYYMMDD()));
									} else recADJ.set("OLDTIME0ID", sh.getOldTimeCode());
									recADJ.set("OLDEVENTGRP", sh.getOldEventGroup());
									recADJ.set("LV_TY",sh.getLV_Type());
									recADJ.set("LV","0");
									recADJ.set("TR_TYPE",sh.getTR_Type());
									recADJ.set("HOUR_S",sh.getHour_s()); 
									recADJ.save();
								} else {
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID",this.getString("companyid"));
									hmData.put("DOCID",this.getString("shiftid"));
									hmData.put("DOCTYPE","C");
									hmData.put("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									hmData.put("TM_BG", sh.get_c_dt_in().getCSCTime());
									hmData.put("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									hmData.put("TM_EN", sh.get_c_dt_out().getCSCTime());								
									hmData.put("UPDTYPE","T");
									hmData.put("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									hmData.put("EMPLOYEEID",this.getString("employeeid"));
									hmData.put("TIME0ID", sh.getTimeCode());
									hmData.put("EVENTGRP", sh.getEventGroup());
									//hmData.put("OLDTIME0ID", sh.getOldTimeCode());
									if (hmOldShift.containsKey(sh.get_c_dt_in().getYYYYMMDD())) {
										hmData.put("OLDTIME0ID", hmOldShift.getString(sh.get_c_dt_in().getYYYYMMDD()));
									} else hmData.put("OLDTIME0ID", sh.getOldTimeCode());
									hmData.put("OLDEVENTGRP", sh.getOldEventGroup());
									hmData.put("LV_TY",sh.getLV_Type());
									hmData.put("LV","0");
									hmData.put("TR_TYPE",sh.getTR_Type());
									hmData.put("HOUR_S",sh.getHour_s()); 
									hmAdd.put(String.valueOf(count2),hmData);
									this.hmResult_Add.put(String.valueOf(count2),hmData);
									count2++;
								}							
							}
						}
					} //End WorkingShift Iterator
				} 
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		/*MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
		try {		
			DbRecord recADJ = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
			recADJ.setColumn("*");
			
			Iterator it = vAdjustSub.iterator();
			MyLog.debug(this, "SUB Transaction");
			while (it.hasNext()) {
				AdjustResult result = (AdjustResult) it.next();
				MyLog.debug(this, result.toString());
				
				if  (result.getType().equals("D")) {				
					recADJ.clearField();								
					recADJ.set("COMPANYID",this.getString("companyid"));
					recADJ.set("DOCID",this.getString("shiftid"));
					recADJ.set("DOCTYPE","C");
					recADJ.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
					recADJ.set("TM_BG",result.get_DT_BG().getCSCTime());
					recADJ.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
					recADJ.set("TM_EN",result.get_DT_EN().getCSCTime());
					recADJ.set("UPDTYPE",result.getType());
					recADJ.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
					recADJ.set("EMPLOYEEID",this.getString("employeeid"));
					recADJ.set("TIME0ID",result.getTimeCode());
					recADJ.set("EVENTGRP", result.getEventGroup().substring(0,1));
					recADJ.set("OLDTIME0ID", result.getOldTime0());
					recADJ.set("OLDEVENTGRP", result.getOldEventGroup());
					recADJ.set("LV_TY",result.get_LV_TY());
					recADJ.set("LV","0");
					recADJ.set("TR_TYPE",result.getEventGroup()); 
					recADJ.save();
				}
			}		
		} catch (Exception e1) {
			MyLog.error(this, e1);			
		}*/
		return hm;
	}

	public String getString(String field) {
		if (field.equalsIgnoreCase("error_msg")) {
			return this.param.get("error_msg").toString();
		} else {
			return super.getString(field);
		}
	}

	private TimeZone getDocTimeZone(WorkingShift ws) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		try {
			DayShift ds1 = (DayShift) ws.get(cs1.getYYYYMMDD());
			Shift sh1 = (Shift) ds1.get((String) ds1.keySet().iterator().next());
			DayShift ds2 = (DayShift) ws.get(cs2.getYYYYMMDD());
			Shift sh2 = (Shift) ds2.get((String) ds2.keySet().iterator().next());
			
			tz.setBeginZone(sh1.get_c_dt_in());
			tz.setEndZone(sh2.get_c_dt_out());
		} catch (Exception e) {
			tz.setBeginZone(new CscCalendar(cs1.getYYYYMMDD() + " 00:00:00"));
			tz.setEndZone(new CscCalendar(cs2.getYYYYMMDD() + " 23:59:00"));
		}
		return tz;
	}

}