package com.csc.library.databean;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.approve.Organization;
import com.csc.library.database.ChildManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

public class Tchshift0_liteon extends RecordCmp{

	private Vector vt = new Vector();
	private DbTable dbChild = null;	
	
	public Tchshift0_liteon() {
		super("Tchshift0_liteon", "Tchshift0_liteon Table");
	}
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Tchshift0_liteon");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("shiftid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private boolean chkForExchangeShift() {
		boolean status = true;
		try {
			DbTable dt;					
			if (this.getChild("Tchshift1_liteon")!=null) {
				dt = (DbTable) this.getChild("Tchshift1_liteon");			
			} else {
				DbTable db = new InitialTable(this.userPro).getDbTable("Tchshift1_liteon");
				db.setColumn("*");
				this.putChild(db);
				this.refreshChild();
				dt = (DbTable) this.getChild("Tchshift1_liteon");	
			}					
			dt.first();
			while (!dt.eof()) {
				DbRecord rec = dt.getCurrentRecordManager();
				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				String emp = rec.getString("employeeid");

				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tadjtime0", " (dt_bg between '"
						+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
						+ "') and employeeid='" + emp + "'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					HashMap tmp = new HashMap();
					tmp.put("empid", emp);
					tmp.put("docid", inq.getString("docid"));
					tmp.put("dt_bg", inq.getString("dt_bg"));
					tmp.put("tm_bg", inq.getString("tm_bg"));
					tmp.put("tm_en", inq.getString("tm_en"));
					vt.addElement(tmp);
					status = false;
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return status;
	}

	protected boolean preInsertTrigger() throws Exception {
		MyLog.debug(this, "******** PRE INSERT TCHSHIFT0 ********");
		
		boolean result = super.preInsertTrigger();	
		this.param.put("error_msg", "No Error");	
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			if (this.chkShiftMaternity()==false) {
				this.param.put("error_msg",	"Error Because This Day, Employee is Maternity");
				MyLog.debug(this, "NOT CHANGESHIFT !!! MATERNITY");
				this.saveStatus = 99;
				return false;
			} else if (this.chkForExchangeShift() == false) {			
				this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
				MyLog.debug(this, "NOT CHANGESHIFT !!!");
				this.saveStatus = 99;
				return false;
			}
		}
		
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
			
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
			|| this.getString("wf_status").equalsIgnoreCase("9")) {
	        this.setWFOff();
	    }
			
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
			this.preProcessWf();
		}
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	protected boolean preUpdateTrigger() throws Exception {
		MyLog.debug(this, "******** PRE UPDATE TCHSHIFT0 ********");
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
		
		boolean result = super.preUpdateTrigger();	
		this.param.put("error_msg", "No Error");		
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			if (this.chkShiftMaternity()==false) {
				this.param.put("error_msg",	"Error Because This Day, Employee is Maternity");
				MyLog.debug(this, "NOT CHANGESHIFT !!!");
				this.saveStatus = 99;
				return false;
			} else if (this.chkForExchangeShift() == false) {
				this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
				MyLog.debug(this, "NOT CHANGESHIFT !!!");
				this.saveStatus = 99;
				return false;
			}
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
			|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
	        this.setWFOff();
	    }
			
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
			this.preProcessWf();
		}
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
			this.getString("wf_status").equalsIgnoreCase("7") || 
			this.getString("wf_status").equalsIgnoreCase("B")) {			
			this.setColumn(this.getListKey()+",wf_status");
		}		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	public String getString(String field) {
		if (field.equalsIgnoreCase("error_msg")) {
			return this.param.get("error_msg").toString();
		} else {
			return super.getString(field);
		}
	}

	protected void postInsertTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}

	protected void postUpdateTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}		
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}

	private void delDataAdjTime0() {
		try {
			DbTable dt;					
			if (this.getChild("Tchshift1_liteon")!=null) {
				dt = (DbTable) this.getChild("Tchshift1_liteon");			
			} else {
				dt = new InitialTable(this.userPro).getDbTable("Tchshift1_liteon");
				dt.setColumn("*");
				this.putChild(dt);
				this.refreshChild();
			}			
			dt.first();
			while (!dt.eof()) {
				DbRecord rec = dt.getCurrentRecordManager();
				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				String emp = rec.getString("employeeid");

				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tadjtime0", "docid='" + this.getString("shiftid")
						+ "' and doctype='C' and (dt_bg between '"
						+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
						+ "') and employeeid='" + emp + "'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord recChild = inq.getCurrentDbRecord().cloneRecord(true);
					recChild.delete();
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private void genRecord() {
		try {
			Vector vAdjustSub = new Vector();
			Vector vAdjustAdd = new Vector();
			
			DbTable dt;					
			if (this.getChild("Tchshift1_liteon")!=null) {
				dt = (DbTable) this.getChild("Tchshift1_liteon");			
			} else {
				dt = new InitialTable(this.userPro).getDbTable("Tchshift1_liteon");
				dt.setColumn("*");
				this.putChild(dt);
				this.refreshChild();
			}			
			dt.first();
			while (!dt.eof()) {
				Tchshift1_liteon db = (Tchshift1_liteon) dt.getCurrentRecordManager();
								
				DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				inqEmp.setParam(this.param);
				inqEmp.setSchemaName(this.userPro.getSchemaName());
				inqEmp.initMyTable("Memployee", "employeeid='" + db.getString("employeeid") + "'", "");
				inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate, emp_level, maternity, maternity_start, maternity_end");
				inqEmp.refresh();
				while (inqEmp.next()) {
					
					CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
					cs1.decDate();
					CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
					cs2.incDate();
					
					//Start Sub Transaction
					Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					rec.set("time0id", inqEmp.getString("time0"));
					rec.set("companyid", this.userPro.get("companyid"));
					rec.search();
					
					rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
					MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
									+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
					WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()), "true");
					if (!ws.isEmpty()) {
						MyLog.debug(this, "<<< WORKINGSHIFT OLD >>>");
						MyLog.debug(this, this.getUProfile(), ws.toString());					
						ws.setUProfile(this.userPro);
						ws.adjust();
						ws.setEmployeeid(inqEmp.getString("employeeid"));
						ws.overlapChecking();
						ws.createLink();
						Iterator itTime = this.getDocAllTimeZone().keySet().iterator();
						while (itTime.hasNext()) {
							String key = (String) itTime.next();
							TimeZone tz =  (TimeZone) this.getDocAllTimeZone().get(key);
														
							Vector vAdjust = ws.genSubShiftTrans(tz);

							MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
							Iterator it = vAdjust.iterator();
							MyLog.debug(this, "Transaction");
							while (it.hasNext()) {
								AdjustResult result = (AdjustResult) it.next();
								MyLog.debug(this, result.toString());
								if  (result.getType().equals("D")) {				
									DbRecord recSub = new InitialRecord(this.userPro).getDbRecord("Tadjtime0");								
									recSub.set("COMPANYID",this.getString("companyid"));
									recSub.set("DOCID",this.getString("shiftid"));
									recSub.set("DOCTYPE","C");
									recSub.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
									recSub.set("TM_BG",result.get_DT_BG().getCSCTime());
									recSub.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
									recSub.set("TM_EN",result.get_DT_EN().getCSCTime());									
									recSub.set("UPDTYPE",result.getType());									
									recSub.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
									recSub.set("EMPLOYEEID", db.getString("employeeid"));
									recSub.set("TIME0ID", result.getTimeCode());
									recSub.set("EVENTGRP", result.getEventGroup().substring(0,1));
									recSub.set("OLDTIME0ID", result.getOldTime0());
									recSub.set("OLDEVENTGRP", result.getOldEventGroup());
									recSub.set("LV_TY",result.get_LV_TY());
									recSub.set("LV",result.get_LV());
									recSub.set("TR_TYPE",result.getEventGroup()); 
									recSub.save();
								}
							}
						}
					}
					
					//Start Add Transaction
					Mtime0 recAdd = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recAdd.set("time0id", db.getString("new_shift"));
					recAdd.set("companyid", this.userPro.get("companyid"));
					recAdd.search();
					recAdd.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
					MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
									+ cs1.getYYYYMMDD() + ", end_date="	+ cs2.getYYYYMMDD());
					WorkingShift wsAdd = recAdd.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()), "true");
					MyLog.debug(this, "WORKINGSHIFT="+wsAdd);
					if (!wsAdd.isEmpty()) {					
						MyLog.debug(this, "<<< WORKINGSHIFT ADD >>>");
						cs1.incDate(); //cs2.decDate();
						Iterator it = wsAdd.keySet().iterator();
						while (it.hasNext()) {
							DayShift ds = (DayShift) wsAdd.get(it.next());
							Iterator it2 = ds.keySet().iterator();
							while (it2.hasNext()) {
								Shift sh = (Shift) ds.get(it2.next());
								if (sh.getShiftDate().afterEquals(cs1)&&sh.getShiftDate().beforeEquals(cs2)) {							
									MyLog.debug(this, this.getUProfile(),  sh.toString());
									DbRecord recAddData = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									recAddData.set("COMPANYID",this.getString("companyid"));
									recAddData.set("DOCID",this.getString("shiftid"));
									recAddData.set("DOCTYPE","C");
									recAddData.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									recAddData.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									recAddData.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									recAddData.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									recAddData.set("UPDTYPE","T");
									recAddData.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									recAddData.set("EMPLOYEEID",db.getString("employeeid"));
									recAddData.set("TIME0ID", sh.getTimeCode());
									recAddData.set("EVENTGRP", sh.getEventGroup());
									recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
									recAddData.set("OLDEVENTGRP", sh.getOldEventGroup());
									recAddData.set("LV_TY",sh.getLV_Type());
									recAddData.set("LV",sh.getLv());
									recAddData.set("TR_TYPE",sh.getTR_Type());
									recAddData.save();
								}
							}
						}
					}
					//this.genRecordDetail(db, inqEmp, "SUB");
					//this.genRecordDetail(db, inqEmp, "ADD");
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);

						
		}	
	}

	private void updateWFChild(String wf) {
		try {
			if (this.getChild("Tchshift1_liteon")!=null) {
				DbTable db = (DbTable) this.getChild("Tchshift1_liteon");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					db.next();				
				} while (!db.eof());		
				//db.save();
			} else {			
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tchshift1_liteon","", "");
				inq.setColumn("SHIFTID, COMPANYID, EMPLOYEEID, WF_STATUS");			
				this.putChild(inq);
				this.refreshChild();
				DbInquiry inqChild = (DbInquiry) this.getChild("Tchshift1_liteon");
				while (inqChild.next()) {
					DbRecord rec = inqChild.getCurrentDbRecord().cloneRecord(true);
					rec.set("wf_status",wf);
					rec.save();
				}
				this.removeChild("Tchshift1_liteon");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	public MyTreeMap getDocAllTimeZone(){
		MyTreeMap hm = new MyTreeMap();
		CscCalendar begDate = new CscCalendar(this.getString("start_date"));
		CscCalendar endDate = new CscCalendar(this.getString("end_date"));
		while (begDate.beforeEquals(endDate)) {	
			CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
			CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
			try {
				cs1.setCSCTime(0.00f);
				cs2.setCSCTime(23.59f);
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
			TimeZone tz = new TimeZone();
			tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
			tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			hm.put(begDate.getYYYYMMDD(), tz);
			begDate.incDate();			
		}
		return hm;
	}

	/*
	 * Ǩͺ  ӡâ¹е駤
	 */
    private boolean chkShiftMaternity() {
    	boolean result = true;
    	try {
    		DbInquiry inqTime = null;
    		DbInquiry inqEmp = null;
	    	if (this.getChild("Tchshift1_liteon")!=null) {
	    		MyHashMap hmTime = new MyHashMap(); 
				DbTable dt = (DbTable) this.getChild("Tchshift1_liteon");			
				dt.first();
				while (!dt.eof()) {					
					if (inqTime==null) {
						inqTime = new InitialInquiry(this.userPro).getDbInquiry();
						inqTime.setParam(this.param);
						inqTime.setSchemaName(this.userPro.getSchemaName());						
						inqTime.initMyTable("Mtime0", "", "");
					}
					
					if (inqEmp==null) {					
						inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
						inqEmp.setParam(this.param);
						inqEmp.setSchemaName(this.userPro.getSchemaName());						
						inqEmp.initMyTable("Memployee", "", "");
						inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate, emp_level, maternity, maternity_start, maternity_end");
						inqEmp.putChild(inqTime);
					}
					inqEmp.setFilter("employeeid='"+dt.getString("employeeid")+"'");
					inqEmp.refresh();
					if (inqEmp.next()) {
						DbRecord rec = inqEmp.getCurrentDbRecord();
						if (rec.getString("maternity").equals("1")) { //駤
							if (!hmTime.containsKey(dt.getString("new_shift"))) { //ʡʶҹТͧ÷ӡ MyHashMap 硵
								inqTime.setFilter("time0id='"+dt.getString("new_shift")+"'");
								inqTime.refresh();
								while (inqTime.next()) {
									hmTime.put(inqTime.getString("time0id"), inqTime.getString("maternity_shift"));									
								}
							}
							
							if (hmTime.containsKey(dt.getString("new_shift"))) { //Ǩͺҡз ö
								if (hmTime.getString("maternity").equals("1")) {
									CscCalendar c1 = new CscCalendar(this.getString("start_date"));
									CscCalendar c2 = new CscCalendar(this.getString("end_date"));									
									CscCalendar e1 = new CscCalendar(rec.getString("maternity_start"));
									CscCalendar e2 = new CscCalendar(rec.getString("maternity_end"));
									if (c1.after(e1) && c2.before(e2)) { //¹㹪ǧ駤
										return false;
									}									
								}
							} else return false; //ҡ
							
						}
					} else return false; //Ҿѡҹ
					dt.next();
				} //End while (!dt.eof())
			} //End if (this.getChild("Tchshift1_liteon")!=null)   	
    	} catch (Exception e) {
    		MyLog.error(this ,e);
    	}
    	return result;
    }
    
}
