package com.csc.library.databean;

import java.sql.Statement;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.GenShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

public class Texchangeshift_nstda extends RecordCmp {

	public Texchangeshift_nstda() {
		super("Texchangeshift_nstda", "Texchangeshift_nstda Table");
	}	
	
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();				
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			delDataAdjTime0();
			genExchangeShift();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delTexchangeShiftAdjData();
		}		
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delTexchangeShiftAdjData();
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delTexchangeShiftAdjData();
		}
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
	}
	
	public MyHashMap getDWRData() {
		return this.genRecord(false);
	}

	private MyHashMap genRecord(boolean isSave){
		MyHashMap hm = new MyHashMap();
		String timeCodeEmp = this.getTimeCode(this.getString("emp_exchange"));
		String timeCodeReceive = this.getTimeCode(this.getString("emp_receive"));
		
		hm.put("HM_EXCHANGE_SUB", this.genSubRecordDetail(this.getString("emp_exchange"), timeCodeEmp, isSave));
		hm.put("HM_EXCHANGE_ADD", this.genAddRecordDetail(this.getString("emp_exchange"), timeCodeReceive, isSave));
		hm.put("HM_RECEIVE_SUB", this.genSubRecordDetail(this.getString("emp_receive"), timeCodeReceive, isSave));		
		hm.put("HM_RECEIVE_ADD", this.genAddRecordDetail(this.getString("emp_receive"), timeCodeEmp, isSave));
		
		return hm;
	}
	
	public MyTreeMap getDocAllTimeZone(){
		MyTreeMap hm = new MyTreeMap();
		CscCalendar begDate = new CscCalendar(this.getString("start_date"));
		CscCalendar endDate = new CscCalendar(this.getString("end_date"));
		while (begDate.beforeEquals(endDate)) {	
			CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
			CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
			try {
				cs1.setCSCTime(0.00f);
				cs2.setCSCTime(23.59f);
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
			TimeZone tz = new TimeZone();
			tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
			tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			hm.put(begDate.getYYYYMMDD(), tz);
			begDate.incDate();			
		}
		return hm;
	}
	
	/* ҧ¹龹ѡҹ¹ оѡҹš */
	private boolean genExchangeShift(){
		try {
			if(!this.getString("shift_exchange").equals("") && !this.getString("shift_receive").equals("")){
				CscCalendar bg = new CscCalendar(this.getString("start_date"));
				CscCalendar en = new CscCalendar(this.getString("end_date"));

				/* ѹٻ¹ ǧѹ¹ */
				genChangeShift(this.getString("emp_exchange"), this.getString("shift_exchange"), this.getString("shift_receive")
						, bg.getYYYYMMDD(), en.getYYYYMMDD());	/* ¹龹ѡҹ¹ */
				genChangeShift(this.getString("emp_receive"), this.getString("shift_receive"), this.getString("shift_exchange")
						, bg.getYYYYMMDD(), en.getYYYYMMDD());	/* ¹龹ѡҹ¹ */
				
				return true;
			}else{
				MyLog.error("!! Error time0id not found, can't exchange shift between " + this.getString("shift_exchange") + " and " + this.getString("shift_receive"));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	private String getTimeCode(String employeeid){
		String timeCode="";
		try {
			DbRecord inqEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			inqEmp.setParam("rsc_skip","true");
			inqEmp.setColumn("employeeid, time0, companyid");
			inqEmp.set("employeeid",employeeid);
			if (inqEmp.search()==1) {
				timeCode = inqEmp.getString("time0");
			}else{
				MyLog.debug("!! Error : employeeid find not found !! ["+employeeid+"]");
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return timeCode;
	}

	private MyHashMap genSubRecordDetail(String emp, String timeCode, boolean isSave) {
		MyHashMap hm = new MyHashMap();
		try {
			DbRecord inqEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			inqEmp.setParam("rsc_skip","true");
			inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			inqEmp.set("employeeid",emp);
			
			if (inqEmp.search()==1) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", timeCode);
				recTime.set("companyid", this.userPro.get("companyid"));
				recTime.search();
				
				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				/**===================================================
				 * Author : Nuiss
				 * Date : 21/01/2553
				 * Logic : NSTDA öšѹش
				 */
				WorkingShift ws =null;
				String isTimeExChange = "";
    			try {
    				isTimeExChange = (String) StaticConfig.getConfigCompany(this.userPro, "TA_TIMEEXCHANGE");
    			} catch (Exception e) {
    				System.out.print("Can't Exchange time with stopday...");
    			}
				if(isTimeExChange.equals("")){
					recTime.setEmpRec(inqEmp);
					ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()));
				}else{
					recTime.setEmpRec(inqEmp);
					ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()),"true");
				}//end if
				/**=======================================================*/
				
				if (!ws.isEmpty()) {						
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(inqEmp.getString("employeeid"));
					ws.adjust();
					ws.overlapChecking();
					ws.createLink();
					
					int i=1;
					MyTreeMap tr = this.getDocAllTimeZone();
					Iterator itTime = tr.keySet().iterator();
					while (itTime.hasNext()) {
						String key = (String) itTime.next();
						TimeZone tz =  (TimeZone) tr.get(key);
													
						Vector vAdjust = ws.genSubShiftTrans(tz);

						Iterator it = vAdjust.iterator();
						while (it.hasNext()) {
							AdjustResult result = (AdjustResult) it.next();
							if  (result.getType().equals("D")&&result.get_DT_BG().getYYYYMMDD().equals(key)) {	
								if (isSave) {
									DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									rec.set("COMPANYID",this.getString("companyid"));
									rec.set("DOCID",this.getString("texshiftid"));
									rec.set("DOCTYPE","E");
									rec.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
									rec.set("TM_BG",result.get_DT_BG().getCSCTime());
									rec.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
									rec.set("TM_EN",result.get_DT_EN().getCSCTime());								
									rec.set("UPDTYPE",result.getType());
									rec.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
									rec.set("EMPLOYEEID", emp);
									rec.set("TIME0ID", result.getTimeCode());
									rec.set("EVENTGRP", result.getEventGroup().substring(0,1));
									rec.set("OLDTIME0ID", result.getOldTime0());
									rec.set("OLDEVENTGRP", result.getOldEventGroup());
									rec.set("LV_TY",result.get_LV_TY());
									rec.set("LV",result.get_LV());
									rec.set("TR_TYPE",result.getEventGroup()); 
									rec.set("HOUR_S", result.getHour_s());
									rec.set("WF_STATUS", this.getString("wf_status"));
									rec.save();
								} else {
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID",this.getString("companyid"));
									hmData.put("DOCID",this.getString("texshiftid"));
									hmData.put("DOCTYPE","E");
									hmData.put("DT_BG",result.get_DT_BG().getYYYYMMDD());
									hmData.put("TM_BG",result.get_DT_BG().getCSCTime());
									hmData.put("DT_EN",result.get_DT_EN().getYYYYMMDD());
									hmData.put("TM_EN",result.get_DT_EN().getCSCTime());								
									hmData.put("UPDTYPE",result.getType());
									hmData.put("DOCDATE",result.getAdjDate().getYYYYMMDD());
									hmData.put("EMPLOYEEID", emp);
									hmData.put("TIME0ID", result.getTimeCode());
									hmData.put("EVENTGRP", result.getEventGroup().substring(0,1));
									hmData.put("OLDTIME0ID", result.getOldTime0());
									hmData.put("OLDEVENTGRP", result.getOldEventGroup());
									hmData.put("LV_TY",result.get_LV_TY());
									hmData.put("LV",result.get_LV());
									hmData.put("TR_TYPE",result.getEventGroup()); 
									hmData.put("HOUR_S", result.getHour_s());
									hmData.put("WF_STATUS", this.getString("wf_status"));
									hm.put(String.valueOf(i),hmData);
									i++;
								}
							}
						}
					}
				}				
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return hm;
	}

	private MyHashMap genAddRecordDetail(String emp, String timeCode, boolean isSave) {
		MyHashMap hm = new MyHashMap();
		try {
			DbRecord inqEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			inqEmp.setParam("rsc_skip","true");
			inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			inqEmp.set("employeeid",emp);
			
			if (inqEmp.search()==1) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", timeCode);
				recTime.set("companyid", this.userPro.get("companyid"));
				recTime.search();
				
				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				/**===================================================
				 * Author : Nuiss
				 * Date : 21/01/2553
				 * Logic : NSTDA öšѹش
				 */
				WorkingShift ws =null;
				String isTimeExChange = "";
    			try {
    				isTimeExChange = (String) StaticConfig.getConfigCompany(this.userPro, "TA_TIMEEXCHANGE");
    			} catch (Exception e) {
    				System.out.print("Can't Exchange time with stopday...");
    			}
				if(isTimeExChange.equals("")){
					recTime.setEmpRec(inqEmp);
					ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()));
				}else{
					recTime.setEmpRec(inqEmp);
					ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()),"true");
				}//end if 
				/**===================================================*/
				if (!ws.isEmpty()) {						
					int i=1;
					cs1.incDate(); //cs2.decDate();
					Iterator it = ws.keySet().iterator();
					while (it.hasNext()) {
						DayShift ds = (DayShift) ws.get(it.next());
						Iterator it2 = ds.keySet().iterator();
						while (it2.hasNext()) {
							Shift sh = (Shift) ds.get(it2.next());
							
							if (sh.getShiftDate().afterEquals(cs1)&&sh.getShiftDate().beforeEquals(cs2)) {							
								if (isSave) {
									DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									rec.set("COMPANYID",this.getString("companyid"));
									rec.set("DOCID",this.getString("texshiftid"));
									rec.set("DOCTYPE","E");
									rec.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									rec.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									rec.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									rec.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									rec.set("UPDTYPE",sh.getEventGroup());
									rec.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									rec.set("EMPLOYEEID", emp);
									rec.set("TIME0ID", sh.getTimeCode());
									rec.set("EVENTGRP", sh.getEventGroup());
									rec.set("OLDTIME0ID", sh.getOldTimeCode());
									rec.set("OLDEVENTGRP", sh.getOldEventGroup());
									rec.set("LV_TY",sh.getLV_Type());
									rec.set("LV",sh.getLv());
									rec.set("TR_TYPE",sh.getTR_Type());
									rec.set("HOUR_S", sh.getHour_s());
									rec.set("WF_STATUS", this.getString("wf_status"));
									rec.save();
								} else {
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID",this.getString("companyid"));
									hmData.put("DOCID",this.getString("texshiftid"));
									hmData.put("DOCTYPE","E");
									hmData.put("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									hmData.put("TM_BG", sh.get_c_dt_in().getCSCTime());
									hmData.put("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									hmData.put("TM_EN", sh.get_c_dt_out().getCSCTime());								
									hmData.put("UPDTYPE","T");
									hmData.put("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									hmData.put("EMPLOYEEID", emp);
									hmData.put("TIME0ID", sh.getTimeCode());
									hmData.put("EVENTGRP", sh.getEventGroup());
									hmData.put("OLDTIME0ID", sh.getOldTimeCode());
									hmData.put("OLDEVENTGRP", sh.getOldEventGroup());
									hmData.put("LV_TY",sh.getLV_Type());
									hmData.put("LV",sh.getLv());
									hmData.put("TR_TYPE",sh.getTR_Type());
									hmData.put("HOUR_S", sh.getHour_s());
									hmData.put("WF_STATUS", this.getString("wf_status"));
									hm.put(String.valueOf(i),hmData);
									i++;
								}
							}
						}						
					}				
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
		return hm;
	}
	
	protected boolean preDeleteTrigger() throws Exception {
		boolean result = super.preDeleteTrigger();
		delTexchangeShiftAdjData();
		return result;
	}
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();
		
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result =  super.preUpdateTrigger();	
		delTexchangeShiftAdjData();
		return result;
	}
	
	/* óźšз źšѾഷἹ駴 */
	private void delTexchangeShiftAdjData(){
		try {
			StringBuffer filter = new StringBuffer();
        	filter.append("delete tadjtime0 ");
        	filter.append(" where docid = '").append(this.getString("texshiftid")).append("' and doctype = 'E'");
        	
        	this.executeQuery(filter.toString());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* óշѹ֡š еͧźš¹з¢ ͡͹ кִ¹ش (㺷ҡ͹˹Ҩж١źšѾഷἹ ѧ¹е鹩Ѻ) */
	private void delDataAdjTime0(){
		try {
			CscCalendar bg = new CscCalendar(this.getString("start_date"));
			CscCalendar en = new CscCalendar(this.getString("end_date"));

			/* źͧѡҹ */
			StringBuffer filter_emp = new StringBuffer();
			filter_emp.append(" delete tadjtime0 where docid in ");
			filter_emp.append(" (select docid from tadjtime0 where DOCDATE between '").append(bg.getYYYYMMDD()).append("' and '").append(en.getYYYYMMDD()).append("'");
			filter_emp.append(" and employeeid = '").append(this.getString("emp_exchange")).append("') and doctype in ('C','E')");
			
			/* źͧѡҹš */
			StringBuffer filter_rec = new StringBuffer();
			filter_rec.append(" delete tadjtime0 where docid in ");
			filter_emp.append(" (select docid from tadjtime0 where DOCDATE between '").append(bg.getYYYYMMDD()).append("' and '").append(en.getYYYYMMDD()).append("'");
			filter_rec.append(" and employeeid = '").append(this.getString("emp_receive")).append("') and doctype in ('C','E')");
        	
        	this.executeQuery(filter_emp.toString());
        	this.executeQuery(filter_rec.toString());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* method ѹ sql */
	private void executeQuery(String sql) {
		CscConnection conn = null;
    	Statement stmt = null;
    	boolean autoCommit=true;
    	
        try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			stmt.executeUpdate(sql);

			conn.commit();
			
        } catch (Exception e) {
            MyLog.error("!! Error in Tabsent_nstda.delDataTleave_summary !!", e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in Tchangeshift_nstda.delDataAdjTime0 !!",e);
    		}
        }
	}
	
	/** ҧš¹  */
	private void genChangeShift(String emp, String oldshift, String newshift, String st, String en) {
		MyHashMap hm = new MyHashMap();
		MyHashMap hmSub = new MyHashMap();
		MyHashMap hmAdd = new MyHashMap();
		MyHashMap hmOldShift = new MyHashMap();
		Vector vAdjustSub = new Vector();
		Vector vAdjustAdd = new Vector();
		try {
            DbRecord dbEMP = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
            dbEMP.setColumn("employeeid,time0,companyid,status,startdate,resigndate");
            dbEMP.setParam("rsc_skip","true");
            dbEMP.set("employeeid", emp);
            
            if(dbEMP.search() == 1) { // search found
				CscCalendar cs1 = new CscCalendar(st);
				CscCalendar cs2 = new CscCalendar(en);
				
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", oldshift);
				rec.set("companyid", this.userPro.get("companyid"));
				if(rec.search() == 1){
					rec.setEmpRec(dbEMP);
					
					/* ź͹ */
					WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), "true");	/* ҧἹ . .*/
					if (!ws.isEmpty()) {
						ws.setUProfile(this.userPro);
						ws.setEmployeeid(dbEMP.getString("employeeid"));
						ws.overlapChecking();
						ws.createLink();
						vAdjustSub = ws.genSubShiftTrans(this.getDocTimeZone());
						
						int i=1;
						Iterator it = vAdjustSub.iterator();
						while (it.hasNext()) {
							AdjustResult result = (AdjustResult) it.next();
							
							if (result.getType().equals("D")) {
								DbRecord recSub = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
								recSub.set("COMPANYID",this.getString("companyid"));
								recSub.set("DOCID",this.getString("texshiftid"));
								recSub.set("DOCTYPE","E");
								recSub.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
								recSub.set("TM_BG",result.get_DT_BG().getCSCTime());
								recSub.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
								recSub.set("TM_EN",result.get_DT_EN().getCSCTime());
								recSub.set("UPDTYPE",result.getType());
								recSub.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
								recSub.set("EMPLOYEEID",emp);
								recSub.set("TIME0ID",result.getTimeCode());
								recSub.set("EVENTGRP", result.getEventGroup().substring(0,1));
								recSub.set("OLDTIME0ID", result.getOldTime0());
								recSub.set("OLDEVENTGRP", result.getOldEventGroup());
								recSub.set("LV_TY",result.get_LV_TY());
								recSub.set("LV","0");
								recSub.set("TR_TYPE",result.getEventGroup()); 
								recSub.set("HOUR_S", result.getHour_s());
								recSub.set("WF_STATUS", this.getString("wf_status"));
								recSub.save();
							}
						} //End While Save Sub Transaction 		
					} 
					
					/*  */
					Mtime0 recAdd = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recAdd.set("time0id", newshift);
					recAdd.set("companyid", this.userPro.get("companyid"));
					recAdd.search();
					recAdd.setEmpRec(dbEMP);
					
					WorkingShift wsAdd = recAdd.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), "true");
					if (!wsAdd.isEmpty()) {					
						int j=1;
						Iterator it = wsAdd.keySet().iterator();
						while (it.hasNext()) {
							DayShift ds = (DayShift) wsAdd.get(it.next());
							Iterator it2 = ds.keySet().iterator();
							while (it2.hasNext()) {
								Shift sh = (Shift) ds.get(it2.next());
								
								if (sh.getShiftDate().afterEqualsDate(cs1)&&sh.getShiftDate().beforeEqualsDate(cs2)) {							
									DbRecord recAddData = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									recAddData.set("COMPANYID",this.getString("companyid"));
									recAddData.set("DOCID",this.getString("texshiftid"));
									recAddData.set("DOCTYPE","E");
									recAddData.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									recAddData.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									recAddData.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									recAddData.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									recAddData.set("UPDTYPE","T");
									recAddData.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									recAddData.set("EMPLOYEEID",emp);
									recAddData.set("TIME0ID", sh.getTimeCode());
									recAddData.set("EVENTGRP", sh.getEventGroup());
									recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
									if (hmOldShift.containsKey(sh.get_c_dt_in().getYYYYMMDD())) {
										recAddData.set("OLDTIME0ID", hmOldShift.getString(sh.get_c_dt_in().getYYYYMMDD()));
									} else recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
									recAddData.set("OLDEVENTGRP", sh.getOldEventGroup());
									recAddData.set("LV_TY",sh.getLV_Type());
									recAddData.set("LV","0");
									recAddData.set("TR_TYPE",sh.getTR_Type());
									recAddData.set("HOUR_S", sh.getHour_s());
									recAddData.set("WF_STATUS", this.getString("wf_status"));
									recAddData.save();
								}
							}
						} 
					} 
				}else{
					MyLog.debug("!! Time0id not found in Tchangeshift_nstda.genRecord() ,process teminate here !! ");
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	/* ҧ timezone */
	private TimeZone getDocTimeZone() {
		TimeZone tz = new TimeZone();
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		tz.setBeginZone(new CscCalendar(cs1.getYYYYMMDD() + " 00:00:00"));
		tz.setEndZone(new CscCalendar(cs2.getYYYYMMDD() + " 23:59:59"));
		return tz;
	}
}
