package com.csc.library.databean;

import com.csc.library.utilities.MyLog;

import java.sql.Statement;
import java.util.HashMap;
import java.util.StringTokenizer;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;

public class Tforgetcard0 extends RecordCmp {
	
	private DbTable dbChild=null;
	private DbInquiry inqEmp = null;
	private DbInquiry inqTforget1 = null;	
	private DbTable dbTforget1 = null; 

	public Tforgetcard0() {
		super("Tforgetcard0", "Tforgetcard0 Table");
	}
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TFORGETCARD0");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("fscardid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void chkEmpInq() {
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTforget1Inq() {
		try {
			if (this.inqTforget1 ==null) {
				this.inqTforget1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTforget1.setParam(this.param);
				this.inqTforget1.setSchemaName(this.userPro.getSchemaName());
				this.inqTforget1.initMyTable("Tforgetcard1", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTforget1Db() {
		try {
			if (this.dbTforget1 == null) {
				this.dbTforget1 = new InitialTable(this.userPro).getDbTable("Tforgetcard1");
				this.dbTforget1.setColumn("*");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}	
	}
	
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.refresh();
			this.inqEmp.setParam("rsc_skip","true");
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		
		/**====================Nuiss  Code===================
         * Author: Nuiss
         * Date : 27/04/2553
         * Site Use : PTT Only
         * If other site want use it. Must alter table and add fields "wf_doc_no" for this feature.
         */
        //this.setWFDocNo();
        /**====================Nuiss  Code===================*/

		this.updateWFChild(this.getString("wf_status"));
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }	
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
				this.getString("wf_status").equalsIgnoreCase("7") || 
				this.getString("wf_status").equalsIgnoreCase("B")) {	
			this.setColumn(this.getListKey()+",employeeid,wf_status");
			dbChild = (DbTable) this.getChild("Tforgetcard1");
			this.removeChild("Tforgetcard1");
		}		
		
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.setEmployeeDetail();
		} 
		this.updateWFChild(this.getString("wf_status"));
		return result;	
	}
	
	public void setProperties(){
		super.setProperties();
		try {
			 DbTable db = new InitialTable(this.userPro).getDbTable("Tforgetcard1");
			 this.putChild(db);
			 this.refreshChild("Tforgetcard1");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public int search() {
		return super.search();
	}
	
	protected void postInsertTrigger() throws Exception {
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.setNewData();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delOldData();
		}		
	}
	
	protected void postUpdateTrigger() throws Exception {
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.setNewData();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delOldData();
		}
		
	}
	
	private void updateWFChild(String wf) {
		try {
			if (this.dbChild != null) {
				this.putChild(this.dbChild);
			}
			if (this.getChild("Tforgetcard1")!=null) {
				DbTable db = (DbTable) this.getChild("Tforgetcard1");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					rec.set("WF_REF_DOC", this.getString("WF_REF_DOC"));
					rec.set("APPROVE", this.getString("APPROVE"));
					
					db.next();				
				} while (!db.eof());		
				//db.save();
			} else {			
				this.chkTforget1Inq();
				this.inqTforget1.setColumn("FSCARDID, COMPANYID, LINE_NO, WF_STATUS");						
				this.putChild(this.inqTforget1);
				this.refreshChild("Tforgetcard1");
				DbInquiry child = (DbInquiry) this.getChild("Tforgetcard1");				
				int lineNo =0;
				do{	
					lineNo++;
					DbRecord rec = child.getCurrentDbRecord().cloneRecord(true);
					rec.set("FSCARDID",this.getString("FSCARDID"));
					rec.set("COMPANYID",this.getString("COMPANYID"));
					rec.set("LINE_NO",lineNo);
					rec.set("wf_status",wf);
					rec.set("WF_REF_DOC", this.getString("WF_REF_DOC"));
					rec.set("APPROVE", this.getString("APPROVE"));
					rec.save();
				} while (child.next());	
				this.removeChild("Tforgetcard1");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
		
	
	private void delOldData() {	
		try {
			DbTable dt;
			DbInquiry inqTimetemp = null;
			if (this.getChild("Tforgetcard1")!=null) {
				dt = (DbTable) this.getChild("Tforgetcard1");
				this.refreshChild("Tforgetcard1");
			} else {
				this.chkTforget1Db();
				this.putChild(this.dbTforget1);
				this.refreshChild("Tforgetcard1");
				dt = (DbTable) this.getChild("Tforgetcard1");
			}
			
			delTimeTemp(this.getString("fscardid"));	/* ź timetemp */
			
			/*
			do{				
				DbRecord recChild = (DbRecord) dt.getCurrentRecordManager();   
				CscCalendar csc = new CscCalendar(recChild.getString("FORGET_DATE"));
				String filter = " employeeid='"+this.getString("EMPLOYEEID")+"' " +
						"and swipedate='"+csc.getYYYYMMDD()+"' " +
						"and swipetime="+recChild.getString("FORGET_TIME");			
				
				if (inqTimetemp==null) {
					inqTimetemp = new InitialInquiry(this.userPro).getDbInquiry();
					inqTimetemp.setParam(this.param);
					inqTimetemp.setSchemaName(this.userPro.getSchemaName());
					inqTimetemp.initMyTable("Ttimetemp", "" , "");
				}
				inqTimetemp.setFilter(filter);
				inqTimetemp.setColumn("SWIPEDATE, EMPLOYEEID, SWIPETIME, COMPANYID");
				inqTimetemp.refresh();
				while (inqTimetemp.next()) {				
					DbRecord rec = inqTimetemp.getCurrentDbRecord().cloneRecord(true);
					rec.delete();
				}				
				dt.next();				
			} while (!dt.eof());
			*/
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	/* ź Timetemp ͹ */
	private void delTimeTemp(String filter){
		CscConnection conn = null;
		Statement stmt = null;
		StringBuffer sql = new StringBuffer();
		boolean autoCommit = true;
		
		try {
			if(filter != null && filter.length() > 0){
				sql.append("delete from ttimetemp where docid = '").append(filter).append("'");
				
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
				autoCommit = conn.getAutoCommit();
    			conn.setAutoCommit(false);
    			
				stmt = conn.createStatement();
				stmt.executeUpdate(sql.toString());
				
				conn.commit();
			}
		} catch(Exception e){
			MyLog.error("!! Error : can't remove ttimetemp !!");
		} finally {
			try {
				if(stmt != null) stmt.close();
				if(conn!=null){
    	    		conn.setAutoCommit(autoCommit);
    	    		conn.close();
    	    	}
			} catch(Exception e) {
				MyLog.error("!! Error :  can't close connection or statement in Tforgetcard0.ttimetemp !!");
			}
		}
	}
	
	private void setNewData() {
		try {		
			String source = "0";
			/* ź Timetemp ͹ */
			this.delTimeTemp(this.getString("fscardid"));
			
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Ttimetemp");
			rec.setColumn("*");
			
			DbTable dt;					
			if (this.getChild("Tforgetcard1")!=null) {
				dt = (DbTable) this.getChild("Tforgetcard1");			
			} else {
				this.chkTforget1Db();
				this.putChild(this.dbTforget1);
				this.refreshChild("Tforgetcard1");
				dt = (DbTable) this.getChild("Tforgetcard1");
			}
			
			/* դ source  param ʴ繡÷ӧҹҡ HR System Ҩҡ WorkFlow */
			if (this.param.get("source") != null && !this.param.get("source").equals(""))
			    source = this.param.get("source").toString();
			else source = "5";
			
			dt.first();
			do{				
				DbRecord recChild = (DbRecord) dt.getCurrentRecordManager();
				
				rec.clearField();
				rec.set("COMPANYID", this.getString("COMPANYID"));			
				rec.set("EMPLOYEEID", this.getString("EMPLOYEEID"));		
				rec.set("SWIPEDATE", recChild.getString("FORGET_DATE"));
				rec.set("SWIPETIME", recChild.getString("FORGET_TIME"));
				rec.set("SWIPETYPE", recChild.getString("FORGET_TYPE"));
				rec.set("SOURCE", source); /* Ҩҡ WorkFlow դ 5 Ҩҡкͧ HR դ 7 */
				rec.set("WF_REF_DOC", this.getString("WF_REF_DOC")); 
				rec.set("APPROVE", this.getString("APPROVE"));
				rec.set("DOCID", this.getString("FSCARDID"));
				rec.save();
				
				dt.next();				
			} while (!dt.eof());		
						
		} catch (Exception e) {
			MyLog.error("!! Error in Tforgetcard0.setNewData() : can't save record in timetemp [id " + this.getString("FSCARDID"));						
		}		
	}
	
	protected boolean preDeleteTrigger() throws Exception { 
		this.delOldData();
		return super.preDeleteTrigger();
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		//this.delOldData();
	}
	 
	
	private void setWFDocNo(){	
		/**====================Nuiss  Code===================
	     * Author : Nuiss
	     * Date : 27/04/2553
	     * Logic :  WF_DOC_NO save ŧ table transacetion ͧ͡ù 
	     */
	    if(this.param!=null && this.param.containsKey("wf_doc_no")){
	    	String wf_doc_no =this.param.get("wf_doc_no").toString();
	    	this.set("wf_doc_no", wf_doc_no);
	    }//end if
	    /**====================Nuiss  Code===================*/
	}//end method setWFDocNo
}