package com.csc.library.databean;

import com.csc.library.utilities.MyLog;

import java.sql.Statement;
import java.util.HashMap;
import java.util.StringTokenizer;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;

public class Tforgetcard0_tmp extends RecordCmp {
	
	private DbTable dbChild=null;
	private DbInquiry inqEmp = null;
	private DbInquiry inqTforget1 = null;	
	protected DbTable dbTforget1 = null; 

	public Tforgetcard0_tmp() {
		super("Tforgetcard0_tmp", "Tforgetcard0_tmp Table");
	}
	
	private void chkEmpInq() {
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTforget1Inq() {
		try {
			if (this.inqTforget1 ==null) {
				this.inqTforget1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTforget1.setParam(this.param);
				this.inqTforget1.setSchemaName(this.userPro.getSchemaName());
				this.inqTforget1.initMyTable("Tforgetcard1_tmp", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	protected void chkTforget1Db() {
		try {
			if (this.dbTforget1 == null) {
				this.dbTforget1 = new InitialTable(this.userPro).getDbTable("Tforgetcard1_tmp");
				this.dbTforget1.setColumn("*");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}	
	}
	
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}
	
	public void setProperties(){
		super.setProperties();
		try {
			 DbTable db = new InitialTable(this.userPro).getDbTable("Tforgetcard1_tmp");
			 this.putChild(db);
			 this.refreshChild("Tforgetcard1_tmp");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void updateWFChild(String wf) {
		try {
			if (this.dbChild != null) {
				this.putChild(this.dbChild);
			}
			if (this.getChild("Tforgetcard1_tmp")!=null) {
				DbTable db = (DbTable) this.getChild("Tforgetcard1_tmp");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					db.next();				
				} while (!db.eof());		
			} else {			
				this.chkTforget1Inq();
				this.inqTforget1.setColumn("FSCARDID, COMPANYID, LINE_NO, WF_STATUS");						
				this.putChild(this.inqTforget1);
				this.refreshChild("Tforgetcard1_tmp");
				DbInquiry child = (DbInquiry) this.getChild("Tforgetcard1_tmp"); 
				if(child.foundData()){ //  record ͧ child ͧ save child
					int lineNo =0;
					do{	
						lineNo++;
						DbRecord rec = child.getCurrentDbRecord().cloneRecord(true);
						rec.set("FSCARDID",this.getString("FSCARDID"));
						rec.set("COMPANYID",this.getString("COMPANYID"));
						rec.set("LINE_NO",lineNo);
						rec.set("wf_status",wf);
						rec.save();
					} while (child.next());	
					this.removeChild("Tforgetcard1_tmp");
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
			
}