package com.csc.library.databean;

import java.util.HashMap;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.RecordCmp;

public class Tforgetcard1 extends RecordCmp {

	private DbInquiry inqEmp = null;
	
	public Tforgetcard1() {
		super("Tforgetcard1", "Tforgetcard1 Table");
	}
	
	private void setEmployeeDetail(){
		try {
			if (this.inqEmp ==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqEmp.setParam(this.param);
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
			}
			this.inqEmp.setFilter("employeeid='"+this.getString("employeeid")+"'");
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.setParam("rsc_skip","true");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	private void delOldData() {	
		try {
				DbInquiry inqTimetemp = new InitialInquiry(this.userPro).getDbInquiry();
				inqTimetemp.setParam(this.param);
				inqTimetemp.setSchemaName(this.userPro.getSchemaName());
				inqTimetemp.initMyTable("Ttimetemp", "" , "");
				
				StringBuffer filter = new StringBuffer();
				CscCalendar csc = new CscCalendar(this.getString("FORGET_DATE"));
				
				filter.append(" employeeid='").append((String)this.param.get("__employeeid")).append("' ");
				filter.append("and companyid='").append(this.getString("COMPANYID")).append("' ");
				filter.append("and swipedate='").append(csc.getYYYYMMDD()).append("' ");
				filter.append("and swipetime='").append(this.getString("FORGET_TIME")).append("'");			
				
				inqTimetemp.setFilter(filter.toString());
				inqTimetemp.setColumn("SWIPEDATE, EMPLOYEEID, SWIPETIME, COMPANYID");
				inqTimetemp.refresh();
				while (inqTimetemp.next()) {				
					DbRecord rec = inqTimetemp.getCurrentDbRecord().cloneRecord(true);
					rec.delete();
				}				
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	protected boolean preDeleteTrigger() throws Exception { 
		this.delOldData();
		return super.preDeleteTrigger();
	}
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();		
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.setEmployeeDetail();
		} 
		return result;
	}
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();	
		 CreateQuque();
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();	
		 CreateQuque();
	}
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		CreateQuque();
	}
	   /* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		DbInquiry inq_emp = new InitialInquiry(this.getUProfile()).getDbInquiry("TFORGETCARD0");
		inq_emp.setColumn("employeeid");
		inq_emp.setFilter("FSCARDID = '"+this.getString("FSCARDID")+"'");
		inq_emp.refresh();
			HashMap tmp_emp = null;
			while(inq_emp.next()){
			HashMap hmCon = new HashMap();
			hmCon.put("uprofile", this.userPro);
			hmCon.put("employeeid", "transfer");
			hmCon.put("companyid", "100");
			hmCon.put("schemaname", this.userPro.getSchemaName());
			hmCon.put("lang", "THA");
			hmCon.put("appname", "TA");
			//hmCon.put("dbname", this.userPro.get("dbname"));
			hmCon.put("startDate", this.getString("forget_date"));
			hmCon.put("endDate", this.getString("forget_date"));
			hmCon.put("cmdValue", "transfer");
			hmCon.put("delStatus", "true");
			hmCon.put("employeeBetween", "(employeeid between '"+inq_emp.getString("employeeid")+"' and '"+inq_emp.getString("employeeid")+"')");
	
			GenProcessQuque gpq = new GenProcessQuque();
			gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "TFORGETCARD", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
			}
	}

}