package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;

public class Tot extends RecordCmp {
	
	private MyHashMap hmResult = new MyHashMap();
	private DbInquiry inqEmp = null;
	boolean isDuplicateRequstOT = false ;
	public Tot() {
		super("Tot", "Tot Table");
	}
	
	private void setEmployeeDetail(){
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			rec.setColumn("*");
			rec.setParam("rsc_skip","true");
			rec.set("employeeid", this.getString("employeeid"));
			rec.set("companyid", (String)this.userPro.get("companyid"));
			
			if (rec.search() == 1) {
				this.set("bu1", rec.getString("bu1"));
				this.set("bu2", rec.getString("bu2"));
				this.set("bu3", rec.getString("bu3"));
				this.set("bu4", rec.getString("bu4"));
				this.set("bu5", rec.getString("bu5"));
				this.set("job", rec.getString("job"));
				this.set("emp_group", rec.getString("emp_group"));
				this.set("emp_position", rec.getString("emp_position"));
				this.set("branch", rec.getString("branch"));
				this.set("bossid", rec.getString("bossid"));
				this.set("salatype", rec.getString("salatype"));
				this.set("workarea", rec.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	

		setEmployeeDetail();
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		return super.preUpdateTrigger();
	}
	
	protected void postInsertTrigger() throws Exception {		
		super.postInsertTrigger();		
		CreateQuque();
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();	
		CreateQuque();
	}
	
	protected void postDeleteTrigger() throws Exception {
		super.postDeleteTrigger();
		CreateQuque();
	}

	private MyHashMap genRecord(boolean isSave) {
		MyHashMap hm = new MyHashMap();
		int count=1;
		
		MyHashMap hmShiftTemp = new MyHashMap();
		Vector vAdjust = new Vector();
		Mtime0 rec = null;
		WorkingShift wsNormal = null ;
				
		try {
			
			DbRecord emp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			emp.setColumn("*");
			emp.setParam("rsc_skip","true");
			emp.set("employeeid", this.getString("employeeid"));
			emp.set("companyid", (String)this.userPro.get("companyid"));
			
			if (emp.search() == 1) {
				rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate(3);
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate(3);
				
				rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				
				wsNormal = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()),"true");
				if (wsNormal!=null && !wsNormal.isEmpty()) {
					for (Iterator it = wsNormal.keySet().iterator(); it.hasNext();) {
						String key = (String) it.next();
						DayShift dsNormal = (DayShift) wsNormal.get(key);
						for (Iterator it2 = dsNormal.keySet().iterator(); it2.hasNext();) {
							String key2 = (String) it2.next();
							Shift sh = (Shift) dsNormal.get(key2);
							hmShiftTemp.put(sh.getShiftDate().getYYYYMMDD(), sh.getTimeCode());
						}
					}
				}
				wsNormal.setUProfile(this.userPro);
				wsNormal.setEmployeeid(this.inqEmp.getString("employeeid"));
				wsNormal.adjust();
				MyLog.debug(this, " ====== WorkingShitf Normal ====== ");
				MyLog.debug(this, this.getUProfile(), wsNormal.toString());
				
				WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()));
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.inqEmp.getString("employeeid"));
					ws.adjust();
					ws.overlapChecking();
					ws.createLink();
					
					ws.removeStopShift(); //ź shift  H  I 㹡ó¹
					
					MyLog.debug(this, this.getUProfile(), ws.toString());
					
					if (ws.chkAddShiftTrans(this.getDocTimeZone(this.getFloat("start_time"), this.getFloat("end_time")))) {
						MyLog.debug(this, "TIME NOT MATCH IN SHIFT !!!");
					} else vAdjust = ws.genAddShiftTrans(this.getDocTimeZone(this.getFloat("start_time"), this.getFloat("end_time")));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		try {
			DbRecord recOT = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
			recOT.setColumn("*");
			
			Iterator it = vAdjust.iterator();
			MyLog.debug(this, "ADD Transaction");
			while (it.hasNext()) {
				AdjustResult result = (AdjustResult) it.next();
				MyLog.debug(this, result.toString());
				
				String tmp="";				
				if (!result.get_DT_EN().getYYYYMMDD().equals(result.get_DT_BG().getYYYYMMDD())) {				
					WorkingShift wsOT = rec.genWorkingShift(new CscCalendar(result.get_DT_EN().getYYYYMMDD()), 
							new CscCalendar(result.get_DT_EN().getYYYYMMDD()),"true");
					String flag="0";
					if (!wsOT.isEmpty()) {					
						wsOT.setUProfile(this.userPro);
						wsOT.setEmployeeid(this.inqEmp.getString("employeeid"));
						wsOT.adjust();
						MyLog.debug(this, "======== wsOT==========");
						MyLog.debug(this, this.getUProfile(), wsOT.toString());
						MyLog.debug(this, this.getUProfile(), wsOT.keySet().toString());
						MyLog.debug(this, this.getUProfile(), String.valueOf(wsOT.size()));
						if (!wsOT.isEmpty()) {							
							DayShift ds = (DayShift) wsOT.get(result.get_DT_EN().getYYYYMMDD());
							Iterator dt = ds.keySet().iterator();
							while (dt.hasNext()) {
								String dKey = (String) dt.next();
								Shift sh = (Shift) ds.get(dKey);
								if (sh.getType()=='T'||sh.getType()=='H') {
									if (result.get_DT_EN().afterEquals(sh.get_c_dt_in())) {
										flag="1";
										continue;
									}
								}
							}							
						}
					} else { 
						tmp = this.getOTContinue(result);
					}
				}
				
				String timeCode = result.getTimeCode();
				if (wsNormal!=null) {
					if (wsNormal.containsKey(result.get_DT_BG().getYYYYMMDD())) {
						DayShift d = (DayShift) wsNormal.get(result.get_DT_BG().getYYYYMMDD());
						Iterator i = d.keySet().iterator();
						while (i.hasNext()) {
							String dKey = (String) i.next();
							Shift s = (Shift) d.get(dKey);
							if (!s.getTimeCode().equals(result.getTimeCode())) {
								timeCode = s.getTimeCode();
								MyLog.debug(this, ">>>timeCode Change === "+timeCode);
							}
						}
					}
				}
				
				MyHashMap hmData = new MyHashMap();
				hmData.put("DOCID", this.getString("otid"));
				hmData.put("DOCTYPE", "B");
				hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
				hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
				hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
				hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
				hmData.put("UPDTYPE", result.getType());
				hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
				hmData.put("EMPLOYEEID", this.getString("employeeid"));
				if (timeCode.trim().equals("")) {
					if (hmShiftTemp.containsKey(result.getAdjDate().getYYYYMMDD())) {
						hmData.put("TIME0ID", hmShiftTemp.getString(result.getAdjDate().getYYYYMMDD()));
					}
				} else hmData.put("TIME0ID", timeCode);
				hmData.put("EVENTGRP", "O");
				hmData.put("OLDTIME0ID", "");
				hmData.put("OLDEVENTGRP", "");
				hmData.put("LV_TY", "");
				hmData.put("LV", result.get_LV());
				hmData.put("TR_TYPE", result.getEventGroup());
				hmData.put("ADJUSTTEMP", tmp);
				hmData.put("STATUS", this.getString("status"));	
				hmData.put("PRIORITY", "2");	
				hmData.put("OT_WORKAREA", this.getString("ot_workarea"));
				hmData.put("OT_SALATYPE", this.getString("ot_salatype"));
				hmData.put("OT_TYPE", this.getString("ot_type"));
				hmData.put("OT_TIME0", this.getString("ot_time0"));
				hm.put(String.valueOf(count),hmData);
				this.hmResult.put(String.valueOf(count),hmData);
				count++;

			}
		} catch (Exception e1) {
			MyLog.error(this, e1);			
		}
		return hm;
	}

	private TimeZone getDocTimeZone(float startTime, float endTime) {
		TimeZone tz = new TimeZone();
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		try {
			cs1.setCSCTime(startTime);
			cs2.setCSCTime(endTime);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		return tz;
	}
	
	public MyHashMap getDWRData() {
		return this.genRecord(false);
	}
	
	private float getTotalOT() {
		float result = 0;
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		try {
			cs1.setCSCTime(this.getFloat("start_time"));
			cs2.setCSCTime(this.getFloat("end_time"));
			result = cs2.subForHour(cs1);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return result;
	}

	//㹡 Genarate Adjtime0 㹡óբ OT ѹ
	private String getOTContinue(AdjustResult result) {
		String value=""; 
		try {
			WorkingShift ws = null;
			DbRecord emp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			emp.setColumn("*");
			emp.setParam("rsc_skip","true");
			emp.set("employeeid", this.getString("employeeid"));
			emp.set("companyid", (String)this.userPro.get("companyid"));
			
			if (emp.search() == 1) {
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
				cs2.incDate();
				
				rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()), "true");
			}
			
			if (ws!=null) {
				CscCalendar csStart = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
				CscCalendar csEnd = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
				String tmpData="";
				while (csStart.beforeEquals(csEnd)) {
					tmpData="";
					//͹ 1 ѹ ҢͧѹѴ
					CscCalendar tmp = new CscCalendar(csStart.getYYYYMMDD());
					tmp.incDate();
										
					DayShift dsOUT = (DayShift) ws.get(csStart.getYYYYMMDD());
					Shift shOUT = (Shift) dsOUT.get((String) dsOUT.firstKey());
					
					DayShift dsIN = (DayShift) ws.get(tmp.getYYYYMMDD());
					Shift shIN = (Shift) dsIN.get((String) dsIN.firstKey());
				
					if (result.get_DT_BG().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
						tmpData += "DT_BG="+result.get_DT_BG().getYYYYMMDD()+",";
						tmpData += "TM_BG="+result.get_DT_BG().getCSCTime()+",";
					} else {
						tmpData += "DT_BG="+shOUT.get_c_dt_in().getYYYYMMDD()+",";
						tmpData += "TM_BG="+shOUT.get_c_dt_in().getCSCTime()+",";
					}
					
					if (!result.get_DT_EN().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
						tmpData += "DT_EN="+shIN.get_c_dt_in().getYYYYMMDD()+",";
						tmpData += "TM_EN="+shIN.get_c_dt_in().getCSCTime()+",";
					} else {
						tmpData += "DT_EN="+result.get_DT_EN().getYYYYMMDD()+",";
						tmpData += "TM_EN="+result.get_DT_EN().getCSCTime()+",";
					}
			
					tmpData += "TIMECODE="+shOUT.getTimeCode()+",";					
					MyLog.debug(this, tmpData);
					csStart.incDate();
					value += tmpData+"#";
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}	
		MyLog.debug(this, ">>>>>>>>>> "+value);
		return value;
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("start_date"));
		hmCon.put("endDate", this.getString("end_date"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "TOT", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}
}