package com.csc.library.databean;

import com.csc.library.utilities.MyLog;

import java.util.HashMap;
import java.util.StringTokenizer;

import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;

public class Tot1 extends RecordCmp {

	private DbInquiry inqEmp = null;
	
	public Tot1() {
		super("Tot1", "Tot1 Table");
	}
	
	private void setEmployeeDetail(){
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			rec.setColumn("*");
			rec.setParam("rsc_skip","true");
			rec.set("employeeid", this.getString("employeeid"));
			rec.set("companyid", (String)this.userPro.get("companyid"));
			
			if (rec.search() == 1) {
				this.set("bu1", rec.getString("bu1"));
				this.set("bu2", rec.getString("bu2"));
				this.set("bu3", rec.getString("bu3"));
				this.set("bu4", rec.getString("bu4"));
				this.set("bu5", rec.getString("bu5"));
				this.set("job", rec.getString("job"));
				this.set("emp_group", rec.getString("emp_group"));
				this.set("emp_position", rec.getString("emp_position"));
				this.set("branch", rec.getString("branch"));
				this.set("bossid", rec.getString("bossid"));
				this.set("salatype", rec.getString("salatype"));
				this.set("workarea", rec.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();		
		setEmployeeDetail();
		this.set("TOTAL_TIME", this.getTotalOT()); 
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		setEmployeeDetail();

		this.set("TOTAL_TIME", this.getTotalOT()); 
		return result;
	}
	
	private float getTotalOT() {
		float result = 0;
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		try {
			cs1.setCSCTime(this.getFloat("start_time"));
			cs2.setCSCTime(this.getFloat("end_time"));
			result = cs2.subForHour(cs1);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return result;
	}
		
	public MyTreeMap getDocAllTimeZone(){
		MyTreeMap hm = new MyTreeMap();
		CscCalendar begDate = new CscCalendar(this.getString("start_date"));
		CscCalendar endDate = new CscCalendar(this.getString("end_date"));
		while (begDate.beforeEquals(endDate)) {	
			CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
			CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
			try {
				cs1.setCSCTime(this.getFloat("start_time"));
				cs2.setCSCTime(this.getFloat("end_time"));
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
			TimeZone tz = new TimeZone();
			tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
			tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			hm.put(begDate.getYYYYMMDD(), tz);
			begDate.incDate();			
		}
		return hm;
	}
	
	public TimeZone getDocTimeZone(){
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));		
		try {
			cs1.setCSCTime(this.getFloat("start_time"));
			cs2.setCSCTime(this.getFloat("end_time"));
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		TimeZone tz = new TimeZone();
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));		
		return tz;
	}
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();	
		 CreateQuque();
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();	
		 CreateQuque();
	}
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		CreateQuque();
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("start_date"));
		hmCon.put("endDate", this.getString("end_date"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "TOT1", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}
}