package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;

public class Tot_af_manyemp0 extends RecordCmp{

    public Tot_af_manyemp0() {
        super("Tot_af_manyemp0","Tot_af_manyemp0 Table");
        // TODO Auto-generated constructor stub
    }
    
    protected void postInsertTrigger() throws Exception {         
        super.postInsertTrigger();
        this.genRecord();
    }

    protected void postUpdateTrigger() throws Exception {       
    	super.postUpdateTrigger();
        this.genRecord();        
    }
    
    protected void postDeleteTrigger() throws Exception {               
        super.postDeleteTrigger();
        this.delDataTot_af_process();
    }
    
    /*protected boolean preInsertTrigger() throws Exception {         
        boolean result = super.preInsertTrigger();
        this.genRecord();
        return result;
    }

    protected boolean preUpdateTrigger() throws Exception {       
    	boolean result = super.preUpdateTrigger();
        this.genRecord();      
        return result;
    }
    
    protected boolean preDeleteTrigger() throws Exception {               
    	boolean result = super.preDeleteTrigger();
        this.delDataTot_af_process();
        return result;
    }*/
    
    private void genRecord() {
        try {
            DbTable dt;
            if (this.getChild("Tot_af_manyemp1") != null) {
                dt = (DbTable) this.getChild("Tot_af_manyemp1");
            } else {
                dt = new InitialTable(this.userPro).getDbTable("Tot_af_manyemp1");
                dt.setColumn("*");
                this.putChild(dt);
                this.refreshChild();
            }
            dt.first();
            
            while (!dt.eof()) {
            	try {
	            	DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Tot_af_process");
	                rec.setColumn("*");
	                rec.set("COMPANYID", this.getString("companyid"));
	                rec.set("DOCID", this.getString("otid"));
	                rec.set("DOCTYPE", "OM");
	                rec.set("START_DATE", dt.getString("start_date"));
	                rec.set("END_DATE", dt.getString("end_date"));
	                rec.set("START_TIME", dt.getString("start_time"));
	                rec.set("END_TIME", dt.getString("end_time"));
	                rec.set("EMPLOYEEID", dt.getString("employeeid"));
	                rec.setWFOff();
	                rec.save();
            	} catch (Exception e) {
            		MyLog.error(this, e);           		
            	}
                dt.next();
              }
               
        } catch (Exception e) {
        	MyLog.error(this, e);            
        }
    }
    
    private void delDataTot_af_process() {        
        try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tot_af_process", "docid='" + this.getString("otid") + "' and doctype='OM'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
    }
    
    
}
