package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.database.FieldManager;
import com.csc.library.database.PropertyField;
import com.csc.library.session.RecordCmp;

public class Tot_af_process extends RecordCmp{
	
	DecimalFormat df = new DecimalFormat("0.00");

    public Tot_af_process() {
        super("Tot_af_process","Tot_af_process Table");
        // TODO Auto-generated constructor stub
    }
    
    public FieldManager getField(String fieldName) {
    	if (fieldName.equalsIgnoreCase("ot_total")) {
    		FieldManager fm = this.initField("String", "", 0, 0, "");
    		PropertyField pf = (PropertyField) this.getField("doctype").getProperty().clone();
    		fm.setProperty(pf);
    		fm.setWorking(true);
    		fm.setName("ot_total");	
    		String desc = "";
    		if (this.getUProfile().get("lang").equalsIgnoreCase("THA")) 
    			desc = "ͷ";
    		else desc = "OT Total";
    		fm.setDescription(desc);
    		try {
    			CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
    			cs1.setCSCTime(this.getFloat("start_time"));
    			CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
    			cs2.setCSCTime(this.getFloat("end_time"));
    			String value = String.valueOf(cs2.subForHour(cs1));
    			fm.set(df.format(Double.parseDouble(value)));
    		} catch (Exception e) {
    			MyLog.error(this, e);
    		}
    		return fm;
    	} else return super.getField(fieldName);
    }

}
