package com.csc.library.databean;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.csc.library.database.ChildManager;
import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.*;
import com.csc.library.utilities.MyLog;

public class Tot_days0 extends RecordCmp{
	
	private DbRecord recUnused = null;
	private DbInquiry inqTot_day1 = null;

    public Tot_days0() {
        super("Tot_days0","Tot_days0 Table");
    }
   
   private void chkTot_day1Inq() {
        try{
            if (this.inqTot_day1  == null) {
            	this.inqTot_day1 = new InitialInquiry(this.userPro).getDbInquiry();
            	this.inqTot_day1.setParam(this.param);
            	this.inqTot_day1.setSchemaName(this.userPro.getSchemaName());
            	this.inqTot_day1.initMyTable("Tot_days1", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this ,e);
        }
    }

    @Override
    protected boolean preInsertTrigger() throws Exception {
        boolean result = super.preInsertTrigger();
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
        return result;
    }
    
    @Override
    protected boolean preUpdateTrigger() throws Exception {
        boolean result = super.preUpdateTrigger();
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
        return result;
    }
    
    @Override
    protected void postInsertTrigger() throws Exception {
        super.postInsertTrigger();
        this.saveUnUsed();
        //update by Nuiss
        this.updateMempl_unused();
    }
    
    @Override
    protected void postUpdateTrigger() throws Exception {
        super.postUpdateTrigger();
        this.saveUnUsed();
        //update by Nuiss
        this.updateMempl_unused();
    }
    
    @Override
    protected void postDeleteTrigger() throws Exception {
        super.postDeleteTrigger();
        //update by Nuiss
        this.updateMempl_unused();
    }//end method 
    
    private void saveUnUsed(){
        try{
            this.chkTot_day1Inq();
            this.inqTot_day1.setColumn("OTID,COMPANYID,OT_DATE,DIGEST_OT");
            ChildManager  Tot_day1 = this.getChild("tot_days1");
            this.putChild(this.inqTot_day1);
            this.refreshChild("Tot_days1");
            
            do{
            	this.isSaveUnUsed(this.inqTot_day1.getString("ot_date")
            			,this.inqTot_day1.getString("DIGEST_OT")
                        ,this.inqTot_day1.getString("OTID"));
            }while (this.inqTot_day1.next());
            
            if(Tot_day1!= null) this.putChild(Tot_day1);
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }//end try
    }
    
    private void isSaveUnUsed(String ot_date, String un5_value, String un5_docno){
    	try{
        	if (this.recUnused==null) {
        		this.recUnused = new InitialRecord(this.userPro).getDbRecord("Mempl_unused");
        		this.recUnused.setColumn("*");
        	}
        	this.recUnused.clearField();
        	this.recUnused.set("employeeid", this.getString("employeeid"));
        	this.recUnused.set("companyid", this.getString("companyid"));
        	this.recUnused.set("dateid", ot_date);
        	this.recUnused.set("un5_value", un5_value);
        	this.recUnused.set("un5_doctype", "O");
            this.recUnused.set("un5_docno", un5_docno);
            this.recUnused.save();
        }catch (Exception e) {
            MyLog.error("SET Field Error in Table MEMPL_UNUSED : ", e);
        }
    }
    
    /**
     * Author : Nuiss
     * Date : 02/07/2552
     * Logic : delete row ͡ҡ tot_days1 ͧ 
     * 		 update mempl_unused.un5_value = ""  
     * 
     * code  ѹ update ѧҡա delete row  ѹ update  
     * @throws SQLException 
     */
    private void updateMempl_unused() throws SQLException{
    	CscConnection conn = null;
   	   	Statement stmt =null;
        ResultSet resultSet = null;
        String employeeid = this.getString("employeeid");
        String otid = this.getString("otid");
        String companyid = this.getString("companyid");
       
       String SQLQuery = "SELECT mun.employeeid,mun.dateid"+
       " ,mun.un5_docno,mun.un5_doctype,mun.un5_value"+
       " ,ot1.otid,ot1.digest_ot,'update' as rowFlag" +
       " FROM mempl_unused mun left outer join tot_days1 ot1 on(mun.dateid=ot1.ot_date and mun.un5_docno=ot1.otid)"+
       " WHERE mun.employeeid ='"+employeeid+"' "+
       " and mun.companyid ='"+companyid+"' "+
       " UNION ALL"+
       " SELECT  t0.employeeid,t1.ot_date"+
       " ,t1.otid as un5_docno ,'O' as un5_doctype ,t1.digest_ot as un5_value"+
       " ,t1.otid,t1.digest_ot,'insert' as rowFlag"+
       " FROM tot_days0 t0,tot_days1 t1   "+
       " WHERE t0.otid = t1.otid"+
       " and t0.otid ='"+otid+"'"+
       " and t1.ot_date not in (select dateid from mempl_unused where un5_docno='"+otid+"')";

 		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(SQLQuery);
					
			while (resultSet.next()) {
				String digestValue = "";
				String docNo ="";
				String docType ="";
				if(resultSet.getString("otid")!=null){
					docNo=resultSet.getString("otid");
					docType=resultSet.getString("un5_doctype");
					digestValue=resultSet.getString("digest_ot");
				}//end if 
				String whereClause = "EMPLOYEEID = '"+employeeid+"' " 
				+" and COMPANYID = '" +companyid+ "' "
				+" and DATEID = '"+resultSet.getString("dateid")+"' ";
				
				DbInquiry inqUnused = new InitialInquiry(this.userPro).getDbInquiry();		
				inqUnused.initMyTable("mempl_unused", whereClause, "");
				inqUnused.setColumn("EMPLOYEEID,COMPANYID,DATEID,UN5_DOCNO,UN5_DOCTYPE,UN5_VALUE");
				inqUnused.refresh();
				DbRecord dbRecord = inqUnused.getCurrentDbRecord().cloneRecord(true);
				dbRecord.set("EMPLOYEEID", employeeid);
				dbRecord.set("COMPANYID", companyid);
				dbRecord.set("DATEID", resultSet.getString("dateid"));
				dbRecord.set("UN5_DOCNO", docNo);
				dbRecord.set("UN5_DOCTYPE", docType);
				dbRecord.set("UN5_VALUE", digestValue);
				dbRecord.save();
			}//end while 
			
		}catch(Exception ex){
			System.out.print(">>>>>Error on Tot_days0.updateMempl_unused()"+ex.getStackTrace())	;
		}finally{
			resultSet.close();
			if(stmt!=null){
				stmt.close();
			}
			conn.close();
		}//end try
    }//end method updateMempl_unused
    
}//end class
