package com.csc.library.databean;

import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class Tot_suspension0 extends RecordCmp{

    private DbTable dbTot_suspension1;
    private DbInquiry inqEmp;
    private DbInquiry inqTime;
    private DbInquiry inqTime1;
    
    public Tot_suspension0() {
        super("Tot_suspension0", "Tot_suspension0 Table");
    }

    private void chkEmpInq() {
        try {
            if (this.inqEmp ==null) {
                this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
                this.inqEmp.setParam(this.param);
                this.inqEmp.setSchemaName(this.userPro.getSchemaName());
                this.inqEmp.initMyTable("Memployee", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this, e);
        }
    }

    
    private void chkTot_suspension1Db() {
        try {
            if (this.dbTot_suspension1 == null) {
                this.dbTot_suspension1 = (DbTable) this.getChild("Tot_suspension1");
                this.dbTot_suspension1.setColumn("*");
            }
        } catch (Exception e) {
            MyLog.debug(this, e);
        }   
    }
    
    private void chkTimeInq(){
        try {
            if (this.inqTime ==null) {
                this.inqTime = new InitialInquiry(this.userPro).getDbInquiry();
                this.param.put("__screen", "");
                this.inqTime.setParam(this.param);
                this.inqTime.setSchemaName(this.userPro.getSchemaName());
                this.inqTime.initMyTable("Ttime_current", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this, e);
        }        
    }
    
    private void chkTime1Inq(){
        try {
            if (this.inqTime1 ==null) {
                this.inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
                this.inqTime1.setParam(this.param);
                this.inqTime1.setSchemaName(this.userPro.getSchemaName());
                this.inqTime1.initMyTable("Ttime_current1", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this, e);
        }        
    }    
    
    @Override
    protected boolean preInsertTrigger() throws Exception {
        boolean result = super.preInsertTrigger();
        String time0id = "";
        DbTable dt;
        String filter = "";
        if (this.getChild("Tot_suspension1") != null) {
            dt = (DbTable) this.getChild("Tot_suspension1");
        } else {
            this.chkTot_suspension1Db();
            this.putChild(this.dbTot_suspension1);
            this.refreshChild("Tot_suspension1");
            dt = (DbTable) this.getChild("Tot_suspension1");
        }
        dt.first();
        
        CscCalendar csStart = new CscCalendar(this.getString("start_date"));
        CscCalendar csEnd = new CscCalendar(this.getString("end_date"));

        while (!dt.eof()) {
            while(csEnd.afterEquals(csStart)){
                filter = "employeeid = '" + dt.getString("employeeid")+"' and dateid = '"+csStart.getYYYYMMDD()+"'";
                this.chkTimeInq();                
                this.inqTime.setColumn("employeeid,companyid,time0id,dateid,unused5");
                this.inqTime.setFilter(filter);
                this.inqTime.refresh();
                while(inqTime.next()){
                    DbRecord rec = inqTime.getCurrentDbRecord().cloneRecord(true);
                    rec.setParam(this.param);
                    rec.set("UNUSED5", "1");
                    rec.save();
                    this.chkTime1Inq();
                    this.inqTime1.setFilter(filter);
                    this.inqTime1.setColumn("employeeid,companyid,time0id,dateid,unused5");
                    this.inqTime1.refresh();
                    while(this.inqTime1.next()){
                        DbRecord rec1 = inqTime1.getCurrentDbRecord().cloneRecord(true);
                        rec1.set("UNUSED5", "1");
                        rec1.save();
                    }
                }
                csStart.incDate();
            }
            dt.next(); 
        }
        return result;
    }
    
}
