package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

/*
 * šâͷͷ ͧ Ƿ
 */
public class Trequestwork_nstda extends RecordCmp {
			
	AdjustResult result=null;	
	float hour_s=0;
	
	public Trequestwork_nstda() {
		super("Trequestwork_nstda", "Trequestwork_nstda Table");
	}	
	
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();				
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}		
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord(true);
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}
	
	public MyHashMap getDWRData() {
		return this.genRecord(false);
	}

	private void delDataAdjTime0() {
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", "docid='"+this.getString("requestid")+"' and doctype='S'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	
	// Day Type 繡ҷѺ - 
	private String getDayType() {
		String result="";
		try {			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Meventgrp", "EVENTGRPID='"+this.getString("request_type")+"'", "");
			inq.setColumn("eventgrpid, companyid, daytype");
			inq.refresh();
			while (inq.next()) {
				result = inq.getCurrentDbRecord().getString("daytype");
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return result;
	}
	
	/*private TimeZone getDocTimeZone(Shift shCheck) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(shCheck.get_c_dt_in().getYYYYMMDD());
		CscCalendar cs2 = new CscCalendar(shCheck.get_c_dt_out().getYYYYMMDD());		
		try {
			cs1.setCSCTime(shCheck.get_c_dt_in().getCSCTime());
			cs2.setCSCTime(shCheck.get_c_dt_out().getCSCTime());
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
		return tz;
	}*/

	private TimeZone getDocTimeZone(Shift shCheck, float startTime, float endTime) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(shCheck.get_c_dt_in().getYYYYMMDD());
		CscCalendar cs2 = new CscCalendar(shCheck.get_c_dt_out().getYYYYMMDD());		
		if (cs1.subForDay(shCheck.get_c_dt_in())!=0 && startTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs1.incDate();
		}
		if (cs2.subForDay(shCheck.get_c_dt_in())!=0 &&  endTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs2.incDate();
		}
		try {
			cs1.setCSCTime(startTime);
			cs2.setCSCTime(endTime);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
		return tz;
	}

	private MyHashMap genRecord(boolean isSave) {
		MyHashMap hm = new MyHashMap();
		Vector vAdjust = new Vector();
		int i=1;
		try {
			DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
			inqEmp.setParam(this.param);
			inqEmp.setSchemaName(this.userPro.getSchemaName());
			inqEmp.initMyTable("Memployee", "employeeid='"	+ this.getString("employeeid") + "'", "");
			inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
			inqEmp.refresh();
			while (inqEmp.next()) {
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				cs2.incDate();
				
				rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
				MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
								+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
				WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()), this.getDayType());				
				if (!ws.isEmpty()) {					
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(inqEmp.getString("employeeid"));
					ws.adjustLeave();
					ws.overlapChecking();
					ws.createLink();
					
					//WorkingShift for check is Null;
					WorkingShift wsCheck = (WorkingShift) ws.clone();
					Shift shCheck=null;
					CscCalendar cscStart=new CscCalendar(this.getString("start_date"));					
					CscCalendar cscEnd=new CscCalendar(this.getString("end_date"));					
					while (cscEnd.afterEquals(cscStart)) {
						Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
						if (itDS.hasNext()) {
							DayShift dsCheck = (DayShift) wsCheck.get(cscStart.getYYYYMMDD());
							if (!dsCheck.isEmpty()) {
								Iterator itSH = (Iterator) dsCheck.keySet().iterator();
								if (itSH.hasNext()) {
									shCheck = (Shift) dsCheck.get((String) itSH.next());
								}
							}
						}					
						
						try {
							
							if (shCheck!=null) {
								vAdjust = ws.genSubShiftTrans(this.getDocTimeZone(shCheck, this.getFloat("start_time"), this.getFloat("end_time")));
								MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
								Iterator it = vAdjust.iterator();			
								while (it.hasNext()) {
									//AdjustResult result = (AdjustResult) it.next();
									result = (AdjustResult) it.next();	
									
									if (!result.getEventGroup().substring(0,1).equalsIgnoreCase("O")) {
										MyLog.debug(this, result.toString());
										if (isSave) {
											DbRecord recADJ = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
											recADJ.set("COMPANYID", this.getString("companyid"));
											recADJ.set("DOCID", this.getString("requestid"));
											recADJ.set("DOCTYPE", "S");
											recADJ.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
											recADJ.set("TM_BG", result.get_DT_BG().getCSCTime());
											recADJ.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
											recADJ.set("TM_EN", result.get_DT_EN().getCSCTime());
											recADJ.set("UPDTYPE", result.getType());
											recADJ.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
											recADJ.set("EMPLOYEEID", this.getString("employeeid"));
											recADJ.set("TIME0ID", result.getTimeCode());
											recADJ.set("EVENTGRP", this.getString("request_type"));
											recADJ.set("OLDTIME0ID", "");
											recADJ.set("OLDEVENTGRP", "");
											recADJ.set("LV_TY", this.getString("request_type"));
											recADJ.set("LV", this.getHourDAdjust(result.getTimeCode(), 
													result.get_DT_BG().getYYYYMMDD(), result.get_DT_EN().getYYYYMMDD(),
													result.get_DT_BG().getCSCTime(), result.get_DT_EN().getCSCTime()));recADJ.set("TR_TYPE", result.getEventGroup());
											recADJ.set("STATUS", this.getString("status"));
											recADJ.set("PRIORITY", "1");
											recADJ.set("HOUR_S", this.hour_s);
											recADJ.save();
										} else {
											if (result.getType().equalsIgnoreCase("A")) {
												MyHashMap hmData = new MyHashMap();
												hmData.put("DOCID", this.getString("requestid"));
												hmData.put("DOCTYPE", "S");
												hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
												hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
												hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
												hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
												hmData.put("UPDTYPE", result.getType());
												hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
												hmData.put("EMPLOYEEID", this.getString("employeeid"));
												hmData.put("TIME0ID", result.getTimeCode());
												hmData.put("EVENTGRP", this.getString("request_type"));
												hmData.put("OLDTIME0ID", "");
												hmData.put("OLDEVENTGRP", "");
												hmData.put("LV_TY", this.getString("request_type"));
												hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
														result.get_DT_BG().getYYYYMMDD(), result.get_DT_EN().getYYYYMMDD(),
														result.get_DT_BG().getCSCTime(), result.get_DT_EN().getCSCTime()));
												hmData.put("TR_TYPE", result.getEventGroup());
												hmData.put("STATUS", this.getString("status"));
												hmData.put("PRIORITY", "1");
												hmData.put("HOUR_S", this.hour_s);
												hm.put(String.valueOf(i),hmData);
												i++;
											}
										}
									}									
								}
							}
						} catch (Exception e1) {
							MyLog.error(this, e1);

							
						}						
						cscStart.incDate();						
					}
					//vAdjust = ws.genSubShiftTrans(this.getDocTimeZone());
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return hm;
	}
	
	private float getHourDAdjust(String timeCode, String date1, String date2, float time1, float time2) {
		float hour = 0; 
		try {			
			float break_hour = 0;
			CscCalendar cs1=null, cs2=null;
			CscCalendar cs = new CscCalendar(date1);
			String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
			DbInquiry inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
			inqTime1.setParam(this.param);
			inqTime1.setSchemaName(this.userPro.getSchemaName());
			inqTime1.initMyTable("Mtime1", filter, "");
			inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
			inqTime1.refresh();
			if (inqTime1.next()) {
				DbRecord rec = inqTime1.getCurrentDbRecord();
				
				this.hour_s = rec.getFloat("hour_d");
				
				//Break Hour
				cs1 = new CscCalendar(date1);
				cs1.setCSCTime(rec.getFloat("timeout1"));
				cs2 = new CscCalendar(date2);
				cs2.setCSCTime(rec.getFloat("timein2"));
				if (rec.getFloat("timein2") < rec.getFloat("timeout1")) {
					cs2.incDate();
				}
				//MyLog.debug(this, ">>> BREAK HOUR >>> cs1="+cs1.getTimestamp()+" >>> cs2="+cs2.getTimestamp());
				break_hour = cs2.subForHour(cs1);
				//Working Hour
				CscCalendar cs3 = new CscCalendar(date1);
				cs3.setCSCTime(rec.getFloat("timein1"));
				CscCalendar cs4 = new CscCalendar(date2);
				cs4.setCSCTime(rec.getFloat("timeout2"));
				if (rec.getFloat("timeout2") < rec.getFloat("timein1")) {
					cs4.incDate();
				}
				//MyLog.debug(this, ">>> WORKING HOUR >>> cs3="+cs3.getTimestamp()+" >>> cs4="+cs4.getTimestamp());
				//MyLog.debug(this, ">>> WORKING >>> "+cs4.subForHour(cs3));
				//MyLog.debug(this, ">>> BREAK >>> "+break_hour);
				//hour = cs4.subForHour(cs3) - break_hour;				
				CscTime c = new CscTime(cs4.subForHour(cs3));
				c.sub(break_hour);
				hour = c.getFloat();				
			}
			
			CscCalendar c_dt_in = new CscCalendar(date1);
			c_dt_in.setCSCTime(time1);
			CscCalendar c_dt_out = new CscCalendar(date2);
			c_dt_out.setCSCTime(time2);
			float hourCom = c_dt_out.subForHour(c_dt_in);
			
			if (cs1!=null&&cs2!=null) {
				if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
					CscTime c = new CscTime(hourCom);
					c.sub(break_hour);
					hourCom = c.getFloat();
				}
			}		
			
			if (hourCom<hour) {
				hour=hourCom;
			}
			
 		} catch (Exception e) {
			MyLog.error(this, e);

		} 		
		return hour;
	}
}

