package com.csc.library.databean;

import java.rmi.RemoteException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.ChildManager;
import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Tswipecard0 extends RecordCmp implements DbRecord{

    HashMap hmField;
    private DbTable dbTswipecard1 = null;
    private DbInquiry inqEmp = null;
    private MyHashMap hmResult = new MyHashMap();
    CheckNull chkNull = new CheckNull();
    private DbInquiry inqTswipecard1 = null;
    private DbRecord recUnused = null;
    public Tswipecard0() {
        super("Tswipecard0","Tswipecard0 Table");
    }

    /**
     * @param oChild
     */
    /*
     * ӡҧ row ѵѵ 
     * зӡҧ row ѹ -  
     * ¨ҧӹǹ 1 ͹
     */
    public void setEmployeeList(ChildManager oChild){
        try {
            if ((oChild instanceof DbTable) && (oChild.getTableName().equalsIgnoreCase("tswipecard1"))) {
                DbTable dbTable = (DbTable) oChild;
                String month = this.getParam("__monthid");
                String year = this.getParam("__yearid");
                
                if ((month==null)||(year==null)){
                    CscCalendar csnow = new CscCalendar();
                    month = csnow.getMM();
                    year = String.valueOf(csnow.getYear());
                }
                
                CscCalendar cscm = new CscCalendar("01-"+month+"-"+year);
                int dim = cscm.getDayInMonth();
                for (int i = 1; i <= dim; i++) {
                    DbRecord rec = dbTable.getNewRecord();
                    String date = i+"-"+month+"-"+year;
                    CscCalendar cs = new CscCalendar(date);
                    rec.set("employeeid",this.getString("employeeid"));
                    rec.set("companyid", this.getUProfile().get("companyid"));
                    rec.set("dateid", cs.getDDMMYYYY());
                    rec.set("monthid",month);
                    rec.set("yearid",year);
                    rec.set("line_no",i);
                    rec.set("w_datein", cs.getDDMMYYYY());
                    rec.set("w_dateout", cs.getDDMMYYYY());
                    rec.set("o_datein", cs.getDDMMYYYY());
                    rec.set("o_dateout", cs.getDDMMYYYY());
                    dbTable.putNewRecord(rec);
                }
            }
        } catch (Exception ex) {
            MyLog.error(this, ex);
        }        
    }

    private void chkEmpInq() {
        try{
            if (inqEmp == null){
                inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
                inqEmp.setParam(this.param);
                inqEmp.setSchemaName(this.userPro.getSchemaName());
                inqEmp.initMyTable("Memployee","","");
            }
        }catch (Exception e) {
            MyLog.debug(this, e);
        }
    }

    private void chkTswipecard1Db() {
        try{
            if (dbTswipecard1 == null){
                dbTswipecard1 = new InitialTable(this.userPro).getDbTable("Tswipecard1");
                dbTswipecard1.setColumn("*");
            }
        }catch (Exception e) {
            MyLog.debug(this, e);
        }
    }

    private void chkTswipecard1Inq() {
        try{
            if(inqTswipecard1  == null){
                inqTswipecard1 = new InitialInquiry(this.userPro).getDbInquiry();
                inqTswipecard1.setParam(this.param);
                inqTswipecard1.setSchemaName(this.userPro.getSchemaName());
                inqTswipecard1.initMyTable("Tswipecard1", "", "");
            }
        }catch (Exception e){
            MyLog.debug(this ,e);
        }
    }    
    
    private void setFieldDT() {
        DbTable dt = (DbTable) this.getChild("TSWIPECARD1");
        String source = chkNull.chkNullString(this.getParam("SOURCE"), "0");
        try {
            dt.first();
            while( !dt.eof() ){
                DbRecord rec = dt.getCurrentRecordManager();
                FieldManager fmWDI = rec.getField("W_DATEIN");
                FieldManager fmWTI = rec.getField("W_TIMEIN");
                FieldManager fmWDO = rec.getField("W_DATEOUT");
                FieldManager fmWTO = rec.getField("W_TIMEOUT");

                FieldManager fmODI = rec.getField("O_DATEIN");
                FieldManager fmOTI = rec.getField("O_TIMEIN");
                FieldManager fmODO = rec.getField("O_DATEOUT");
                FieldManager fmOTO = rec.getField("O_TIMEOUT");
                
                this.beforeSave(fmWDI, fmWTI, "w_datein", "w_timein", source, "0");
                this.beforeSave(fmWDO, fmWTO, "w_dateout", "w_timeout", source, "1");

                this.beforeSave(fmODI, fmOTI, "o_datein", "o_timein", source, "0");
                this.beforeSave(fmODO, fmOTO, "o_dateout", "o_timeout", source, "1");
                
                dt.next();
            }
        } catch (RemoteException e) {
            MyLog.error("SET FIELD TSWIPECARD1 ERROR : "+e);
        }
    }

    private void beforeSave(FieldManager fmDate, FieldManager fmTime, String fieldDate, String fieldTime, String source, String swipetype) {
        DbRecord rec = (new InitialRecord(userPro)).getDbRecord("Ttimetemp");
        try {
            rec.clearField();
            if(!pRemote.getString(fieldDate).equals(fmDate.getValue())){
                rec.set("employeeid", this.getString("employeeid"));
                rec.set("companyid", this.getString("companyid"));
                if(!fmDate.getValue().trim().equals("") && !fmTime.getValue().trim().equals("")) {
                    rec.set("swipedate", fmDate.getValue());
                    rec.set("swipetime", fmTime.getValue());
                    rec.set("swipetype", swipetype);
                    rec.set("source", source);
                    rec.save();
                } else {
                    rec.set("swipedate", pRemote.getString(fieldDate));
                    rec.set("swipetime", pRemote.getString(fieldTime));
                    rec.set("swipetype", swipetype);
                    rec.set("source", source);
                    rec.delete();
                }
            }
        }
        catch(Exception e){
            MyLog.error(this, e);
        }
    }

    private void updateReturnDocument() {
        try {
            HashMap cparam = (HashMap) this.param.clone();
            cparam.put("returnstatus","true");
            cparam.put("__wf_status","8");
            cparam.put("wf_command","delete");
            cparam.remove("__oldWF");
            DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Tswipecard0");         
            rec.setParam(cparam);
            rec.setColumn(rec.getListKey()+",wf_status");
            rec.set("otid",(String)cparam.get("__oldDocumentID"));
            rec.set("companyid",this.userPro.get("companyid"));
            rec.setWFOff();
            rec.save();
        } catch (Exception e) {
            MyLog.error(this, e);   
        }
    }
   
    /*
     * ӡ update WF_STATUS  child ͹㹵
     */
    private void updateWFChild(String wf) {
        boolean isSave = false;
        try {
            DbTable dt;
            if (this.getChild("Tswipecard1") != null) {
                dt = (DbTable) this.getChild("Tswipecard1");
                do{             
                    DbRecord rec = (DbRecord) dt.getCurrentRecordManager();             
                    rec.set("WF_STATUS",wf);
                    dt.next();
                } while (!dt.eof());
            } else {
                this.chkTswipecard1Inq();
                this.inqTswipecard1.setColumn("OTID, COMPANYID, EMPLOYEEID, WF_STATUS");           
                this.putChild(this.inqTswipecard1);
                this.refreshChild("Tswipecard1");
                do{ 
                    DbRecord rec = inqTswipecard1.getCurrentDbRecord().cloneRecord(true);
                    rec.set("wf_status",wf);
                    rec.save();
                } while (inqTswipecard1.next());  
            }            
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
    }

    protected boolean preInsertTrigger() throws Exception {
        boolean flag = super.preInsertTrigger();              
        this.hmResult.clear();
        
        if (this.param.containsKey("__oldWF")) {
            if (((String) this.param.get("__oldWF")).equals("7")) {
                this.updateReturnDocument();
            }
        }
        
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
                || this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
        
        if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
        
        this.updateWFChild(this.getString("wf_status"));
        this.setFieldDT();
        this.genRecord(false);
        if (this.hmResult.isEmpty()) {
            this.param.put("error_msg", "No Data For This Request OT");
            MyLog.error(this, "No Data For This Request OT");
            return false; //ӡâͷբ㹡÷ͷ
        }        
        return flag;
    }

    protected boolean preUpdateTrigger() throws Exception {
        boolean result = super.preUpdateTrigger();  
        this.hmResult.clear();
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
                || this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
        
        if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
        if (this.getString("wf_status").equalsIgnoreCase("8") || 
                this.getString("wf_status").equalsIgnoreCase("7") || 
                this.getString("wf_status").equalsIgnoreCase("B")) {        
            this.setColumn(this.getListKey()+",wf_status");
        }
        
        this.updateWFChild(this.getString("wf_status"));
        this.setFieldDT();
        return result;
    }

    protected void postInsertTrigger() throws Exception {       
        if (this.param.containsKey("__wfcmd")) {
            if (this.param.get("__wfcmd").equals("true")) {
                this.setWFOn();         
            } else this.setWFOff();
        }
        
        super.postInsertTrigger();
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
            this.delDataAdjTime0();
            this.saveHashMapData("TADJTIME0", this.hmResult);
            this.saveUnUsed();
            //update by Nuiss
            this.updateMempl_unused();
        } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.delDataAdjTime0();
        }       
    }

    protected void postUpdateTrigger() throws Exception {       
        if (this.param.containsKey("__wfcmd")) {
            if (this.param.get("__wfcmd").equals("true")) {
                this.setWFOn();         
            } else this.setWFOff();
        }
        
        super.postUpdateTrigger();
        if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
            this.delDataAdjTime0();
            this.genRecord(true);
            this.saveUnUsed();
            //update by Nuiss
            this.updateMempl_unused();
        } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.delDataAdjTime0();
        }   
    }
    
    protected void postDeleteTrigger() throws Exception {       
        super.postDeleteTrigger();
        this.delDataAdjTime0();
        //update by Nuiss
        this.updateMempl_unused();
    }

    private void delDataAdjTime0() {        
        try {
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setParam(this.param);
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("Tadjtime0", "docid='"+this.getString("swipecardid")+"' and doctype='O'", "");
            inq.setColumn("*");
            inq.refresh();
            while (inq.next()) {
                DbRecord recChild = inq.getCurrentDbRecord().cloneRecord(true);
                recChild.delete();
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
    }    
        
    private MyHashMap genRecord(boolean isSave) {
        try {
            DbTable dt;         
            int count=1;
            WorkingShift wsNormal = null ;
            
            DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
            rec.setColumn("*");
            
            if (this.getChild("Tswipecard1")!=null) {
                dt = (DbTable) this.getChild("Tswipecard1");           
            } else {
                this.chkTswipecard1Db();
                this.putChild(this.dbTswipecard1);
                this.refreshChild("Tswipecard1");
                dt = (DbTable) this.getChild("Tswipecard1");
            }
            dt.first();
            while (!dt.eof()) {
                Tswipecard1 db = (Tswipecard1) dt.getCurrentRecordManager();
                
                MyHashMap hmShiftTemp = new MyHashMap();
                this.chkEmpInq();
                this.inqEmp.setFilter("employeeid='" + this.getString("employeeid") + "'");
                this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
                this.inqEmp.refresh();
                while (this.inqEmp.next()) {

                    Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                    recTime.set("time0id", this.inqEmp.getString("time0"));
                    recTime.set("companyid", this.userPro.get("companyid"));
                    recTime.search();

                    CscCalendar cs1 = new CscCalendar(db.getString("o_datein"));
                    cs1.decDate(3);
                    CscCalendar cs2 = new CscCalendar(db.getString("o_dateout"));
                    cs2.incDate(3);
                    
                    recTime.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
                                        
                    WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                            new CscCalendar(cs2.getYYYYMMDD()));
                    if (!ws.isEmpty()) {                        
                        ws.setUProfile(this.userPro);
                        ws.setEmployeeid(this.inqEmp.getString("employeeid"));
                        ws.adjust();
                        ws.overlapChecking();
                        ws.createLink();
                        
                        Iterator itTime = db.getDocAllTimeZone().keySet().iterator();
                        while (itTime.hasNext()) {
                            String key = (String) itTime.next();
                                        
                            Vector vAdjust = new Vector();
                            if (ws.chkAddShiftTrans(db.getDocTimeZone())) {
                                MyLog.debug(this, "TIME NOT MATCH IN SHIFT !!!");
                            } else vAdjust = ws.genAddShiftTrans(db.getDocTimeZone());
                            
                            MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
                            Iterator it = vAdjust.iterator();
                            MyLog.debug(this, "ADD Transaction");
                            while (it.hasNext()) {
                                AdjustResult result = (AdjustResult) it.next();
                                MyLog.debug(this, result.toString());
                                
                                String tmp="";
                                String flag="0";
                                if (!result.get_DT_EN().getYYYYMMDD().equals(result.get_DT_BG().getYYYYMMDD())) {
                                    WorkingShift wsOT = recTime.genWorkingShift(new CscCalendar(result.get_DT_EN().getYYYYMMDD()), 
                                            new CscCalendar(result.get_DT_EN().getYYYYMMDD()),"true");
                                    if (!wsOT.isEmpty()) {                  
                                        wsOT.setUProfile(this.userPro);
                                        wsOT.setEmployeeid(this.inqEmp.getString("employeeid"));
                                        wsOT.adjust();
                                        MyLog.debug(this, "======== wsOT==========");
                                        MyLog.debug(this, this.getUProfile(), wsOT.toString());
                                        if (!wsOT.isEmpty()) {                                          
                                            DayShift ds = (DayShift) wsOT.get(result.get_DT_EN().getYYYYMMDD());
                                            Iterator dtt = ds.keySet().iterator();
                                            while (dtt.hasNext()) {
                                                String dKey = (String) dtt.next();
                                                Shift sh = (Shift) ds.get(dKey);
                                                if (sh.getType()=='T'||sh.getType()=='H') {
                                                    if (result.get_DT_EN().afterEquals(sh.get_c_dt_in())) {
                                                        flag="1";
                                                        continue;
                                                    }
                                                }
                                            }                                           
                                        }
                                    } else flag="1";
                                    
                                    if (flag.equals("1")) {
                                        MyLog.debug(this, "OT REQUEST ORVER DAY!!!");
                                        tmp = this.getOTContinue(result, this.getString("employeeid"));
                                    }               
                                }
                                
                                String timeCode = result.getTimeCode();
                                
                                    wsNormal = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                                            new CscCalendar(cs2.getYYYYMMDD()),"true");
                                    if (wsNormal!=null && !wsNormal.isEmpty()) {
                                        for (Iterator itNormal = wsNormal.keySet().iterator(); itNormal.hasNext();) {
                                            String keyNormal = (String) itNormal.next();
                                            DayShift dsNormal = (DayShift) wsNormal.get(keyNormal);
                                            for (Iterator it2 = dsNormal.keySet().iterator(); it2.hasNext();) {
                                                String key2 = (String) it2.next();
                                                Shift sh = (Shift) dsNormal.get(key2);
                                                hmShiftTemp.put(sh.getShiftDate().getYYYYMMDD(), sh.getTimeCode());
                                            }
                                        }
                                    }
                                    wsNormal.setUProfile(this.userPro);
                                    wsNormal.setEmployeeid(this.inqEmp.getString("employeeid"));
                                    wsNormal.adjust();
                                    MyLog.debug(this, " ====== WorkingShitf Normal ====== ");
                                    MyLog.debug(this, this.getUProfile(), wsNormal.toString());

                                if (wsNormal!=null) {
                                    if (wsNormal.containsKey(result.get_DT_BG().getYYYYMMDD())) {
                                        DayShift d = (DayShift) wsNormal.get(result.get_DT_BG().getYYYYMMDD());
                                        Iterator i = d.keySet().iterator();
                                        while (i.hasNext()) {
                                            String dKey = (String) i.next();
                                            Shift s = (Shift) d.get(dKey);
                                            if (!s.getTimeCode().equals(result.getTimeCode())) {
                                                timeCode = s.getTimeCode();
                                                MyLog.debug(this, ">>>timeCode Change === "+timeCode);
                                            }
                                        }
                                    }
                                }
                                
                                if (isSave) {
                                    rec.clearField();
                                    rec.set("COMPANYID", this.getString("companyid"));
                                    rec.set("DOCID", this.getString("swipecardid"));
                                    rec.set("DOCTYPE", "O");
                                    rec.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
                                    rec.set("TM_BG", result.get_DT_BG().getCSCTime());
                                    rec.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
                                    rec.set("TM_EN", result.get_DT_EN().getCSCTime());
                                    rec.set("UPDTYPE", result.getType());
                                    rec.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
                                    rec.set("EMPLOYEEID", this.getString("employeeid"));
                                    if (timeCode.equals("")) {
                                        if (hmShiftTemp.containsKey(result.getAdjDate().getYYYYMMDD())) {
                                            rec.set("TIME0ID", hmShiftTemp.getString(result.getAdjDate().getYYYYMMDD()));
                                        }
                                    } else rec.set("TIME0ID", timeCode);
                                    rec.set("EVENTGRP", "O");
                                    rec.set("OLDTIME0ID", "");
                                    rec.set("OLDEVENTGRP", "");
                                    rec.set("LV_TY", "");
                                    rec.set("LV", result.get_LV());
                                    rec.set("TR_TYPE", result.getEventGroup());
                                    rec.set("ADJUSTTEMP", tmp);
                                    rec.set("STATUS", "");
                                    rec.set("PRIORITY", "2");   
                                    rec.set("OT_WORKAREA", dt.getString("o_workarea"));
                                    rec.set("OT_SALATYPE", dt.getString("costcenterid"));
                                    rec.set("OT_TYPE", "");
                                    rec.set("OT_TIME0", "");
                                    rec.save();
                                } else {
                                    MyHashMap hmData = new MyHashMap();
                                    hmData.put("COMPANYID", this.getString("companyid"));
                                    hmData.put("DOCID", this.getString("swipecardid"));
                                    hmData.put("DOCTYPE", "O");
                                    hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
                                    hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
                                    hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
                                    hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
                                    hmData.put("UPDTYPE", result.getType());
                                    hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
                                    hmData.put("EMPLOYEEID", this.getString("employeeid"));
                                    if (timeCode.equals("")) {
                                        if (hmShiftTemp.containsKey(result.getAdjDate().getYYYYMMDD())) {
                                            hmData.put("TIME0ID", hmShiftTemp.getString(result.getAdjDate().getYYYYMMDD()));
                                        }
                                    } else hmData.put("TIME0ID", timeCode);
                                    hmData.put("EVENTGRP", "O");
                                    hmData.put("OLDTIME0ID", "");
                                    hmData.put("OLDEVENTGRP", "");
                                    hmData.put("LV_TY", "");
                                    hmData.put("LV", result.get_LV());
                                    hmData.put("TR_TYPE", result.getEventGroup());
                                    hmData.put("ADJUSTTEMP", tmp);
                                    hmData.put("STATUS", "");
                                    hmData.put("PRIORITY", "2");    
                                    hmData.put("OT_WORKAREA", dt.getString("o_workarea"));
                                    hmData.put("OT_SALATYPE",dt.getString("costcenterid"));
                                    hmData.put("OT_TYPE", "");
                                    hmData.put("OT_TIME0", "");
                                    this.hmResult.put(String.valueOf(count),hmData);
                                    count++;
                                }
                            }
                        }
                    }
                }
                dt.next();
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return this.hmResult ;
    }

    //  㹡 Genarate Adjtime0 㹡óբ OT ѹ
    private String getOTContinue(AdjustResult result, String empID) {
        String value=""; 
        try {
            WorkingShift ws=null;
            this.chkEmpInq();
            this.inqEmp.setFilter("employeeid='" + empID + "'");
            this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
            this.inqEmp.refresh();
            while (this.inqEmp.next()) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                rec.set("time0id", this.inqEmp.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                rec.search();

                CscCalendar cs1 = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
                cs1.decDate();
                CscCalendar cs2 = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
                cs2.incDate();
                
                rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
                ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                        new CscCalendar(cs2.getYYYYMMDD()), "true");
                
                if (ws!=null) {
                    CscCalendar csStart = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
                    CscCalendar csEnd = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
                    String tmpData="";
                    while (csStart.beforeEquals(csEnd)) {
                        tmpData="";
                        //͹ 1 ѹ ҢͧѹѴ
                        CscCalendar tmp = new CscCalendar(csStart.getYYYYMMDD());
                        tmp.incDate();
                                            
                        DayShift dsOUT = (DayShift) ws.get(csStart.getYYYYMMDD());
                        Shift shOUT = (Shift) dsOUT.get((String) dsOUT.firstKey());
                        
                        DayShift dsIN = (DayShift) ws.get(tmp.getYYYYMMDD());
                        Shift shIN = (Shift) dsIN.get((String) dsIN.firstKey());
                    
                        if (result.get_DT_BG().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
                            tmpData += "DT_BG="+result.get_DT_BG().getYYYYMMDD()+",";
                            tmpData += "TM_BG="+result.get_DT_BG().getCSCTime()+",";
                        } else {
                            tmpData += "DT_BG="+shOUT.get_c_dt_in().getYYYYMMDD()+",";
                            tmpData += "TM_BG="+shOUT.get_c_dt_in().getCSCTime()+",";
                        }
                        
                        if (!result.get_DT_EN().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
                            tmpData += "DT_EN="+shIN.get_c_dt_in().getYYYYMMDD()+",";
                            tmpData += "TM_EN="+shIN.get_c_dt_in().getCSCTime()+",";
                        } else {
                            tmpData += "DT_EN="+result.get_DT_EN().getYYYYMMDD()+",";
                            tmpData += "TM_EN="+result.get_DT_EN().getCSCTime()+",";
                        }       
                        
                        tmpData += "TIMECODE="+shOUT.getTimeCode()+",";
                        //MyLog.debug(this, tmpData);
                        csStart.incDate();
                        value += tmpData+"#";
                    }
                }
            }
            
        } catch (Exception e) {
            MyLog.error(this, e);           
        }   
        MyLog.debug(this, ">>>>>>>>>> "+value);
        return value;
    }
       
    private void isSaveUnUsed(String swipecardid, String w_datein, String benifit){
    	try{
        	if (this.recUnused==null) {
        		this.recUnused = new InitialRecord(this.userPro).getDbRecord("Mempl_unused");
        		this.recUnused.setColumn("*");
        	}
        	this.recUnused.clearField();
        	this.recUnused.set("employeeid", this.getString("employeeid"));
        	this.recUnused.set("companyid", this.getString("companyid"));
        	this.recUnused.set("dateid", w_datein);
        	this.recUnused.set("un4_value", benifit);
        	this.recUnused.set("un4_doctype", "O");
            this.recUnused.set("un4_docno", swipecardid);
            this.recUnused.save();
        }catch (Exception e) {
            MyLog.error("SET Field Error in Table MEMPL_UNUSED : ", e);
        }
    }
    
    private void saveUnUsed(){
        try{
            this.chkTSwipecard1Inq();
            this.inqTswipecard1.setColumn("swipecardid,w_datein,benifit");
            ChildManager  tSwipecard1 = this.getChild("tswipecard1");
            this.putChild(this.inqTswipecard1);
            this.refreshChild("tswipecard1");
            
            do{
            	this.isSaveUnUsed(this.inqTswipecard1.getString("swipecardid")
            			,this.inqTswipecard1.getString("w_datein")
                        ,this.inqTswipecard1.getString("benifit"));
            }while (this.inqTswipecard1.next());
            
            if(tSwipecard1!= null) this.putChild(tSwipecard1);
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }//end try
    }
    
    private void chkTSwipecard1Inq() {
        try{
            if (this.inqTswipecard1  == null) {
            	this.inqTswipecard1 = new InitialInquiry(this.userPro).getDbInquiry();
            	this.inqTswipecard1.setParam(this.param);
            	this.inqTswipecard1.setSchemaName(this.userPro.getSchemaName());
            	this.inqTswipecard1.initMyTable("tswipecard1", "", "");
            }
        } catch (Exception e) {
            MyLog.debug(this ,e);
        }
    }
   
    /**
     * Author : Nuiss
     * Date : 02/07/2552
     * Logic : delete row ͡ҡ tswipecard1 ͧ 
     * 		 update mempl_unused.un4_value = "" 
     * mempl_unused.un4_doctype = "" 
     * mempl_unused.un4_docno = "" 
     * @throws SQLException 
     */
    private void updateMempl_unused() throws SQLException{
    	CscConnection conn = null;
   	   	Statement stmt =null;
        ResultSet resultSet = null;
        
        String employeid = this.getString("employeeid");
        String companyid = this.getString("companyid");
        String swipecardid = this.getString("swipecardid");
      
       String SQLQuery = "SELECT mun.employeeid,mun.dateid "+
		" ,mun.un4_docno,mun.un4_doctype,mun.un4_value "+
		" ,sw1.swipecardid,sw1.benifit,'update' as rowFlag "+
		" FROM mempl_unused mun left outer join tswipecard1 sw1 on(mun.dateid=sw1.w_datein) "+ 
		" WHERE mun.employeeid ='"+employeid+"' "+ 
		" and mun.companyid ='"+companyid+"' "+
		" UNION ALL "+
		" SELECT  sw0.employeeid,sw1.w_datein "+ 
		" ,sw1.swipecardid as un5_docno ,'O' as un4_doctype ,sw1.benifit as un4_value "+ 
		" ,sw1.swipecardid,sw1.benifit,'insert' as rowFlag "+
		" FROM tswipecard0 sw0,tswipecard1 sw1 "+ 
		" WHERE sw0.swipecardid = sw1.swipecardid "+
		" and sw0.swipecardid ='"+swipecardid+"' "+
		" and sw1.w_datein not in (select dateid from mempl_unused where un4_docno='"+swipecardid+"')";

 		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(SQLQuery);
					
			while (resultSet.next()) {
				String benifitValue = "";
				String docNo ="";
				String docType ="";
				if(resultSet.getString("swipecardid")!=null){
					docNo=resultSet.getString("swipecardid");
					docType=resultSet.getString("un4_doctype");
					benifitValue=resultSet.getString("benifit");
				}//end if 
				String whereClause = "EMPLOYEEID = '"+employeid+"' " 
				+" and COMPANYID = '" +companyid+ "' "
				+" and DATEID = '"+resultSet.getString("dateid")+"' ";
				
				DbInquiry inqUnused = new InitialInquiry(this.userPro).getDbInquiry();		
				inqUnused.initMyTable("mempl_unused", whereClause, "");
				inqUnused.setColumn("EMPLOYEEID,COMPANYID,DATEID,UN4_DOCNO,UN4_DOCTYPE,UN4_VALUE");
				inqUnused.refresh();
				DbRecord dbRecord = inqUnused.getCurrentDbRecord().cloneRecord(true);
				dbRecord.set("EMPLOYEEID", employeid);
				dbRecord.set("COMPANYID", companyid);
				dbRecord.set("DATEID", resultSet.getString("dateid"));
				dbRecord.set("UN4_DOCNO", docNo);
				dbRecord.set("UN4_DOCTYPE", docType);
				dbRecord.set("UN4_VALUE", benifitValue);
				dbRecord.save();
			}//end while 
			
		}catch(Exception ex){
			System.out.print(">>>>>Error on Tswipecard0.updateMempl_unused()"+ex.getStackTrace())	;
		}finally{
			resultSet.close();
			if(stmt!=null){
				stmt.close();
			}
			conn.close();
		}//end try
    }//end method updateMempl_unused

}//end class
