package com.csc.library.databean;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;

import com.csc.library.session.RecordCmp;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;

/*
 * 红ŷԴҡõǨͺ  Һ, ٴѵ
 * NOT USED 2008/09/15 
 */
public class Ttimeerror extends RecordCmp {
	
	private DecimalFormat df = new DecimalFormat("0.00");
	private MyHashMap hmZoneIN = new MyHashMap();
	private MyHashMap hmZoneOUT = new MyHashMap();
	private MyHashMap hmErrorIN = new MyHashMap();
	private MyHashMap hmErrorOUT = new MyHashMap();
	
	public Ttimeerror() {
		super("Ttimeerror", "Ttimeerror Table");
	}
	
	/*
	 * Error_Type
	 *		ٴ = FORGOT-IN ---> 0
	 * 		ٴ͡ = FORGOT-OUT ---> 1
	 * 		 = LATE ---> 2		
	 * 		ͷա͹ = OT-BEFORE ---> 3
	 * 		ͷѧ = OT-AFTER ---> 4
	 * 		͡͹ = OUT-ABSENT ---> 5
	 * 		Ҫ = IN-ABSENT ---> 6
	 * 		//ٴ¤ = IN-MORE ---> 7
	 * 		//ٴ͡¤ = OUT-MORE ---> 8
	 * 		ӧҹ͹ҧҹ WK-BEFORE ---> 9
	 * 		ӧҹѧҧҹ WK-AFTER ---> 10
	 * 		ٴѵѹشҹ WK-HOLIDAY ---> 11
	 * 		ͷԹ͹ OT-OVER-BEFORE ---> 12
	 * 		ͷԹѧ OT-OVER-AFTER ---> 13
	 *    	ͷբҴ͹ OT-LESS-BEFORE ---> 14
	 * 		ͷբҴѧ OT-LESS-AFTER ---> 15
	 */
	
	private void initErrorType() {
		if (this.hmZoneIN.isEmpty() && this.hmZoneOUT.isEmpty() 
				&& this.hmErrorIN.isEmpty() && this.hmErrorOUT.isEmpty()) {
		this.hmZoneIN.put("0", "0");
		this.hmZoneIN.put("2", "2");
		this.hmZoneIN.put("3", "3");
		this.hmZoneIN.put("6", "6");
		this.hmZoneIN.put("7", "7");
		this.hmZoneIN.put("9", "9");
		this.hmZoneIN.put("12", "12");
		this.hmZoneIN.put("14", "14");
		
		this.hmZoneOUT.put("1", "1");
		this.hmZoneOUT.put("4", "4");
		this.hmZoneOUT.put("5", "5");
		this.hmZoneOUT.put("8", "8");
		this.hmZoneOUT.put("10", "10");		
		this.hmZoneOUT.put("13", "13");
		this.hmZoneOUT.put("15", "15");
		
		this.hmErrorIN.put("2","2");
		this.hmErrorIN.put("3","3");
		this.hmErrorIN.put("6","6");
		this.hmErrorIN.put("9","9");
		this.hmErrorIN.put("12","12");
		this.hmErrorIN.put("14","14");
		
		this.hmErrorOUT.put("4","4");
		this.hmErrorOUT.put("5","5");
		this.hmErrorOUT.put("10","10");
		this.hmErrorOUT.put("13","13");
		this.hmErrorOUT.put("15","15");
		}
	}
	
	public String getString(String fieldName) {
		this.initErrorType();
		String data = super.getString(fieldName);
		if (fieldName.equalsIgnoreCase("dt_m_in")) {			
			if (data.equalsIgnoreCase("01-01-1009")) {
				return "";
			}
		} else if (fieldName.equalsIgnoreCase("dt_m_out")) {			
			if (data.equalsIgnoreCase("01-01-2009")) {
				return "";
			}
		} else if (fieldName.equalsIgnoreCase("error_value")) {
			return this.changeDataFormat(data);
		} else if (fieldName.equalsIgnoreCase("error_datetime")) {
			if (this.hmErrorIN.containsKey(this.getString("error_type"))) {
				CscCalendar cs = new CscCalendar(this.getString("dt_m_in"));
				return cs.getDDMMYYYY()+":"+this.df.format(this.getDouble("tm_m_in"));
			} else if (this.hmErrorOUT.containsKey(this.getString("error_type"))) {
				CscCalendar cs = new CscCalendar(this.getString("dt_m_out"));
				return cs.getDDMMYYYY()+":"+this.df.format(this.getDouble("tm_m_out"));
			} else return " ";
		} else if (fieldName.equalsIgnoreCase("error_value_full")) {
			String value = this.changeDataFormat(this.getString("error_value"));
			if (this.getString("error_type").equals("0") || this.getString("error_type").equals("1")) {
				value = value.substring(value.length()-4, value.length());
			} else if (this.getString("error_type").equals("11")) {
				return value;
			} else {
				if (this.userPro.get("lang").equalsIgnoreCase("ENG")) {
					value += " Hour";
				} else value += " .";		
			}
			return value;
		} 
		return data;
	}
	
	private String changeDataFormat(String data) {
		try {
			if (!data.equals("")) {
				if (data.indexOf(":")>-1) {
					String date = data.substring(0, data.indexOf(":"));
					String time = this.df.format(Double.parseDouble(data.substring(data.indexOf(":")+1, data.length())));
					return date+":"+time;
				} else return this.df.format(Double.parseDouble(data));
			} else return data;
		} catch (Exception ex) {
			MyLog.error(this, ex);
			return data;
		}
	}

	public FieldManager getField(String fieldName) {
		FieldManager fm = super.getField(fieldName);
		this.initErrorType();
		if (fieldName.equalsIgnoreCase("datetimeshift")) {
			String data = this.getString("dateshift") + ":" + this.changeDataFormat(this.getString("timeshift"));
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ѹҢͧ");
			} else
				fm.setDescription("Shift Date-Time");
			fm.setName("datetimeshift");
			fm.set(data);
		} else if (fieldName.equalsIgnoreCase("intimenear_begin")) {
			String date = "";
			String time = "";			
			if (!this.getString("dt_inzone_timenear_begin").equalsIgnoreCase("01-01-1900")
					&&!this.getString("dt_inzone_timenear_begin").equalsIgnoreCase("1900-01-01")){
				date = this.getString("dt_inzone_timenear_begin");			 
				time = this.changeDataFormat(this.getString("tm_inzone_timenear_begin"));
			}					
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ§ǧ");
			} else
				fm.setDescription("In Time Near Begin");
			fm.setName("intimenear_begin");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		} else if (fieldName.equalsIgnoreCase("intimenear_end")) {
			String date = "";
			String time = "";		
			if (!this.getString("dt_inzone_timenear_end").equalsIgnoreCase("01-01-1900")
					&&!this.getString("dt_inzone_timenear_end").equalsIgnoreCase("1900-01-01")){			
				date = this.getString("dt_inzone_timenear_end");
				time = this.changeDataFormat(this.getString("tm_inzone_timenear_end"));
			}
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ§ǧ͡");
			} else
				fm.setDescription("In Time Near End");
			fm.setName("intimenear_end");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		} else if (fieldName.equalsIgnoreCase("outtimenear_begin")) {
			String date = "";
			String time = "";		
			if (!this.getString("dt_outzone_timenear_begin").equalsIgnoreCase("01-01-1900")
					&&!this.getString("dt_outzone_timenear_begin").equalsIgnoreCase("1900-01-01")){			
				date = this.getString("dt_outzone_timenear_begin");		
				time = this.changeDataFormat(this.getString("tm_outzone_timenear_begin"));
			}
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ͡§ǧ");
			} else
				fm.setDescription("Out Time Near Begin");
			fm.setName("outtimenear_begin");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		} else if (fieldName.equalsIgnoreCase("outtimenear_end")) {
			String date = "";
			String time = "";		
			if (!this.getString("dt_outzone_timenear_end").equalsIgnoreCase("01-01-1900")
					&&!this.getString("dt_outzone_timenear_end").equalsIgnoreCase("1900-01-01")){
				date = this.getString("dt_outzone_timenear_end");
				time = this.changeDataFormat(this.getString("tm_outzone_timenear_end"));
			}
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ͡§ǧ͡");
			} else
				fm.setDescription("Out Time Near End");
				fm.setName("outtimenear_end");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		} else if (fieldName.equalsIgnoreCase("intimenear")) {
			String date = "";
			String time = "";		
			if (this.hmZoneIN.containsKey(this.getString("error_type"))) {
				if (!this.getString("dt_inzone_timenear_begin").equalsIgnoreCase("01-01-1900")
						&&!this.getString("dt_inzone_timenear_begin").equalsIgnoreCase("1900-01-01")){
					date = this.getString("dt_inzone_timenear_begin");
					time = df.format(this.getDouble("tm_inzone_timenear_begin"));
					//time = this.changeDataFormat(this.getString("tm_inzone_timenear_begin"));
				}					
			} else if (this.hmZoneOUT.containsKey(this.getString("error_type"))) {
				if (!this.getString("dt_outzone_timenear_begin").equalsIgnoreCase("01-01-1900")
						&&!this.getString("dt_outzone_timenear_begin").equalsIgnoreCase("1900-01-01")){
					date = this.getString("dt_outzone_timenear_begin");
					time = df.format(this.getDouble("tm_inzone_timenear_begin"));
					//time = this.changeDataFormat(this.getString("tm_outzone_timenear_begin"));
				}
			} 	
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ§");
			} else
				fm.setDescription("In Time Near");
			fm.setName("intimenear");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		} else if (fieldName.equalsIgnoreCase("outtimenear")) {
			String date = "";
			String time = "";		
			if (this.hmZoneIN.containsKey(this.getString("error_type"))) {
				if (!this.getString("dt_inzone_timenear_end").equalsIgnoreCase("01-01-2900")
						&&!this.getString("dt_inzone_timenear_end").equalsIgnoreCase("2900-01-01")){
					date = this.getString("dt_inzone_timenear_end");
					time = df.format(this.getDouble("tm_outzone_timenear_end"));
					//time = this.changeDataFormat(this.getString("dt_inzone_timenear_end"));
				}					
			} else if (this.hmZoneOUT.containsKey(this.getString("error_type"))) {
				if (!this.getString("dt_outzone_timenear_end").equalsIgnoreCase("01-01-2900")
						&&!this.getString("dt_outzone_timenear_end").equalsIgnoreCase("2900-01-01")){
					date = this.getString("dt_outzone_timenear_end");
					time = df.format(this.getDouble("tm_outzone_timenear_end"));
					//time = this.changeDataFormat(this.getString("dt_outzone_timenear_end"));
				}
			} 		
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ٴѵ͡§");
			} else
				fm.setDescription("Out Time Near");
				fm.setName("outtimenear");
			if (date.length()==0&&time.length()==0){
				fm.set(" - ");
			} else fm.set(date+":"+time);
		}
		return fm;		
	}		

}