package com.csc.library.databean;

import java.util.Iterator;

import org.jdom.Element;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

public class Ttimetemp_ski extends Ttimetemp {
	
	DbRecord recChShift = null;
	MyHashMap hm = null;
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();
		this.loadXML();
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();
		this.loadXML();
		return result;
	}
	
	private void changeShift() {
		if (this.getString("swipetype").equals("01")) {
			double swipetime = this.getDouble("swipetime");
			String shift = "", shift_ex = "";
			String key="";
			MyHashMap hmDetail = null;
			Iterator it = this.hm.keySet().iterator();
			while (it.hasNext()) {
				key =(String) it.next();
				hmDetail = (MyHashMap) this.hm.get(key);
				double time_start = hmDetail.getDouble("time_start");
				double time_end = hmDetail.getDouble("time_end");
				
				String currentTime0Id = this.getCurrentTime0Id(new CscCalendar(this.getString("swipedate"))
																						,new CscCalendar( this.getString("swipedate")));
				if(currentTime0Id.equals(hmDetail.getString("shift")) && 
					swipetime>=time_start && swipetime<=time_end) {					
					System.out.print(">>> Nuiss Debug : Condition is corrected exchange shift...");
					shift = hmDetail.getString("shift");
					shift_ex = hmDetail.getString("shiftexchange");
					this.changeShift(shift, shift_ex);
					break;
				}
			}//end while
		}
	}
	
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();	
		this.changeShift();
	}


	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();	
		this.changeShift();
	}
	
	private void changeShift(String shift, String shift_ex) {
		try {
			if (this.recChShift == null) {
				
				//==============Nuiss Start Edit 21/11/2551==========
				/**
				 * Author:nuiss
				 * Logic:ͧ¹ save  tchangeshift_nstda 
				 *  file TAU145_NSTDA.jsp
				 */
				//this.recChShift = new InitialRecord(this.userPro).getDbRecord("TCHSHIFT");
				this.recChShift = new InitialRecord(this.userPro).getDbRecord("tchangeshift_nstda");
				//=================Nuiss End Edit 21/11/2551=========
				
				this.recChShift.setColumn("*");
				this.recChShift.setParam(this.param); 
			}
			this.recChShift.clearField();
			this.recChShift.set("TCHSHIFTID",("AUTO-"+this.getString("runno")));
			this.recChShift.set("COMPANYID", (String) this.userPro.get("companyid"));
			this.recChShift.set("EMPLOYEEID", this.getString("employeeid")); 
			this.recChShift.set("OLD_SHIFT", shift);
			this.recChShift.set("NEW_SHIFT", shift_ex);
			//this.recChShift.set("CHANGE_DATE", this.getString("swipedate")); 
			this.recChShift.set("START_DATE", this.getString("swipedate")); 
			this.recChShift.set("END_DATE", this.getString("swipedate")); 
			this.recChShift.set("WF_STATUS","6"); 
			this.recChShift.set("STATUS", "2");
			this.recChShift.setWFOff();
			this.recChShift.save();
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void loadXML() {
		if (this.hm == null) {
			this.hm = new MyHashMap();
			try {
				InitialEnvironment en = new InitialEnvironment("GLOBAL");
				String xmlPath = en.getValue("import-dir");
				String fileName = "SWIPETIME_SKI.xml";
				
				ReadXml r = new ReadXml(xmlPath +"XML/"+fileName);
				Element root = r.getRootElement();
				Iterator it = root.getChildren().iterator();
				while (it.hasNext()) {
					Element key = (Element) it.next();
					MyHashMap hmDetail = new MyHashMap();
					Iterator itChild = key.getChildren().iterator();
					while (itChild.hasNext()) {
						Element data = (Element) itChild.next();
						hmDetail.put(data.getName().toLowerCase(), data.getText());						
					}
					this.hm.put(key.getName().toLowerCase(), hmDetail);
				}
				MyLog.debug("LOAD XML DATA : "+this.hm);
			} catch (Exception e) {
				MyLog.error(this, e);
			}
		}
	}
	
	private String getCurrentTime0Id(CscCalendar startDate,CscCalendar endDate){
		String currentTime0Id = "";
		
		String filter = "employeeid='"+this.getString("employeeid")+"'";
		try{
			DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
			inqEmp.setParam(param);
			inqEmp.setSchemaName(this.userPro.getSchemaName());
			inqEmp.initMyTable("Memployee", filter, "");
			inqEmp.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level, workarea," +
			"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid, status, startdate, resigndate");			
			inqEmp.refresh();
			
			while (inqEmp.next()) {
				DbRecord empRec = inqEmp.getCurrentDbRecord();				
				Mtime0 timeRec = null;
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Mtime0", "time0id='" + empRec.getString("time0") + "'", "");
				inq.setColumn("*");
				inq.refresh();
				
				if(inq.next()){
					timeRec = (Mtime0) inq.getCurrentDbRecord();
				}//end if
				
				timeRec.setEmpRec(empRec);		
				
				WorkingShift ws = timeRec.genWorkingShift(startDate,endDate,"true");
				if (!ws.isEmpty()){
					ws.setUProfile(this.userPro);
					ws.setEmployeeid(this.getString("employeeid"));
					ws.adjust();
					
					for (Iterator IT = ws.keySet().iterator(); IT.hasNext(); ) {
						String key = (String) IT.next();
						DayShift dShift = (DayShift) ws.get(key);
						for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext(); ) {
							String key1 = (String) IT1.next();
							Shift sh = (Shift) dShift.get(key1);
							currentTime0Id = sh.getResultTimeCode();
						}//end for IT1
					}//end for IT
				}//end if 
			}//end while
		}catch(Exception ex){
			System.out.print(">>> Nuiss Debug : Error on Ttimetemp.getCurrentTime0Id() at generate Working Shift ...");
		}//end try
	 		
		return currentTime0Id;
	}//end method
	
}//end class
