package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * Table 红šҨҡ 
 * TADJTIME0, TTIME_CURRENT1, TTIME_HISTORY1
 * ѹ 㹡ô٢šҷ
 * ͧ select Ҩҡ 3 
 */
public class Tworking_summary extends RecordCmp {
	
	private String result_avg = "null";
	private MyHashMap hmHoliday = null;
	private String dayOfMonth = "null";
	
	public Tworking_summary() {
		super("Tworking_summary", "Tworking_summary Table");
	}
	
	public String getString(String fieldName) {		
		if (fieldName.equalsIgnoreCase("TOTAL_AVG")) {
			DecimalFormat df = new DecimalFormat("0.00");
			String result = "0";
			if (this.result_avg.equals("null")) {
				try {
					double total = 0;
					int count = 0;
					String filter = "yearid="+this.getString("yearid")+" and monthid="+this.getString("monthid")+" and swipetype<>'N'";
					if (this.param.containsKey("BRANCH") && !((String)this.param.get("BRANCH")).equals("")) {
						filter += " and branch='"+(String)this.param.get("BRANCH")+"'";
					} 
					DbInquiry inqTotal = new InitialInquiry(this.getUProfile()).getDbInquiry();
					inqTotal.setSchemaName(this.getUProfile().getSchemaName());
					inqTotal.initMyTable("Tworking_summary", filter, "");										
					inqTotal.setColumn("*");
					inqTotal.refresh();
					while (inqTotal.next()) {
						total += inqTotal.getCurrentDbRecord().getDouble("working_avg");
						count++;
					}					
					if (count==0) {
						this.result_avg = "0.00";
					} else {
						this.result_avg = df.format(total/count);
					}
					return this.result_avg;
				} catch (Exception e) {
					MyLog.error(this, e);
					return "0.00";
				}
			} 
			if (this.result_avg!=null) {
				return this.result_avg;
			} else return result;
		} else if (fieldName.equalsIgnoreCase("TOTAL_COM_WORKING")) {
			try { 
				if (this.dayOfMonth.equals("null")) {
					String hCode = (String) StaticConfig.getConfigCompany(this.userPro, "ta1007");
					CscCalendar c1 = new CscCalendar("01-"+this.getString("monthid")+"-"+this.getString("yearid"));
					CscCalendar c2 = new CscCalendar(c1.getEndDateOfMonth()+"-"+this.getString("monthid")+"-"+this.getString("yearid"));
										
					int holiday = 0;
					if (this.hmHoliday==null) {
						this.hmHoliday = new MyHashMap();
						DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
						inq.setSchemaName(this.getUProfile().getSchemaName());
						inq.initMyTable("Mholiday1","holidayid='"+hCode+"' and (hdate between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"')", "");
						inq.setColumn("*");
						inq.refresh();
						while (inq.next()) {
							holiday++;
						}
					}
						
					int stopday = 0;
					while (c1.beforeEqualsDate(c2)) {
						if (c1.getDOW()==6 || c1.getDOW()==7) {
							stopday++;
						}
						c1.incDate();
					}
						
					this.dayOfMonth = String.valueOf(c1.getEndDateOfMonth() - stopday - holiday);
				} else return this.dayOfMonth;
			} catch (Exception e) {
				MyLog.error(this, e);
			}
			return this.dayOfMonth;
		} else return super.getString(fieldName);
	}
}
