package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.text.DecimalFormat;

import org.apache.log4j.Logger;

import com.csc.library.database.FieldManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscException;

public class Vw_emp_d_pea extends RecordCmp {
	private static final long serialVersionUID = 1L;

	final static private Logger logger = Logger.getLogger(Vw_emp_d_pea.class);

	String[] swipe = new String[21];

	public Vw_emp_d_pea() {
		super("Vw_emp_d_pea", "Vw_emp_d_pea Table");
		this.reSetSwipe();
	}

	private void reSetSwipe() {
		for (int i = 0; i < swipe.length; i++)
			swipe[i] = "--:--";
	}

	private void getSwipetime() {

		DbInquiry inq = null;
		if (this.getChild("ttimetemp") instanceof DbInquiry) {
			inq = (DbInquiry) this.getChild("ttimetemp");
			try {
				CscCalendar cDate = this.getCscCalendar("SWIPEDATE");
				cDate.setSecond(0);
				cDate.setHour(0);
				cDate.setMinute(0);
				inq.setFilter("SWIPETIME >= '6.00'");
				this.refreshChild("ttimetemp");
				if (inq.getCurrentDbRecord().getFloat("SWIPETIME") > 9.0) {
					try {
						CscCalendar swTime = this.getCscCalendar("SWIPEDATE");
						swTime.setSecond(0);
						swTime.setHour(0);
						swTime.setMinute(0);
						swTime.setCSCTime((float) (inq.getCurrentDbRecord().getFloat("SWIPETIME") - 9.0));
						DecimalFormat df = new DecimalFormat("00.00");
						swipe[0] = df.format((inq.getCurrentDbRecord().getFloat("SWIPETIME") - 9.0)).replace('.', ':');
					} catch (Exception e) {
						MyLog.error(this, e);

						// TODO Auto-generated catch block
						
					}
				}

				for (int i = 1; i < swipe.length; i++) {
					if (inq.getCurrentDbRecord().getFloat("SWIPETIME") > 0) {
						try {
							cDate.setCSCTime(inq.getCurrentDbRecord().getFloat("SWIPETIME"));
						} catch (CscException e) {
							MyLog.error(this, e);

							// TODO Auto-generated catch block
							
						}
						swipe[i] = cDate.getHHMM();
					}
					if (!inq.next())
						break;
				}
			} catch (RemoteException e) {
				MyLog.error(this, e);

				// TODO Auto-generated catch block
				
			}
		}
	}

	public FieldManager getField(String fieldName) {
		FieldManager fm = null;
		int point = 0;
		String Fname = "";
		if ((fieldName.toUpperCase().indexOf("SWIPE") >= 0)
				&& (!fieldName.equalsIgnoreCase("SWIPEDATE"))) {
			point = Integer.parseInt(fieldName.toUpperCase().substring(
					fieldName.toUpperCase().indexOf("SWIPE") + 5,fieldName.length()));
			Fname = "SWIPE" + point;
		}
		if (fieldName.equalsIgnoreCase(Fname)) {
			try {point = Integer.parseInt(fieldName.toUpperCase().substring(
						fieldName.toUpperCase().indexOf("SWIPE") + 5,fieldName.length()));
				fm = (FieldManager) this.initField("String", "SWIPE" + point,100, 0, "SWIPETIME_LIST");
				fm.setWorking(true);
				fm.set(swipe[point]);
			} catch (Exception e) {
				MyLog.error(this, e);

				// TODO Auto-generated catch block
				
			}
		} else
			fm = super.getField(fieldName);
		return fm;
	}

	public void postInqNext() {
		this.reSetSwipe();
		this.getSwipetime();
	}
}