package com.csc.library.databean;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Vw_meventgrp_statics extends RecordCmp{
	private CscConnection conn = null;
	private Statement stmt =null;
	public Vw_meventgrp_statics(){
		super("Vw_meventgrp_statics","Vw_meventgrp_statics View");
	}//end constructor
	
	 public FieldManager getField(String fieldName) {		
		FieldManager fm = super.getField(fieldName);      
	 			if (fieldName.toUpperCase().indexOf("HEADCOL")==0) {
	            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	            fm.setWorking(true);
	            String strHeader = this.retrieveData("header",fieldName,"");
	            if (fieldName.equalsIgnoreCase("HEADCOL15")){
	            	fm.set(""); 
	            }else{
	            	fm.set(strHeader); 
	            }//end if 
	        }else  if (fieldName.toUpperCase().indexOf("COL")==0) {
	        	String strLeaveTDesc= this.retrieveData("header","head"+fieldName.toLowerCase(),"");
	         	if(fieldName.equalsIgnoreCase("COL15")){
	         		strLeaveTDesc = "lateStatics";
	         	} 
	        	String strStatics = this.retrieveData("statics",fieldName,strLeaveTDesc);
	        	fm.set(strStatics);
	        }else{
	        	fm = super.getField(fieldName);
	        }//end if 
        
        return fm;
	}//end method getField
	
	private String retrieveData(String queryType,String fieldName,String leaveTDesc){ 	
		ResultSet resultSet = null;
		String strReturn ="";
		//
		int LateCount = 0;
		int LateHH = 0;
		int LateMM = 0;
		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			stmt = conn.createStatement();
			String sqlQuery="";
			if(queryType.equals("header")){
				sqlQuery = this.getSQLQueryHeader();
			}else{ 
				sqlQuery = this.getSQLQueryStatics(leaveTDesc);
			}//end if 
			
			resultSet = stmt.executeQuery(sqlQuery);
	 		
			while (resultSet.next()){	
				if(queryType.equals("header")){
					strReturn = resultSet.getString(fieldName);
				}else{
					if(leaveTDesc.equalsIgnoreCase("lateStatics")){
						LateCount += resultSet.getInt("LateCount");
						LateHH += resultSet.getInt("LateHH");
						LateMM += resultSet.getInt("LateMM");
		 			}else{
	 					float HourPerDay = 8.0f;
						if(resultSet.getFloat("HourPerDay")>0.0f){
							HourPerDay = resultSet.getFloat("HourPerDay");
						}//end if 
						int LeaveHH = resultSet.getInt("LeaveHH");
						int LeaveMM = resultSet.getInt("LeaveMM");
						
						if(LeaveHH==0 && LeaveMM == 0){
							strReturn="00:00:00";
						}else{
							if(LeaveHH==0){
								strReturn="00:00:"+(String.valueOf(LeaveMM).length()==1?("0"+LeaveMM):String.valueOf(LeaveMM));
							}else{
								//ըӹǹ .  ҡ sum 
								if(LeaveHH<HourPerDay){
									strReturn="00:"+(String.valueOf(LeaveHH).length()==1?("0"+LeaveHH):String.valueOf(LeaveHH))
													  +":"+(String.valueOf(LeaveMM).length()==1?("0"+LeaveMM):String.valueOf(LeaveMM));
								}else{
									int day = (int) (LeaveHH/HourPerDay);
									int hour = (int) (LeaveHH%HourPerDay);
									strReturn= (String.valueOf(day).length()==1?("0"+day):String.valueOf(day))
									  +":"+(String.valueOf(hour).length()==1?("0"+hour):String.valueOf(hour))
									  +":"+(String.valueOf(LeaveMM).length()==1?("0"+LeaveMM):String.valueOf(LeaveMM));
								}//end if 
							}//end if 
						}//end if 
					}//end if 
				}//end if 
			}//end if
			
		}catch(Exception ex){
			System.out.print(">>>>>Error on Vw_MEventGrp_Statics.retrieveData()"+ex.getStackTrace())	;
		}finally{
			try {
				resultSet.close();
				if(stmt!=null){
					stmt.close();
				}
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}//end try
		}//end try
		
		if(leaveTDesc!= null && leaveTDesc.equalsIgnoreCase("lateStatics")){
			if(LateMM>59){
				LateHH = LateHH + (int)(LateMM/60);
				LateMM= LateMM%60;
			}//end if  
			if(LateCount==0){
				strReturn="";
			}else{
				strReturn=LateCount + "   "+(String.valueOf(LateHH).length()==1?("0"+LateHH):String.valueOf(LateHH))
			   +":"+(String.valueOf(LateMM).length()==1?("0"+LateMM):String.valueOf(LateMM));
			}//end if 
		}//end if 
		
		return strReturn;
	}//end method retrieveData
	
	private String getSQLQueryStatics(String leaveTDesc){
		String SQLQuery ="";
		String strWhere = "";
		String strFilter = "";
		String strHaving = "";
		if(leaveTDesc==null){
			leaveTDesc="";
		}
		if(this.param.get("STARTDATE")==null || this.param.get("STARTDATE").equals("")||
			this.param.get("ENDDATE")==null || this.param.get("ENDDATE").equals("")){
			strWhere = " 1=2 ";
		}else{
			if(leaveTDesc.equalsIgnoreCase("lateStatics")){
				strHaving ="HAVING SUM(case when t1.lt > 0 then  1 else 0 end )  > 0";
			}else{
				strFilter = " and eg.tdesc='"+leaveTDesc+"'";
			}//end if
			CscCalendar startDate = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar endDate = new CscCalendar((String) this.param.get("ENDDATE"));
			strWhere = " t1.dateid>='"+startDate.getYYYYMMDD()+"' " +
				" and t1.dateid<='"+endDate.getYYYYMMDD()+"' " +
				" and t1.employeeid ='"+this.getString("employeeid")+"' " +strFilter;
		}//end if 
	 		
		SQLQuery = "SELECT t1.EmployeeId,t1.lv_ty as EventCode " +
		" ,t1.hour_s as HourPerDay " +
		" ,eg.tdesc as EventDesc " +
		" ,SUM(1) as EventCount " + 
		" ,SUM(case when t1.m_lv > 0 then  1 else 0 end ) as LeaveCount " + 
		" ,SUM(CAST(substring(CAST(t1.m_lv AS varchar), 0, charindex('.', t1.m_lv)) AS int)) + SUM(CAST(substring(CAST(t1.m_lv AS varchar), charindex('.', t1.m_lv) + 1, len(t1.m_lv)) AS int)) / 60 AS LeaveHH " +
		" ,SUM(CAST(substring(CAST(t1.m_lv AS varchar), charindex('.', t1.m_lv) + 1, len(t1.m_lv)) AS int)) % 60 AS LeaveMM " +
		" ,SUM(case when t1.lt > 0 then  1 else 0 end ) as LateCount " +
		" ,SUM(CAST(substring(CAST(t1.lt AS varchar), 0, charindex('.', t1.lt)) AS int)) + SUM(CAST(substring(CAST(t1.lt AS varchar), charindex('.', t1.lt) + 1, len(t1.lt)) AS int)) / 60 AS LateHH " +
		" ,SUM(CAST(substring(CAST(t1.lt AS varchar), charindex('.', t1.lt) + 1, len(t1.lt)) AS int)) % 60 AS LateMM " +
		" FROM ttime_current1 t1 left outer join  meventgrp eg on (t1.lv_ty=eg.eventgrpid) " +
		" WHERE " + strWhere +
		" GROUP BY t1.employeeid,t1.lv_ty,t1.hour_s,eg.tdesc " +strHaving+
		" ORDER BY t1.employeeid";
		
		return SQLQuery;
	}//end method getSQLQueryStatics
	
	private String getSQLQueryHeader(){
		String leaveCode = "";
		if(this.param.get("LEAVECOLUMN")==null || this.param.get("LEAVECOLUMN").equals("")){
			leaveCode = "null";
		}else{
			leaveCode = this.param.get("LEAVECOLUMN").toString();
		}//end if 
		
		String SQLQuery ="";
	 		
		SQLQuery = "SELECT mr.codeid,mr.tdesc "+
		",me1.tdesc as headcol01 ,me2.tdesc as headcol02 ,me3.tdesc as headcol03 ,me4.tdesc as headcol04 ,me5.tdesc as headcol05 "+ 
		",me6.tdesc as headcol06 ,me7.tdesc as headcol07 ,me8.tdesc as headcol08 ,me9.tdesc as headcol09 ,me10.tdesc as headcol10 "+
		",me11.tdesc as headcol11 ,me12.tdesc as headcol12 ,me13.tdesc as headcol13 ,me14.tdesc as headcol14 ,me15.tdesc as headcol15 "+
		",me16.tdesc as headcol16 ,me17.tdesc as headcol17 ,me18.tdesc as headcol18 ,me19.tdesc as headcol19 ,me20.tdesc as headcol20 "+
		",me21.tdesc as headcol21 ,me22.tdesc as headcol22 ,me23.tdesc as headcol23 ,me24.tdesc as headcol24 ,me25.tdesc as headcol25 "+
		"FROM mleave_report mr left outer join meventgrp me1 on (mr.col01=me1.eventgrpid) "+
		"left outer join meventgrp me2 on (mr.col02=me2.eventgrpid) "+
		"left outer join meventgrp me3 on (mr.col03=me3.eventgrpid) "+
		"left outer join meventgrp me4 on (mr.col04=me4.eventgrpid) "+
		"left outer join meventgrp me5 on (mr.col05=me5.eventgrpid) "+
		"left outer join meventgrp me6 on (mr.col06=me6.eventgrpid) "+
		"left outer join meventgrp me7 on (mr.col07=me7.eventgrpid) "+
		"left outer join meventgrp me8 on (mr.col08=me8.eventgrpid) "+
		"left outer join meventgrp me9 on (mr.col09=me9.eventgrpid) "+
		"left outer join meventgrp me10 on (mr.col10=me10.eventgrpid) "+
		"left outer join meventgrp me11 on (mr.col11=me11.eventgrpid) "+
		"left outer join meventgrp me12 on (mr.col12=me12.eventgrpid) "+
		"left outer join meventgrp me13 on (mr.col13=me13.eventgrpid) "+
		"left outer join meventgrp me14 on (mr.col14=me14.eventgrpid) "+
		"left outer join meventgrp me15 on (mr.col15=me15.eventgrpid) "+
		"left outer join meventgrp me16 on (mr.col16=me16.eventgrpid) "+
		"left outer join meventgrp me17 on (mr.col17=me17.eventgrpid) "+
		"left outer join meventgrp me18 on (mr.col18=me18.eventgrpid) "+
		"left outer join meventgrp me19 on (mr.col19=me19.eventgrpid) "+
		"left outer join meventgrp me20 on (mr.col20=me20.eventgrpid) "+
		"left outer join meventgrp me21 on (mr.col21=me21.eventgrpid) "+
		"left outer join meventgrp me22 on (mr.col22=me22.eventgrpid) "+
		"left outer join meventgrp me23 on (mr.col23=me23.eventgrpid) "+
		"left outer join meventgrp me24 on (mr.col24=me24.eventgrpid) "+
		"left outer join meventgrp me25 on (mr.col25=me25.eventgrpid) "+
		"WHERE mr.codeid ='"+leaveCode+"' ";
		
		return SQLQuery;
	}//end method getSQLQueryHeader

}//end class
