package com.csc.library.databean;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.Hashtable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.report.ReportUDF;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utility.NUtils;

public class Vw_vacation_rslt extends RecordCmp0{
	private CscConnection conn = null;
	private Statement stmt =null;  
	
	public Vw_vacation_rslt() {
		// TODO Auto-generated constructor stub
		super("Vw_vacation_rslt","View Vw_vacation_rslt");
	}//end constructor

	public FieldManager getField(String fieldName) {		
		FieldManager fm = super.getField(fieldName);   
		NUtils nUtils = new NUtils(); 
        if (fieldName.equalsIgnoreCase("vacremain")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            if(this.getString("employeeid")!=null && !this.getString("employeeid").equals("") 
            		&& this.getString("hour_d")!=null && !this.getString("hour_d").equals("")
               		&& Float.valueOf(((this.getString("hour_d")==null || this.getString("hour_d").equals(""))?"0.0f":this.getString("hour_d")))>0.0f){
                String vacation0 = "00:00:00"; String vacation1 = "00:00:00";
	    		float hour_d = Float.valueOf(this.getString("hour_d"));
	            if(this.getString("vacation0")!=null && !this.getString("vacation0").equals("")){
	            	vacation0 = this.getString("vacation0");
	            }//end if 
	            if(this.getString("vacation1")!=null && !this.getString("vacation1").equals("")){
	           	 	vacation1 = this.getString("vacation1");
	            }//end if 
	            String vacPrvlg = nUtils.addDayTime(vacation0,vacation1, hour_d, ":",true);
	            CscCalendar stVacDate = new CscCalendar();
	            CscCalendar endVacDate = new CscCalendar();
	            try {			
	            	stVacDate =  new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro,"ta1003"));
	               	endVacDate =  new CscCalendar((String) StaticConfig.getConfigCompany(this.userPro,"ta1004"));
	            } catch (Exception e) {	
	    			System.out.print(">>> Nuiss Debug : Can't get Config for Vacation Leave ConfigId is : TA1003 & TA1004");
	    		}//end try 
	            String vacUsed=	"00:00:00";
	            if(this.getString("vacusedmm")!=null && !this.getString("vacusedmm").equals(""))	{
	            	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm"))
							,hour_d,":");
	            }//end if 						 	
	            String vacremain = nUtils.subDayTime(vacPrvlg,vacUsed, (int) hour_d, ":",true);
	            fm.set(vacremain);
            }else{
            	 fm.set("00:00:00");
            }//end if 
        }else if (fieldName.equalsIgnoreCase("vackeep")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            if(this.getString("employeeid")!=null && !this.getString("employeeid").equals("") 
            		&& this.getString("hour_d")!=null && !this.getString("hour_d").equals("")
            		&& Float.valueOf(((this.getString("hour_d")==null || this.getString("hour_d").equals(""))?"0.0f":this.getString("hour_d")))>0.0f 
             		&& this.getString("last_privilege")!=null && !this.getString("last_privilege").equals("")
            		&& this.getString("vacremain")!=null && !this.getString("vacremain").equals("")){
            	
            	String lastPrvlg = this.getString("last_privilege");
            	String vacRemain = this.getString("vacremain");
            	if(nUtils.isOverFlowDayTime(lastPrvlg,vacRemain, ":")){
            		// vacRemain > lastPrvlg
            		fm.set(lastPrvlg);
            	}else{
            		// vacRemain < lastPrvlg
            		fm.set(vacRemain);
            	}//end if 
            }else{
            	 fm.set("00:00:00");
            }//end if      
        }else if (fieldName.equalsIgnoreCase("vactotal")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            if(this.getString("employeeid")!=null && !this.getString("employeeid").equals("") 
            		&& this.getString("hour_d")!=null && !this.getString("hour_d").equals("")
            		&& Float.valueOf(((this.getString("hour_d")==null || this.getString("hour_d").equals(""))?"0.0f":this.getString("hour_d")))>0.0f   		
            		&& this.getString("vackeep")!=null && !this.getString("vackeep").equals("")
            		&& this.getString("vacnextyear")!=null && !this.getString("vacnextyear").equals("")){

            	  float hour_d = Float.valueOf(this.getString("hour_d"));
            	  String vacKeep = this.getString("vackeep");
            	  String vacNextYear = this.getString("vacnextyear");
            	  String vacTotal = nUtils.addDayTime(vacKeep,vacNextYear, hour_d, ":",true);
            	  fm.set(vacTotal);
            }else{
            	fm.set("00:00:00");
            }//end if
            
        }else if (fieldName.equalsIgnoreCase("vacused")) {
	    	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("employeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
	        	 float hour_d = Float.valueOf(this.getString("hour_d")); 
		         String vacUsed=	"00:00:00";
	             if(this.getString("vacusedmm")!=null && !this.getString("vacusedmm").equals(""))	{
	             	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm"))
				 			,hour_d,":");
	             	fm.set(vacUsed);
	             }else{
	            	 fm.set("00:00:00");
	             }
	         }
       }else if (fieldName.equalsIgnoreCase("vacused_JAN")) {
	    	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("employeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
	        	 float hour_d = Float.valueOf(this.getString("hour_d")); 
		         String vacUsed=	"00:00:00";
	             if(this.getString("vacusedmm_jan")!=null && !this.getString("vacusedmm_jan").equals(""))	{
	             	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_jan"))
				 			,hour_d,":");
	             	fm.set(vacUsed);
	             }else{
	            	 fm.set("00:00:00");
	             }
	         }
       }else if (fieldName.equalsIgnoreCase("vacused_FEB")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_feb")!=null && !this.getString("vacusedmm_feb").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_feb"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_MAR")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00"; 
		        if(this.getString("vacusedmm_mar")!=null && !this.getString("vacusedmm_mar").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_mar"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_APR")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_apr")!=null && !this.getString("vacusedmm_apr").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_apr"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_MAY")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_may")!=null && !this.getString("vacusedmm_may").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_may"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_JUN")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_jun")!=null && !this.getString("vacusedmm_jun").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_jun"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_JUL")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_jul")!=null && !this.getString("vacusedmm_jul").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_jul"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_AUG")) { 	    	
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_aug")!=null && !this.getString("vacusedmm_aug").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_aug"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_SEP")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
	        	 float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_sep")!=null && !this.getString("vacusedmm_sep").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_sep"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_OCT")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_oct")!=null && !this.getString("vacusedmm_oct").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_oct"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_NOV")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_nov")!=null && !this.getString("vacusedmm_nov").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_nov"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("vacused_DEC")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String vacUsed=	"00:00:00";
		        if(this.getString("vacusedmm_dec")!=null && !this.getString("vacusedmm_dec").equals(""))	{
		        	vacUsed = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("vacusedmm_dec"))
							,hour_d,":");
		        	fm.set(vacUsed);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("plusedDDHHMM")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         String plused=	"00:00:00";
		        if(this.getString("plused")!=null && !this.getString("plused").equals(""))	{
		        	plused = nUtils.cnvrtMinute2DDHHMM(Integer.valueOf(this.getString("plused"))
							,hour_d,":");
		        	fm.set(plused);
		        }else{
		         fm.set("00:00:00");
		        }
	         }
	    }else if (fieldName.equalsIgnoreCase("plremain")) {
	       	 fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
	         fm.setWorking(true);
	         if(!(this.getString("empoyeeid") ==null || this.getString("employeeid").equals("")) && !(this.getString("hour_d")==null || this.getString("hour_d").equalsIgnoreCase(""))){
		         float hour_d = Float.valueOf(this.getString("hour_d"));
		         int hour_dMM = Integer.valueOf(new ReportUDF().getTime2Min(String.valueOf(hour_d)));
		         int plprvlg = Integer.parseInt(this.getString("plprvlg"))*(hour_dMM);
		         String plUsed=	nUtils.cnvrtMinute2DDHHMM(plprvlg
							,hour_d,":");
		        if(this.getString("plused")!=null && !this.getString("plused").equals(""))	{ 
		        	plUsed = nUtils.cnvrtMinute2DDHHMM(plprvlg-Integer.valueOf(this.getString("plused"))
							,hour_d,":");
		        	fm.set(plUsed);
		        }else{
		         fm.set(plUsed);
		        }
	         }
	    }else{
        	 fm = super.getField(fieldName);
        }//end if 
        return fm;
	}//end method getField
	/**
	 * @param employeeid
	 * @param startDate
	 * @param endDate
	 * @param hour_s
	 * @return
	 * @deprecated :  script ҡ SQL     sum  method ѹҹ
	 */
	private String getVacUsed(String employeeid,String startDate,String endDate,float hour_s){
		NUtils nUlits = new NUtils();
		String vacUsed= "00:00:00";
		ResultSet resultSet = null;
		int rowEffected =0;		
		String sqlQuery ="SELECT tlv.employeeid,tlv.m_lv "+
								" FROM tleave_summary tlv "+
								" WHERE tlv.lv_type = (select mev.eventgrpid from meventgrp mev where mev.daytype='7') "+
								" and tlv.doctype='A' "+
								" and tlv.employeeid ='"+employeeid+"' "+
								" and tlv.lv_bg_date >= '"+startDate+"' "+
								" and tlv.lv_bg_date <= '"+endDate+"'" ;
		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(sqlQuery);
			String m_lv = "0.0";
			DecimalFormat dc = new DecimalFormat();
			dc.applyPattern("#0.00");
			while (resultSet.next()) {
				rowEffected++;
				m_lv = resultSet.getString("m_lv");
				m_lv = "00:"+m_lv.replace(".",":");
				if(hour_s>0.0f){
					vacUsed = nUlits.addDayTime(vacUsed,m_lv,hour_s,":",true);
				}//end if 			
			}//end while 
			
		}catch(Exception ex){
			System.out.print(">>>> Nuiss Debug : Error on Vw_vacation.getVacUsed()"+ex.getStackTrace());
		}finally{
			try {
				resultSet.close();
				stmt.close();
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}		
		}//end try
		
		return vacUsed;
	}//end method getVacUsed
}//end class
