package com.csc.library.dwr;

import com.csc.library.timeattendance.ChkTimeOverLap;
import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Properties;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tabsent_nstda;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
import com.csc.library.utility.NUtils;

public class Tabsent_nstda_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Tabsent_nstda_dwr() { }
	
	public void writeUProfile(UProfile up) {
		this.up = up;
	}
	
	public String getDWRLeave(String[] str) {
		String flag = "0";
 		if (this.up == null) {
			this.setUProfile();
		}	
		CscCalendar cs = new CscCalendar();
		CheckNull chknull = new CheckNull();
		
		String emp = this.chkEmptyData(str, 0);
		String lv_type = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String startTime = this.chkEmptyData(str, 3);
		String endDate = this.chkEmptyData(str, 4);
		String endTime = this.chkEmptyData(str, 5);
        float amoutLeave = Float.parseFloat(this.chkEmptyData(str, 6));
        int typeLeave = Integer.parseInt(this.chkEmptyData(str, 7));
        float hourLeave = Float.valueOf(this.chkEmptyData(str, 8)).floatValue();        
        String used = this.chkEmptyData(str, 9);
        String chkDateRequest = chknull.chkNullString(this.chkEmptyData(str, 10));	/* 繵ͧ͹ѧ ǧ˹ (workflow  ˹Ҩ admin ѧҹ) */
        String absentid = chknull.chkNullString(this.chkEmptyData(str, 11));	/*  update  new */
        String st_period = chknull.chkNullString(this.chkEmptyData(str, 12));
        String en_period = chknull.chkNullString(this.chkEmptyData(str, 13));
        
        String reqDate = cs.getDDMMYYYY();
        float reqTime = cs.getCSCTime();
		
        HashMap param = new HashMap();
        if (!chkDateRequest.equals("")) {
        	param.put("chkdaterequest", chkDateRequest);
        }
		
		try {
			Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(this.up).getDbRecord("TABSENT_NSTDA");
			rec.setParam(param);
			if (absentid.equals("")) {
				rec.set("ABSENTID","0");
			} else rec.set("ABSENTID", absentid);
			rec.set("EMPLOYEEID", emp);
			rec.set("TYPE_ABSENT", lv_type);
			rec.set("START_DATE", startDate);
			rec.set("START_TIME", startTime);
			rec.set("END_DATE", endDate);
			rec.set("END_TIME",  endTime);
			rec.set("COMPANYID", this.up.get("companyid"));
			rec.set("LEAVE_FORMAT",  typeLeave);
			rec.set("REQUEST_DATE",reqDate);
			rec.set("REQUEST_TIME",reqTime);
			if (typeLeave==0) {
				 rec.set("LEAVE_DAY",  amoutLeave);
			} else{
				rec.set("LEAVE_HOUR",  hourLeave);
			}//end if 

			/* Ѻӹǳ . Ẻ () */
			rec.set("st_period", st_period);
			rec.set("en_period", en_period);
			
			flag  = rec.calulateLeaveRemain(amoutLeave, typeLeave, hourLeave, used, chkDateRequest);
		
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return flag;
	}
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String lv_type = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String startTime = this.chkEmptyData(str, 3);
		String endDate = this.chkEmptyData(str, 4);
		String endTime = this.chkEmptyData(str, 5);
		float amoutLeave = Float.parseFloat(this.chkEmptyData(str, 6));
        int typeLeave = Integer.parseInt(this.chkEmptyData(str, 7));
        float hourLeave = Float.valueOf(this.chkEmptyData(str, 8)).floatValue();
		
		try {
			Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(up).getDbRecord("TABSENT_NSTDA");
			rec.set("ABSENTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("TYPE_ABSENT", lv_type);
			rec.set("START_DATE", startDate);
			rec.set("START_TIME", startTime);
			rec.set("END_DATE", endDate);
			rec.set("END_TIME",  endTime);
			rec.set("COMPANYID", this.up.get("companyid"));
			rec.set("LEAVE_FORMAT",  typeLeave);
			if (typeLeave==0) {
				 rec.set("LEAVE_DAY",  amoutLeave);
			} else rec.set("LEAVE_HOUR",  hourLeave);
			MyTreeMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
			
			
			String lv_desc="";
			String time_desc = "";
			DbInquiry inqEvent = this.getInquiry("Meventgrp", "*", "eventgrpid='"+lv_type+"'", "", this.up);
			if (inqEvent.next()) {
				lv_desc = inqEvent.getString("tdesc");
			}
			
			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0' >";			
			data += "<tr bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Leave Request Information&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Ũӹǹѹ&nbsp;:&nbsp;</strong></td>";
            }
			//Leave Request Information = Ũӹǹѹ
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='title2'><strong>Leave Type&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td class='title2'><strong>&nbsp;:&nbsp;</strong></td>";                
            }
			//Leave Type = 
			data += "<td class='desc'>"+lv_type+" : "+lv_desc+"</td>";
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='title2'><strong>Leave_Date&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td class='title2'><strong>ǧѹ&nbsp;:&nbsp;</strong></td>";
            }
			//Leave Date = ǧѹ 
			data += "<td class='desc'>"+startDate+" - "+endDate+"</td>";
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='title2'><strong>Leave_Time&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td class='title2'><strong>ǧҷ &nbsp;:&nbsp;</strong></td>";       
            }
			//Leave Time = ǧҷ 
			data += "<td class='desc'>"+startTime+" - "+endTime+"</td>";
			data += "</tr>";
			
			/*data += "<tr>";
			data += "<td></td>";
			data += "<td>"+hm.size()+"</td>";
			data += "</tr>";*/
			
			data += "</table>";			
			data += "</font>";
			data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";		
			data += "<tr align='center' bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='txt_normal'><strong>Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Day&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Working_Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Leave_Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Leave_Total&nbsp;</strong></td>";
            } else {
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ҷӧҹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>. &nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
            }
			data += "</tr>";
									
			int hm_size = hm.size();
			int i=1;
			while (i<=hm_size) {
				MyHashMap hmData = (MyHashMap) hm.get(Integer.valueOf(i));
					
				DbInquiry inqTimet = this.getInquiry("Mtime0", "*", "time0id='"+hmData.getString("TIME0ID")+"'", "", this.up);
				if (inqTimet.next()) {
					time_desc = inqTimet.getString("tdesc");
				}
				
				data += "<tr align='center'>";
				CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
				data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='desc'>"+cs.getDOWTHI()+"</td>";
				data += "<td class='desc'>"+hmData.getString("TIME0ID")+" : "+time_desc+"</td>";
				//===================== Nuiss Code ==================================
				/**
				 * Author : Nuiss 
				 * Date : 31/03/2552
				 * Logic : ҷѹ save Ҩԧ ѹҡäӹǳ
				 */
				//ͧẺ
				//data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+" - "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";	
				//
				if(i==1){
					//data += "<td class='desc'>"+startTime+" - "+endTime+"</td>";	
					data += "<td class='desc'>"+startTime+" - "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";	
				}else{
					data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))
					+" - "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";	
				}//end if 
				//===================== Nuiss Code ==================================
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";		
				data += "</tr>";
				i++;
			}					
			data += "</table>";	
		} catch (Exception e) {
			MyLog.error(this, e);			
		}			
		data += this.getBelowFrame();
		return data;
	}
	
	public String getDWRDataService(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String lv_type = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String startTime = this.chkEmptyData(str, 3);
		String endDate = this.chkEmptyData(str, 4);
		String endTime = this.chkEmptyData(str, 5);
		float amoutLeave = Float.parseFloat(this.chkEmptyData(str, 6));
        int typeLeave = Integer.parseInt(this.chkEmptyData(str, 7));
        float hourLeave = Float.valueOf(this.chkEmptyData(str, 8)).floatValue();
		
		try {
			Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(up).getDbRecord("TABSENT_NSTDA");
			rec.set("ABSENTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("TYPE_ABSENT", lv_type);
			rec.set("START_DATE", startDate);
			rec.set("START_TIME", startTime);
			rec.set("END_DATE", endDate);
			rec.set("END_TIME",  endTime);
			rec.set("COMPANYID", this.up.get("companyid"));
			rec.set("LEAVE_FORMAT",  typeLeave);
			if (typeLeave==0) {
				 rec.set("LEAVE_DAY",  amoutLeave);
			} else rec.set("LEAVE_HOUR",  hourLeave);
			MyTreeMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
			
			
			String lv_desc="";
			String time_desc = "";
			DbInquiry inqEvent = this.getInquiry("Meventgrp", "*", "eventgrpid='"+lv_type+"'", "", this.up);
			if (inqEvent.next()) {
				lv_desc = inqEvent.getString("tdesc");
			}
			
			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0' >";			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td colspan='2' align='center' class='row-title'>Leave Request Information</td>";
            } else {
                data += "<td colspan='2' align='center' class='row-title'>Ũӹǹѹ</td>";
            }
			//Leave Request Information = Ũӹǹѹ
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='column-label' width='25%'>Leave Type</td>";
            } else {
                data += "<td class='column-label' width='25%'></td>";                
            }
			//Leave Type = 
			data += "<td class='column-data' width='75%'>"+lv_type+" : "+lv_desc+"</td>";
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='column-label' width='25%'>Leave Date</td>";
            } else {
                data += "<td class='column-label' width='25%'>ǧѹ</td>";
            }
			//Leave Date = ǧѹ 
			data += "<td class='column-data' width='75%'>"+startDate+" - "+endDate+"</td>";
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='column-label' width='25%'>Leave Time</td>";
            } else {
                data += "<td class='column-label' width='25%'>ǧҷ</td>";       
            }
			//Leave Time = ǧҷ 
			data += "<td class='column-data' width='75%'>"+startTime+" - "+endTime+"</td>";
			data += "</tr>";
			/*data += "<tr>";
			data += "<td></td>";
			data += "<td>"+hm.size()+"</td>";
			data += "</tr>";*/	
			data += "</table>";
			data += "</font>";
			data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";		
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='row-header' width='15%'>Date&nbsp;</td>";
                data += "<td class='row-header' width='10%'>Day&nbsp;</td>";
                data += "<td class='row-header' width='45%'>Working Time&nbsp;</td>";
                data += "<td class='row-header' width='20%'>Leave Time&nbsp;</td>";
                data += "<td class='row-header' width='10%'>Leave Total&nbsp;</td>";
            } else {
                data += "<td class='row-header' width='15%'>ѹ&nbsp;</td>";
                data += "<td class='row-header' width='10%'>ѹ&nbsp;</td>";
                data += "<td class='row-header' width='45%'>ҷӧҹ&nbsp;</td>";
                data += "<td class='row-header' width='20%'>. &nbsp;</td>";
                data += "<td class='row-header' width='10%'>&nbsp;</td>";
            }
			data += "</tr>";			
									
			int hm_size = hm.size();
			int i=1;
			while (i<=hm_size) {
				MyHashMap hmData = (MyHashMap) hm.get(Integer.valueOf(i));
					
				DbInquiry inqTimet = this.getInquiry("Mtime0", "*", "time0id='"+hmData.getString("TIME0ID")+"'", "", this.up);
				if (inqTimet.next()) {
					time_desc = inqTimet.getString("tdesc");
				}
				
				data += "<tr align='center'>";
				CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
				data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='row-data'>"+cs.getDOWTHI()+"</td>";
				data += "<td class='row-data'>"+hmData.getString("TIME0ID")+" : "+time_desc+"</td>";
				data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+" - "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";				
				data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";		
				data += "</tr>";
				i++;
			}					
			data += "</table>";	
		} catch (Exception e) {
			MyLog.error(this, e);			
		}			
		data += this.getBelowFrame();
		return data;
	}
	
	public String[] getWorkingDateTime(String[] str){
		if (this.up == null) {
			this.setUProfile();
		}
		
		String empid = this.chkEmptyData(str, 0);
		String startdate = this.chkEmptyData(str, 1);
		String[] data = null;
		
		try{
			Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(this.up).getDbRecord("Tabsent_nstda");
			rec.set("EMPLOYEEID", empid);
			rec.set("COMPANYID", this.up.get("COMPANYID"));
			rec.set("START_DATE", startdate);
			MyHashMap hmData = rec.getWorkingDateTime(empid, startdate);
			
			data = new String[hmData.size()];
			if (data.length > 2){
				data[0] = hmData.getString("START_TIME");
				data[1] = hmData.getString("END_DATE");
				data[2] = hmData.getString("END_TIME");
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return data;
	}
	
	public boolean chkDuplicateLeave(String[] absent){
		boolean chkOverLap = false;
		try {
	        /* 礡ҫӡѺǧ */
			this.setUProfile();
			
	    	ChkTimeOverLap chkTOverLap = new ChkTimeOverLap();
	    	chkTOverLap.setProp(absent, this.up);
	    	chkOverLap = chkTOverLap.chkTimeOverlap();
		}catch(Exception e){
			MyLog.error("!! Error : chkDuplicateLeave !!",e);
		}
		return chkOverLap;
	}
	
	public boolean chkDuplicateLeaveNissan(String[] absent, String absid){
		boolean chkOverLap = false;
		try {
	        /* 礡ҫӡѺǧ */
			this.setUProfile();
			
	    	ChkTimeOverLap chkTOverLap = new ChkTimeOverLap();
	    	chkTOverLap.setProp(absent, this.up);
	    	chkTOverLap.setExceptDocId(absid);
	    	chkOverLap = chkTOverLap.chkTimeOverlap();
		}catch(Exception e){
			MyLog.error("!! Error : chkDuplicateLeave !!",e);
		}
		return chkOverLap;
	}
	
	/* Ѻ㺻Ѻا¡ԡ 
	 * input	str : ҷ价礡
	 * 			absid : ͡١¡һѺاź
	 * 			mode : U Ѿഷ  D ź
	 * */
	public String getLeaveWithExceptId(String[] str, String absid, String mode) {
		String flag = "0";
 		if (this.up == null) {
			this.setUProfile();
		}	
		CscCalendar cs = new CscCalendar();
		CheckNull chknull = new CheckNull();
		
		String emp = this.chkEmptyData(str, 0);
		String lv_type = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String startTime = this.chkEmptyData(str, 3);
		String endDate = this.chkEmptyData(str, 4);
		String endTime = this.chkEmptyData(str, 5);
        float amoutLeave = Float.parseFloat(this.chkEmptyData(str, 6));
        int typeLeave = Integer.parseInt(this.chkEmptyData(str, 7));
        float hourLeave = Float.valueOf(this.chkEmptyData(str, 8)).floatValue();        
        String used = this.chkEmptyData(str, 9);
        String chkDateRequest = chknull.chkNullString(this.chkEmptyData(str, 10));	/* 繵ͧ͹ѧ ǧ˹ (workflow  ˹Ҩ admin ѧҹ) */
        String absentid = chknull.chkNullString(this.chkEmptyData(str, 11));	/*  update  new */
        String st_period = chknull.chkNullString(this.chkEmptyData(str, 12));
        String en_period = chknull.chkNullString(this.chkEmptyData(str, 13));
        String exc_absendid = absid ; /* Ţ͡ ͧ令ӹǳʹ ֧ѴἹ  */
        String reqDate = cs.getDDMMYYYY();
        float reqTime = cs.getCSCTime();
		
        HashMap param = new HashMap();
        if (!chkDateRequest.equals("")) {
        	param.put("chkdaterequest", chkDateRequest);
        }
		
		try {
			Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(this.up).getDbRecord("TABSENT_NSTDA");
			rec.setParam(param);
			if (absentid.equals("")) {
				rec.set("ABSENTID","0");
			} else rec.set("ABSENTID", absentid);
			rec.set("EMPLOYEEID", emp);
			rec.set("TYPE_ABSENT", lv_type);
			rec.set("START_DATE", startDate);
			rec.set("START_TIME", startTime);
			rec.set("END_DATE", endDate);
			rec.set("END_TIME",  endTime);
			rec.set("COMPANYID", this.up.get("companyid"));
			rec.set("LEAVE_FORMAT",  typeLeave);
			rec.set("REQUEST_DATE",reqDate);
			rec.set("REQUEST_TIME",reqTime);
			if (typeLeave==0) {
				 rec.set("LEAVE_DAY",  amoutLeave);
			} else{
				rec.set("LEAVE_HOUR",  hourLeave);
			}//end if 

			/* Ѻӹǳ . Ẻ () */
			rec.set("st_period", st_period);
			rec.set("en_period", en_period);
			
			/* ˹Ţ͡÷ͧ令ӹǳʹ ШѴἹ */
			rec.set("exc_absentid",exc_absendid) ;
			
			/* óա˹Ţ͡÷ͧ令ӹǳ ˹ mode ҨѾഷ ź */
			rec.set("exc_mode", mode);
			
			flag  = rec.calulateLeaveRemain(amoutLeave, typeLeave, hourLeave, used, chkDateRequest);
		
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return flag;
	}
}
