package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;

import com.csc.library.databean.Tforgetcard_nstda;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Tforgetcard_nstda_dwr extends DWR_base {

	DecimalFormat df = new DecimalFormat("0.00");
	
	public Tforgetcard_nstda_dwr() { }
		
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String month = this.chkEmptyData(str, 1);
		String year = this.chkEmptyData(str, 2);
		
		CscCalendar cs1 = new CscCalendar("01-"+month+"-"+year);
		CscCalendar cs2 = new CscCalendar(cs1.getEndDateOfMonth()+"-"+month+"-"+year);
		
		try {
			String col = "employeeid, companyid, time0id, dateid, c_dt_bg, c_dt_en, c_tm_bg, c_tm_en, eventgrpid, forget_in, forget_out, eventgrp";
			String filter = "employeeid='"+emp+"' and (dateid between '"+cs1.getYYYYMMDD()+"' " +
					"and '"+cs2.getYYYYMMDD()+"') and (forget_in=1 or forget_out=1) and (eventgrp <> 'H' and eventgrp <> 'I')";		
			DbInquiry inq = this.getInquiry("Ttime_current1", col, filter, "dateid", this.up);
						
			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";
			data += "<tr bgcolor='#0099CC'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
    			data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Swipe Time Forget Information&nbsp;:&nbsp;</strong></td>";
    			//Swipe Time Forget Information = šٴѵ
    			data += "</tr>";
    			
    			data += "<tr>";
    			data += "<td class='columnlabel'><strong>Date To Inspection&nbsp;:&nbsp;</strong></td>";
    			//Date To Inspection  = ǧѹǨͺ 
    			data += "<td class='desc'>"+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
    			data += "</tr>";
    			
    			data += "<tr>";
    			data += "<td class='columnlabel'><strong>Total Swipe Time&nbsp;:&nbsp;</strong></td>";
    			//Date  = ǧѹǨͺ 
    			data += "<td class='desc'>"+inq.recCount()+" Day</td>";
    			data += "</tr>";
    			data += "</table>";
    			
    			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";		
    			data += "<tr align='center' bgcolor='#0099CC'>";
    			data += "<td class='txt_normal' width='25%'><strong>Date&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='60%'><strong>Description&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='15%'><strong>Time Forget&nbsp;</strong></td>";
            }else{
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;šٴѵ&nbsp;:&nbsp;</strong></td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>ǧѹǨͺ&nbsp;:&nbsp;</strong></td>";
                //Date To Inspection  = ǧѹǨͺ 
                data += "<td class='desc'>"+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>¡÷ٴ&nbsp;:&nbsp;</strong></td>";
                //Date  = ǧѹǨͺ 
                data += "<td class='desc'>"+inq.recCount()+" ѹ</td>";
                data += "</tr>";
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";     
                data += "<tr align='center' bgcolor='#0099CC'>";
                data += "<td class='txt_normal' width='25%'><strong>ѹٴѵ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='60%'><strong>С÷ӧҹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='15%'><strong>ҷͧٴ&nbsp;</strong></td>";
            }
			data += "</tr>";
						
			while (inq.next()) {
				if (inq.getString("forget_in").equals("1") && inq.getString("forget_out").equals("1")) {
					CscCalendar cs = new CscCalendar(inq.getString("c_dt_bg"));
					data += "<tr align='center'>";
					data += "<td class='txt_normal'>"+cs.getDDMMYYYY()+"</td>";
					data += "<td class='txt_normal'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</td>";
					data += "<td class='txt_normal'>"+df.format(Double.parseDouble(inq.getString("c_tm_bg")))+"</td>";
					data += "</tr>";
					CscCalendar cstmp = new CscCalendar(inq.getString("c_dt_en"));
					data += "<tr align='center'>";
					data += "<td class='txt_normal'>"+cstmp.getDDMMYYYY()+"</td>";
					data += "<td class='txt_normal'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</td>";
					data += "<td class='txt_normal'>"+df.format(Double.parseDouble(inq.getString("c_tm_en")))+"</td>";
					data += "</tr>";
				} else if (inq.getString("forget_in").equals("1")) {
					CscCalendar cs = new CscCalendar(inq.getString("c_dt_bg"));
					data += "<tr align='center'>";
					data += "<td class='txt_normal'>"+cs.getDDMMYYYY()+"</td>";
					data += "<td class='txt_normal'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</td>";
					data += "<td class='txt_normal'>"+df.format(Double.parseDouble(inq.getString("c_tm_bg")))+"</td>";
					data += "</tr>";
				} else if (inq.getString("forget_out").equals("1")) {
					CscCalendar cs = new CscCalendar(inq.getString("c_dt_en"));
					data += "<tr align='center'>";
					data += "<td class='txt_normal'>"+cs.getDDMMYYYY()+"</td>";
					data += "<td class='txt_normal'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</td>";
					data += "<td class='txt_normal'>"+df.format(Double.parseDouble(inq.getString("c_tm_en")))+"</td>";
					data += "</tr>";
				}
			}				
			data += "</table>";						
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		data += this.getBelowFrame();
		return data;
	}
 	
    public String getDWRDataTtimeError(String[] str) {
        this.setUProfile();
        String data="";
        data += this.getHeaderFrame();
        
        String emp = this.chkEmptyData(str, 0);
        String start_date = this.chkEmptyData(str, 1);
        String end_date = this.chkEmptyData(str, 2);
        
        CscCalendar cs1 = new CscCalendar(start_date);
        CscCalendar cs2 = new CscCalendar(end_date);
        
        String error_value = "";
        String[] splitDateTime;
        
        try {
            String col = "employeeid, time0id, dateshift, error_type, error_value, dt_c_in, tm_c_in, dt_c_out, tm_c_out";
            String filter = "employeeid='"+emp+"' and (dateshift between '"+cs1.getYYYYMMDD()+"' " +
                    "and '"+cs2.getYYYYMMDD()+"') and (error_type='0' or error_type='1')";       
            DbInquiry inq = this.getInquiry("ttimeerror", col, filter, "dateshift", this.up);
                        
            data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";
            data += "<tr bgcolor='#0099CC'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Swipe Time Forget Information&nbsp;:&nbsp;</strong></td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>Date To Inspection&nbsp;:&nbsp;</strong></td>";
                //Date To Inspection  = ǧѹǨͺ 
                data += "<td class='desc'>"+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>Total Swipe Time&nbsp;:&nbsp;</strong></td>";
                //Date  = ǧѹǨͺ 
                data += "<td class='desc'>"+inq.recCount()+" Day</td>";
                data += "</tr>";
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";       
                data += "<tr align='center' bgcolor='#0099CC'>";
                data += "<td class='txt_normal' width='25%'><strong>Date&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='60%'><strong>Description&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='25%'><strong>Error Type&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='15%'><strong>Time Forget&nbsp;</strong></td>";
            }else{
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;šٴѵ&nbsp;:&nbsp;</strong></td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>ǧѹǨͺ&nbsp;:&nbsp;</strong></td>";
                //Date To Inspection  = ǧѹǨͺ 
                data += "<td class='desc'>"+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                data += "</tr>";
                
                data += "<tr>";
                data += "<td class='columnlabel'><strong>¡÷ٴ&nbsp;:&nbsp;</strong></td>";
                //Date  = ǧѹǨͺ 
                data += "<td class='desc'>"+inq.recCount()+" ѹ</td>";
                data += "</tr>";
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0' bgcolor='#333333'>";     
                data += "<tr align='center' bgcolor='#0099CC'>";
                data += "<td class='txt_normal' width='20%'><strong>ѹٴѵ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='45%'><strong>С÷ӧҹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='20%'><strong>üԴҴ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='15%'><strong>ҷͧٴ&nbsp;</strong></td>";
            }
            data += "</tr>";
                        
            while (inq.next()) {
                splitDateTime = inq.getString("error_value").split(":");
                CscCalendar cs = new CscCalendar(splitDateTime[0]);
                data += "<tr align='center'>";
                data += "<td class='columnobject1'><div align='center'>"+cs.getDDMMYYYY()+"</div></td>";
                data += "<td class='columnobject1'><div align='center'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</div></td>";
                data += "<td class='columnobject1'><div align='center'>"+inq.getCurrentDbRecord().getSystemCode("error_type")+"</div></td>";
                data += "<td class='columnobject1'><div align='center'>"+df.format(Double.parseDouble(splitDateTime[1]))+"</div></td>";
                data += "</tr>";
            }               
            data += "</table>";                     
        } catch (Exception e) {
            MyLog.error(this, e);            
        }
        data += this.getBelowFrame();
        return data;
    }
    
    public String getWorkingTime(String[] str){
        this.setUProfile();
        String start_time = "";
        String empCode = this.chkEmptyData(str, 0);
        String fgdate = this.chkEmptyData(str, 1);

        try {
            Tforgetcard_nstda rec = (Tforgetcard_nstda) new InitialRecord(up).getDbRecord("Tforgetcard_nstda");
            rec.set("FGCARDID","0");           
            rec.set("EMPLOYEEID", empCode);
            rec.set("FGDATE", fgdate);
            rec.set("COMPANYID", this.up.get("companyid"));
            
            start_time =  rec.getWorkingTime(empCode, fgdate);
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return start_time;
    }
    
    private String getFindSwipeErrorFilter(String emp, CscCalendar cs1, CscCalendar cs2){
    	String filter = "";
    	try {
    		InitialEnvironment inv = new InitialEnvironment(this.up.getDbName());
    		String dbType = inv.getValue("datasource-dbtype");
    		
    		if (dbType.equals("ORACLE")){ 
    			filter = "employeeid='"+emp+"' and (dateid between '"+cs1.getYYYYMMDD()+"' " +
                "and '"+cs2.getYYYYMMDD()+"') and (warn00<>' ' or warn01<>' ')";  
    		}else{
    			filter = "employeeid='"+emp+"' and (dateid between '"+cs1.getYYYYMMDD()+"' " +
                "and '"+cs2.getYYYYMMDD()+"') and (warn00<>' ' or warn01<>' ')";  
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return filter;
    }
    
    public String getDWRDataTtimeErrorService(String[] str) {
        this.setUProfile();
        String data="";
        data += this.getHeaderFrame();
        
        String emp = this.chkEmptyData(str, 0);
        String start_date = this.chkEmptyData(str, 1);
        String end_date = this.chkEmptyData(str, 2);
        
        CscCalendar cs1 = new CscCalendar(start_date);
        CscCalendar cs2 = new CscCalendar(end_date);
        
        try {
            String col = "employeeid, time0id, dateid, companyid, c_dt_bg, c_dt_en, c_tm_bg, c_tm_en, warn00, warn01";
            String filter = getFindSwipeErrorFilter(emp, cs1, cs2);
            DbInquiry inq = this.getInquiry("ttime_current1", col, filter, "dateid", this.up);
                        
            data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";
            data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
                data += "<td colspan='2' align='center' class='row-title'>Swipe Time Forget Information&nbsp; "+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";       
                data += "<tr align='center'>";
                data += "<td class='row-header' width='15%'>Date</td>";
                data += "<td class='row-header' width='40%'>Description</td>";
                data += "<td class='row-header' width='20%'>Error Type</td>";
                data += "<td class='row-header' width='25%'>Time Forget</td>";
            }else{
                data += "<td colspan='2' align='center' class='row-title'>šٴѵ&nbsp;" +cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";      
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0''>";     
                data += "<tr align='center'>";
                data += "<td class='row-header' width='15%'>ѹٴѵ</td>";
                data += "<td class='row-header' width='40%'>С÷ӧҹ</td>";
                data += "<td class='row-header' width='20%'>üԴҴ</td>";
                data += "<td class='row-header' width='25%'>ҷͧٴ</td>";
            }
            data += "</tr>";
                        
            while (inq.next()) {
            	DbRecord rec = inq.getCurrentDbRecord();
            	CscCalendar cs = new CscCalendar(rec.getString("dateid"));
            	
            	if (!rec.getString("warn00").equals("")) {
            		data += "<tr align='center'>";
	                data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
	                data += "<td class='row-data'>"+rec.getString("time0id")+" : "+this.getTimeDesc(rec.getString("time0id"))+"</td>";   
	                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
	                	data += "<td class='row-data'>Not Swipe In</td>";
	                } else {
	                	data += "<td class='row-data'>ٴ</td>";
	                }
	                data += "<td class='row-data'>"+rec.getString("warn00")+"</td>";
	                data += "</tr>";
            	}
            	
            	if (!rec.getString("warn01").equals("")) {
            		data += "<tr align='center'>";
	                data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
	                data += "<td class='row-data'>"+rec.getString("time0id")+" : "+this.getTimeDesc(rec.getString("time0id"))+"</td>";   
	                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
	                	data += "<td class='row-data'>Not Swipe Out</td>";
	                } else {
	                	data += "<td class='row-data'>ٴ͡</td>";
	                }
	                data += "<td class='row-data'>"+rec.getString("warn01")+"</td>";
	                data += "</tr>";
            	}
            }               
            data += "</table>";                     
        } catch (Exception e) {
            MyLog.error(this, e);            
        }
        data += this.getBelowFrame();
        return data;
    }
    
    /**
	 * Author : Nuiss
	 * Date : 21/05/2553
	 * Logic : for  ͧ¹ header column ѹ retrun  innerHTML ͡ ҧ method 
	 *  site 蹡ѹ
	 */
    public String getDWRDataTtimeErrorService_ONESQA(String[] str) {
        this.setUProfile();
        String data="";
        data += this.getHeaderFrame();
        
        String emp = this.chkEmptyData(str, 0);
        String start_date = this.chkEmptyData(str, 1);
        String end_date = this.chkEmptyData(str, 2);
        
        CscCalendar cs1 = new CscCalendar(start_date);
        CscCalendar cs2 = new CscCalendar(end_date);
        
        try {
            String col = "employeeid, time0id, dateid, companyid, c_dt_bg, c_dt_en, c_tm_bg, c_tm_en, warn00, warn01";
            String filter = "employeeid='"+emp+"' and (dateid between '"+cs1.getYYYYMMDD()+"' " +
                    "and '"+cs2.getYYYYMMDD()+"') and (warn00<>'' or warn01<>'')";       
            DbInquiry inq = this.getInquiry("ttime_current1", col, filter, "dateid", this.up);
                        
            data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";
            data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
                data += "<td colspan='2' align='center' class='row-title'>Swipe Time Forget Information&nbsp; "+cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";       
                data += "<tr align='center'>";
                data += "<td class='row-header' width='15%'>Date</td>";
                data += "<td class='row-header' width='40%'>Description</td>";
                data += "<td class='row-header' width='20%'>Error Type</td>";
                data += "<td class='row-header' width='25%'>Time Forget</td>";
            }else{
                data += "<td colspan='2' align='center' class='row-title'>šѹ֡&nbsp;" +cs1.getDDMMYYYY()+" - "+cs2.getDDMMYYYY()+"</td>";
                //Swipe Time Forget Information = šٴѵ
                data += "</tr>";      
                data += "</table>";
                
                data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0''>";     
                data += "<tr align='center'>";
                data += "<td class='row-header' width='15%'>ѹѹ֡</td>";
                data += "<td class='row-header' width='40%'>ҡ÷ӧҹ</td>";
                data += "<td class='row-header' width='20%'>üԴҴ</td>";
                data += "<td class='row-header' width='25%'>ҷͧѹ֡</td>";
            }
            data += "</tr>";
                        
            while (inq.next()) {
            	DbRecord rec = inq.getCurrentDbRecord();
            	CscCalendar cs = new CscCalendar(rec.getString("dateid"));
            	
            	if (!rec.getString("warn00").equals("")) {
            		data += "<tr align='center'>";
	                data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
	                data += "<td class='row-data'>"+rec.getString("time0id")+" : "+this.getTimeDesc(rec.getString("time0id"))+"</td>";   
	                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
	                	data += "<td class='row-data'>Not Swipe In</td>";
	                } else {
	                	data += "<td class='row-data'>ٴ</td>";
	                }
	                data += "<td class='row-data'>"+rec.getString("warn00")+"</td>";
	                data += "</tr>";
            	}
            	
            	if (!rec.getString("warn01").equals("")) {
            		data += "<tr align='center'>";
	                data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
	                data += "<td class='row-data'>"+rec.getString("time0id")+" : "+this.getTimeDesc(rec.getString("time0id"))+"</td>";   
	                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
	                	data += "<td class='row-data'>Not Swipe Out</td>";
	                } else {
	                	data += "<td class='row-data'>ٴ͡</td>";
	                }
	                data += "<td class='row-data'>"+rec.getString("warn01")+"</td>";
	                data += "</tr>";
            	}
            }               
            data += "</table>";                     
        } catch (Exception e) {
            MyLog.error(this, e);            
        }
        data += this.getBelowFrame();
        return data;
    }
}
