package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tot;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Tot_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Tot_dwr() { }
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String empCode = this.chkEmptyData(str, 0);
		String startDate = this.chkEmptyData(str, 1);
		String endDate = this.chkEmptyData(str, 2);
		String startTime = this.chkEmptyData(str, 3);
		String endTime = this.chkEmptyData(str, 4);
		
		try {
			Tot rec = (Tot) new InitialRecord(up).getDbRecord("TOT");
			rec.set("OTID","0");			 
			rec.set("EMPLOYEEID", empCode);
			rec.set("START_DATE", startDate);
			rec.set("START_TIME", startTime);
			rec.set("END_DATE", endDate);
			rec.set("END_TIME",  endTime);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyHashMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
			
			data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";		
			data += "<tr align='center' bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='txt_normal'><strong>Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Day&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Start Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>End Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>OT Total&nbsp;</strong></td>";
            } else {
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹش&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
            }
			data += "</tr>";
									
			int hm_size = hm.size();
			int i=1;
			while (i<=hm_size) {
				MyHashMap hmData = (MyHashMap) hm.get(String.valueOf(i));					
				data += "<tr align='center'>";
				CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
				data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='desc'>"+cs.getDOWTHI()+"</td>";
				CscCalendar cs1 = new CscCalendar(hmData.getString("DT_BG"));
				CscCalendar cs2 = new CscCalendar(hmData.getString("DT_EN"));
				data += "<td class='desc'>"+cs1.getDDMMYYYY()+" : "+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";
				data += "<td class='desc'>"+cs2.getDDMMYYYY()+" : "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";		
				data += "</tr>";
				i++;
			}					
			data += "</table>";				
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}		
		
		data += this.getBelowFrame();
		return data;
	}

}
