package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tabsentdate0;
import com.csc.library.databean.Tot_m_date0;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;

public class Tot_m_date0_dwr extends DWR_base {
    
    DecimalFormat df = new DecimalFormat("0.00");

    public Tot_m_date0_dwr() { }
    
    public String getDWRData(String[] str) {
        this.setUProfile();
        String data="";
        data += this.getHeaderFrame();
        
        String emp = this.chkEmptyData(str, 0);
        
        MyTreeMap tr = new MyTreeMap();
        
        int j=1;
        for (int i=1;i<=31;i++) {
            String chk = this.chkEmptyData(str, j++);
            String startdate = this.chkEmptyData(str, j++);
            String starttime = this.chkEmptyData(str, j++);
            String enddate = this.chkEmptyData(str, j++);
            String endtime = this.chkEmptyData(str, j++);
            if (chk.equals("1")) {
                MyHashMap hm = new MyHashMap();
                hm.put("startdate", startdate);
                hm.put("starttime", starttime);
                hm.put("enddate", enddate);
                hm.put("endtime", endtime);
                tr.put(Integer.valueOf((String.valueOf(i))), hm);
            }
        }
        
        int loop =1;
        MyHashMap hmValue = new MyHashMap();
        DbTable dbOT = new InitialTable(this.up).getDbTable("TOT_M_DATE1");
        Iterator it = tr.keySet().iterator();
        while (it.hasNext()) {
            hmValue.clear();
            Integer key = (Integer) it.next();
            hmValue = (MyHashMap) tr.get(key);
            
            try{
                DbRecord recOT = dbOT.getNewRecord(); 
                recOT.set("OTID","0");
                recOT.set("COMPANYID", this.up.get("companyid"));
                recOT.set("LINE_NO", loop);
                recOT.set("START_DATE", hmValue.getString("startdate"));
                recOT.set("START_TIME", hmValue.getString("starttime"));
                recOT.set("END_DATE", hmValue.getString("enddate"));            
                recOT.set("END_TIME", hmValue.getString("endtime"));
                dbOT.putNewRecord(recOT);
            } catch (Exception e) {
                MyLog.error(this, e);

                
            }
            loop++;
        }
        
        Tot_m_date0 rec = (Tot_m_date0) new InitialRecord(up).getDbRecord("TOT_M_DATE0");
        rec.set("OTID","0");             
        rec.set("EMPLOYEEID", emp);
        rec.set("COMPANYID", this.up.get("companyid"));
        rec.putChild(dbOT);
        MyHashMap hm = rec.getDWRData();
        MyLog.debug(this, "===="+hm);
        
        data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";       
        data += "<tr align='center' bgcolor='#0099cc'>";
        if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
            data += "<td class='txt_normal'><strong>Date&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>Day&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>Start Date&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>End Date&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>OT Total&nbsp;</strong></td>";
        } else {
            data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>ѹش&nbsp;</strong></td>";
            data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
        }
        data += "</tr>";
        
        int hm_size = hm.size();
        int i=1;
        while (i<=hm_size) {
            MyHashMap hmData = (MyHashMap) hm.get(String.valueOf(i));                   
            data += "<tr align='center'>";
            CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
            data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
            data += "<td class='desc'>"+cs.getDOWTHI()+"</td>";
            CscCalendar cs1 = new CscCalendar(hmData.getString("DT_BG"));
            CscCalendar cs2 = new CscCalendar(hmData.getString("DT_EN"));
            data += "<td class='desc'>"+cs1.getDDMMYYYY()+" : "+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";
            data += "<td class='desc'>"+cs2.getDDMMYYYY()+" : "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";
            data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";      
            data += "</tr>";
            i++;
        }                   
        data += "</table>";     
        
        data += this.getBelowFrame();
        return data;
    }
    
    public String getDWROT(String[] str){
        this.setUProfile();
        String data="";
        String emp = this.chkEmptyData(str, 0);
        MyTreeMap tr = new MyTreeMap();
        String[] subStr = this.chkEmptyData(str, 1).split("#");  

        for (int i=1; i<subStr.length; i++) {
            int j=0;
            String[] strValue = this.chkEmptyData(subStr, i).split("\\$");
            if(strValue.length == 4){
                String startdate = this.chkEmptyData(strValue, j++);
                String enddate = this.chkEmptyData(strValue, j++);
                String starttime = this.chkEmptyData(strValue, j++);
                String endtime = this.chkEmptyData(strValue, j++);
                if(!(startdate.equals("") || starttime.equals("") || enddate.equals("") || endtime.equals(""))){
                    MyHashMap hm = new MyHashMap();
                    hm.put("startdate", startdate);
                    hm.put("starttime", starttime);
                    hm.put("enddate", enddate);
                    hm.put("endtime", endtime);
                    tr.put(Integer.valueOf((String.valueOf(i))), hm);
                }
            }
        }
        
        int loop =1;
        MyHashMap hmValue = new MyHashMap();
        DbTable dbOT = new InitialTable(this.up).getDbTable("TOT_M_DATE1");
        Iterator it = tr.keySet().iterator();
        while (it.hasNext()) {
            hmValue.clear();
            Integer key = (Integer) it.next();
            hmValue = (MyHashMap) tr.get(key);
            
            try{
                DbRecord recOT = dbOT.getNewRecord(); 
                recOT.set("OTID","0");
                recOT.set("COMPANYID", this.up.get("companyid"));
                recOT.set("LINE_NO", loop);
                recOT.set("START_DATE", hmValue.getString("startdate"));
                recOT.set("START_TIME", hmValue.getString("starttime"));
                recOT.set("END_DATE", hmValue.getString("enddate"));            
                recOT.set("END_TIME", hmValue.getString("endtime"));
                dbOT.putNewRecord(recOT);
            } catch (Exception e) {
                MyLog.error(this, e);
            }
            loop++;
        }
        
        Tot_m_date0 rec = (Tot_m_date0) new InitialRecord(up).getDbRecord("TOT_M_DATE0");
        rec.set("OTID","0");             
        rec.set("EMPLOYEEID", emp);
        rec.set("COMPANYID", this.up.get("companyid"));
        rec.putChild(dbOT);
        MyHashMap hm = rec.getDWRData();
        MyLog.debug(this, "===="+hm);
        
        Iterator it_ot  = hm.keySet().iterator();
        float ot_date;
        CscTime cs_ot = new CscTime();
        while(it_ot.hasNext()){
            String key = (String) it_ot.next();
            MyHashMap hmOT = (MyHashMap) hm.get(key);
            ot_date = hmOT.getFloat("LV");
            cs_ot.add(ot_date);
        }
        
        if(cs_ot.getFloat() > 4){
            data = "true";
        }else{
            data = "false";
        }
        
        MyLog.debug("===== TOTAL OT : "+cs_ot.getFloat());
        
        return data;        
    }
    
    public String checkDWROT(String[] str){ // ҷ öͷ
        this.setUProfile();
        String data="";
        String emp = this.chkEmptyData(str, 0);
        MyTreeMap tr = new MyTreeMap();
        String[] subStr = this.chkEmptyData(str, 1).split("#");  
        MyTreeMap hmRequest = new MyTreeMap();

        for (int i=1; i<subStr.length; i++) {
            int j=0;
            String[] strValue = this.chkEmptyData(subStr, i).split("\\$");
            if(strValue.length == 5){
                String startdate = this.chkEmptyData(strValue, j++);
                String enddate = this.chkEmptyData(strValue, j++);
                String starttime = this.chkEmptyData(strValue, j++);
                String endtime = this.chkEmptyData(strValue, j++);
                String screenline = this.chkEmptyData(strValue, j++);
                if(!(startdate.equals("") || starttime.equals("") || enddate.equals("") || endtime.equals(""))){
                    MyHashMap hm = new MyHashMap();
                    hm.put("startdate", startdate);
                    hm.put("starttime", starttime);
                    hm.put("enddate", enddate);
                    hm.put("endtime", endtime);
                    hm.put("line", screenline);
                    tr.put(Integer.valueOf((String.valueOf(i))), hm);
                    
                    try {
	                    CscCalendar sDate = new CscCalendar(startdate); 
	                    sDate.setCSCTime(Float.parseFloat(starttime));
	                    CscCalendar eDate = new CscCalendar(enddate); 
	                    eDate.setCSCTime(Float.parseFloat(endtime));
	                    hmRequest.put(sDate.toString()+eDate.toString(), screenline);
                    } catch (Exception e) {
                    	MyLog.error(this, e);
                    }                    
                }
            }
        }
        
        int loop =1;
        MyHashMap hmValue = new MyHashMap();
        DbTable dbOT = new InitialTable(this.up).getDbTable("TOT_M_DATE1");
        Iterator it = tr.keySet().iterator();
        while (it.hasNext()) {
            hmValue.clear();
            Integer key = (Integer) it.next();
            hmValue = (MyHashMap) tr.get(key);
            
            try{
                DbRecord recOT = dbOT.getNewRecord(); 
                recOT.set("OTID","0");
                recOT.set("COMPANYID", this.up.get("companyid"));
                recOT.set("LINE_NO", loop);
                recOT.set("START_DATE", hmValue.getString("startdate"));
                recOT.set("START_TIME", hmValue.getString("starttime"));
                recOT.set("END_DATE", hmValue.getString("enddate"));            
                recOT.set("END_TIME", hmValue.getString("endtime"));
                dbOT.putNewRecord(recOT);
            } catch (Exception e) {
                MyLog.error(this, e);
            }
            loop++;
        }
        
        Tot_m_date0 rec = (Tot_m_date0) new InitialRecord(up).getDbRecord("TOT_M_DATE0");
        rec.set("OTID","0");             
        rec.set("EMPLOYEEID", emp);
        rec.set("COMPANYID", this.up.get("companyid"));
        rec.putChild(dbOT);
        MyHashMap hmOT = rec.getDWRData();
        MyLog.debug(this, "===="+hmOT);
        
        /*Iterator it_ot  = hm.keySet().iterator();
        float ot_date;
        CscTime cs_ot = new CscTime();
        while(it_ot.hasNext()){
            String key = (String) it_ot.next();
            MyHashMap hmOT = (MyHashMap) hm.get(key);
            ot_date = hmOT.getFloat("LV");
            cs_ot.add(ot_date);
        }*/
        try {
	        Iterator it_ot  = hmOT.keySet().iterator();
	        while(it_ot.hasNext()){
	        	String key = (String) it_ot.next();
	        	MyHashMap hmDetail = (MyHashMap) hmOT.get(key);
	        	CscCalendar sDate = new CscCalendar(hmDetail.getString("DT_BG"));
	        	sDate.setCSCTime(hmDetail.getFloat("TM_BG"));
	        	CscCalendar eDate = new CscCalendar(hmDetail.getString("DT_EN"));
	        	eDate.setCSCTime(hmDetail.getFloat("TM_EN"));
	        	String k = sDate.toString()+eDate.toString();
	        	if (hmRequest.containsKey(k)) {
	        		//data += (String) hmRequest.get(k)+",";
	        		hmRequest.remove(k);
	        	}
	        }    
	        
	        Iterator it_request  = hmRequest.keySet().iterator();
	        while(it_request.hasNext()){
	        	String key = (String) it_request.next();
	        	data += (String) hmRequest.get(key)+",";
	        }
	        
        } catch (Exception e) {
            MyLog.error(this, e);
        }       
        return data;        
    }

}
