package com.csc.library.inqbean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.MyInquiry;
import com.csc.library.database.MyInquirySumByGroupTotal;
import com.csc.library.report.ReportUDF;
import com.csc.library.utilities.CscTime;

public class Inq_ttime_current1 extends MyInquirySumByGroupTotal {
	
	ReportUDF rf = new ReportUDF();
	
	public Object calculate(String fieldName, Object oldValue) {
		Object resultValue = oldValue;  
		
		/*MyLog.debug(this, "cal... date"+this.getString("dateid")+
				" lv_ty="+this.getString("lv_ty")+
				" late="+this.getString("lt")+
				" ot1="+this.getString("ot1")+
				" ot5="+this.getString("ot5")+
				" ot2="+this.getString("ot2")+
				" ot3="+this.getString("ot3")+
				" ");*/
		
		if (fieldName.equalsIgnoreCase("lateless")) {
			if (this.getDouble("lt")>0 && this.getDouble("lt")<=0.15) {
				resultValue = (Object) this.countLate(oldValue);
			} 	
		} else if (fieldName.equalsIgnoreCase("latemore")) {
			if (this.getDouble("lt")>0.15) {
				resultValue = (Object) this.countLate(oldValue);
			} 	
		} else if (fieldName.equalsIgnoreCase("sumot1")) {
			if (this.getDouble("ot1")>0) {
				resultValue = (Object) this.sumOT(oldValue, "ot1");
			} 	
		} else if (fieldName.equalsIgnoreCase("sumot5")) {
			if (this.getDouble("ot5")>0) {
				resultValue = (Object) this.sumOT(oldValue, "ot5");				
			} 
		} else if (fieldName.equalsIgnoreCase("sumot2")) {
			if (this.getDouble("ot2")>0) {
				resultValue = (Object) this.sumOT(oldValue, "ot2");
			} 
		} else if (fieldName.equalsIgnoreCase("sumot3")) {
			if (this.getDouble("ot3")>0) {
				resultValue = (Object) this.sumOT(oldValue, "ot3");
			} 
		} else if (fieldName.indexOf("sumleave")>-1) {
			String lv="01,02,03,04";
			String lv_ty = fieldName.substring(9, fieldName.length()).toLowerCase();
			if (this.getDouble("m_lv")>0 && lv.indexOf(this.getString("lv_ty"))<=-1 && lv_ty.equalsIgnoreCase("05")) {
				resultValue = (Object) this.sumLeave(oldValue);
			} else if (this.getDouble("m_lv")>0 && lv_ty.equals(this.getString("lv_ty").toLowerCase())) {
				resultValue = (Object) this.sumLeave(oldValue);
			} 
		} else if (fieldName.equalsIgnoreCase("sumwork")) {
			resultValue = (Object) this.sumWork(oldValue);
		}
		
		if (resultValue==null) {
			resultValue = "0";
		}
		return resultValue;
	}
	
	private String sumNumeric(Object oldValue, Object newValue) {
		return String.valueOf(Integer.parseInt(oldValue.toString()) + Integer.parseInt(newValue.toString()));
	}
	
	private String sumTime(Object oldValue, Object newValue) {
		CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
		ct.add(Float.parseFloat(newValue.toString()));
		return String.valueOf(ct.getFloat());	
	}
	
	private String sumTime(Object oldValue, Object newValue, boolean round) {
		CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
		String value = rf.getRoundOTEasy(String.valueOf(newValue.toString()));
		value = value.toString().replaceAll(",","");
		ct.add(Float.parseFloat(value));
		return String.valueOf(ct.getFloat());	
	}
	
	public Object calculateSumGroup(String fieldName, Object oldValue, Object newValue) {
		Object resultValue = oldValue;  
		if (oldValue==null) oldValue = "0";
		if (newValue==null) newValue = "0";
		
		if (fieldName.equalsIgnoreCase("lateless")) {
			resultValue = this.sumNumeric(oldValue, newValue);
		} else if (fieldName.equalsIgnoreCase("latemore")) {
			resultValue = this.sumNumeric(oldValue, newValue);
		} else if (fieldName.equalsIgnoreCase("sumot1") || fieldName.equalsIgnoreCase("sumot5") || 
				fieldName.equalsIgnoreCase("sumot2") || fieldName.equalsIgnoreCase("sumot3")) {
			//String value = rf.getRoundOTEasy(String.valueOf(newValue.toString()));
			//value = value.toString().replaceAll(",","");
			resultValue = this.sumTime(oldValue, newValue);
		} else if (fieldName.indexOf("sumleave")>-1) {			
			resultValue = this.sumTime(oldValue, newValue);
		} else if (fieldName.equalsIgnoreCase("sumwork")) {
			resultValue = this.sumTime(oldValue, newValue);
		}
		
		if (resultValue==null) {
			resultValue = "0";
		}
		return resultValue;
	}
	
	protected void groupChange(int level)  {  	// summary data from group total to supergroup total
		int g = this.getGroupSize()-1;
		MyHashMap hm = (MyHashMap) this.getGroupData().get(String.valueOf(g));
		MyHashMap hmUDF = (MyHashMap) hm.get("udf");
		String key = "";
		Iterator it = hmUDF.keySet().iterator();
		while (it.hasNext()) {
			key = (String) it.next();
			if (key.indexOf("sumot")>-1) {
				String value = rf.getRoundOTEasy((String) hmUDF.get(key));
				value = value.toString().replaceAll(",","");
				hmUDF.put(key, value);
			}
		}
		hm.put("udf", hmUDF);
		this.getGroupData().put(String.valueOf(g), hm);		
		super.groupChange(level);
	}
	
	private String countLate(Object oldValue) {
		int result = 0;
		if (oldValue==null) {	
			result=1;			
		} else {
			result = Integer.parseInt(oldValue.toString());
			result++;			
		}
		return String.valueOf(result);
	}
	
	private float chkHour(float time) {
		float result=time;
		if (time<=0) {
			result=0;
		} else if (time>0&&time<=2) {
			result=2;
		} else if (time>2&&time<=4) {
			result=4;
		} else if (time>4&&time<=6) {
			result=6;
		} if (time>6) {
			result=8;
		}
		return result;
	}
	
	private String sumLeave(Object oldValue) {
		float result = 0;
		if (oldValue==null) {				
			result = this.chkHour(this.getFloat("m_lv"));
		} else {
			CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
			ct.add(this.chkHour(this.getFloat("m_lv")));
			result = ct.getFloat();
		}
		return String.valueOf(result);
	}
	
	/*
	 * Ѻӡúǡ . ÷ͷ
	 *  ӹǹ. ЪͿŴ纪. ÷ͷ 
	 *  sumOT(2.5, "OT1") 
	 */
	private String sumOT(Object oldValue, String field) {
		float result = 0;
		if (oldValue==null) {				
			result=this.getFloat(field);
		} else {
			CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
			ct.add(this.getFloat(field));
			result = ct.getFloat();
		}
		return String.valueOf(result);
	}
	
	private String sumOT(Object oldValue, String field, boolean round) {
		float result = 0;
		if (oldValue==null) {			
			String value = rf.getRoundOTEasy(this.getString(field));
			value = value.toString().replaceAll(",","");
			result=Float.parseFloat(value);
		} else {
			CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
			String value = rf.getRoundOTEasy(this.getString(field));
			value = value.toString().replaceAll(",","");
			ct.add(Float.parseFloat(value));
			result = ct.getFloat();
		}
		return String.valueOf(result);
	}
	
	/*
	 * ӡúǡ . ÷ӧҹ ´٨ҡѹ
	 * 觻ѹʴǧѹӧҹԤͻ T
	 *  . ÷ӧҹ еͧź (LT) Ъ.÷ͷ(AC_OT)
	 *  .÷ӧҹ зӡûѴɡ͹
	 */
	private String sumWork(Object oldValue) {
		float result = 0;
		CscTime ctWork = new CscTime(this.getFloat("hour_d"));
		ctWork.add(this.getFloat("lt"));
		//ctWork.sub(this.getFloat("ac_ot"));
		if (oldValue==null) {				
			if (this.getString("eventgrp").toLowerCase().equals("t")) {
				result = this.chkHour(ctWork.getFloat());
			} 
		} else {
			if (this.getString("eventgrp").toLowerCase().equals("t")) {
				CscTime ct = new CscTime(Float.parseFloat(oldValue.toString()));
				ct.add(this.chkHour(ctWork.getFloat()));
				result = ct.getFloat();
			} else result = Float.parseFloat(oldValue.toString());
		}
		//MyLog.debug(this, this.getString("dateid")+" : "+this.getString("hour_d")+" : "+
		//		this.getString("lt")+" : "+this.getString("ac_ot")+" result===="+result);
		return String.valueOf(result);
	}
	
	public String getString(String fieldName) {
		String result="";		
		if (fieldName.indexOf(":")>-1) {
			result = super.getSimString(fieldName);
			if (result==null || result.equals("")) {
				result = "0";
			}
			//MyLog.debug(this, "SimString fieldName ------ "+fieldName+ ": "+super.getSimString(fieldName));
			return result;
		} else {
			return super.getString(fieldName);
		}
	}
	
	/*
	 * Overide Method  Group ش
	 *  employee  ͧ͡Ҩҡ˹Ҩ
	 */
	public void setGroupBy(String o) throws RemoteException {
		super.setGroupBy(o+",employeeid");		
	}
	
}
