package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.UProfile;

/*
 * ѺӹǳԷҾѡ͹ͧѡҹ 
 * Ңѹӡ觻ż ѡҹԷҾѡ͹ѹ
 * Ѻ EasyBuy
 */
public class CalulateVacation extends ProcessTimeBase {
	
	FormulaString util = new FormulaString();
	CscCalendar cscDate = null;
	double hour_d = 8.0;
	MyHashMap hmStandardTemp = null;
	MyHashMap hmStandardPer = null;
	DecimalFormat df = new DecimalFormat("0.0");
	DbInquiry inqEmp = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");			
			inq.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level," +
				"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid," + 
				"status, startdate, resigndate, workarea, emp_type");	
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void process() throws Exception {
		long start=System.currentTimeMillis();		
		this.setParamData();
		this.cscDate = new CscCalendar(this.getParamValue("startDate")); //ѹӡûż
		Vector vt = this.processList;
		for (int i=0;i<vt.size();i++) {
			try {
				if (this.inqEmp == null) {
					this.inqEmp = new InitialInquiry(this.upf).getDbInquiry();
					this.inqEmp.setParam(this.data);
					this.inqEmp.setSchemaName(this.upf.getSchemaName());
					this.inqEmp.initMyTable("MEMPLOYEE","","");
					this.inqEmp.setColumn("employeeid, companyid, status, emp_type, startdate, status, vacation0, vacation1");					
				}
				this.inqEmp.setFilter("employeeid='"+(String) vt.elementAt(i)+"'");
				this.inqEmp.refresh();
				if (this.inqEmp.next()) {
	        		MyLog.debug(this, "-----------> employeeid=" + inqEmp.getString("employeeid"));
	        		DbRecord empRec = this.inqEmp.getCurrentDbRecord().cloneRecord(true);
	        		CscCalendar cscStartDate = new CscCalendar(inqEmp.getString("startdate")); //ѹҹ
	        		CscCalendar cscFirstDate = new CscCalendar(inqEmp.getString("firsthiredate")); //ѹѭ
	        		if (empRec.getString("emp_type").equals("2")) { //١ҧ
	        			empRec.set("vacation0","00:00:00"); //ӹǹѹҾѡ͹¡
	        			empRec.set("vacation1", this.getVacationFormat(this.getVacationTemp(cscStartDate), 8.0)); //Էѡ͹չ 
	        		} else if (empRec.getString("emp_type").equals("1")) { //աҹШ
	        			HashMap hm = this.getVacationPermanent(cscStartDate, cscFirstDate, empRec.getString("employeeid"), 
	        					empRec.getString("vacation0"), empRec.getString("vacation1"));
	        			empRec.set("vacation0", (String) hm.get("vacation0")); //ӹǹѹҾѡ͹¡
	        			empRec.set("vacation1", (String) hm.get("vacation1")); //Էѡ͹չ
	        		}
	        		MyLog.debug(this, "-----------> employeeid=" + empRec.getString("employeeid"));
	        		MyLog.debug(this, "-----------> vacation0=" + empRec.getString("vacation0"));
	        		MyLog.debug(this, "-----------> vacation1=" + empRec.getString("vacation1"));
	        		empRec.save();
				}
        	} catch (Exception e) {
		MyLog.error(this, e);

        		
        	}
		}
		long end=System.currentTimeMillis();
		MyLog.debug(this, "Process >>> End Process :>>> time  : "+(end-start)/10000 + "Total Process="+vt.size());
	}
	
	private String getVacationFormat(String vacation, double hour_d) {
		String data = "00:00:00";
		try {
			int day = Integer.parseInt(vacation.substring(0, vacation.indexOf(".")));
			int hour = Integer.parseInt(vacation.substring(vacation.indexOf(".")+1, vacation.length()));
			if (hour==25) {
				hour = 2;
			} else if (hour==50) {
				hour = 4;
			} else if (hour==75) {
				hour = 6;
			}
			int minute = ((day*8)+hour)*60;
			data = this.util.MTODhm(minute, hour_d);
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return data;
	}
	
	/*
	 * ӹǳԷԡҾѡ͹㹻ջѨغѹͧѡҹǤ
	 */
	private String getVacationTemp(CscCalendar startDate) {
		String value = "0";		
		
		int[] dates = startDate.getCountDMY(this.cscDate);
		
		MyLog.debug(this, "START DATE : " + startDate+" >>>>> <<<<< DATE PROCESS : "+this.cscDate);
		MyLog.debug(this, "EMP WORK AGE [Y:M:D] : "+dates[0]+":"+dates[1]+":"+dates[2]);
		
		if (dates[0] >= 1) { //اҹҡ 1 
			value = "6.0";
		} else { //اҹ֧ 1 	
			value = df.format(this.getVacation(startDate, "2"));
		}
		return value;
	}	
	
	private MyHashMap setVacationTemp() {
		if (this.hmStandardTemp == null) {
			this.hmStandardTemp = new MyHashMap();
			this.hmStandardTemp.put("01_1", "6.0");
			this.hmStandardTemp.put("01_16", "5.5");
			this.hmStandardTemp.put("02_1", "5.5");
			this.hmStandardTemp.put("02_16", "5.0");
			this.hmStandardTemp.put("03_1", "5.0");
			this.hmStandardTemp.put("03_16", "4.5");
			this.hmStandardTemp.put("04_1", "4.5");
			this.hmStandardTemp.put("04_16", "4.0");
			this.hmStandardTemp.put("05_1", "4.0");
			this.hmStandardTemp.put("05_16", "3.5");
			this.hmStandardTemp.put("06_1", "3.5");
			this.hmStandardTemp.put("06_16", "3.0");
			this.hmStandardTemp.put("07_1", "3.0");
			this.hmStandardTemp.put("07_16", "2.5");
			this.hmStandardTemp.put("08_1", "2.5");
			this.hmStandardTemp.put("08_16", "2.0");
			this.hmStandardTemp.put("09_1", "2.0");
			this.hmStandardTemp.put("09_16", "1.5");
			this.hmStandardTemp.put("10_1", "1.5");
			this.hmStandardTemp.put("10_16", "1.0");
			this.hmStandardTemp.put("11_1", "1.0");
			this.hmStandardTemp.put("11_16", "0.5");
			this.hmStandardTemp.put("12_1", "0.5");
			this.hmStandardTemp.put("12_16", "0.0");
		}
		return this.hmStandardTemp;
	}
	
	private MyHashMap setVacationPermanent() {
		if (this.hmStandardPer == null) {
			this.hmStandardPer = new MyHashMap();
			this.hmStandardPer.put("01_1", "8.0");
			this.hmStandardPer.put("01_16", "7.5");
			this.hmStandardPer.put("02_1", "7.5");
			this.hmStandardPer.put("02_16", "6.75");
			this.hmStandardPer.put("03_1", "6.75");
			this.hmStandardPer.put("03_16", "6.0");
			this.hmStandardPer.put("04_1", "6.0");
			this.hmStandardPer.put("04_16", "5.5");
			this.hmStandardPer.put("05_1", "5.5");
			this.hmStandardPer.put("05_16", "4.75");
			this.hmStandardPer.put("06_1", "4.75");
			this.hmStandardPer.put("06_16", "4.0");
			this.hmStandardPer.put("07_1", "4.0");
			this.hmStandardPer.put("07_16", "3.5");
			this.hmStandardPer.put("08_1", "3.5");
			this.hmStandardPer.put("08_16", "2.75");
			this.hmStandardPer.put("09_1", "2.75");
			this.hmStandardPer.put("09_16", "2.0");
			this.hmStandardPer.put("10_1", "2.0");
			this.hmStandardPer.put("10_16", "1.5");
			this.hmStandardPer.put("11_1", "1.5");
			this.hmStandardPer.put("11_16", "0.75");
			this.hmStandardPer.put("12_1", "0.75");
			this.hmStandardPer.put("12_16", "0.0");
		}
		return this.hmStandardPer;
	}
	
	private double getVacation(CscCalendar cs, String type) {
		//type 1=per, 2=temp
		double result = 0;
		String mm = cs.getMM();
		int dd = 0;
		
		if (cs.getDate()<=15) {
			dd = 1;
		} else dd = 16;
		
		if (type.equalsIgnoreCase("1")) {
			result = Double.parseDouble(this.hmStandardPer.getString(mm+"_"+dd));
		} else if (type.equalsIgnoreCase("2")) {
			result = Double.parseDouble(this.hmStandardTemp.getString(mm+"_"+dd));
		}
		return result;
	}
	
	private double getVacation(CscCalendar cs, CscCalendar cs2, String type) {
		//type 1=per, 2=temp
		double result = 0;
		String mm = cs.getMM();
		if (cs.getMonth()>cs2.getMonth()) {
			int m = cs.getMonth()+cs2.getMonth();
			if (m<=9) {
				mm = "0"+m;
			} else mm = String.valueOf(m);
		}
		int dd = 0;
		
		if (cs.getDate()<=15) {
			dd = 1;
		} else dd = 16;
		
		if (type.equalsIgnoreCase("1")) {
			result = Double.parseDouble(this.hmStandardPer.getString(mm+"_"+dd));
		} else if (type.equalsIgnoreCase("2")) {
			result = Double.parseDouble(this.hmStandardTemp.getString(mm+"_"+dd));
		}
		return result;
	}
	
	/*
	 * ӹǳԷԡҾѡ͹㹻ջѨغѹͧѡҹШ
	 * ӹǳԷԡҾѡ͹¡㹻ջѨغѹͧѡҹШ
	 */
	private HashMap getVacationPermanent(CscCalendar startDate, CscCalendar firstDate, String employeeid, 
			String vacation0, String vacation1) {
		HashMap  hm = new HashMap();
		String value = "0";
		int[] dates = startDate.getCountDMY(this.cscDate);
		
		MyLog.debug(this, "START DATE : " + startDate+" >>>>> <<<<< DATE PROCESS : "+this.cscDate);
		MyLog.debug(this, "EMP WORK AGE [Y:M:D] : "+dates[0]+":"+dates[1]+":"+dates[2]);
						
		if (dates[0] >= 5) { //اҹҡ 5 
			value = "13.0";
		} else if (dates[0] >= 3) { //اҹҡ 3 
			value = "12.0";
		} else if (dates[0] >= 2) { //اҹҡ 2 
			value = "10.0";
		} else if (dates[0] >= 1) { //اҹҡ 1 
			value = "8.0";
		} else { //اҹ֧ 1 			
			if (!startDate.equalsDate(firstDate)) {
				//¨ҡ Temp --> Per 
				int[] dates0 = firstDate.getCountDMY(this.cscDate);
				int[] dates1 = startDate.getCountDMY(this.cscDate);
				
				//if (dates1[1] <= 1) {
					CscCalendar lastDate = new CscCalendar(startDate.getYYYYMMDD());
					lastDate.decDate();
					
					// Prolate ͧǧ temp
					double tempWork = this.getVacation(firstDate, "2");
					double tempMove = this.getVacation(firstDate, lastDate, "2");
					double tempResult = (tempWork*tempMove)/12;
					
					// Prolate ͧǧ permanent
					double perResult = this.getVacation(startDate, "1");
					MyLog.debug(this, firstDate.getYYYYMMDD()+" tempWork="+tempWork + " : "+lastDate.getYYYYMMDD()+" tempMove="+tempMove);
					MyLog.debug(this, "tempResult="+tempResult + " : perResult="+perResult);
					value = df.format(tempResult+perResult);
				//}
			} else {
				value = df.format(this.getVacation(startDate, "1"));
			} 		
		}
		
		/*
		 * ͹ 1 ͧʹҾա͹㹻շǡ͹
		 * ͨӹǳʹ 㹪ͧԷ¡ҢͧջѨغѹ
		 */
		if (this.cscDate.getMM().equals("01")) {
			int m0 =this.util.DhmToM(vacation0, 8.0);
			int m1 =this.util.DhmToM(vacation1, 8.0);
			int m_total = m0+m1;
			int use = 0;
			try {
				CscTime ct = new CscTime(0);
				String vCode = this.getVacationCode();
				String filter = "employeeid='"+employeeid+"' and lv_type='"+vCode+"' and " +
						"(dateid between '"+(this.cscDate.getYear()-1)+"-01-01' " +
						"and '"+(this.cscDate.getYear()-1) +"-12-31')";
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Tleave_summary", filter, "");			
				inq.setColumn("*");	
				inq.refresh();
				if (inq.next()) {
					ct.add(inq.getCurrentDbRecord().getFloat("m_lv"));
				}
				use = (ct.getHour()*60)+ct.getMinute();
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
			
			String vacation_remain = "00:00:00";
			if (use<m0) {
				vacation_remain = this.util.MTODhm(m1);
			} else {
				vacation_remain = this.util.MTODhm(m_total-use);
			}				
			hm.put("vacation0", vacation_remain);
		} else {
			hm.put("vacation0", vacation0);	
		}
		hm.put("vacation1", this.getVacationFormat(value, 8.0));
		
		return hm;
	}
	
	
	private String getVacationCode() {
		String code="";
		try {
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Meventgrp", "daytype='7'", "");			
			inq.setColumn("eventgrpid, companyid");	
			inq.refresh();
			if (inq.next()) {
				code = inq.getString("eventgrpid");
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return code;
	}
}
