package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Memployee;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Ttime_current;
import com.csc.library.databean.Ttime_current1;
import com.csc.library.service.ServiceTimeWorking;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
import com.csc.library.utility.DiffTime;

public class DocRetroactive extends MyProcess{
/**
 * Author : Nuiss
 * Date : 05/02/2551
 * Logic : ͡͹ѧ ӡûż
 * Example : ҧ͡ ŧٴѵ͹ѧ 
 * 				ѹ 05/02/2551 ŧٴѵ͹ѧ
 * 				ѹ 01/02/2552 觵ͧӡûż͹ѧ
 * 				ҧ Data  Table Ttime_current1 
 */
	private CscConnection conn = null;
	private Statement stmt =null;
	private TransferTimeProcess transTimeCls  = new TransferTimeProcess();
	DbRecord empRec = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.add("processDocRetroactive");
		return v;
	 }//end method getProcessList
	 
	public void process() throws Exception {
		this.retrieveData(this.upf);
	}//end method process

	public void retrieveData(UProfile upf){ 		
 		if(upf==null){
			upf = this.getUProfile();
		}//end if 
		ResultSet resultSet = null;

	 	try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(this.getSQLQuery());

			while (resultSet.next()){
				String employeeId =resultSet.getString("empid");
				//ż Time  employee  retroDate

				 if (this.empRec == null) {
		        	this.empRec = new InitialRecord(this.upf).getDbRecord("MEMPLOYEE");
		        	this.empRec.setColumn("*");
			    }//end if 
				 
				this.empRec.clearField();
	        	this.empRec.set("employeeid", employeeId);
	        	this.empRec.set("companyid", (String) upf.get("comcode"));
	        	this.empRec.search();
	        	transTimeCls.setUProfile(upf);
	        	
            	CscCalendar retroDate = new CscCalendar(resultSet.getString("retroDate"));        
 	        	//-------------------------------- Start FlexTime NSTDA --------------------------//
    			String isCalFlexTime = "";
    			try {
    				isCalFlexTime = (String) StaticConfig.getConfigCompany(this.upf, "ta1012");
    			} catch (Exception e) {
    				MyLog.error("ERROR !!! Find Config TA1012 not found : is use for calculate flex time NSTDA");
    			}
    			
    			MyTreeMap tr = new MyTreeMap();
    			if (isCalFlexTime.equals("1")) {
	                ServiceTimeWorking st = new ServiceTimeWorking(this.upf);
					tr = st.getSwipeData(this.empRec.getString("employeeid"), retroDate, retroDate, "");
					this.alive("Process TransferTimeProvess Load Swipecard.... ");
    			}    			
    			//-------------------------------- End FlexTime NSTDA --------------------------//

    			CscCalendar stDate = new CscCalendar(retroDate.getDDMMYYYY());
    			CscCalendar enDate = new CscCalendar(retroDate.getDDMMYYYY());
    			
    			CscCalendar stDate1 = new CscCalendar(retroDate.getDDMMYYYY());
    			CscCalendar enDate1 = new CscCalendar(retroDate.getDDMMYYYY());

    			stDate.decDate(1);
    			enDate.incDate(1);

    			stDate1.decDate(1);
    			enDate1.incDate(1);

    			Mtime0 timeRec = transTimeCls.getTimeRecord(this.empRec.getString("time0"));
	            if (timeRec != null) {
	                timeRec.setEmpRec(this.empRec);
	                timeRec.setEmpSwipeTime(tr);
	                	            						
	                WorkingShift wstmp = timeRec.genWorkingShift(stDate, enDate, "true");	//ѹش
	                this.alive("Process TransferTimeProvess Load WorkimgShift Temp.... ");
	                WorkingShift ws = timeRec.genWorkingShift(stDate1, enDate1); //ѹش
	                this.alive("Process TransferTimeProvess Load WorkingShift.... ");
	                this.upf.set("empRecord", employeeId);
	                
                	transTimeCls.calOT = new CalOT(this.upf);
                	Ttime_current t = new Ttime_current();
                	Ttime_current1 t1 = new Ttime_current1();
                	transTimeCls.calOT.initValue((Memployee_ta) this.empRec, (Ttime_current1) t1, (Mtime0) timeRec, new HashMap(), new HashMap(), (Ttime_current) t, new DiffTime(), StaticProperties.messagePools);
                	if (timeRec.getString("STICKTM").equals("D")) {
                		transTimeCls.hmSwipeCard = transTimeCls.getTimetemp(employeeId, retroDate.getYYYYMMDD(),  retroDate.getYYYYMMDD());
                	}//end if 
                	
                	transTimeCls.hmParam.put("startDate",retroDate.getYYYYMMDD());
                	transTimeCls.hmParam.put("endDate",retroDate.getYYYYMMDD());
                	transTimeCls.cs1 = retroDate;
                	transTimeCls.cs2 = retroDate;
                	transTimeCls.tempCs1 = retroDate;
                	transTimeCls.tempCs2 = retroDate;
                	
    	        	// ----- Load data for process in MCONFIG ----- //
                	transTimeCls.flag_ot = "0"; //ͷẺͧ͡
            		try {			
            			transTimeCls.flag_ot = (String) StaticConfig.getConfigCompany(this.upf, "ta1008");
            		} catch (Exception e) {	
            			MyLog.debug("Can't get ConfigCompany TA1008");
            		}
            		
            		transTimeCls.flag_cost = "0"; //ѡҹ ¹ costcenter 
            		try {			
            			transTimeCls.flag_cost = (String) StaticConfig.getConfigCompany(this.upf, "ta1009");
            		} catch (Exception e) {		
            			MyLog.debug("Can't get ConfigCompany TA1009");
            		}
            		
            		transTimeCls.flag_buslate = "0"; //Ǩͺ¢ͧ  㹡óöѺ
            		try {			
            			transTimeCls.flag_buslate = (String) StaticConfig.getConfigCompany(this.upf, "ta1010");
            		} catch (Exception e) {
            			MyLog.debug("Can't get ConfigCompany TA1010");
            		}
            		
            		transTimeCls.flag_unused = "0"; //Ǩͺ UNUSED
            		try {			
            			transTimeCls.flag_unused = (String) StaticConfig.getConfigCompany(this.upf, "ta1011");
            		} catch (Exception e) {
            			MyLog.debug("Can't get ConfigCompany TA1011");
            		}
               		
        			transTimeCls.hmCostcenter = new MyHashMap();//transTimeCls.loadDayChangeCostcenter(employeeId);                
 	        		transTimeCls.hmOTAdjust = transTimeCls.loadOTAdjust(employeeId); 	
  	        		transTimeCls.hmBusLate = new MyHashMap();//transTimeCls.loadBusLate(employeeId);
 	        		transTimeCls.hmUnused = new MyHashMap();//transTimeCls.loadUnused(employeeId);
 	           		transTimeCls.hashOT = transTimeCls.loadOTFormula();
 	           	 
    	        	
                	transTimeCls.transferTimeProcess(ws, wstmp, this.empRec, timeRec);
                	
                	System.out.print("DocRetroactive Process Completed..."
                			+"\nretroDate is "+retroDate.getYYYYMMDD()
                			+"\nemployeeId is :"+employeeId);
	            }//end if
			}//end while
			
		}catch(Exception ex){
			MyLog.error(">>>>> Error on DocRetroactive.retrieveData()",ex)	;
		}finally{
			try {
				resultSet.close();
				if(stmt!=null){
					stmt.close();
				}		
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}//end try
	}//end method retrieveData
	
	private String getSQLQuery(){
		/** 
		 * Ңŷ١Ѿഷѹ 觻ż 礨ҡ 
		 * šٴѵ÷١Ѿഷ (0 HR update,2 HR ŧ½ºؤ,3 HR ŧ繡½ºؤ,
		 * 						4 ͡ ˹ (WF),5 ͡ (WF),6 ٴѵ (HR),7 ٴѵ˹ (HR) 
		 * ͡÷١͹ѵѹ (A S ,OM O B 㺢ͷ,C D ¹,CH ¹ѹش,E š,F ѹ֡ٴѵ ) 
		 * ͹͡÷ Tadjtime0 ͧ T (ҷӧҹ)  D (ж١ź)
		 */
		StringBuffer SQLQuery = new StringBuffer();
		String whereClause = new CscCalendar().getYYYYMMDD(); 
		SQLQuery.append("SELECT tadjtime0.edit_date,tadjtime0.employeeid as empid,tadjtime0.dt_bg as retroDate ");
		SQLQuery.append(" FROM tadjtime0  ");
		SQLQuery.append(" WHERE tadjtime0.edit_date ='").append(whereClause).append("' "); 
		SQLQuery.append(" and to_date(tadjtime0.dt_bg,'YYYY-MM-DD') <= to_date(tadjtime0.edit_date,'YYYY-MM-DD') ");
		SQLQuery.append(" and tadjtime0.doctype in ('A','OM','CH','F','E','D','C','O','B','S') ");
		SQLQuery.append(" and tadjtime0.updtype not in ('T','D') ");
		SQLQuery.append(" UNION ALL   ");
		SQLQuery.append(" SELECT ttimetemp.edit_date,ttimetemp.employeeid as empid,ttimetemp.swipedate as retroDate ");
		SQLQuery.append(" FROM ttimetemp  ");
		SQLQuery.append(" WHERE ttimetemp.edit_date ='").append(whereClause).append("' ");
		SQLQuery.append(" and ttimetemp.source in ('0','2','3','5','4','6','7') ");
		SQLQuery.append(" GROUP BY ttimetemp.edit_date,ttimetemp.employeeid,ttimetemp.swipedate ");
		SQLQuery.append(" ORDER BY edit_date,empid,retroDate");
		return SQLQuery.toString();
	}//end method getSQLQuery
	
}//end class DocRetroactive
