package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.MyLog;

public class ForceFinishWorkflow extends MyProcess {
	
	private CscConnection conn = null;
	private Statement stmt = null;
	private Statement stmt1 = null;
	private ResultSet rs = null;
	private String WF_ID = "8002";
	private boolean isToSave = true;
	
	Vector success = new Vector();
	Vector fail = new Vector();
	
	@Override
	public Vector getProcessList() {
		Vector temp = new Vector();
		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery("select doc_no,runno from workflow_data where wf_status = '1' and wf_id = '"+WF_ID+"'");

			while (rs.next()){
				temp.add(rs.getString("runno"));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				rs.close();
				if(stmt!=null){
					stmt.close();
				}		
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
		return temp;
	}
	
	@Override
	public void process() throws Exception {
		if(upf==null){
			upf = this.getUProfile();
		}//end if 
		
		Vector item = this.getProcessList();
		
		for(int i=0; i < item.size(); i++ ){
			String runno = (String)item.get(i);
			updateActor(runno);
			if(isToSave){
				updateStep(runno);
				updateWFIncident(runno);
				updateWF(runno);
				
				success.add(runno);
			}else{
				fail.add(runno);
			}
			System.out.println("Process progress [" + i + "/" +item.size()+ "]");
		}
		System.out.println("!! success !!");
		for(int j=0; j < success.size(); j++){
			System.out.print((String)item.get(j)+":");
		}
		System.out.println("!! fail !!");
		for(int j=0; j < fail.size(); j++){
			System.out.print((String)item.get(j)+":");
		}
		
	}
	
	private void updateActor(String runno){
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			stmt1 = conn.createStatement();
			rs = stmt.executeQuery("select top 1 * from ACTOR_INCIDENT where WF_ID = '"+WF_ID+"' and WF_SEQ_NO = '" +runno+ "' order by STEP_ID desc;");

			while (rs.next()){
				if(rs.getString("status").equals("3")){
					isToSave = false;
					System.out.println("!!!!This workflow status is not in approve state!!!!!" + rs.getString("runno"));					
				}else{
					isToSave = true;
					stmt1.executeUpdate("update actor_incident set step_id = '6',completion_time = start_time,status = '2' where step_id = '"+rs.getString("step_id")+"' and step_seq_no = '"+rs.getString("step_seq_no")+"' and wf_id = '"+WF_ID+"' and wf_seq_no = '"+runno+"'");
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				rs.close();
				if(stmt!=null){
					stmt.close();
				}	
				if(stmt1!=null){
					stmt1.close();
				}
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
	}
	
	private void updateWFIncident(String runno){
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			stmt1 = conn.createStatement();
			rs = stmt.executeQuery("select top 1 * from WORKFLOW_INCIDENT where WF_ID = '"+WF_ID+"' and WF_SEQ_NO = '" +runno+ "'");

			while (rs.next()){
				stmt1.executeUpdate("update workflow_incident set completion_time = start_time,status = '1' where wf_id = '"+WF_ID+"' and wf_seq_no = '"+runno+"'");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				rs.close();
				if(stmt!=null){
					stmt.close();
				}	
				if(stmt1!=null){
					stmt1.close();
				}
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
	}
	
	private void updateStep(String runno){
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			stmt1 = conn.createStatement();
			rs = stmt.executeQuery("select top 1 * from STEP_INCIDENT where WF_ID = '"+WF_ID+"' and WF_SEQ_NO = '" +runno+ "' order by STEP_ID desc;");

			while (rs.next()){
				stmt1.executeUpdate("update step_incident set step_id = '6',completion_time = start_time,status = '1' where step_id = '"+rs.getString("step_id")+"' and step_seq_no = '"+rs.getString("step_seq_no")+"' and wf_id = '"+WF_ID+"' and wf_seq_no = '"+runno+"'");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				rs.close();
				if(stmt!=null){
					stmt.close();
				}	
				if(stmt1!=null){
					stmt1.close();
				}
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
	}
	
	private void updateWF(String runno){
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt1 = conn.createStatement();
			stmt1.executeUpdate("update workflow_data set completion_time = start_time,wf_status = '4',TRANSFER='0' where wf_id = '"+WF_ID+"' and runno = '"+runno+"'");
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				rs.close();
				if(stmt!=null){
					stmt.close();
				}	
				if(stmt1!=null){
					stmt1.close();
				}
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
	}
	
}
