package com.csc.library.process;

import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class MoveTleave_SummaryToHistory extends ProcessTimeBase{
	private DbInquiry inq = null;
	private String startMethodTime =""; 
	private String endSaveTime ="";
	
  public Vector getProcessList() {
		Vector v = new Vector();
		v.add("move2hisList1");
		return v;
  }//end getProcessList
  
  public void process() throws Exception {	
	//start method
	CscCalendar performanceTime1=new CscCalendar(); 
	this.startMethodTime ="start method at: "+ performanceTime1.getDDMMYYHHMMSS();
	String strWhereClause =" 1=1 ";
	
	Vector move2hisList1= this.processList;
	  
	  for (int i=0;i<move2hisList1.size() && !this.isCancle();i++) {
		
			this.setParamData();
			CscCalendar stDate = new CscCalendar(this.getParamValue("startDate"));
			CscCalendar endDate = new CscCalendar(this.getParamValue("endDate"));
		   	
			
			strWhereClause += " and dateid >='" + stDate.getYYYYMMDD() +"'" ;
			strWhereClause += " and dateid <='" + endDate.getYYYYMMDD() +"'" ;
	
			if(!this.getParamData("employeeBetween").equals("")&&this.getParamData("employeeBetween")!=null){
				strWhereClause += " and (" + this.getParamData("employeeBetween");	
			}//end if 
			
			if(!this.getParamData("employeeSelect").equals("")&&this.getParamData("employeeSelect")!=null){
				if(!this.getParamData("employeeBetween").equals("")&&this.getParamData("employeeBetween")!=null){
					strWhereClause += " OR employeeid in(" + this.getWhereClause(this.getParamData("employeeSelect")) +"))" ;
				}else{
					strWhereClause += " and employeeid in(" + this.getWhereClause(this.getParamData("employeeSelect")) +")" ;
				}//end if 
			}else{
				strWhereClause += ")";
			}//end if 
			
			if(!this.getParamData("positionSelect").equals("")&&this.getParamData("positionSelect")!=null){
				strWhereClause += " and emp_position in(" + this.getWhereClause(this.getParamData("positionSelect")) +")" ;
			}//end if 
			
			if(!this.getParamData("bu1Select").equals("")&&this.getParamData("bu1Select")!=null){
				strWhereClause += " and bu1 in(" + this.getWhereClause(this.getParamData("bu1Select")) +")" ;
			}//end if 
			
			if(!this.getParamData("bu2Select").equals("")&&this.getParamData("bu2Select")!=null){
				strWhereClause += " and bu2 in(" + this.getWhereClause(this.getParamData("bu2Select")) +")" ;
			}//end if 
			
			if(!this.getParamData("bu3Select").equals("")&&this.getParamData("bu3Select")!=null){
				strWhereClause += " and bu3 in(" + this.getWhereClause(this.getParamData("bu3Select")) +")" ;
			}//end if 
			
			if(!this.getParamData("bu4Select").equals("")&&this.getParamData("bu4Select")!=null){
				strWhereClause += " and bu4 in(" + this.getWhereClause(this.getParamData("bu4Select")) +")" ;
			}//end if 
			
			if(!this.getParamData("salatypeSelect").equals("")&&this.getParamData("salatypeSelect")!=null){
				strWhereClause += " and salatype in(" + this.getWhereClause(this.getParamData("salatypeSelect")) +")" ;
			}//end if 
		 	
	  }//end for
	  
	  	this.move2History(strWhereClause);
		CscCalendar performanceTime4=new CscCalendar(); 
	 	this.endSaveTime ="end save to DB at: "+ performanceTime4.getDDMMYYHHMMSS();
	
	 	System.out.print("MoveTleave_SummaryToHistory Time List:"+"\n"+
	 			 startMethodTime +"\n"+
	 			 endSaveTime + "\n");
		//=========== debug =========
	 	
		this.setFullMessage("Successful of MoveTleave_SummaryToHistory : "+move2hisList1.size());
	}//end process
	
	private String getWhereClause(String strValue){
		String[] valueList = strValue.split(",");
		String whereclauseRtn ="";
		for (int i1 =0;i1<valueList.length;i1++){
			if(whereclauseRtn.equals("")){
				whereclauseRtn = "\'"+valueList[i1]+"\'";
			}else{
				whereclauseRtn +=   ","+"\'"+valueList[i1]+ "\'";
			}//end if 
		}//end for 
		return whereclauseRtn;
	}//end getWhereClause
	
	private void move2History(String strWhereClause) {
		String sourceTable = "tleave_summary";
		String backupTable = "tleave_summary_history";
		try {
			if (this.inq == null){
				this.inq = new InitialInquiry(this.upf).getDbInquiry();
				this.inq.setParam(this.data);
				this.inq.setSchemaName(this.upf.getSchemaName());
				this.inq.initMyTable(sourceTable, strWhereClause , "");
				this.inq.setColumn("*");
			}
			
			DbRecord recHis = new InitialRecord(this.upf).getDbRecord(backupTable);
			recHis.setColumn("*");
			
			this.inq.refresh();
			while (this.inq.next()) {
				DbRecord rec =  this.inq.getCurrentDbRecord().cloneRecord(true);
				recHis.setData(rec);
				recHis.save();
				
			 	rec.delete(); 	 
			}//end while
		} catch (Exception e) {
			MyLog.error(this, e);			
		}//end try
	}//end moveHistory
	
}//end class
