package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;

public class ProcessOTAfterTransfer extends ProcessTimeBase {
	
	DecimalFormat df = new DecimalFormat("00.00");
	DbTable dbOT = null;
	CscCalendar cs_in = null;
	CscCalendar cs_out = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.getParamValue("filterProcess").equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
				inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, companyid, status, startdate, resigndate");			
				inq.setFatchAll(true);
				inq.refresh();
				while (inq.next()) {
					v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
		
	public void process() throws Exception {		
		this.setParamData();
		CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
		cs1.decDate();
		CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
		cs2.incDate();
		Vector vt = this.processList;
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			String empID = (String) vt.elementAt(i);
			MyTreeMap tr= new MyTreeMap();
			this.loadTimeData(empID, tr);
			this.loadOTData(empID, tr);
			
			Iterator it = tr.keySet().iterator();
			while (it.hasNext()) {
				String key = (String) it.next();
				this.cs_in = null;
				this.cs_out = null;
				MyTreeMap trDay = (MyTreeMap) tr.get(key);
				Iterator itDay = trDay.keySet().iterator();
				while (itDay.hasNext()) {
					String key1 = (String) itDay.next();
					System.out.println(key+" : "+(String) trDay.get(key1));
				}
				float ot = this.getOT(trDay);
				System.out.println("==================================");
				System.out.println("ot approve = "+trDay.getDouble("ap_ot"));
				System.out.println("ot total = "+ot);
				System.out.println();
				this.saveOT(key, empID, trDay.getDouble("ap_ot"), ot);
			}
			this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of ProcessOTAfterTransfer : "+vt.size());
		this.setFullMessage("Successful of ProcessOTAfterTransfer : "+vt.size()+"\n");	
	}
	
	private void loadTimeData(String empID, MyTreeMap tr) {
		try {
			CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
			CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
			
			DbInquiry inqTime = new InitialInquiry(this.upf).getDbInquiry();
			inqTime.initMyTable("TTIME_CURRENT1", "employeeid='"+empID+"' " +
					"and (dateid between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')", "");
			inqTime.setColumn("*");
			inqTime.refresh();
			while (inqTime.next()) {
				DbRecord rec = inqTime.getCurrentDbRecord();
				
				MyTreeMap trDay = null;
				CscCalendar csc = new CscCalendar(rec.getString("dateid"));
				if (!tr.containsKey(csc.getYYYYMMDD())) {
					trDay = new MyTreeMap();
					trDay.put("ap_ot", "0");
				} else trDay = (MyTreeMap) tr.get(csc.getYYYYMMDD());
				
				CscCalendar csc1 = new CscCalendar(rec.getString("c_dt_bg"));
				String key1 = csc1.getYYYYMMDD()+this.df.format(rec.getDouble("c_tm_bg"))+"#";
				trDay.put(key1, key1);
				
				CscCalendar csc2 = new CscCalendar(rec.getString("c_dt_en"));
				String key2 = csc2.getYYYYMMDD()+this.df.format(rec.getDouble("c_tm_en"))+"*";
				trDay.put(key2, key2);
				
				tr.put(csc.getYYYYMMDD(), trDay);
			}
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
	}
	
	private void loadOTData(String empID, MyTreeMap tr) {
		try {
			CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
			CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
			
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();						
			inq.initMyTable("TOT_AF_PROCESS", "employeeid='"+empID+"' " +
					"and (start_date between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				
				MyTreeMap trDay = null;
				CscCalendar csc = new CscCalendar(rec.getString("start_date"));
				if (!tr.containsKey(csc.getYYYYMMDD())) {
					trDay = new MyTreeMap();
					trDay.put("ap_ot", "0");
				} else { 
					trDay = (MyTreeMap) tr.get(csc.getYYYYMMDD());
				}
				
				CscCalendar csc1 = new CscCalendar(rec.getString("start_date"));
				csc1.setCSCTime(rec.getFloat("start_time"));
				String key1 = csc1.getYYYYMMDD()+df.format(rec.getDouble("start_time"))+"+";
				trDay.put(key1, key1);
				
				CscCalendar csc2 = new CscCalendar(rec.getString("end_date"));
				csc2.setCSCTime(rec.getFloat("end_time"));
				String key2 = csc2.getYYYYMMDD()+df.format(rec.getDouble("end_time"))+"@";
				trDay.put(key2, key2);
				
				CscTime ct = new CscTime(Float.parseFloat((String) trDay.get("ap_ot")));
				ct.add(csc2.subForHour(csc1));				
				trDay.put("ap_ot", String.valueOf(ct.getFloat()));
				
				tr.put(csc.getYYYYMMDD(), trDay);
			}
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
	}

	public float getOT(MyTreeMap trDay) {
		CscTime ct = new CscTime(0f);
		String rule1= "+@";				//OT ͡ҡ÷ӧҹ
		String rule2= "+#"; 				//OT ͹ҧҹ
		String rule3= "*@"; 			//OT ѧԡҹ
		String ruleFalse = "#+@*";	//ͷ㹪ǧҧҹ
		
		String seq = "";
		Iterator itDay = trDay.keySet().iterator();
		while (itDay.hasNext()) {
			String key = (String) itDay.next();
			seq += key.substring(key.length()-1, key.length());
		}
		
		System.out.println("seq initial ====== "+seq);
		
		if (seq.indexOf(ruleFalse)==-1) {		
			while (seq.length()>0) {
				if (seq.indexOf(rule1)>-1) {
					System.out.println("rule 1 >>>> "+seq.substring(seq.indexOf(rule1), seq.indexOf(rule1)+2));				
					ct.add(this.processCase(trDay, rule1, seq));
					seq = seq.substring(0, seq.indexOf(rule1))+seq.substring(seq.indexOf(rule1)+2, seq.length());
				} else if (seq.indexOf(rule2)>-1) {
					System.out.println("rule 2 >>>> "+seq.substring(seq.indexOf(rule2), seq.indexOf(rule2)+2));
					ct.add(this.processCase(trDay, rule2, seq));
					seq = seq.substring(0, seq.indexOf(rule2))+seq.substring(seq.indexOf(rule2)+2, seq.length());
				} else if (seq.indexOf(rule3)>-1) {
					System.out.println("rule 3 >>>> "+seq.substring(seq.indexOf(rule3), seq.indexOf(rule3)+2));
					ct.add(this.processCase(trDay, rule3, seq));
					seq = seq.substring(0, seq.indexOf(rule3))+seq.substring(seq.indexOf(rule3)+2, seq.length());
				} else seq="";
			}
		}
		return ct.getFloat();
	}
	
	public float processCase(MyTreeMap trDay, String rule, String seq) {
		float ot=0;
		try {			
			String ch1 = rule.substring(0,1);
			String ch2 = rule.substring(1,2);
			String key1="";
			String key2="";
			String tmpkey="";
			CscCalendar cs1 = null;
			CscCalendar cs2 = null;
			int loop=0;
			Iterator it = trDay.keySet().iterator();
			while (it.hasNext()) {
				String key = (String) it.next();
				
				if (loop==0) {
					tmpkey = key;
				} 
				
				if (key.indexOf(ch2)>-1 && tmpkey.indexOf(ch1)>-1) {
					cs1 = new CscCalendar(tmpkey.substring(0,10));
					cs1.setCSCTime(Float.parseFloat(tmpkey.substring(10,15)));		
					
					cs2 = new CscCalendar(key.substring(0,10));
					cs2.setCSCTime(Float.parseFloat(key.substring(10,15)));
					
					key1 = key;
					key2 = tmpkey;
					break;
				}					
				loop++;
				tmpkey = key;
			}
			
			trDay.remove(key1);
			trDay.remove(key2);
			ot = cs2.subForHour(cs1);
			this.cs_in = cs1;
			this.cs_out = cs2;
			System.out.println("cs1 = "+cs1);
			System.out.println("cs2 = "+cs2);
			System.out.println("ot = "+cs2.subForHour(cs1));
		} catch (Exception e) {
			MyLog.error(this, e);	
		}	
		return ot;
	}
	
	private void saveOT(String date, String empID, double ap_ot, float ac_ot) {
		try {
			if (dbOT==null) {
				dbOT = new InitialTable(this.upf).getDbTable("TTIME_CURRENT1");
			}
			dbOT.setColumn("*");
			
			this.data.put("__calulate", "");
			DbInquiry inq0 = new InitialInquiry(this.upf).getDbInquiry();
			inq0.setParam(this.data);						
			inq0.initMyTable("TTIME_CURRENT", "employeeid='"+empID+"' and dateid='"+date+"'", "");
			inq0.setColumn("*");
			inq0.putChild(dbOT);
			inq0.refresh();
			if (inq0.next()) {					
				DbRecord rec = inq0.getCurrentDbRecord().cloneRecord(true);
				DbTable child = (DbTable) rec.getChild("ttime_current1");
				child.set("ap_ot", ap_ot);
				child.set("ac_ot", ac_ot);
				rec.save();
			} else {
				DbInquiry inqEmp = new InitialInquiry(this.upf).getDbInquiry();
				inqEmp.initMyTable("MEMPLOYEE", "employeeid='"+empID+"'", "");
				inqEmp.setColumn("employeeid,companyid,time0");
				inqEmp.refresh();
				inqEmp.next();
				
				DbInquiry inqTime = new InitialInquiry(this.upf).getDbInquiry();
				inqTime.initMyTable("MTIME0", "time0id='"+inqEmp.getString("time0")+"'", "");
				inqTime.setColumn("time0id,companyid,hour_d");
				inqTime.refresh();
				inqTime.next();
				
				DbTable db = new InitialTable(this.upf).getDbTable("TTIME_CURRENT1");
				DbRecord rec = db.getNewRecord(); 
				rec.setColumn("*");
				rec.set("employeeid", inqEmp.getString("employeeid"));
                rec.set("companyid", inqEmp.getString("companyid"));
                rec.set("dateid", this.cs_in.getDDMMYYYY());
                rec.set("doctype", "O");
                rec.set("docno", "");
                rec.set("forget_in","0");
				rec.set("forget_out","0");
				rec.set("time0id", inqEmp.getString("time0"));
	            rec.set("old_time0", "");
	            rec.set("sequence", "01");
	            
	            rec.set("c_dt_bg", this.cs_in.getDDMMYYYY());								
				rec.set("c_tm_bg", this.cs_in.getCSCTime());
				rec.set("c_dt_en", this.cs_out.getDDMMYYYY());
				rec.set("c_tm_en", this.cs_out.getCSCTime());
				
				rec.set("m_dt_bg", this.cs_in.getDDMMYYYY());		
				rec.set("m_tm_bg", this.cs_in.getCSCTime());
				rec.set("m_dt_en", this.cs_out.getDDMMYYYY());
				rec.set("m_tm_en", this.cs_out.getCSCTime());
				
				rec.set("o_dt_bg", this.cs_in.getDDMMYYYY());		
				rec.set("o_tm_bg", this.cs_in.getCSCTime());
				rec.set("o_dt_en", this.cs_out.getDDMMYYYY());
				rec.set("o_tm_en", this.cs_out.getCSCTime());
								
				rec.set("m_lv", "0");
				rec.set("c_lv", "0");
                rec.set("lv_ty", "H");
                rec.set("tr_type", "H0");
                rec.set("ap_ot", ap_ot);
                rec.set("ac_ot", ac_ot);
                rec.set("hour_d", ac_ot);
                rec.set("hour_s", inqTime.getString("hour_d"));
             
				rec.set("iswork", "0");
                rec.set("eventgrp", "H");
                rec.set("oldeventgrp", "");
                rec.set("previousshift", "");
                rec.set("nextshift", "");
                rec.set("status", "");               
                rec.set("source_in", "");
                rec.set("source_out", "");
                rec.set("ot_workarea", "");
                rec.set("ot_salatype", "");
                rec.set("ot_type", "");
				
				db.putNewRecord(rec);
				DbRecord recTime = new InitialRecord(this.upf).getDbRecord("TTIME_CURRENT");
				recTime.setParam(this.data);		
				recTime.set("employeeid", inqEmp.getString("employeeid"));
				recTime.set("companyid", inqEmp.getString("companyid"));
				recTime.set("time0id", inqEmp.getString("time0"));
				recTime.set("dateid", this.cs_in.getDDMMYYYY());
				recTime.set("hour_d", ac_ot);
				recTime.set("hour_s", inqTime.getString("hour_d"));
				recTime.putChild(db);
				recTime.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
	}
}

