package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ReportData {
	Vector vData = new Vector();
	
	UProfile upf = null;
	
	String emp = "";
	public String grade = "";
	public String tablename = "";
	
	public int work = 0;
	public int late = 0;
	public int absent = 0;

	public int[] count_col = {0,0,0,0,0,0,0,0,0};	/* count leave {col1,col2,col3,..,col8,misc */
	
	public CscTime csLate = new CscTime();
	public CscTime csAbsent = new CscTime();
	public CscTime csWork = new CscTime();
	
	public CscTime[] csCol = {new CscTime(),new CscTime(),new CscTime(),new CscTime(),new CscTime(),new CscTime()
									,new CscTime(),new CscTime(),new CscTime()};	/* leave summary col1,..,col8,misc */
	
	public CscTime csOt1 = new CscTime();
	public CscTime csOt5 = new CscTime();
	public CscTime csOt2 = new CscTime();
	public CscTime csOt3 = new CscTime();

	CscCalendar startdate = new CscCalendar();
	CscCalendar enddate = new CscCalendar();
	
	HashMap hEvent = new HashMap();
	
	/*  */
	String COLUMNS[] = {"DATEID","C_DT_BG","C_TM_BG","C_DT_EN","C_TM_EN","M_DT_BG","M_TM_BG","M_DT_EN","M_TM_EN"
			,"EVENTGRP","DOCTYPE","DOCNO","TIME0ID","M_LV","LT","AC_OT","HOUR_D","AP_OT","SEQUENCE","OT1","OT5","OT2","OT3"};
	public String REPORT_COLUMNS[] = {"","","","","","","","",""};
	
	public void setUProfile(UProfile upf){
		this.upf = upf;
	}
	
	public void setEmployeeCode(String code){
		this.emp = code;
	}
	
	public void setReportColumns(String col[]){
		this.REPORT_COLUMNS = col;
	}
	
	public void setStartDate(String st){
		this.startdate.setCalendar(st);
	}

	public void setEndDate(String en){
		this.enddate.setCalendar(en);
	}
	
	public void setTableName(String tablename){
		this.tablename = tablename;
	}
	
	public void fetchData(){
		CscConnection conn = null;
    	Statement stmt = null;
    	ResultSet rs = null;
    	int count = 0;
    	
		Vector v = new Vector();
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			rs = stmt.executeQuery("select * from " + this.tablename + " where employeeid = '" + this.emp + "'" + " and dateid between '" + this.startdate.getYYYYMMDD() 
					+ "' and '" + this.enddate.getYYYYMMDD() + "'");
			
			while (rs.next()) {
				vData.add(cloneTcurData(rs));	/* ´÷ӧҹѹ   */
			}	
		}catch(Exception e){
			MyLog.error(this,e);
		} finally {
    		try{
    			if(rs != null) rs.close();
    			if(stmt != null) stmt.close();
	    		if(conn!=null) conn.close();
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in executeQuery!!",e);
    		}
        }
	}
	
	/* copy  DbRecord ŧ HashMap ᷹ */
	private HashMap cloneTcurData(ResultSet db){
		HashMap hm = new HashMap();
		try {
			/* ˹ value ͡ҹ  */
			for(int j=0; j < COLUMNS.length; j++){
				hm.put(COLUMNS[j], db.getString(COLUMNS[j]));	
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return hm;
	}

	public void calWorkTime(){
		HashMap db = null;
		try {
			for(int i=0; i < vData.size(); i++){
				db = (HashMap) vData.get(i);
				calWork(db);
				calLate(db);
				calLeaveHour(db);
				calOT(db);
				calGrade();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}

	
	/* ֧Żҷ */
	public void setColumnDetail(){
		try {
			 DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
	         inq.initMyTable("Meventgrp", "", "eventgrpid");
	         inq.setColumn("eventgrpid,tdesc,edesc");
	         inq.refresh();
	            
	         while (inq.next()) {
	        	 String[] ename = {"",""};
	        	 ename[0] = inq.getString("tdesc");
	        	 ename[1] = inq.getString("edesc");
	        	 hEvent.put(inq.getString("eventgrpid"), ename);
	         }
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public String getColHeaderThai(String event){
		try {
			String[] header = (String[]) hEvent.get(event);
			return header[0];
		}catch(Exception e){
			return "";
		}
	}
	
	public String getColHeaderEng(String event){
		try {
			String[] header = (String[]) hEvent.get(event);
			return header[1];
		}catch(Exception e){
			return "";
		}
	}
	
	private void calOT(HashMap db){
		try {
			float ot1 = Float.parseFloat((String) db.get("OT1"));
			float ot5 = Float.parseFloat((String) db.get("OT5"));
			float ot2 = Float.parseFloat((String) db.get("OT2"));
			float ot3 = Float.parseFloat((String) db.get("OT3"));
			
			csOt1.add(ot1);
			csOt5.add(ot5);
			csOt2.add(ot2);
			csOt3.add(ot3);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void calWork(HashMap db){
		try {
			/* Ѻѹӧҹ (ءѹ hour_d > 0)  */
			float hourd = Float.parseFloat((String) db.get("HOUR_D"));
			if(hourd > 0){
				work++;
				csWork.add(hourd);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void calLate(HashMap db){
		try {
			/* Ѻ */
			float lt = Float.parseFloat((String) db.get("LT"));
			if(lt > 0){
				late++;
				csLate.add(lt);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void calLeaveHour(HashMap db){
		try {
			float mlv = Float.parseFloat((String) db.get("M_LV"));
			String event = (String) db.get("EVENTGRP");
			String dateid = (String) db.get("DATEID");
			String doctype = (String) db.get("DOCTYPE");
			String abKey = "";
			
			/* Ѻ  ӧҹ */
			if(event.equals("T")){			/* ӧҹ */
				//work++;
			}else if(event.equals("J")){ 	/* Ҵҹ */
				if(!abKey.equals(dateid)){
					absent++;
					csAbsent.add(mlv);
					abKey = dateid;
				}
			}else if(doctype.equals("A")){
				for(int i=0; i < REPORT_COLUMNS.length; i++){
					if(REPORT_COLUMNS[i].trim().indexOf(event) != -1){
						count_col[i]++;
						csCol[i].add(mlv);
						break;
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳô ѡṹҡ Ҵ  
	 * 	͹䢡äԴôûԺѵԧҹҡ,Ҵ,							
		ô A  Դҡ,Ҵ, ЧǴ㹪ǧṹ 0.00 - 5.00 ṹ							
		ô B  Դҡ,Ҵ, ЧǴ㹪ǧṹ 5.01 - 10.00 ṹ							
		ô C  Դҡ,Ҵ, ЧǴ㹪ǧṹ 10.01 - 25.00 ṹ							
		ô D  Դҡ,Ҵ, ЧǴ㹪ǧṹ 25.01 - 50.00 ṹ							
		ô F  Դҡ,Ҵ, ЧǴ㹪ǧṹ 50.01 ṹ繵	
		
								ء͹ µѴṹ
					觤ṹ						
		Ҵҹ			3 ṹ						
		ҷء	1 ṹ (¡Ҿѡ͹,ѹԴ)
	 * */
	private void calGrade(){
		try {
			float score = getLateScore() + getAbsentScore() + getLeaveScore();
			if(score >= 0 && score <= 5){
				this.grade = "A";
			}else if(score >= 5.01 && score <= 10){
				this.grade = "B";
			}else if(score >= 10.01 && score <= 25.00){
				this.grade = "C";
			}else if(score >= 25.01 && score <= 50.00){
				this.grade = "D";
			}else if(score >= 50.01){
				this.grade = "F";
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private float getLateScore(){
		try {
			return (float) (this.late * .5);
		}catch(Exception e){
			MyLog.error("!! Error calculate late score !! ",e);
			return 0;
		}
	}
	
	private float getAbsentScore(){
		try {
			return (float) (this.absent * 3);
		}catch(Exception e){
			MyLog.error("!! Error calculate absent score !! ",e);
			return 0;
		}
	}
	
	private float getLeaveScore(){
		try {
			int count = 0;
			for(int i = 0; i < count_col.length; i++){
				if(!REPORT_COLUMNS[i].equals("ANL") && !REPORT_COLUMNS[i].equals("BDL")){	/* fix code Ѻ Ҿѡ͹ ѹԴ */
					count += count_col[i];
				}
			}
			return count;
		}catch(Exception e){
			MyLog.error("!! Error calculate leave score !! ",e);
			return 0;
		}
	}
}
	