package com.csc.library.schedule;

import com.csc.library.utilities.MyLog;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Element;

import com.csc.library.cscexport.ExportTAData;
import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Memployee;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Ttime_current;
import com.csc.library.databean.Ttime_current1;
import com.csc.library.process.CalOT;
import com.csc.library.report.GenCondition;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.SwipeData;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTimerTask;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.ReadXml;
import com.csc.library.utilities.ThaiUtilities;
import com.csc.library.utilities.UProfile;

public class ControlSchedule extends MyTimerTask {
	
	String processCondition="";
	String exportCondition="";
	MyHashMap hmTime=null;
	MyHashMap hmDayTime=null;
	MyTreeMap hashOT=null;
	MyHashMap hmHoliday=null;
	CalOT calOT=null;
	
	public void process() {	
		long start=System.currentTimeMillis();	
		
		CscCalendar csc = new CscCalendar();
		csc.decDate();
		this.getCondition();
		Vector vt = this.getProcessList();
		this.hmTime = new MyHashMap();
        this.hmDayTime = new MyHashMap();
        this.hashOT = this.loadOTFormula();
        this.hmHoliday = new MyHashMap();
		for (int i=0;i<vt.size();i++) {
			try {
				DbRecord empRec = new InitialRecord(this.getUProfile()).getDbRecord("MEMPLOYEE");
				empRec.set("employeeid", (String) vt.elementAt(i));
				empRec.set("companyid", (String) this.getUProfile().get("companyid"));
				empRec.search();
				
				Mtime0 timeRec = this.getTimeRecord(empRec.getString("time0"));			
				if (timeRec != null) {
					timeRec.setEmpRec(empRec);
					WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(csc	.getTimestamp()), new CscCalendar(csc.getTimestamp()));				
					this.getUProfile().set("empRecord",empRec.getString("employeeid"));
					
					this.calOT = new CalOT();
                	Ttime_current1 t = new Ttime_current1();
                	this.calOT.initValue((Memployee_ta) empRec, (Ttime_current1) t, (Mtime0) timeRec, new HashMap());
                    this.parisTimeProcess(ws, empRec, csc.getYYYYMMDD());				
					
				}
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
		}
		
		//Export SwipeCard Data
		this.exportSwipeCardData(csc.getYYYYMMDD());
		
		long end=System.currentTimeMillis();
		MyLog.debug(this, "Process >>> time  : "+(end-start)/100);
		
	}
	
	private void exportSwipeCardData(String date) {
		try {
			ThaiUtilities th = new ThaiUtilities();
			HashMap con = new HashMap();
			con.put("CONDITIONID", date);
			con.put("CLASSNAME","ExportSwipeCard");
			con.put("EXPORT_TYPE","EXPORTFILE");
			con.put("FILE_TYPE","txt");
			con.put("REF_TYPE","EXPORT");		
			con.put("SCREEN","EXPORTSWIPECARD");
			con.put("DATEFORMAT","YYYYMMDD");
			con.put("UPROFILE", this.getUProfile());
			con.put("FIXFILTER","");
			if (this.exportCondition.equals("")) {
				con.put("FILTERCON","ttimetemp.swipedate = '"+date+"'");
			} else {
				con.put("FILTERCON",this.exportCondition+"*AND *ttimetemp.swipedate = '"+date+"'");			}
			con.put("DATA","");
			Properties p = new GenCondition(th.ASCII2Unicode((String) con.get("FILTERCON"))).getCondition();
			con.put("FILTER", p);
			
			ExportTAData ex = new ExportTAData();
			ex.setCondition(con);			
			ex.process(date);
		} catch (Exception e) {
			MyLog.error(this, e);
			
			
		}
	}
	
	private Mtime0 getTimeRecord(String id) {
		Mtime0 rec = null;
		try {
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable("Mtime0", "time0id='" + id + "'", "");
			inq.setColumn("*");
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				rec = (Mtime0) inq.getCurrentDbRecord();
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return rec;
	}
	
	private void getCondition() {
	    MyLog.debug(this, "**** LOAD XML SCHEDULE CONDITION FILE****");
	    try {
			String fileName = "SCHEDULE_CONDITION.xml";
			InitialEnvironment en = new InitialEnvironment("GLOBAL");
			String xmlPath = en.getValue("import-dir");
			ReadXml read = new ReadXml();
			read.setDataManager(xmlPath+"/XML/" + fileName);
			Element root = read.getRootElement();
			Iterator it = root.getChildren().iterator();
			
			Element obj = (Element) root.getChild("PROCESS");
			if (obj!=null)
				this.processCondition=obj.getText().trim();
			
			obj = (Element) root.getChild("EXPORT");
			if (obj!=null)
				this.exportCondition=obj.getText().trim();
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	 }
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable("Memployee", this.processCondition, "employeeid");
			inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, companyid, status, startdate, resigndate, bu0");			
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return v;
	}	
	
	private void parisTimeProcess(WorkingShift ws, DbRecord empRec, String date) {
		try {
			if (!ws.isEmpty()) {
				CscCalendar csStart = new CscCalendar(date);
				csStart.decDate();
				CscCalendar csEnd = new CscCalendar(date);
				csEnd.incDate();

				ws.setUProfile(this.getUProfile());
				ws.setEmployeeid(empRec.getString("employeeid"));
				ws.adjust();
				ws.createLink();

				SwipeData SD = new SwipeData();				
				SD.setUProfile(this.getUProfile());
				SD.loadData(empRec.getString("employeeid"), csStart, csEnd);
				ws.genTimeZone();
				ws.setSwipeTrans(SD);
				ws.findTime(new CscCalendar(date + " 00:00:00.000000000"),
						new CscCalendar(date + " 23:59:00.000000000"));			
				SD.updateData();		
				this.saveTransferTimeProcess(ws, empRec, date);
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

    // Delete Old Data Before Save Process Transfer Data To Time_Current and Time_Current1
    private void delOldData(String emp, String date) {
        try {
            CscCalendar csStart = new CscCalendar(date);
            CscCalendar csEnd = new CscCalendar(date);

            DbTable db = new InitialTable(this.getUProfile()).getDbTable("Ttime_current1");
            db.setColumn("employeeid, time0id, runno, companyid, dateid, sequence");

            DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
            inq.setSchemaName(this.getUProfile().getSchemaName());
            inq.initMyTable("Ttime_current", "", "employeeid");
            inq.setFilter("employeeid='" + emp + "' and (dateid between '" + csStart.getYYYYMMDD() + "' and '" + csEnd.getYYYYMMDD() + "')");
            inq.setColumn("employeeid, time0id, runno, companyid, dateid");
            inq.putChild(db);
            inq.refresh();
            while (inq.next()) {
                DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);

                DbTable dt = (DbTable) inq.getChild("Ttime_current1");
                dt.delete();

                rec.delete();
            }
        } catch (Exception e) {
	MyLog.error(this, e);

            // TODO Auto-generated catch block
            
        }
    }

    private void saveTransferTimeProcess(WorkingShift ws, DbRecord empRec, String d) {
        try {            
        	MyLog.debug(this, "===== WORKING SHIFT ======");
        	MyLog.debug(this, ws.getUprofile(), ws.toString());
            CscCalendar date = null;
            CscCalendar csStart = new CscCalendar(d);
            CscCalendar csEnd = new CscCalendar(d);
            
            MyTreeMap hmADJ = new MyTreeMap();
            TimeResult tResult = null;
            
            this.delOldData(empRec.getString("employeeid"), d);

            float hour_s=0;
            DbTable db = new InitialTable(this.getUProfile()).getDbTable("Ttime_current1");

            for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {
            	            	
                String key = (String) IT.next();
                DayShift dShift = (DayShift) ws.get(key);

                CscCalendar csDate = new CscCalendar(key);
                // Check save record for in process date
                if (csDate.afterEquals(csStart) && csDate.beforeEquals(csEnd)) {

                    HashMap errorDayShiftResult = dShift.getErrorResult();
                    int i = 1, recCount = 0;
                    db.clear();

                    for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {
                    	hour_s=0;
                        boolean isSave = true;
                        String key1 = (String) IT1.next();
                        TimeResult tr = (TimeResult) dShift.get(key1);

                        HashMap errorResult = tr.getResultError();
                        int flag=9;
						//9=, 0=ٴ, 1=ٴ͡, 2=ٴͧ 
						String autoSwip=""; //0=ٴ ,1=ٴ
						if (errorResult.isEmpty()) {
							isSave=true;
						} else {						
							if (errorResult.containsKey("0") && errorResult.containsKey("1")) {
                            	isSave = true;
                        		flag = 2;
                        	} else if (errorResult.containsKey("0") && !errorResult.containsKey("1")) {
                        		//isSave = false;
                        		isSave = true; //For Pea
                        		flag = 0;
                        	} else if (!errorResult.containsKey("0") && errorResult.containsKey("1")) {
                        		//isSave = false;
                        		isSave = true; //For Pea
                        		flag = 1;
                        	}
							
							if (tr.getResultPropertyShf()!=null) {
								HashMap shf = tr.getResultPropertyShf();
								autoSwip = (String) shf.get("FGTYPE");
								if (autoSwip.equals("1")) {
									isSave = true;
									flag = 9;
								}
							}
						}

                        date = new CscCalendar(tr.getResultShiftCalendar().getYYYYMMDD());
                        if (isSave && !tr.getResultTR_Type().equalsIgnoreCase("M")) {
                            DbRecord rec = db.getNewRecord();
                            hmADJ.clear(); //㹡ͷբѹ
                        	tResult = null; //з㹡äӹǳͷբѹ
                            //Check 㹡óͷբѹ
                            MyLog.debug(this, "## DATE="+tr.getResultShiftCalendar()+" ## ADJUST="+tr.getResultAdjustTemp());
							if (!tr.getResultAdjustTemp().equals("")) {
								StringTokenizer str = new StringTokenizer(tr.getResultAdjustTemp(),"#");
								MyTreeMap hm;
								String adj="", adj2="";
								while (str.hasMoreTokens()) {
									adj = str.nextToken();					
									hm = new MyTreeMap();
									StringTokenizer str2 = new StringTokenizer(adj,",");
									while (str2.hasMoreTokens()) {				
										adj2 = str2.nextToken();
										hm.put(adj2.substring(0,adj2.indexOf("=")), adj2.substring(adj2.indexOf("=")+1,adj2.length()));				
									}
									hmADJ.put(adj.substring(6,16), hm);		
								}
								tResult = tr;
							}
							
                            rec.set("employeeid", empRec.getString("employeeid"));
                            rec.set("companyid", empRec.getString("companyid"));
                            rec.set("dateid", tr.getResultShiftCalendar().getYYYYMMDD());
                            rec.set("doctype", tr.getResultDocType());
                            rec.set("docno", tr.getResultDocNo());
                            rec.set("forget_in","0");
							rec.set("forget_out","0");
                            if (!tr.getResultTimeCode().equalsIgnoreCase("HOLIDAY")) {
								rec.set("time0id", tr.getResultTimeCode());
							} else rec.set("time0id", empRec.getString("time0"));
                            rec.set("old_time0", tr.getResultOldTimeCode());
                            rec.set("sequence", this.getStringID(i, 2));
                                                       
                            //Check  hmADJ  OT ѹդ
                            if (hmADJ.isEmpty()) {								
								try {
									rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
									rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
								} catch (Exception e) {
									MyLog.error(this, e);
}
								try {
									rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
									rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
								} catch (Exception e) {
									MyLog.error(this, e);
}							
						
								//for PEA
								try {									
									if (flag==2) { //ٴ͡						
										rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_c_dt_in().getCSCTime());
										rec.set("forget_in","1");
									} else if (autoSwip.equals("1")) {
										rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_c_dt_in().getCSCTime());
									}
									if (tr.getResult_m_dt_in()!=null) {
										rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
										if ((tr.getResult_m_dt_in().getCSCTime()>=8.31) && 
											tr.getResult_c_dt_out().getCSCTime()==16) {
											rec.set("c_tm_bg", 8.30);	
											rec.set("c_tm_en", 16.30);	
										} else if ((tr.getResult_m_dt_in().getCSCTime()>=9.01) && 
											tr.getResult_c_dt_out().getCSCTime()==16) {
											rec.set("c_tm_bg", 9.00);	
											rec.set("c_tm_en", 17.00);	
										}
									} 
								} catch (Exception e) {
									MyLog.error(this, e);
}
								try {									
									if (flag==2) {
										rec.set("m_dt_en", tr.getResult_c_dt_in().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_c_dt_in().getCSCTime());
										rec.set("forget_out","1");
									} else if (autoSwip.equals("1")) {
										rec.set("m_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_c_dt_out().getCSCTime());
									}
									if (tr.getResult_m_dt_out()!=null) {
										rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
									}
									rec.set("ap_ot", tr.getResultAp_ot());
								} catch (Exception e) {
									MyLog.error(this, e);
}
									
								try {
									if (flag==0) { //ٴ
										rec.set("m_dt_bg", tr.getResult_m_dt_out().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_m_dt_out().getCSCTime());	
										rec.set("forget_in","1");
										rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
									} else if (flag==1) { //ٴ͡
										rec.set("m_dt_en", tr.getResult_m_dt_in().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_m_dt_in().getCSCTime());
										rec.set("forget_out","1");
										rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
									} 
								}catch (Exception e) {
									MyLog.error(this, e);
}
							} else {
								MyTreeMap h = (MyTreeMap) hmADJ.get(tr.getResultShiftCalendar().getYYYYMMDD());
								
								CscCalendar cOUT = new CscCalendar(tr.getResult_c_dt_out().getYYYYMMDD());
								cOUT.setCSCTime(tr.getResult_c_dt_out().getCSCTime());
								CscCalendar scOUT = new CscCalendar((String) h.get("DT_EN"));
								scOUT.setCSCTime(Float.valueOf((String) h.get("TM_EN")).floatValue());
								
								CscCalendar mOUT = new CscCalendar(tr.getResult_m_dt_out().getYYYYMMDD());
								mOUT.setCSCTime(tr.getResult_m_dt_out().getCSCTime());
								CscCalendar smOUT = new CscCalendar((String) h.get("DT_EN"));
								smOUT.setCSCTime(Float.valueOf((String) h.get("TM_EN")).floatValue());
								
								rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());								
								rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
								rec.set("c_dt_en", scOUT.getYYYYMMDD());
								rec.set("c_tm_en", scOUT.getCSCTime());
								
								if (smOUT.before(mOUT)) {
									rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
									rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
									rec.set("m_dt_en", smOUT.getYYYYMMDD());
									rec.set("m_tm_en", smOUT.getCSCTime());
								} else {
									rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
									rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
									rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
									rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
								}
								
								CscCalendar cIN = new CscCalendar(tr.getResult_c_dt_in().getYYYYMMDD());
								cIN.setCSCTime(tr.getResult_c_dt_in().getCSCTime());								
								rec.set("ap_ot",scOUT.subForHour(cIN));
							}
							
                            rec.set("c_lv", tr.getResultC_LV());
                            //rec.set("ap_ot", tr.getResultAp_ot());
                            //rec.set("lv_ty", tr.getResultLV_Type());
                            rec.set("lv_ty", tr.getResultEventGroup());
                            rec.set("tr_type", tr.getResultTR_Type());
                            rec.set("ac_ot", tr.getResultAc_ot());
                           /* try {
                                rec.set("forget_in", tr.getResultForget_in());
                            } catch (Exception e) {
	MyLog.error(this, e);
}
                            try {
                                rec.set("forget_out", tr.getResultForget_out());
                            } catch (Exception e) {
	MyLog.error(this, e);
}*/
                            try {
                                if (tr.getResult_Inzone_begin() != null) {
                                    rec.set("dt_in_inzone", tr.getResult_Inzone_begin().getYYYYMMDD());
                                    rec.set("tm_in_inzone", tr.getResult_Inzone_begin().getCSCTime());
                                }
                            } catch (Exception e) {
	MyLog.error(this, e);

                            }
                            try {
                                if (tr.getResult_Inzone_end() != null) {
                                    rec.set("dt_out_inzone", tr.getResult_Inzone_end().getYYYYMMDD());
                                    rec.set("tm_out_inzone", tr.getResult_Inzone_end().getCSCTime());
                                }
                            } catch (Exception e) {
	MyLog.error(this, e);

                            }
                            try {
                                if (tr.getResult_Outzone_begin() != null) {
                                    rec.set("dt_in_outzone", tr.getResult_Outzone_begin().getYYYYMMDD());
                                    rec.set("tm_in_outzone", tr.getResult_Outzone_begin().getCSCTime());
                                }
                            } catch (Exception e) {
	MyLog.error(this, e);

                            }
                            try {
                                if (tr.getResult_Outzone_end() != null) {
                                    rec.set("dt_out_outzone", tr.getResult_Outzone_end().getYYYYMMDD());
                                    rec.set("tm_out_outzone", tr.getResult_Outzone_end().getCSCTime());
                                }
                            } catch (Exception e) {
	MyLog.error(this, e);

                            }

                            try {
                                if (tr.getResultMidDayStop() != null) {
                                    try {
                                        if (tr.getResultMidDayStop().getBeginZone() != null) {
                                            rec.set("dt_breakin", tr.getResultMidDayStop().getBeginZone().getDDMMYYYY());
                                            rec.set("tm_breakin", tr.getResultMidDayStop().getBeginZone().getCSCTime());
                                        }
                                    } catch (Exception e) {
	MyLog.error(this, e);

                                    }
                                    try {
                                        if (tr.getResultMidDayStop().getEndZone() != null) {
                                            rec.set("dt_breakout", tr.getResultMidDayStop().getEndZone().getDDMMYYYY());
                                            rec.set("tm_breakout", tr.getResultMidDayStop().getEndZone().getCSCTime());
                                        }
                                    } catch (Exception e) {
	MyLog.error(this, e);

                                    }
                                }
                            } catch (Exception e) {
	MyLog.error(this, e);

                            }
                            rec.set("iswork", tr.getResultIsWork());
                            rec.set("eventgrp", tr.getResultEventGroup());
                            rec.set("oldeventgrp", tr.getResultOldEventGroup());
                            rec.set("previousshift",tr.getResultPreviousShiftType());
                            rec.set("nextshift",tr.getResultNextShiftType());
                            rec.set("status",tr.getResultStatus());
                            rec.set("hour_s", tr.getResultHour_s());
                            hour_s=tr.getResultHour_s();
                            Ttime_current1 t1 = (Ttime_current1) rec;
                            t1.setTimeHashMap(this.hmTime);
                            t1.setDayTimeHashMap(this.hmDayTime);
                            t1.setEmpRecord(empRec);
                            t1.setOTHashMap((MyTreeMap) this.hashOT.clone());
                            t1.setHolidayHashMap(this.hmHoliday);
                            t1.setCalOTProcess(this.calOT);
                            db.putNewRecord(rec);
                            recCount++;
                            i++;
                            this.hmTime = t1.getTimeHashMap();
                            this.hmDayTime = t1.getDayTimeHashMap();
                            this.hmHoliday = t1.getHolidayHashMap();
                            /*
                             * Ŵ Mtime1 Ѻ Ttime_current1 ͹㹡äӹǳ
                             * ¡͹Ŵ硡͹բ Hash ѧ ѧդŴ
                             * ҡ鹨 Hash 鹡Ѻҷ class process ͹ record 蹵 
                             */
                        } // i++;
                    } // end for shift
                                   
                    if (recCount > 0) {
                        DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord("Ttime_current");
                        rec.set("employeeid", empRec.getString("employeeid"));
                        rec.set("companyid", empRec.getString("companyid"));
                        rec.set("time0id", empRec.getString("time0"));
                        rec.set("dateid", date.getYYYYMMDD());
                        rec.set("hour_s", hour_s);
                        rec.putChild(db);
                        Ttime_current t = (Ttime_current) rec;
						t.setEmpRecord(empRec);
                        rec.save();
                        
                        if (hmADJ!=null && !hmADJ.isEmpty()) {
                        	hmADJ.remove(date.getYYYYMMDD());
                        	this.saveOTContinue(empRec, this.getUProfile(), hmADJ, tResult);
                        }
                    }           
                }
            } // end for dShift
        } catch (Exception e) {
	MyLog.error(this, e);

            
        }
    }
    
    private MyTreeMap loadOTFormula() {
    	MyTreeMap hFormula = new MyTreeMap();
		try {
			DbRecord rec;
			String key, field;
			StringTokenizer str;
			MyHashMap hProp;
			DbInquiry inqFormula = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inqFormula.setSchemaName(this.getUProfile().getSchemaName());
			inqFormula.initMyTable("Otformula", "", "formulaid");
			inqFormula.setColumn("*");
			inqFormula.refresh();			
			while (inqFormula.next()) {
				rec = inqFormula.getCurrentDbRecord();
				key = rec.getString("formulaid");
				hProp = new MyHashMap();
				str = new StringTokenizer(rec.getFieldList(),",");
				while (str.hasMoreTokens()) {
					field = str.nextToken();
					hProp.put(field, rec.getString(field));
				}
				hFormula.put(key, hProp);
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}	
		return hFormula;
	}
       
    //Save OT Continue
    private void saveOTContinue(DbRecord empRec, UProfile up, MyTreeMap hmADJ, TimeResult tr) {		
		if (hmADJ!=null && !hmADJ.isEmpty()) {
			try {
				CscCalendar breakIN = tr.getResultMidDayStop().getBeginZone();
				CscCalendar breakOUT = tr.getResultMidDayStop().getEndZone();
				for (Iterator it = hmADJ.keySet().iterator(); it.hasNext();) {
					int i=1;
					breakIN.incDate();
					breakOUT.incDate();
					
					//FOR SHIFT					
					String key = it.next().toString();
					CscCalendar csc = new CscCalendar(key);
					DbTable db = new InitialTable(up).getDbTable("Ttime_current1");
					DbRecord rec = db.getNewRecord();				
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("dateid", csc.getYYYYMMDD());
					rec.set("docno", tr.getResultDocNo());
					rec.set("doctype", tr.getResultDocType());
					
					if (!tr.getResultTimeCode().equalsIgnoreCase("HOLIDAY")) {
						rec.set("time0id", tr.getResultTimeCode());
					} else rec.set("time0id", empRec.getString("time0"));
					rec.set("old_time0", tr.getResultOldTimeCode());						
					rec.set("sequence", this.getStringID(i, 2));
					
					MyTreeMap d = (MyTreeMap) hmADJ.get(key);
					CscCalendar cIN = new CscCalendar((String) d.get("DT_BG"));
					cIN.setCSCTime(Float.valueOf((String) d.get("TM_BG")).floatValue());
					CscCalendar cOUT = new CscCalendar((String) d.get("DT_EN"));
					cOUT.setCSCTime(Float.valueOf((String) d.get("TM_EN")).floatValue());
					
					rec.set("c_dt_bg", cIN.getYYYYMMDD());						
					rec.set("c_tm_bg", cIN.getCSCTime());
					rec.set("c_dt_en", cOUT.getYYYYMMDD());
					rec.set("c_tm_en",cOUT.getCSCTime());
					
					rec.set("m_dt_bg", cIN.getYYYYMMDD());
					rec.set("m_tm_bg", cIN.getCSCTime());
					if (csc.getYYYYMMDD().equalsIgnoreCase(tr.getResult_m_dt_out().getYYYYMMDD())) {
						rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
						rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
					} else {
						rec.set("m_dt_en", cOUT.getYYYYMMDD());
						rec.set("m_tm_en", cOUT.getCSCTime());
					}
					
					rec.set("ap_ot",cOUT.subForHour(cIN));	
					
					MyLog.debug(this, "======= OT CONTINUE ACTURE =======");
					MyLog.debug(this, "DATE ="+rec.getString("dateid"));
					MyLog.debug(this, "C IN ="+rec.getString("c_dt_bg")+":"+rec.getString("c_tm_bg"));
					MyLog.debug(this, "C OUT ="+rec.getString("c_dt_en")+":"+rec.getString("c_tm_en"));
					MyLog.debug(this, "M IN ="+rec.getString("m_dt_bg")+":"+rec.getString("m_tm_bg"));
					MyLog.debug(this, "M OUT ="+rec.getString("m_dt_en")+":"+rec.getString("m_tm_en"));
					MyLog.debug(this, "AP_OT ="+rec.getString("ap_ot"));		
					
					rec.set("c_lv", tr.getResultC_LV());
                    //rec.set("lv_ty", tr.getResultLV_Type());
                    rec.set("lv_ty", tr.getResultEventGroup());
                    rec.set("tr_type", tr.getResultTR_Type());
                   try {
						if (tr.getResultMidDayStop()!=null){
							try {
								if (breakIN!=null) {
									rec.set("dt_breakin", breakIN.getYYYYMMDD());
									rec.set("tm_breakin", breakIN.getCSCTime());
								}		
							} catch (Exception e) {
								MyLog.error(this, e);
}
							try { 										
								if (breakOUT!=null) {
									rec.set("dt_breakout", breakOUT.getYYYYMMDD());							
									rec.set("tm_breakout", breakOUT.getCSCTime());
								}
							} catch (Exception e) {
								MyLog.error(this, e);
}
						} 
					} catch (Exception e) {
						MyLog.error(this, e);
}
					
					rec.set("iswork", tr.getResultIsWork());
                    rec.set("eventgrp", tr.getResultEventGroup());
                    rec.set("oldeventgrp", tr.getResultOldEventGroup());
                    rec.set("previousshift",tr.getResultPreviousShiftType());
                    rec.set("nextshift",tr.getResultNextShiftType());
                    rec.set("status",tr.getResultStatus());
                    Ttime_current1 t1 = (Ttime_current1) rec;
                    t1.setTimeHashMap(this.hmTime);
                    t1.setDayTimeHashMap(this.hmDayTime);
                    t1.setEmpRecord(empRec);
                    t1.setOTHashMap((MyTreeMap) this.hashOT.clone());
                    t1.setHolidayHashMap(this.hmHoliday);
                    t1.setCalOTProcess(this.calOT);
                    db.putNewRecord(rec);
                    this.hmTime = t1.getTimeHashMap();
                    this.hmDayTime = t1.getDayTimeHashMap();
                    this.hmHoliday = t1.getHolidayHashMap();
                    
                    //Save TTIME_CURRENT
                    DbRecord recCurrent = new InitialRecord(this.getUProfile()).getDbRecord("Ttime_current");
                    recCurrent.set("employeeid", empRec.getString("employeeid"));
                    recCurrent.set("companyid", empRec.getString("companyid"));
                    recCurrent.set("time0id", empRec.getString("time0"));
                    recCurrent.set("dateid", csc.getYYYYMMDD());
                    recCurrent.putChild(db);
                    Ttime_current t = (Ttime_current) recCurrent;
					t.setEmpRecord(empRec);
					recCurrent.save();
				}		
				
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}			
		}			
	}
    
    private String getStringID(int data, int i) {
		String text="";
        java.text.DecimalFormat dc=new java.text.DecimalFormat();
        for (int j=1;j<=i;j++){
        	text=text+"0";
        }       
        dc.applyPattern(text);
        return String.valueOf(dc.format(data));
	}
}
