package com.csc.library.timeattendance;

import java.text.DecimalFormat;
import java.util.Hashtable;

import std.library.DataTable;
import std.library.TimeSpan;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.UProfile;
/**
 * 
 * @author _NUISS
 * @since 07/08/2552
 *@see ǨͺͼԴҴ㹡ٴѵ Ҿѡ
 *<br>mtime0.breaktype =="1"
 */
public class BreakCheck {
  
	private boolean isError = false;
	private UProfile userProFile = null;
	private String employeeId =null;
	private String time0Id =null;
	
	private String stDateBreak =null;
	private String endDateBreak=null;
	
	private String dateSwipeOut=null;
	private double timeSwipeOut=0.0d;
 	
	private Hashtable hsBreakVar = null;
	private double breakHour= 0.0d;
	private String breakMsg="";
	private String bTimeChk="";
	private String bTimeList="";
	
	public BreakCheck(UProfile userProFile,String employeeid ,String time0Id 
			, String stDateBreak, String endDateBreak
			, String dateSwipeOut, float timeSwipeOut){
		// TODO Auto-generated constructor stub
		this.isError = false;
		this.userProFile =userProFile;
		this.employeeId =employeeid;
		this.time0Id =time0Id;
		this.stDateBreak =stDateBreak;
		this.endDateBreak =endDateBreak;
		
		this.dateSwipeOut =dateSwipeOut;
		this.timeSwipeOut =timeSwipeOut;
	}//end constructor

	public String[] checkBreak(){
		String[] valueReturn = new String[4];
		DecimalFormat dc=new DecimalFormat();
		dc.applyPattern("#0.00");
		this.getBreakVar();	
		this.findSwipeAtBreakTime();
		valueReturn[0] = dc.format(this.breakHour);
		valueReturn[1] = this.breakMsg;
		valueReturn[2] = this.bTimeChk;
		valueReturn[3] = this.bTimeList;
		return valueReturn;
	}//end method calulateOTBreak
	
	private void getBreakVar(){
		DecimalFormat dc = new DecimalFormat();
		dc.applyPattern("#0.00");
		this.hsBreakVar = new Hashtable();
		TimeSpan tsZoneIn = new TimeSpan();
		TimeSpan tsZoneOut = new TimeSpan();
		try{
			DbInquiry inqMtime0= new InitialInquiry(this.userProFile).getDbInquiry();		
			inqMtime0.initMyTable("MTIME0", "breaktype='1' and time0id ='"+this.time0Id+"' ", "");
			inqMtime0.setColumn("TIME0ID,COMPANYID,TDESC" +
					",BINRANGE,BOUTRANGE,BLIMIT,BZIN,BZOUT");
			inqMtime0.refresh();
			if(inqMtime0.next()){
				this.hsBreakVar.put("BINRANGE", inqMtime0.getString("BINRANGE"));
				this.hsBreakVar.put("BOUTRANGE", inqMtime0.getString("BOUTRANGE"));
				this.hsBreakVar.put("BLIMIT", inqMtime0.getString("BLIMIT")); 
				this.hsBreakVar.put("BZIN", inqMtime0.getString("BZIN"));
				this.hsBreakVar.put("BZOUT", inqMtime0.getString("BZOUT"));
				//ZoneIn
				tsZoneIn.setSignSeperateOfDate("-");
				tsZoneIn.cnvrtToTimeSpan(this.stDateBreak, inqMtime0.getString("BINRANGE").replace(".", ":")); 
				tsZoneIn =tsZoneIn.timeSubtract(tsZoneIn, Double.valueOf(inqMtime0.getString("BZIN")));
				this.hsBreakVar.put("DTZIN",tsZoneIn);
				//ZoneOut
				tsZoneOut.setSignSeperateOfDate("-");
				tsZoneOut.cnvrtToTimeSpan(this.endDateBreak,inqMtime0.getString("BOUTRANGE").replace(".", ":")); 
				tsZoneOut =tsZoneOut.timeAdd(tsZoneOut, Double.valueOf(inqMtime0.getString("BZOUT")));
				this.hsBreakVar.put("DTZOUT",tsZoneOut);
			}else{
				this.isError = true;
			}//end if
		}catch(Exception ex){
			System.out.print("Error on BreakCheck.getOtBreakVar()...");
			this.isError = true;
		}//end try
	}//end method getOtBreakVar

	private void findSwipeAtBreakTime(){ 
		if(this.isError==true){
			return ;
		}//end if 
		TimeSpan dateStart =(TimeSpan)this.hsBreakVar.get("DTZIN");
		dateStart.setSignSeperateOfDate("-");
		TimeSpan dateEnd =(TimeSpan)this.hsBreakVar.get("DTZOUT");
		dateEnd.setSignSeperateOfDate("-");
		try{
			DbInquiry inqSWT= new InitialInquiry(this.userProFile).getDbInquiry();		
			inqSWT.initMyTable("TTIMETEMP"
					, "EMPLOYEEID='"+this.employeeId+"' "+
					  " AND SWIPEDATE >='"+dateStart.getCurDate()+"'"+
					  " AND SWIPEDATE <='"+dateEnd.getCurDate()+"'" +
					  " AND SWIPETIME >="+dateStart.getHourOfDay()+"." +dateStart.getMinute()+
					  " AND SWIPETIME <="+dateEnd.getHourOfDay()+"." +dateEnd.getMinute()
					  , "EMPLOYEEID ASC,SWIPEDATE ASC,SWIPETIME ASC");
			inqSWT.setColumn("COMPANYID,EMPLOYEEID,SWIPEDATE,SWIPETIME");
			inqSWT.refresh();
			int item = 0 ;
			TimeSpan breakStart = new TimeSpan();
			TimeSpan breakEnd = new TimeSpan();
			TimeSpan dateTimeSwipeOut = new TimeSpan();
			dateTimeSwipeOut.setSignSeperateOfDate("-");
			dateTimeSwipeOut.cnvrtToTimeSpan(this.dateSwipeOut, this.timeSwipeOut);
			String[] columnName = {"SWIPEDATE","SWIPETIME"};
			String[] columnType ={"varchar","varchar"};
			DataTable dtbSwipeData = new DataTable(columnName,columnType);
			//ͧաٴѵ㹪ǧ break ҧ 2 
			if(inqSWT.recCount()>=2){
				while(inqSWT.next()){
					item++;
					String swipeDate = inqSWT.getString("SWIPEDATE");
					String swipeTime = inqSWT.getString("SWIPETIME").replace(".", ":");
					
					//storage swipeDate ,swipeTime
					dtbSwipeData.insertRow(1);
					dtbSwipeData.setItem(dtbSwipeData.rowCount(), columnName[0], swipeDate);
					dtbSwipeData.setItem(dtbSwipeData.rowCount(), columnName[1], swipeTime);
					//ҷշش 2 
					if(item==1){
						breakStart.setSignSeperateOfDate("-");
						breakStart.cnvrtToTimeSpan(swipeDate, swipeTime);
					}else{
						breakEnd.setSignSeperateOfDate("-");
						breakEnd.cnvrtToTimeSpan(swipeDate, swipeTime);
						/**
						 * ٴѵҾѡѹ >= ҷٴ͡ ͧл (¡ǧ break Ѻ ҷӧҹ ͡ҡѹ logic)
						 *  ҧҹ 8.00-17.00 ѡ 12.00-13.00
						 * 
						 * Case Study:
						 * աٴ 8.00,12.01,12.51,13.00
						 * ͧ ٴ 13.00 繡ٴͧ͡л 
						 *  ٴ 12.01 ,12.51 繡ٴ -͡ ͧѡ 
						 *   ٴ ͡  17.01  ͧ  13.00 ͡ٴͧ͡ѡ§
						 * 
						 * Case Study:
						 * աٴ 8.00,12.01,13.00
						 * ͧ ٴ 13.00 繡ٴͧ͡л 
						 *  ٴ 12.01 繡ٴ աٴͧ͡ѡ
						 */
						int cmprValue =breakEnd.compareDateTime(breakEnd, dateTimeSwipeOut);
						if(cmprValue>=0){
							// ٴѵèҡ Row ͹˹ҹ  ش 
							if((item-1)>1){
								breakEnd.cnvrtToTimeSpan(dtbSwipeData.getItemString((item-1), columnName[0])
                                         ,dtbSwipeData.getItemString((item-1), columnName[1]));
							}//end if 
							break;
						}//end if
					}//end if 
				}//end while
		
				TimeSpan ts = new TimeSpan();
				this.breakHour = ts.timeDiff(breakStart, breakEnd);
				double breakLimit = Double.valueOf((String) this.hsBreakVar.get("BLIMIT"));
				
 				if(this.breakHour<=breakLimit){
					this.breakMsg="ѡҷ˹";
				}else if (this.breakHour>breakLimit){
					this.breakMsg="ѡԹҷ˹";
				}//end if
 				
 				TimeSpan stBRange =new TimeSpan();
 				stBRange.setSignSeperateOfDate("-");
 				stBRange.cnvrtToTimeSpan(this.stDateBreak, this.hsBreakVar.get("BINRANGE").toString().replace(".", ":"));
				TimeSpan endBRange =new TimeSpan();
				endBRange.setSignSeperateOfDate("-");
				endBRange.cnvrtToTimeSpan(this.endDateBreak, this.hsBreakVar.get("BOUTRANGE").toString().replace(".", ":")); 

 				if(breakStart.compareDateTime(breakStart, stBRange)<0){
 					this.breakMsg+="  ٴѵ ͹ǧҾѡ˹";
 				}
 				if(breakEnd.compareDateTime(breakEnd, endBRange)>0){
 					this.breakMsg+="  ٴѵ ªǧҾѡ˹";
 				}//end if 
 				this.bTimeChk = breakStart.getCurDateTime()+","+breakEnd.getCurDateTime();
			}else if(inqSWT.recCount()==1){
				this.breakHour =0.0d;
  				this.breakMsg="šٴѵ 㹪ǧҾѡúǹ [ͧٴҧ 2 ]";
  				this.bTimeChk ="";
			}else if(inqSWT.recCount()==0){
				this.breakHour =0.0d;
				this.breakMsg="辺šٴѵ 㹪ǧҾѡ [ͧٴҧ 2 ]";
				this.bTimeChk ="";
			}//end if 
			
			
			//bTimeList
			inqSWT.refresh();
			while(inqSWT.next()){
				String swipeDate = inqSWT.getString("SWIPEDATE");
				String swipeTime = inqSWT.getString("SWIPETIME").replace(".", ":");
				TimeSpan dateTimeList = new TimeSpan();
				dateTimeList.setSignSeperateOfDate("-");
				dateTimeList.cnvrtToTimeSpan(swipeDate, swipeTime);
				if(this.bTimeList.equals("")){
					this.bTimeList = dateTimeList.getCurDateTime();
				}else{
					this.bTimeList +=","+dateTimeList.getCurDateTime();
				}//end if 
			}//end while	
 				
		}catch(Exception ex){
			System.out.print("Error on BreakCheck.findSwipeAtBreakTime()...");
			this.isError = true;
		}//end try
	}//end method findSwipeAtBreakTime

}//end class
