package com.csc.library.timeattendance;

import java.sql.ResultSet;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Tabsent_error;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ChkTimeOverLap {
	private String employeeid = "00000";
	private String absentid = "";
	private String companyid = "";
	private String strDate = new CscCalendar().getYYYYMMDD();
	private String endDate = new CscCalendar().getYYYYMMDD();
	private String strTime = new CscCalendar().getHHMM();
	private String endTime = new CscCalendar().getHHMM();
	private String dtStdate = "";
	private String dtEndate = "";
	private UProfile upf = null;
	private Vector vAbsent = new Vector();
	
	private String exc_absentid = ""; 
	
	public ChkTimeOverLap(){
	}

	/* ѺҾ ʾѡҹ ѹ ѹش  ش */
	public ChkTimeOverLap(DbRecord tabsent) {
		try {
			this.setProp(tabsent);
		} catch(Exception e){
			MyLog.error("!! Error : can't set properties in ChkTimeOverLap.ChkTimeOverlap() !!",e);
		}
	}

	/* ૵Ѻ String Array (Ҩҡ˹ҨҢ鹵͹͹ѵ ҫ)*/
	public void setProp(String[] tabsent, UProfile upf){ 
		try {
			this.setAbsentID(tabsent[0]);
			this.setEmployee(tabsent[1]);
			this.setCompanyid(tabsent[2]);
			this.setStartDate(tabsent[3]);
			this.setStartTime(tabsent[4]);
			this.setEndDate(tabsent[5]);
			this.setEndTime(tabsent[6]);
			this.setUProfile(upf);
			this.setDateTimeStart();
			this.setDateTimeEnd();
		} catch(Exception e){
			MyLog.error("!! Error : can't set properties in ChkTimeOverLap.setProp() !!",e);
		}
	}
	
	public void setProp(DbRecord tabsent){
		try {
			this.setAbsentID(tabsent.getString("absentid"));
			this.setEmployee(tabsent.getString("employeeid"));
			this.setCompanyid(tabsent.getString("companyid"));
			this.setStartDate(tabsent.getString("start_date"));
			this.setStartTime(tabsent.getString("start_time"));
			this.setEndDate(tabsent.getString("end_date"));
			this.setEndTime(tabsent.getString("end_time"));
			this.setUProfile(tabsent.getUProfile());
			this.setDateTimeStart();
			this.setDateTimeEnd();
		} catch(Exception e){
			MyLog.error("!! Error : can't set properties in ChkTimeOverLap.setProp() !!",e);
		}
	}

	public void setProp(DbRecord tabsent,UProfile upf){
		try {
			this.setAbsentID(tabsent.getString("absentid"));
			this.setEmployee(tabsent.getString("employeeid"));
			this.setCompanyid(tabsent.getString("companyid"));
			this.setStartDate(tabsent.getString("start_date"));
			this.setStartTime(tabsent.getString("start_time"));
			this.setEndDate(tabsent.getString("end_date"));
			this.setEndTime(tabsent.getString("end_time"));
			this.setUProfile(upf);
			this.setDateTimeStart();
			this.setDateTimeEnd();
		} catch(Exception e){
			MyLog.error("!! Error : can't set properties in ChkTimeOverLap.setProp() !!",e);
		}
	}
	
	public void setExceptDocId(String absid){
		this.exc_absentid = absid ;
	}
	
	private void setDateTimeStart(){
		try{
			this.dtStdate = this.strDate + " " + this.strTime;
		} catch(Exception e) {
			MyLog.error("!! Error : can't set DateTimeStart in ChkTimeOverLap !!",e);
		}
	}
	
	private void setDateTimeEnd(){
		try {
			this.dtEndate = this.endDate + " " + this.endTime;
		} catch(Exception e) {
			MyLog.error("!! Error : can't set DateTimeEnd in ChkTimeOverLap !!",e);
		}
	}
	
	private void setAbsentID(String id){
		this.absentid = id;
	}
	
	private void setCompanyid(String id){
		this.companyid = id;
	}
	
	private void setUProfile(UProfile upf){
		this.upf = upf;
	}
	
	private void setEmployee(String emp){
		this.employeeid = emp;
	}
	
	private void setStartDate(String stDate){
		this.strDate = stDate;
	}
	
	private void setStartTime(String stTime){
		DecimalFormat df = new DecimalFormat("00.00");
		try{
			this.strTime = df.format(Double.parseDouble(stTime));
		}catch(Exception e){
			MyLog.error("!! Error : Can't set start time in ChkTimeOverLap !!",e);
		}
	}
	
	private void setEndDate(String enDate){
		this.endDate = enDate;
	}
	
	private void setEndTime(String enTime){
		DecimalFormat df = new DecimalFormat("00.00");
		try{
			this.endTime = df.format(Double.parseDouble(enTime));
		}catch(Exception e){
			MyLog.error("!! Error : Can't set End time in ChkTimeOverLap !!",e);
		}
	}

	public Vector getData(){
		return this.vAbsent;
	}
	
	private String genQuery(String dbms){
		if(dbms.equals("MSSQL")){
			return this.getSQLQuery();
		} else {
			return this.getOrclQuery();
		}
	}
	
	private String getSQLQuery(){
		StringBuffer sql = new StringBuffer();
		try {
			sql.append(" select absentid,emp_request,employeeid,start_date,end_date,start_time,end_time,type_absent "); 
			sql.append(" from tabsent_nstda "); 
			sql.append(" where approve != 'W' and wf_status in ('4','6') and employeeid = '").append(this.employeeid).append("' and ");  
			sql.append("	( "); 
			sql.append("		( "); 
			sql.append("			( "); 
			sql.append("			 convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("			 and convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("			) ");
			sql.append("			and convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("		) "); 
			sql.append("        or "); 
			sql.append("		( ");  
			sql.append("			( "); 
			sql.append(" 			convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("			and convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("			) ");
			sql.append("			and convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("		) "); 
			sql.append("		or "); 
			sql.append("		( "); 
			sql.append("			convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("			and convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("		)  ");
			sql.append("		or "); 
			sql.append("		( "); 
			sql.append("			( "); 
			sql.append("			 convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("			 and convert(datetime, start_date + ' ' + replace(start_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("			) "); 
			sql.append("			and "); 
			sql.append("			( "); 
			sql.append("			 convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) >= convert(datetime, replace('").append(this.dtStdate).append("','.',':'), 120) ");
			sql.append("			 and convert(datetime, end_date + ' ' + replace(end_time,'.',':'), 120) <= convert(datetime, replace('").append(this.dtEndate).append("','.',':'), 120) ");
			sql.append("			) "); 
			sql.append("		) "); 
			sql.append("	) "); 
			
			/* óա˹Ţ͡÷ͧù礴 */
			if(!this.exc_absentid.equals("")){
				sql.append(" and absentid != '").append(this.exc_absentid).append("'");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sql.toString();
	}
	
	private String getOrclQuery(){
		StringBuffer sql = new StringBuffer();
		try {
			sql.append("select absentid,emp_request,employeeid,start_date,end_date,start_time,end_time,type_absent ");
			sql.append(" from tabsent_nstda "); 
			sql.append(" where approve != 'W' and wf_status in ('4','6') and employeeid = '").append(this.employeeid).append("' and "); 
			sql.append(" ( ");
			sql.append(" ( ");
			sql.append("  ( ");
			sql.append(" to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
			sql.append(" and to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" )");
	    	sql.append(" and to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" ) ");
	    	sql.append(" or ");
	    	sql.append(" ( "); 
	    	sql.append(" ( ");
	    	sql.append(" to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" and to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" )");
	    	sql.append(" and to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" ) ");
	    	sql.append(" or ");
	    	sql.append(" ( ");
	    	sql.append(" to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" and to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" ) ");
	    	sql.append(" or ");
	    	sql.append(" ( ");
	    	sql.append(" ( ");
	    	sql.append(" to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" and to_date(concat(concat(start_date,' '),start_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" ) ");
	    	sql.append(" and ");
	    	sql.append(" ( ");
	    	sql.append(" to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') >= to_date('").append(this.dtStdate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" and to_date(concat(concat(end_date,' '),end_time),'YYYY-MM-DD HH24.Mi') <= to_date('").append(this.dtEndate).append("','YYYY-MM-DD HH24.Mi')");
	    	sql.append(" ) ");
	    	sql.append(" ) ");
	    	sql.append(" ) ");
	    	
			/* óա˹Ţ͡÷ͧù礴 */
			if(!this.exc_absentid.equals("")){
				sql.append(" and absentid != '").append(this.exc_absentid).append("'");
			}
		}catch(Exception e){
			MyLog.error("!! Error : Can't create oracle sql command in ChkTimeOverLap !!",e);
		}

		return sql.toString();
	}
	
	public boolean chkTimeOverlap(){
		boolean result = false;
		CscConnection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = "";
		try {
			sql = this.genQuery(new InitialEnvironment(this.upf.getDbName()).getValue("datasource-dbtype"));
			
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql.toString());
			
			while(rs.next()){
				if(!this.absentid.equals(rs.getString("absentid"))){ /* 㺷Ţ͡ çѺ㺷  ʴ仫ӡѺ蹵ͧѹ֡ Error */
	        		CscCalendar leave1 = new CscCalendar(rs.getString("start_date"));
	            	leave1.setCSCTime(rs.getFloat("start_time"));
	            	CscCalendar leave2 = new CscCalendar(rs.getString("end_date"));
	            	leave2.setCSCTime(rs.getFloat("end_time"));
	            	
	            	CscCalendar csc1 = new CscCalendar(this.strDate);
	                csc1.setCSCTime(Float.parseFloat(this.strTime));
	                CscCalendar csc2 = new CscCalendar(this.endDate);   
	                csc2.setCSCTime(Float.parseFloat(this.endTime));
	                
	                /* 礪ǧҡѺҷѹ  ҪǧҷѺ͹ѹ */
	                if(csc1.beforeEquals(leave1)&& (leave2.after(csc1)) && leave2.beforeEquals(csc2)){
	                	result = true; 
	                } else if(csc1.afterEquals(leave1)&&csc2.beforeEquals(leave2)) {
	                	result = true;
	                } else if((csc1.afterEquals(leave1)&&csc1.before(leave2)) && csc2.after(leave2)) {
	                	result = true;
	                } else if(csc1.beforeEquals(leave1)&&csc2.afterEquals(leave2)) {
	                	result = true;
	                }
				} else {
					result = false; /* 㺷͡÷繵ѹͧ ʴ */
				}
			}
			
		} catch(Exception e){
			MyLog.error("!! Error : can't create any transaction due to Uprofile is null or invalid sql command !!",e);
		} finally {
			try {
				conn.close();
				stmt.close();
			} catch(Exception e) {
				MyLog.error("!! Error :  can't close connection or statement in ChkTimeOverLap.chkTimeOverlap !!");
			}
		}
		
		return result;
	}
	
	public void saveLog(){
		try {
			if(this.vAbsent.size()>0){
				Enumeration en  = this.vAbsent.elements();
				while(en.hasMoreElements()){
					Tabsent_error tabsentERR = (Tabsent_error) en.nextElement();
					tabsentERR.save();
				}
			}
		} catch(Exception e) {
			MyLog.error("!! Error : can't save Tabsent_error in ChkTimeOverlap.saveLog() !!");
		}
	}
	
}
