package com.csc.library.timeattendance;

import java.rmi.RemoteException;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * ҧ¹ѵѵ 
 * µǨٴѵ еҧ÷ӧҹ çѹҧ¹ѵѵ 
 * ֧Ѻҷҡ͹˹ҹ §Ѻ Ңͧ 
 **/

public class CreateChangeShift implements AutoGenChangeShift {
	private DbRecord recMtime0;

	private String empTime0id; /* ʡ١˹㹵ҧҡ÷ӧҹͧѡҹ */
	private String newTime0id; /* ʡ 礨ҡٴѵ ºѺ㹵ҧ AUTOSHIFT_CONFIG */

	private boolean AUTO_GEN_FLAG ; 	/* Ҥ кҵͧҧ¹Ẻѵѵ (True ,False )*/
	
	private HashMap hmTime0Config = new HashMap(); /* ´ͧз˹㹵ҧ AUTOSHIFT_CONFIG */
	
	private Vector leaveDoc = new Vector(); /* ҷ͹¹ ͺѹ֡Ѻŧѧҡ¹ */
	
	public CreateChangeShift(DbRecord recMtime0){
		try {
			this.recMtime0 = recMtime0;
		}catch(Exception e){
			MyLog.error("!! timetemp is null while create change shift !!",e);
		}
	}
	
	private UProfile getUProfile(){
		try {
			return recMtime0.getUProfile();
		} catch (Exception e) {
			MyLog.error("!! UProfile is null !!",e);
			return null;
		}
	}
	
	/* ʾѡҹ */
	private String getEmp(){
		try {
			return recMtime0.getString("employeeid");
		} catch (RemoteException e) {
			MyLog.error("!! employeeid is null !!",e);
			return null;
		}
	}
	
	/* ʡз١Ѻ Employee  Table Memployee.time0 */
	private String getTime0id(){
		return empTime0id;
	}
	
	/* ʡзçѺǧٴѵ */
	private String getNewTime0id(){
		return newTime0id;
	}
	
	/* ѹٴѵ */
	private CscCalendar getSwipeDate(){
		try {
			return recMtime0.getCscCalendar("swipedate");
		} catch (RemoteException e) {
			MyLog.error("!! Swipe date is null !!",e);
			return null;
		}
	}
	
	/* ٴѵ */
	private String getSwipeTime(){
		try {
			return recMtime0.getString("swipetime");
		} catch (RemoteException e) {
			MyLog.error("!! Swipe time is null !!",e);
			return null;
		}
	}
	
	/* ҧ¹Ẻѵѵ */
	public void createChangeShift() {
		setAutoGenFlag(); 			/* ҵͧҧ¹Ẻѵѵ */
		
		if(AUTO_GEN_FLAG){
			System.out.print("!! Gen flag is treu !!");
			setEmpTime0(); 			/* ʡШҡἹҧ */
			setSwpTimeMatching(); 	/* ʡ礨ҡٴѵ Ἱ駤㹵ҧ AUTOSHIFT_CONFIG */
			System.out.print("!! matching :  !! old : " + empTime0id + " vs " + newTime0id);
			if(!Matching() && !newTime0id.equals("")){
				genChangShiftDoc(); /* ҧ¹ лѺҢͧҷѹ */
				genNewTime0OT();
			}
		}
	}
	
	private void genNewTime0OT(){
		String tablename = "";
		String childtable = "";
		try{
			DbInquiry ot_inq = new InitialInquiry(this.getUProfile()).getDbInquiry("tadjtime0");
			ot_inq.setColumn("employeeid,docid,doctype");
			ot_inq.setFilter("doctype in('O','B','OM') and employeeid = '"+recMtime0.getString("employeeid")+"' and DT_BG = '"+getSwipeDate().getYYYYMMDD()+"'");
			ot_inq.refresh();
			
			while(ot_inq.next()){
				if(ot_inq.getString("doctype").equals("O")){
					tablename = "TOT0";
					childtable = "TOT1";
				}else if(ot_inq.getString("doctype").equals("OM")){
					tablename = "TOT_M_DATE0";
					childtable = "TOT_M_DATE1";
				}else{//B
					tablename = "TOT";
				}
				DbInquiry update_inq = new InitialInquiry(this.getUProfile()).getDbInquiry(tablename);
				update_inq.setColumn("*");
				update_inq.setFilter("OTID", ot_inq.getString("DOCID"));
				
				DbTable dt_update = new InitialTable(this.getUProfile()).getDbTable(tablename);
				dt_update.setColumn("*");
				if(!childtable.equals("")){
					update_inq.putChild(dt_update);
				}
				
				update_inq.refresh();
				while(update_inq.next()){
					DbRecord update_M = update_inq.getCurrentDbRecord();
					if(!childtable.equals("")){
						dt_update.first();
						do{
							dt_update.set("OT_TIME0", newTime0id);
							dt_update.next();
						}while(!dt_update.eof());
					}else{
						update_M.set("OT_TIME0", newTime0id);
					}
					update_M.save();
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ҧ¹ лѺҢͧ  */
	private void genChangShiftDoc(){
		try{
			removeLeaveDoc();	/* źѹ   ͡͹ ͵ͧöѹ֡¹ ѧҡ鹨֧ºѹ֡Ѻŧ */
			saveChangShiftDoc();/* ҧ¹ */
			reAdjustLeaveDoc();	/* ѺҢͧҷѹ ͧҡʡ¹ ҡ÷ӧҹ¹ ǧҢͧҵͧ¹ */
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* źѹ   ͡͹ ͵ͧöѹ֡¹ ѧҡ鹨֧ºѹ֡Ѻŧ */
	private void removeLeaveDoc(){
		try {
			DbInquiry doc = new InitialInquiry(getUProfile()).getDbInquiry();
			doc.setSchemaName(getUProfile().getSchemaName());		
			doc.initMyTable("Tadjtime0", "", "");			
			doc.setColumn("*");
			doc.setFilter("employeeid = '" + getEmp() + "' and docdate = '" + getSwipeDate().getYYYYMMDD() + "' and doctype = 'A' and updtype = 'A'");
			doc.refresh();
			
			while(doc.next()){
				DbRecord leaveRec = new InitialRecord(getUProfile()).getDbRecord("Tabsent_nstda");
				leaveRec.setColumn("*");
				leaveRec.set("absentid", doc.getString("docid"));
				if(leaveRec.search()==1){
					leaveRec.set("wf_status", "8"); /* ˹ʶҹź½ºؤ  adjust  tleave ж١ź͡ ͡ѧ */
					leaveRec.save();
				}

				leaveDoc.add(leaveRec);  
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ҧ¹ ʡ */
	private void saveChangShiftDoc(){
		String COMPANYID = "100"; /* fix code companyid */
		String REMARK = "Generated by SYSTEM.";
		String STATUS = "6"; /* fix code 6, Workflow status is updated by HR */
		try {
			DbRecord dbChShift = new InitialRecord(getUProfile()).getDbRecord("TCHANGESHIFT_NSTDA");
			dbChShift.set("companyid", COMPANYID);
			dbChShift.set("emp_request", getEmp());
			dbChShift.set("employeeid", getEmp());
			dbChShift.set("start_date", getSwipeDate().getYYYYMMDD());
			dbChShift.set("end_date", getSwipeDate().getYYYYMMDD());
			dbChShift.set("old_shift", getTime0id());
			dbChShift.set("new_shift", getNewTime0id());
			dbChShift.set("remark", REMARK);
			dbChShift.set("wf_status", STATUS);
			dbChShift.save();
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}	
	
	/* ѺҢͧҷաâѹ ʡж١¹ Ἱ¹ ѧ鹶բѹ ͤѹ ش ͧѹѺἹ */
	private void reAdjustLeaveDoc(){
		try {
			for(int i = 0; i < leaveDoc.size(); i++){
				adjAbsent((DbRecord)leaveDoc.get(i)); /* ҡ кѹ֡ա ѺἹ÷ӧҹ */
			}
				 
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}

	/* ҡ кѹ֡ա ѺἹ÷ӧҹ */
	private void adjAbsent(DbRecord leave){
		HashMap hmTime0 = new HashMap();

		try {
			hmTime0 = getTime0Details(getNewTime0id()); /* ´ͧ ֧ҡҧ MTIME1*/
			
			leave.setParam("CHKDATEREQUEST", "true"); /* ૵ҹŧͧա öǧ˹͹ѧ ͹Ѻ觤Ҩҡ˹Ҩͧ͢ҧ HR ա蹡ѹ */
				
			/* ֧ѹͧҢ ѾഷçѺѹͧ 
			 * ҧ ʡ 00001 ,DATE_ZONE_IN 0,DATE_ZONE_OUT 1
			 * ʴ 繡Тѹͧҡ DATE_ZONE_IN = 0 (źѺѹҢͧ) 
			 *  DATE_ZONE_OUT = 1 (ǡա 1 ѹҡѹҢͧ)
			 **/
			if(leave.getString("leave_format").equals("0")){ /* ѹ */
				leave.set("start_date", leave.getCscCalendar("start_date").decDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_IN")))); 	/* Ѿഷѹ 鹪ǧáͧἹ */
				leave.set("end_date", leave.getCscCalendar("end_date").incDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_OUT1")))); 	/* Ѿഷѹش شǧѧͧἹ */
				leave.set("start_time", (String) hmTime0.get("TIMEIN1")); /* 鹢ͧ ǧá */
				leave.set("end_time", (String) hmTime0.get("TIMEOUT2"));  /* شͧ ǧѧ */
			}else if(leave.getString("leave_format").equals("2")){ /* Ҥá */
				leave.set("start_date", leave.getCscCalendar("start_date").decDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_IN")))); 	/* Ѿഷѹ 鹪ǧáͧἹ */
				leave.set("end_date", leave.getCscCalendar("end_date").incDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_OUT")))); 	/* Ѿഷѹش شǧáͧἹ */
				leave.set("start_time", (String) hmTime0.get("TIMEIN1")); /* 鹢ͧ ǧá */
				leave.set("end_time", (String) hmTime0.get("TIMEOUT1"));  /* شͧ ǧá */
			}else if(leave.getString("leave_format").equals("3")){ /* Ҥѧ */
				leave.set("start_date", leave.getCscCalendar("start_date").decDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_IN1")))); /* Ѿഷѹ 鹪ǧѧͧἹ */
				leave.set("end_date", leave.getCscCalendar("end_date").incDate(Integer.parseInt((String)hmTime0Config.get("DATE_ZONE_OUT1")))); 	/* Ѿഷѹش شǧѧͧἹ */
				leave.set("start_time", (String) hmTime0.get("TIMEIN2")); /* 鹢ͧ ǧѧ */
				leave.set("end_time", (String) hmTime0.get("TIMEOUT2"));  /* شͧ ǧѧ */
			}
			
			leave.set("wf_status", "4"); /* ˹ʶҹ͹ѵ  adjust  tleave ж١ѹ֡ŧա */
			leave.save(); /* ѹ֡ */
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* Ǩͺʡзҧ (л) ԧѺǧٴѵ ç ͧҧ¹ѺاἹ÷ӧҹ */
	private boolean Matching(){
		if(empTime0id.equals(newTime0id)){
			return true;
		} else { 
			return false;
		}
	}
	
	/* ͨͺٴѵѹ Ѻǧҷ˹㹵ҧ AUTOSHIFT_CONFIG */
	private void setSwpTimeMatching(){
		newTime0id = findTime0fromAutoConfig();
		
	}
	
	/* ʡТͧѡҹ١˹ѹ   ¹ҧҡ÷ӧҹ */
	private void setEmpTime0() {
		try {
			Memployee_ta mt = (Memployee_ta) new InitialRecord(getUProfile()).getDbRecord("Memployee_ta"); 
			mt.setColumn("employeeid,time0");
			mt.set("employeeid", recMtime0.getString("employeeid"));
			if (mt.search()==1){
				empTime0id = mt.getDailyTime0id(
						new CscCalendar(getSwipeDate().getYYYYMMDD())
					);
			}else{
				MyLog.error("!! can't fine time0id from emp : " + recMtime0.getString("employeeid"));
			}
		}catch(Exception e){
			MyLog.error("!! time0id not found !! ",e);
		} 
	}
	
	/* Ҥ кҵͧҧ¹Ẻѵѵ (True ,False )*/
	private void setAutoGenFlag(){
		try {
			AUTO_GEN_FLAG = Boolean.valueOf((String) StaticConfig.getConfigCompany(getUProfile(), "AUTOGENFLAG"));
		}catch(Exception e){
			MyLog.error("!! AUTOGENFLAG is not found from MConfig or is null",e);
			AUTO_GEN_FLAG = false;
		}
		System.out.print("!! auto gen flage is " + AUTO_GEN_FLAG);
	}
	
	/* ҧ query Ѻ ORACLE */
	private String getQueryORCL(){
		StringBuffer sb = new StringBuffer();
		try {
			sb.append("select * from autoshift_config ");
			sb.append("where to_date('").append(getSwipeDate().getYYYYMMDD()).append(" ").append(getSwipeTime()).append("','YYYY-MM-DD HH24.MI')");
			sb.append(" between to_date(concat('").append(getSwipeDate().getYYYYMMDD()).append(" ").append("',zone_in),'YYYY-MM-DD HH24.MI')");
			sb.append(" and ");
			sb.append(" to_date(concat('").append(getSwipeDate().getYYYYMMDD()).append(" ").append("',zone_out),'YYYY-MM-DD HH24.MI')");
			sb.append(" and time0id = '").append(getTime0id()).append("'");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sb.toString();
	}
	
	/* ҧ query Ѻ MSSQL */
	private String getQueryMSSQL(){
		StringBuffer sb = new StringBuffer();
		try {
			sb.append("select * from autoshift_config ");
			sb.append("where convert(datetime, '").append(getSwipeDate().getYYYYMMDD()).append(" ' + replace('").append(getSwipeTime()).append("','.',':') , 120)");
			sb.append(" >= dateadd(day, convert(int,date_zone_in)*-1 , convert(datetime, '").append(getSwipeDate().getYYYYMMDD()).append(" ' + replace(ZONE_IN,'.',':') , 120))");
			sb.append(" and convert(datetime, '").append(getSwipeDate().getYYYYMMDD()).append(" ' + replace('").append(getSwipeTime()).append("','.',':'), 120)");
			sb.append(" <= dateadd(day, convert(int,date_zone_out), convert(datetime, '").append(getSwipeDate().getYYYYMMDD()).append(" ' + replace(ZONE_OUT,'.',':') , 120))");
			sb.append(" and time0id = '").append(getTime0id()).append("'");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sb.toString();
	}
	
	/* ҧ query ѹѺش 觵ͧ DB (ORACLE or MSSQL) */
	private String getQuery(){
		String sql = "";
		try {
			String dbType = new InitialEnvironment(recMtime0.getUProfile().getDbName()).getValue("datasource-dbtype");
			if(dbType.equalsIgnoreCase("ORACLE")){
				sql = getQueryORCL();
			}else if(dbType.equalsIgnoreCase("MSSQL")){
				sql = getQueryMSSQL();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sql;
	}
	
	/**
	 * ֧šШҡҧ AutoShift_Config ѹѺٴ ŧ HashMap ŷմѧ 
	 * ʡ (time0id), ӹǹѹͧǡͧѹشͧ (DATE_ZONE_OUT), ӹǹѹͧźͧѹ鹢ͧ(DATE_ZONE_IN)
	 * ҧҹͧ  DATE_ZONE_IN  DATE_ZONE_OUT
	 * ʡ 0000001 ,DATE_ZONE_IN 0,DATE_ZONE_OUT 0 --> ʴҡй ش ѹǡѹ Фҷͧǡź 0
	 * ʡ 0000002 ,DATE_ZONE_IN 0,DATE_ZONE_OUT 1 --> ʴҡй ش 繤ѹ ФҢͧ ZONE_IN = 0 Ңͧ ZONE_OUT = 1 (ǡ 1 ѹ)
	 **/
	
	private String findTime0fromAutoConfig(){
		CscConnection conn = null;
		Statement stmt = null;
		ResultSet rs = null;

		String time0id = "";
		String _Query = "";
		try {
			_Query = getQuery(); /* ҧ query Ҫǧٴѵ çѺʡ */

			conn = (CscConnection) StaticProperties.myConnection.getConnection(getUProfile().get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(_Query);
			System.out.print("!!! query sql --> " + _Query);
			
			/* ֧ʡ ǧҡٴ */
			while(rs.next()){
				time0id = rs.getString("newtime0id");
				
				/* 红ŷ Hashmap 㹢鹵͹ûѺѧ */
				hmTime0Config.put("TIME0ID", rs.getString("time0id"));
				hmTime0Config.put("NEWTIME0ID", rs.getString("newtime0id"));
				hmTime0Config.put("DATE_ZONE_IN", rs.getString("date_zone_in"));
				hmTime0Config.put("DATE_ZONE_OUT", rs.getString("date_zone_out"));
				hmTime0Config.put("DATE_ZONE_IN1", rs.getString("date_zone_in1"));
				hmTime0Config.put("DATE_ZONE_OUT1", rs.getString("date_zone_out1"));				
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				if(rs != null) rs.close();
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				MyLog.error(this,e);
			}
		}
		return time0id;
	}
	
	/**
	 * ֧š ŧ HashMap ŷմѧ 
	 * ʡ (time0id), 鹪ǧá (timein1), شǧá(timeout1), 鹪ǧѧ(timein2), شǧѧ(timeout2)
	 **/
	private HashMap getTime0Details(String time0){
		HashMap hm = new HashMap();

		CscConnection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		StringBuffer _Query = new StringBuffer();
		
		try {
			/* ҧ query ֧ѹ鹨ҡ Tadjtime0,Tabsent_nstda ͡੾зѹ Фѹҹ (leave_format = '0','1','2')*/
			_Query.append("select time0id,timein1,timeout1,timein2,timeout2 ");
			_Query.append("from mtime1 ");
			_Query.append("where time0id = '").append(time0).append("' ");
			_Query.append("order by dayweekid");
			
			conn = (CscConnection) StaticProperties.myConnection.getConnection(getUProfile().get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(_Query.toString());
			
			while(rs.next()){
				hm.put("TIME0ID", rs.getString("time0id"));
				hm.put("TIMEIN1", rs.getString("timein1"));
				hm.put("TIMEOUT1", rs.getString("timeout1"));
				hm.put("TIMEIN2", rs.getString("timein2"));
				hm.put("TIMEOUT2", rs.getString("timeout2"));
				break; /* 㹵ҧ Mtime1 բҡ÷ӧҹͧШӹǹ 7 ѹ͹ѹ ѧä촡 */
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				if(rs != null) rs.close();
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				MyLog.error(this,e);
			}
		}
		return hm;
	}
}
