package com.csc.library.timeattendance;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeinterface.AdjustTime;
import com.csc.library.timeinterface.SwipeTrans;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

public class DayShift extends MyTreeMap {
	
	CscCalendar shiftDate; //ѹͧ
	SwipeTrans swipeData; //šٴѵâͧѡҹ
	Vector swipeHoliday = new Vector();
	HashMap errorResult;
	
	public DayShift() {
		super();
		this.errorResult = new HashMap();
	}

	public DayShift(CscCalendar d) {
		this.shiftDate = d;
		this.errorResult = new HashMap();
	}

	/*
	 * ˹ҡŧС
	 * ͹㹡èѺ÷ӧҹ
	 */
	public void setSwipeTrans(SwipeTrans trans) {
		this.swipeData = trans;
		Shift s;
		String key;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			s = (Shift) this.get(key);
			s.setSwipeTrans(this.swipeData);
		}
	}
	
	public SwipeTrans getSwipeTrans() {
		return this.swipeData;
	}

	/*
	 * ӡèѺ÷ӧҹºº
	 * ҧ÷ӧҹТšٴѵ
	 */
	public void findTime() {
		Shift s;
		String key;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			s = (Shift) this.get(key);
			s.setSecondLoop(false);
			s.findTime();
		}
	}
	
	public void findTime(boolean secondLoop) {
		Shift s;
		String key;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			s = (Shift) this.get(key);
			s.setSecondLoop(secondLoop);
			s.findTime();
		}
	}
	
	/*
	 * ӡҧҡٴѵѵѵ
	 * 㹡óշաзͧѹ
	 * 	T 08.00 - 17.00
	 * 			O 17.00 - 19.00
	 * зӡҧšٴѵ 17.00 Ѻͧ
	 */
	 public void genVirtualSwipeForJoinShift() {
		Shift s;
		String key;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			s = (Shift) this.get(key);
			s.genVirtualSwipeForJoinShift();
		}
	}

	 /*
	  * ҧŢѴ仢ͧ TR_type е T, A, O, H, I
	  */
	public String getNextRuningCode(String code) {		
		String result;
		int max = 0;		
		Iterator it = this.keySet().iterator();
		if (this.isEmpty()) {
			max = 0;
		} else {
			while (it.hasNext()) {
				Shift sh = (Shift) this.get((String) it.next());
				String t = sh.getTR_Type();
				if (t.equalsIgnoreCase("")) {
					max = 0;
				} else {
					if (t.substring(0, 1).equalsIgnoreCase(code)) {
						if (Integer.valueOf(t.substring(1, 2)).intValue() >= max) {
							max = Integer.valueOf(t.substring(1, 2)).intValue();
							max++;
						}
					}
				}
			}
		}		
		if (code.length()==1) 
			result = code + max;
		else result = code.substring(0, 1) + max;
		return result;
	}

	/*
	 * ӡù 2 ѹ
	 */
	public DayShift addShift(DayShift ds1, DayShift ds2) {
		Iterator it = ds2.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) ds2.get(code);
			ds1.put(sh);
		}
		return ds1;
	}

	/*
	 * ӡùӢ ADJTIME0 ҷӡûѺا
	 * ҡ÷ӧҹԷҧ
	 * + ----> ADD SHIFT [UPDTYPE != D --> A, O, H, T]
	 * - ----> SUB SHIFT [UPDTYPE = D]
	 */
	public void adjust(AdjustTime ajTime) {
		adjust(ajTime, ajTime.getDocDate());
	}
	
	/*  actual date 仴 */
	public void adjust(AdjustTime ajTime, CscCalendar keydate) {
		//MyLog.debug(this, "DayShift="+this);
		if (!ajTime.getUpdateType().equalsIgnoreCase("D")) { //ӡ
			Shift sh = new Shift(new CscCalendar(ajTime.getDocDate().getTimestamp()));
			sh.setActualDate(keydate.getDDMMYYYY());	// ѹͧзŧἹ
			sh.set_c_dt_in(ajTime.get_DT_BG()); //˹ѹѺ
			sh.set_c_dt_out(ajTime.get_DT_EN()); //˹ѹشѺ
			
			CscCalendar c = new CscCalendar(ajTime.getDocDate().getDDMMYYYY());	/* ҧеѹͧ actual date */
			try {
				c.setCSCTime(ajTime.get_DT_BG().getCSCTime());
			} catch (Exception e) {}
			sh.setShiftDate(c); //˹ѹѺ
			
			sh.setTimeCode(ajTime.getTime0()); 			//˹ʵҧ÷ӧҹѺ
			sh.setOldTimeCode(ajTime.getOldTime0()); 	//˹ʵҧ÷ӧҹѺ
			sh.setEventGroup(ajTime.getEventGroup()); 	//˹ѹѺ
			sh.setOldEventGroup(ajTime.getOldEventGroup()); //˹ѹѺ
			sh.setTR_Type(ajTime.get_TR_Type());		//˹ѹѺ
			sh.setDocType(ajTime.getDocType()); 		//ӹ͡Ѻ
			sh.setDocNo(ajTime.getDocNo()); 			//˹Ţ͡Ѻ
			sh.setLV_Type(ajTime.get_LV_TY()); 			//˹Ѻ
			//sh.setAppStatus(ajTime.getAppStatus()); 	//˹ʶҹС͹ѵ͡ (W ҧ͹ѵ 繪ͧҧʴ͹ѵ)
			sh.set_o_dt_in(ajTime.get_DT_BG()); 
			sh.set_o_dt_out(ajTime.get_DT_EN());
			
			TimeZone tz = ajTime.getTimeWork(); //֧ѹҵҧ÷ӧҹͧ͡
			if(tz!=null){
				sh.set_sh_dt_in(tz.getBeginZone()); //˹ѹ鹵ҧ÷ӧҹѺ
				sh.set_sh_dt_out(tz.getEndZone()); //˹ѹشҧ÷ӧҹѺ
			}//end if 			
			if (ajTime.getUpdateType().equalsIgnoreCase("A")) { // set ҷŧ				
				sh.setLv(ajTime.get_LV()); //ҷ
				sh.setDocStatus(ajTime.getDocStatus());	
				sh.setTR_Type("A0");
				try {
					sh.setActualEvent(ajTime.get_TR_Type().substring(0,1)); /* ˹ѹԧ  ͧ */
				}catch(Exception e){
					sh.setActualEvent("T");
				}
			} else if (ajTime.getUpdateType().equalsIgnoreCase("O")||
					ajTime.getUpdateType().equalsIgnoreCase("H")||
					ajTime.getUpdateType().equalsIgnoreCase("I")) { //ͷ set ҷͷŧ	
				if(ajTime.getUpdateType().equalsIgnoreCase("O")) {
					sh.setTR_Type("O0");
				}
				if (!this.isEmpty()) { //ա H  I  OT ӡźз
					Shift shHoliday = (Shift) this.get((String) this.keySet().iterator().next());
					/* ҡзѾഷ O ͧ actual_event ѹشѹӧҹ */
					sh.setAp_ot(ajTime.get_LV()); //ҷͷ
					if(shHoliday!=null && shHoliday.getType()=='A'){ /* ͷ Ѻ ͧѺͷ͡ Ѻ */
						if(sh.get_c_dt_in().beforeEqualsDateTime(shHoliday.get_c_dt_in()) 
								&& sh.get_c_dt_out().afterEqualsDateTime(shHoliday.get_c_dt_out())){
							/* ͷդҷ ͷŧ */
						}else if(sh.get_c_dt_in().afterEqualsDateTime(shHoliday.get_c_dt_in())
								&& sh.get_c_dt_out().beforeEqualsDateTime(shHoliday.get_c_dt_out())){
							/* Ҥͷշ ͷŧ */
						}else if(sh.get_c_dt_in().beforeDateTime(shHoliday.get_c_dt_in()) 
								&& sh.get_c_dt_out().afterDateTime(shHoliday.get_c_dt_in()) 
								&& sh.get_c_dt_out().beforeEqualsDateTime(shHoliday.get_c_dt_out()) ){
							/* ͷշѺҺҧǹ شҡѺ */
							sh.c_dt_out = new CscCalendar(shHoliday.get_c_dt_in().getTime());
						}else if(sh.get_c_dt_in().afterEqualsDateTime(shHoliday.get_c_dt_in())
								&& sh.get_c_dt_in().beforeDateTime(shHoliday.get_c_dt_out())
								&& sh.get_c_dt_out().afterDateTime(shHoliday.get_c_dt_out())){
							/* ͷ㹪ǧ ͧѺͷ */
							sh.c_dt_in = new CscCalendar(shHoliday.get_c_dt_out().getTime()); 
						}
					}else if (shHoliday!=null && (shHoliday.getType()=='H' || shHoliday.getType()=='I')) {
						sh.setActualEvent(String.valueOf(shHoliday.getType()));
						//sh.setEventGroup(String.valueOf(shHoliday.getType()));	/* 繡ͷ ѹش Ѻ eventgrp ѹش (H ش, I شѡѵġ)*/
						//sh.setTR_Type(String.valueOf(shHoliday.getTR_Type()));
						sh.setTimeCode(shHoliday.getTimeCode());	// óͷѹش ͧѺʡ çѺзѺἹѹش ͧҡռŵ͡äӹǳͷ й͡ҷӧҹ
						sh.set_sh_dt_in(new CscCalendar(shHoliday.get_sh_dt_in().getYYYYMMDDHHMMSS()));
						sh.set_sh_dt_out(new CscCalendar(shHoliday.get_sh_dt_out().getYYYYMMDDHHMMSS()));
						
						this.remove(this.keySet().iterator().next().toString());
					}else if(shHoliday.getActualEvent().equals("H") || shHoliday.getActualEvent().equals("I")){ /* 繡ͷѹش */
						if(shHoliday.getEventGroup().equals("O")){	/* С͹˹ѹǡѹͷѹش ֧ͧ actual event ૵Ѻͷ */
							sh.setActualEvent(shHoliday.getActualEvent());
						}else{
							sh.setActualEvent(String.valueOf(shHoliday.getType()));	/* ѹشͷ ˹ actual_event ѹشӡѺ */
						}
						if(shHoliday.getType()=='H' || shHoliday.getType()=='I'){	/* ͧ繡ѹش֧ź 繡ͷѹشͧź */
							this.remove(this.keySet().iterator().next().toString());
						}
					}else{	/* ѹش 繡ͷ ͧ ѹӧҹ*/
						sh.setActualEvent("T");
					}
					
					/* 繡ͷ ѹش źѹش͡ ͷŧ 繵ͧ˹  㹡ѹشѺͷմ */
					sh.setMidDayStop(shHoliday.midDayStop); //˹ǧҡþѡѺ
					sh.setAdjustTemp(shHoliday.getAdjustTemp());
					//----- ˹ŵҧ Ѻ ͡÷͡ -----//
					sh.setWorkarea(shHoliday.getWorkarea()); //˹ʶҹӧҹѺ
					sh.setSalatype(shHoliday.getSalatype()); //˹ʤѺ
					sh.setOT_type(shHoliday.getOT_type()); //˹ͷѺ
					sh.setOT_time0(shHoliday.getOT_time0()); //˹ʵҧ÷ӧҹͷѺ
					//-------------------------------------------------------//
					sh.setHour_s(shHoliday.getHour_s()); //˹ .ӧҹѹ Ѻ
					sh.setHour_d(shHoliday.getHour_d()); //˹ . /ӧҹ/ͷ Ѻ
					sh.setDocStatus(shHoliday.getDocStatus()); //˹âͧá͡͡ [4=͹ѵԨҡ WF, 6=HR ͡]
				}else{	/* աѹ ʴѹش ж١ adjust Ἱѹش  TransfertimeProcess */
					sh.setActualEvent("H");
				}
			} else if (ajTime.getUpdateType().equalsIgnoreCase("T") && !ajTime.getDocType().equals("CH") 
					&& !ajTime.getDocType().equals("C")
					/**
				 * Author : Nuiss
				 * Date : 27/03/2553
				 * Logic : š  ͧ clear property ҹҧ 
				 * Site NSTDA Doctype ='E' š
				 */
					&& !ajTime.getDocType().equals("E") &&  !ajTime.getDocType().equals("D") ) {
				//繡л Ҩҡ¹ źҷǡѺ͡÷
				
				sh.setOldEventGroup("");
				sh.setDocType("");
				sh.setDocNo("");
				sh.setLV_Type("");
			}else if(ajTime.getUpdateType().equalsIgnoreCase("T")){
				sh.setActualEvent(ajTime.getUpdateType()); /* ˹ѹԧ  ͧ ѹӧҹ */
			}
				
			if((sh.getEventGroup().equals("H") && sh.getActualEvent().equals("H")) || (sh.getEventGroup().equals("O"))){
				// ͧ˹ҫ ж١˹ҡ괢ҧ
			}else{
				sh.setMidDayStop(ajTime.getTimeBreak()); //˹ǧҡþѡѺ
				sh.setAdjustTemp(ajTime.getAdjustTemp());
				//----- ˹ŵҧ Ѻ ͡÷͡ -----//
				sh.setWorkarea(ajTime.getWorkarea()); //˹ʶҹӧҹѺ
				sh.setSalatype(ajTime.getSalatype()); //˹ʤѺ
				sh.setOT_type(ajTime.getOT_type()); //˹ͷѺ
				sh.setOT_time0(ajTime.getOT_time0()); //˹ʵҧ÷ӧҹͷѺ
				//-------------------------------------------------------//
				sh.setHour_s(ajTime.getHour_s()); //˹ .ӧҹѹ Ѻ
				sh.setHour_d(ajTime.get_LV()); //˹ . /ӧҹ/ͷ Ѻ
				sh.setDocStatus(ajTime.getDocStatus()); //˹âͧá͡͡ [4=͹ѵԨҡ WF, 6=HR ͡]
			}
			
			if (ajTime.getEventGroup().equals("T")) {  //繡л ͡ çѺǧѡ ͧáѺй				
				TimeZone timeBreak = sh.getMidDayStop();
				if (timeBreak.getBeginZone().equals(sh.get_c_dt_in()) && 
						timeBreak.getEndZone().equals(sh.get_c_dt_out())) {
					//do nothing
				} else {
					this.put(sh);
				}//end if 
			} else {
				if(sh.getTimeCode().equals("")){	/* ó time0id ʢͧѹ   */
					copyTimeCodeFromDefault(sh);
				}
				this.put(sh);			
			}
		} else if (ajTime.getUpdateType().equalsIgnoreCase("D")) { //ӡź		
			String tmp = ajTime.get_DT_BG().getTimestamp().toString();
			String key = tmp.substring(0,tmp.length()-2);			
			if (this.containsKey(key)) {
				//MyLog.debug(this, "======> REMOVE SHIFT : "+key);
				Shift shTmp = (Shift) this.get(key);				
				if (shTmp.get_c_dt_in().equals(ajTime.get_DT_BG()) && 
						(shTmp.get_c_dt_out().equals(ajTime.get_DT_EN()))) {
					this.remove(key);		
				}			
			} 
		}
	}
	
	/* ó time0id ʢͧѹ   */
	private void copyTimeCodeFromDefault(Shift sh){
		try {
			Iterator it = this.keySet().iterator();
			for(;it.hasNext();){
				String key = (String) it.next();
				Shift tmsh = (Shift) this.get(key);
				if(tmsh.getEventGroup().equals("T") || tmsh.getEventGroup().equals("H") || tmsh.getEventGroup().equals("I")){
					if(!tmsh.getTimeCode().equals("")){
						sh.setTimeCode(tmsh.getTimeCode());
						sh.set_sh_dt_in(new CscCalendar(tmsh.get_sh_dt_in().getYYYYMMDDHHMMSS()));
						sh.set_sh_dt_out(new CscCalendar(tmsh.get_sh_dt_out().getYYYYMMDDHHMMSS()));
						break;
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}

	private String getTimeFormat(String str) {
		DecimalFormat df = new DecimalFormat("#0.00");
		String value = df.format(Double.valueOf(str).doubleValue());
		String tmp = value.substring(0, value.indexOf("."));
		if (tmp.length() == 1)
			value = "0" + value;
		return value;
	}

	public String toString() {
		String buff = "";
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			buff = buff + "Key : " + code + " # " + sh.toString() + "\n";
		}
		return buff;
	}

	public void put(Shift sh) {
		super.put(sh.getKey(), sh);
	}

	/*
	 * ҧἹ÷ӧҹ ੾ѹͧӧҹ
	 */
	public void genWorkingTimeTransaction(MyTreeMap tm) {		
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			if (sh.isWorking()) { //繡зͧӧҹ
				tm.put(sh.getStringTimeIn(), sh.getKey());
				tm.put(sh.getStringTimeOut(), sh.getKey());
			}
		}
	}

	/*
	 * ҧἹ÷ӧҹءѹ
	 */
	public void genAllTimeTransaction(MyTreeMap tm) {
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			tm.put(sh.getStringTimeIn(), sh.getKey());
			tm.put(sh.getStringTimeOut(), sh.getKey());
		}
	}

	public void setShiftDate(CscCalendar d) {
		this.shiftDate = d;
	}

	public CscCalendar getShiftDate() {
		return this.shiftDate;
	}
	
	/** ӡäҡٴѵѹش */
	public void findHolidaySwipe() {
		CscCalendar beg, end;
		beg = new CscCalendar(this.shiftDate.getTimestamp());
		end = new CscCalendar(this.shiftDate.getTimestamp());
		
		try {
			beg.setCSCTime((float)00.00);
			end.setCSCTime((float)23.59);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		Vector vt;
		this.swipeHoliday.clear();
		vt = this.swipeData.getSwipeList(new TimeZone(beg, end));
		this.swipeHoliday = (Vector) vt.clone();
		
		return;
	}
	
	public void genProcessResult() {		
		this.errorResult.clear();
 		if (this.swipeHoliday.size() > 0) {
   			this.errorResult.put("11",this.swipeHoliday);    			  				
   		}
    }

	public HashMap getErrorResult() {
		return this.errorResult;
	}
	
	public void setErrorResult(HashMap hm) {
		this.errorResult = hm;
	}
	
	/*
	 * ѹѧ ѹͧӧҹ
	 * 硨ҡѹͧ
	 * ҡ A  M  return false
	 */
	public boolean isHoliday() {
		boolean result = true;
		String eventGroup = "";
		Iterator it = this.keySet().iterator();
		while (it.hasNext() && result) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			eventGroup = sh.getEventGroup();
			if (sh.isWorking()) result = false;
		}
		
		/*if (this.size()==1 && eventGroup.equals("O")) {
			result = true;
		}*/
		return result;
	}
		
	public Vector getSwipeHoliday() {
		return this.swipeHoliday;
	}
	
	public void setSwipeHoliday(Vector vt) {
		this.swipeHoliday = vt;
	}
	
	/*
	 * ӡäѹ˹ѹشШѻѹشШӻ
	 *  H=ѹشШѻ, I=ѹشШӻ, T=ѹӧҹ
	 */
	public String getStopDayStatus() { 
		String status = "";
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			if (sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I")) {
				return sh.getEventGroup();
			} else if (sh.getEventGroup().equals("A") || sh.getEventGroup().equals("T")) {
				return "T";
			}
		}
		return status;
	}
	
	/*
	 * ӡ clone 
	 */
	/*public DayShift cloneData() {
		DayShift ds = new DayShift();
		ds.setErrorResult(this.errorResult);
		ds.setShiftDate(this.shiftDate);
		ds.setSwipeHoliday(this.swipeHoliday);
		ds.setSwipeTrans(this.swipeData);
		ds.setUprofile(this.getUprofile());
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			Shift sh = (Shift) this.get(code);
			ds.put(code, sh.cloneData());
		}
		return ds;
	}*/
	
}