package com.csc.library.timeattendance;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utility.DHMConvert;

public class LeaveStatProp {
	private DbRecord lvdata ;
	private String limit = "00:00:00";
	private String used = "00:00:00";
	private String remain = "00:00:00";
	private int usedcount = 0;
	private double hourd = 8 ; /* default */
	
	public LeaveStatProp(){
	}
	
	public LeaveStatProp(DbRecord db){
		lvdata = db ;
	}
	
	public DbRecord getLvData(){
		return lvdata;
	}
	
	public String getLimit(){
		return limit;
	}
	
	public String getUsed(){
		return used ;
	}
	
	public String getRemain(){
		try {
			DHMConvert dhm = new DHMConvert();
			int limit = dhm.DHMToMin(this.getLimit(), Double.toString(this.getHourd()));
			int used  = dhm.DHMToMin(this.getUsed(), Double.toString(this.getHourd()));
			
			if(limit >= used){
				remain = dhm.MinToDHM((limit - used),this.getHourd());
			}else{
				remain = dhm.MinToDHM((used - limit),this.getHourd());
				remain = "-" + remain;
				MyLog.debug("!! Leave used is greater than limit, result will be negative value !! ");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return remain ;
	}
	
	public int getCount(){
		return usedcount ;
	}
	
	public void setLvData(DbRecord db){
		this.lvdata = db ;
	}
	
	public void setLimit(String limit){
		this.limit = limit ;
	}
	
	public void setLimit(int limit){
		try {
			DHMConvert dhm = new DHMConvert();
			this.limit = dhm.MinToDHM(limit, hourd);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void setUsed(String used){
		this.used = used ;
	}
	
	public void setUsed(int used){
		try {
			DHMConvert dhm = new DHMConvert();
			this.used = dhm.MinToDHM(used, hourd);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void setRemain(String remain){
		this.remain = remain;
	}
	
	public void setRemain(int remain){
		try {
			DHMConvert dhm = new DHMConvert();
			this.remain = dhm.MinToDHM(remain, hourd);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void setHourd(double hourd){
		this.hourd = hourd ;
	}
	
	public double getHourd(){
		return this.hourd;
	}
	
	/* ʹ */
	public void addUsed(float val){
		try {
			DHMConvert dhm = new DHMConvert();
			int mm = dhm.timeToMin(val);
			int total = dhm.DHMToMin(this.used, Double.toString(this.hourd)) + mm ;
			this.used = dhm.MinToDHM(total, this.hourd);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void addUsed(String val){
		try {
			addUsed(Float.parseFloat(val));
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void addUsedCount(){
		addUsedCount(1);
	}
	
	public void addUsedCount(int c){
		try {
			this.usedcount += c ;
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
}
