package com.csc.library.timeattendance;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.StaticConfig;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.databean.Mtime0;
import com.csc.library.process.RoundingTime;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
import com.csc.library.utility.DHMConvert;

public class ManageEmpLeaveStat {
	public Memployee_ta empRec ;
	public DbRecord grpRec, grpRecBranch ;
	private UProfile upf ;
	
	private String employeeid ;
	private String eventgrpid ;
	private String remain ;
	private String limit ;
	private String used ;
	private String exc_absentid = "" ;
	
	private int used_count = 0;
	private int[] lvcount = {0, 0, 0, 0};	/* ӹǹ駢ͧ ѹ,., Ф觺 */
	
	private DbRecord absentProp ;	/* šҤ駹  */
	
	private CscCalendar reqdate_st = new CscCalendar();	/* ˹ѹ ͤӹǳԷԡ */
	private CscCalendar reqdate_en = new CscCalendar();	/* ˹ѹش ͤӹǳԷԡ */
	
	public CscCalendar normalLeaveStart ;	/* Էҷ*/
	public CscCalendar normalLeaveEnd ;		/* Էҷش */
	public CscCalendar vacationStart ;		/* ԷҾѡ͹ */
	public CscCalendar vacationEnd ;		/* ԷҾѡ͹ش */

	
	public ManageEmpLeaveStat(UProfile upf,String empid,String eventgrp){
		setUProfile(upf);
		setEmployee(empid);
		setEventGrp(eventgrp);
		
		initialEmp(this);
		initialEventGrp(this);
		initialDateConfig(this);	/* ˹ѹ ش էҳ */
	}
	
	public void setAbsentProp(DbRecord absent){
		this.absentProp = absent ;
	}
	
	public void clearStat(){
		this.limit = "";
		this.remain = "";
		this.used = "";
		this.used_count = 0;
	}
	
	public void setUProfile(UProfile upf){
		this.upf = upf;
	}
	
	public void setEmployee(String empid){
		this.employeeid = empid;
	}
	
	public void setEventGrp(String eventgrp){
		this.eventgrpid = eventgrp;
	}
	
	public String getEmployeeid(){
		return this.employeeid;
	}
	
	public String getEventGrp(){
		return this.eventgrpid;
	}
	
	public void setExceptAbsentID(String abid){
		this.exc_absentid = abid ;
	}
	
	/* ֧žѡҹ */
	private void initialEmp(ManageEmpLeaveStat ms){
		try {
			empRec = (Memployee_ta) new InitialRecord(this.upf).getDbRecord("MEMPLOYEE_TA");
			empRec.setColumn("*");
			empRec.setParam("rsc_skip","true");
			empRec.set("employeeid", ms.getEmployeeid());
			empRec.set("companyid", this.upf.get("companyid"));
			if(empRec.search() == 1){
				MyLog.debug("!! Employee found for managing leave stat !!");
			}else{
				MyLog.debug("!! Employee not found for managing leave stat [" + ms.getEmployeeid() + "]");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ֧Ż */
	private void initialEventGrp(ManageEmpLeaveStat ms){
		try {
			clearStat();
			
			/* һ¡Ң֧ҡ MEVENTGRP1 (Ẻ)  MEVENTGRP  */
			if(isLeaveLimitByBranch()){	
				grpRec = new InitialRecord(this.upf).getDbRecord("MEVENTGRP1");
				grpRec.setColumn("*");
				grpRec.set("eventgrpid", ms.getEventGrp());
				grpRec.set("companyid", this.upf.get("companyid"));
				grpRec.set("branchid", this.empRec.getString(getFieldBranchValue()));
			}else{
				grpRec = new InitialRecord(this.upf).getDbRecord("MEVENTGRP");
				grpRec.setColumn("*");
				grpRec.set("eventgrpid", ms.getEventGrp());
				grpRec.set("companyid", this.upf.get("companyid"));
			}
			
			if(grpRec.search()==1){
				MyLog.debug("!! Eventgrp found for managing leave stat !!");
			}else{
				MyLog.debug("!! Eventgrp not found for managing leave stat [" +ms.getEventGrp()+"]");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ʹ͡ */
	public String getRemainLeave(String eventgrp){
		String remain = "00:00:00";
		try {
			DHMConvert dhm = new DHMConvert();
			int limit = dhm.DHMToMin(getLimitLeave(eventgrp),Float.toString(getHour_Day(this)));
			int used  = dhm.DHMToMin(getLeaveUsed(eventgrp, this.absentProp),Float.toString(getHour_Day(this)));
			
			if(limit >= used){
				remain = dhm.MinToDHM((limit - used),getHour_Day(this));
			}else{
				remain = dhm.MinToDHM((used - limit),getHour_Day(this));
				remain = "-" + remain;
				MyLog.debug("!! Leave used is greater than limit, result will be negative value !! ");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return remain;
	}
	
	/* ֧ limit  觡ѺٻẺ ѹ::ҷ */
	public String getLimitLeave(){
		return getLimitLeave(this.getEventGrp());
	}
	
	/* ֧ limit  觡ѺٻẺ ѹ::ҷ */
	public String getLimitLeave(String eventgrp){
		DHMConvert dhm = new DHMConvert();
		String limit = "00:00:00";
		try {
			if(grpRec.getString("needapprovedate").equals("1")){	/* ѹҹͧҹ ѧ֧öԷ */
				if(!empRec.getCscCalendar("APPROVE_DATE").beforeDate(new CscCalendar())){
					return limit ;
				}
			}
			
			if(grpRec.getString("daytype").equals("7")){	/* 繻Ҿѡ͹Шӻ ֧ͧҨҡ vacation1  memployee */
				
				/* limit Фӹǳҡ  vacation0 (Է¡) + vacation1 (ԷԻջѨغѹ) 
				 * բ Է¡ҹ еͧ礡Ѻ vacation_last 㹵ҧ mvacation0 (memployee.vacation0 --> mvacation0.vacationid)
				 * Թѹ˹㹿Ŵ vacation_last Ѻ vacation1
				 * */
				String v0 = (this.empRec.getString("vacation0")!=null&&!this.empRec.getString("vacation0").equals(""))?
						this.empRec.getString("vacation0"):"00:00:00";	/* Է¡ */
				String v1 = (this.empRec.getString("vacation1")!=null&&!this.empRec.getString("vacation1").equals(""))?
						this.empRec.getString("vacation1"):"00:00:00";	/* ԷԢͧջѨغѹ */
				String hour_d = Float.toString(getHour_Day(this));	/* . ӧҹѹ */
				
				if(isVacation0StillActive()){	/* ѧöԷ¡ */
					int total = dhm.DHMToMin(v0, hour_d) + dhm.DHMToMin(v1, Float.toString(getHour_Day(this)));
					limit = dhm.MinToDHM(total, Double.parseDouble(hour_d));
				}else{	/* ªǧöԷ¡ */
					/*limit = (this.empRec.getString("vacation1")!=null&&!this.empRec.getString("vacation1").equals(""))?
						this.empRec.getString("vacation1"):"00:00:00";*/
						
					int total = dhm.DHMToMin(this.getAnnualLeaveOnV0Period(eventgrp), hour_d) + dhm.DHMToMin(v1, Float.toString(getHour_Day(this)));
					limit = dhm.MinToDHM(total, Double.parseDouble(hour_d));
				}
			}else{	/* 繡ҷ֧ limit ҡ meventgrp.limit */
				if(isLeaveLimitByBranch()){	/* ֧ limit Ң */
					int lm = getLimitByBranch();
					limit = ((lm <= 9)?"0"+ Integer.toString(lm):Integer.toString(lm)) + ":" + getLimitHoursByBranch();
				}else{
					limit = ((grpRec.getInt("limit") <= 9)?"0"+grpRec.getString("limit"):grpRec.getString("limit")) + ":00:00";
				}
			}
			
            // Ҿѡҹѧ㹪ǧͧҹ ԷԷж١᷹մԷ㹪ǧͧҹ
			if (empRec.getString("status").equals("V")) { 
            	int lv_prob = getLimitProbation();
                limit = ((lv_prob <= 9)?"0"+ Integer.toString(lv_prob):Integer.toString(lv_prob)) +":00:00";
            }
            
            //if(!isLeaveTypeActive()){ /* ҡ˹ʴԷ  ૵ 00:00:00 */
            //	limit = "00:00:00";
            //}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return limit;
	}
	
	/* ʶҹТͧʴԷԡ (display_limit)   1 ʴ  0 ʴ 00:00:00 */
	public boolean isLeaveTypeActive(){
		try {
			if(isLeaveLimitByBranch()){	/* ֧ limit Ң */
				if(initEventGrpBranch()){
					return (grpRecBranch.getInt("display_limit")==1)?true:false;
				}else{
					MyLog.error(" !! event " + this.getEventGrp() + " for branch " + this.empRec.getString("branch") + " not found !!");
				}
			}else{
				if(grpRec != null){
					return (grpRec.getInt("display_limit")==1)?true:false;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	public int getLimitProbation(){
		try {
			if(isLeaveLimitByBranch()){	/* ֧ limit Ң */
				if(initEventGrpBranch()){
					return grpRecBranch.getInt("limit_probation");
				}else{
					MyLog.error(" !! event " + this.getEventGrp() + " for branch " + this.empRec.getString("branch") + " not found !!");
				}
			}else{
				if(grpRec != null){
					return grpRec.getInt("limit_probation");
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0;
	}
	
	/* ӹǹ駷 */
	public int getLimitAmount(){
		return getLimitAmount(this.getEventGrp());
	}
	
	/* ӹǹ駷 */
	public int getLimitAmount(String eventgrp){
		int max = 0;
		try {
			if(grpRec == null){ initialEventGrp(this); }
			if(!grpRec.getString("eventgrp").equals(eventgrp)){
				this.setEventGrp(eventgrp);
				initialEventGrp(this);
			}
			
			if(isLeaveLimitByBranch()){	/* ֧ limit Ң */
				if(initEventGrpBranch()){
					max = grpRecBranch.getInt("limit_times");
				}else{
					MyLog.error(" !! event " + this.getEventGrp() + " for branch " + this.empRec.getString("branch") + " not found !!");
				}
			}else{
				if(grpRec != null){
					max = grpRec.getInt("limit_times");
				}
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return max ;
	}
	
	/* ѧöԷ¡ */
	private boolean isVacation0StillActive(){
		try {
			CscCalendar lastAvailable = getVacationLast();
			if(lastAvailable != null){
				if(lastAvailable.afterEqualsDate(new CscCalendar())){	/* ѹöԷ¡ ѧѹѨغѹʴѧöԷ¡ */
					return true;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/*  ѹ شͧԷ¡ */
	private CscCalendar getVacationLast(){
		CscCalendar last = null;
		try {
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));	/* ѹ鹻էҳ */
            CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));		/* ѹشէҳ */
			
			DbRecord mv0 = new InitialRecord(this.upf).getDbRecord("MVACATION0");
			mv0.setColumn("*");
			mv0.set("vacationid", this.empRec.getString("vacationcode"));
			mv0.set("companyid", this.empRec.getString("companyid"));
			if(mv0.search() == 1){
				String strLast = mv0.getString("vacation_last").replace(":", "-");	/* ҷ ѹ-͹ ,ҧ 31-03*/
				
				if(strLast.equals("")) {	/* Ҥҷ繪ͧ ˹ѹ 01 ͹ 1 */
					strLast = "31-12";
				}

				if(strLast.split("-").length == 3){
					last = new CscCalendar(strLast);
					return last;
				}else{
					/* ѹشͧԷ¡ҷö ҡѺǧէҳ mconfig */
					last  = new CscCalendar(strLast + "-" + Integer.toString(cscLeaveStart.getYear()));
				}
				
				/* 㹪ǧէҳ ʴһէҳẺ ( 01-01 ش 31-12 ͧѺ ͵ͧ㹪ǧէҳ˹ mconfig */
				if(!(last.afterEqualsDate(cscLeaveStart) && last.beforeEqualsDate(cscLeaveEnd))){
					last.incYear(1);
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return last;
	}
	
	/* ֧Ż ͧǨͺẺͧ meventgrp Ẻ¡Ң meventgrp1 */
	public DbRecord getEventgrpProp(String eventgrp){
		try {
			if(!this.getEventGrp().equals(eventgrp)){
				this.setEventGrp(eventgrp);
				initialEventGrp(this);
			}
		} catch(Exception e){
			MyLog.error(this,e);
		}
		return this.grpRec ;
	}
	
	/* ͹  */
	private boolean isClearStatByMonth(String eventgrp){
		try {
			if(this.getEventgrpProp(eventgrp).getField("clear_leave_month") != null){
				if(this.getEventgrpProp(eventgrp).getString("clear_leave_month").equals("1")){
					return true;
				}else{
					return false;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* ֧ʹ */
	public String getLeaveUsed(String eventgrp, DbRecord absentprop){
		String lv = "00:00:00";
		try {
			used_count = 0;
			
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));
            CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));
            CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));
            CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));
            
            CscTime lv_hour = new CscTime();
            
            if(isClearStatByMonth(eventgrp)){	/* ʹء͹ ੾Ъǧ͹ */
            	CscCalendar curmonth_st = new CscCalendar(absentprop.getString("start_date"));
            	CscCalendar curmonth_en = new CscCalendar(absentprop.getString("start_date"));
            	curmonth_st.setDate(1); /* ѹ 1 */
            	curmonth_en.setDate(curmonth_en.getEndDateOfMonth());
            	
            	cscLeaveStart = new CscCalendar(curmonth_st.getYYYYMMDD());	/* ˹ѹ͹᷹ */
            	cscLeaveEnd = new CscCalendar(curmonth_en.getYYYYMMDD());	/* ˹ѹشͧ͹᷹ */
            }
            
            /*  */
            String eventlist = "";
            if(!grpRec.getString("sharelimit_event").equals("")){
            	eventlist = "lv_type in ('" + eventgrp + "','" + grpRec.getString("sharelimit_event") + "') ";
            }else{
            	eventlist = "lv_type = '" + eventgrp + "'";
            }
			
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			leave.setColumn("*");
			String filter = eventlist + " and employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and dateid between '" + cscLeaveStart.getYYYYMMDD() 
					+ "' and '"+ cscLeaveEnd.getYYYYMMDD() +"'" ;
			
			if(!this.exc_absentid.equals("")){ /* Ţ͡÷˹͡¡ Ҥӹǳʹ  */
				filter += " and docid != '" + this.exc_absentid + "'";
			}
			
			leave.setFilter(filter);
			leave.refresh();
			
			String docid = "";
			while(leave.next()){
				lv_hour.add(Float.parseFloat(leave.getString("m_lv")));
				
				if(!docid.equals(leave.getString("docid"))){
					docid = leave.getString("docid");
					used_count++;
				}
			}
			
			DHMConvert dhm = new DHMConvert(lv_hour.getFloat(), getHour_Day(this));
			lv = dhm.parseDHM();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return lv;
	}
	
	/* ֧ʹ */
	public String getLeaveUsed(String eventgrp){
		String lv = "00:00:00";
		try {
			used_count = 0;
			
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));
            CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));
            CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));
            CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));
            
            CscTime lv_hour = new CscTime();
            
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			leave.setColumn("*");
			
			/*  */
            String eventlist = "";
            if(!grpRec.getString("sharelimit_event").equals("")){
            	eventlist = "(";
            	eventlist += "lv_type in ('" + eventgrp + "','" + grpRec.getString("sharelimit_event") + "') ";
            	eventlist += " OR lv_type in (select eventgrpid from " + grpRec.getActualName() + " where sharelimit_event in ('" + eventgrp + "','" + grpRec.getString("sharelimit_event") + "'))" ;
            	eventlist += ")";
            }else{
            	eventlist = "(";
            	eventlist += "lv_type = '" + eventgrp + "'";
            	eventlist += " OR lv_type in (select eventgrpid from " + grpRec.getActualName() + " where sharelimit_event in ('" + eventgrp + "','" + grpRec.getString("sharelimit_event") + "'))" ;
            	eventlist += ")";
            }
            
			String filter = eventlist + " and employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and dateid between '" + cscLeaveStart.getYYYYMMDD() 
					+ "' and '"+ cscLeaveEnd.getYYYYMMDD() +"'" ;
			
			if(!this.exc_absentid.equals("")){ /* Ţ͡÷˹͡¡ Ҥӹǳʹ  */
				filter += " and docid != '" + this.exc_absentid + "'";
			}
			
			leave.setFilter(filter);
			leave.refresh();
			
			String docid = "";
			while(leave.next()){
				lv_hour.add(Float.parseFloat(leave.getString("m_lv")));
				
				if(!docid.equals(leave.getString("docid"))){
					docid = leave.getString("docid");
					used_count++;
				}
			}
			
			/* óҬһԨ ˹ mconfig  ʴҵͧӹǳӹǹªԵԧ  */
			if(getFixFeneralLeave().equals(this.getEventGrp())){
				lv_hour = new CscTime();
				lv_hour.add(this.getHisFuneralLeave());
			}
			
			DHMConvert dhm = new DHMConvert(lv_hour.getFloat(), getHour_Day(this));
			lv = dhm.parseDHM();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return lv;
	}
	
	/* ֧Ũӹǹ駡Ңͧʹ */
	public int getAmountLeaveUsed(String eventgrp, DbRecord absentprop) {
		int count = 0;
		try {
			if(!this.getEventGrp().equals(eventgrp)) {
				this.setEventGrp(eventgrp);
				initialEventGrp(this);
			}
			
			if(used_count > 0){ return used_count; }	/* ӹǳǨҡ getLeaveUsed()  */
			
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));
            CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));
            CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));
            CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));
            
			if(isClearStatByMonth(eventgrp)){	/* ʹء͹ ੾Ъǧ͹ */
            	CscCalendar curmonth_st = new CscCalendar(absentprop.getString("start_date"));
            	CscCalendar curmonth_en = new CscCalendar(absentprop.getString("start_date"));
            	curmonth_st.setDate(1); /* ѹ 1 */
            	curmonth_en.setDate(curmonth_en.getEndDateOfMonth());
            	
            	cscLeaveStart = new CscCalendar(curmonth_st.getYYYYMMDD());	/* ˹ѹ͹᷹ */
            	cscLeaveEnd = new CscCalendar(curmonth_en.getYYYYMMDD());	/* ˹ѹشͧ͹᷹ */
            }
			
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			leave.setColumn("*");
			leave.setFilter("lv_type = '" + eventgrp + "' and employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and dateid between '" + cscLeaveStart.getYYYYMMDD() 
					+ "' and '"+ cscLeaveEnd.getYYYYMMDD() +"'" );
			leave.refresh();
			
			String docid = "";
			while(leave.next()){
				if(!docid.equals(leave.getString("docid"))){
					docid = leave.getString("docid");
					count++;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return count;
	}
	
	/* ֧Ũӹǹ駡Ңͧʹ */
	public int getAmountLeaveUsed(){
		return getAmountLeaveUsed(this.getEventGrp());
	}
	
	/* ֧Ũӹǹ駡Ңͧʹ */
	public int getAmountLeaveUsed(String eventgrp){
		int count = 0;
		try {
			if(!this.getEventGrp().equals(eventgrp)){
				this.setEventGrp(eventgrp);
				initialEventGrp(this);
			}
			
			if(used_count > 0){ return used_count; }	/* ӹǳǨҡ getLeaveUsed()  */
			
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));
            CscCalendar cscLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));
            CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));
            CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));
            
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			leave.setColumn("*");
			leave.setFilter("lv_type = '" + eventgrp + "' and employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and dateid between '" + cscLeaveStart.getYYYYMMDD() 
					+ "' and '"+ cscLeaveEnd.getYYYYMMDD() +"'" );
			leave.refresh();
			
			String docid = "";
			while(leave.next()){
				if(!docid.equals(leave.getString("docid"))){
					docid = leave.getString("docid");
					count++;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return count;
	}
	
	public boolean isCountLeaveFormatOverLimit(DbRecord absent){
		try {
			int max = getCountLeaveFormatLimit(absent.getInt("leave_format"));
			int used = getCountLeaveUsedPerMonth(absent.getString("type_absent"), absent.getString("start_date"), absent.getString("leave_format"));
			
			if(max >= (used + 1)){
				return false ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return true;
	}
	
	/* ֧ӹǹ駵 (ѹ,  -   .) */
	public int getFormatLimit(int format){
		try {
			return lvcount[format];
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0 ;
	}
	
	public int getCountLeaveFormatLimit(int mode){
		try {
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		if(grpRecBranch.getField("month_limit0") == null ){	/* տŴ觤 default Ѻ */
            			return 99;
            		}else{
	            		if(mode == 0){
	            			return grpRecBranch.getInt("month_limit0");
	            		}else if(mode == 1){
	            			return grpRecBranch.getInt("month_limit1");
	            		}else if(mode == 2){
	            			return grpRecBranch.getInt("month_limit2");
	            		}else if(mode == 3){
	            			return grpRecBranch.getInt("month_limit3");
	            		}
            		}
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
            	if(grpRec.getFieldList().indexOf("month_limit0") > -1){
            		if(mode == 0){
            			return grpRec.getInt("month_limit0");
            		}else if(mode == 1){
            			return grpRec.getInt("month_limit1");
            		}else if(mode == 2){
            			return grpRec.getInt("month_limit2");
            		}else if(mode == 3){
            			return grpRec.getInt("month_limit3");
            		}
            	}
            }
		}catch(Exception e){/* óտŴк觤 99 繤 default кӧҹ (ö) */
			MyLog.error(this,e);
			return 99; 
		}
		return 99 ;
	}
	
	/* ֧Ũӹǹ駡Ңͧʹ */
	public int getCountLeaveUsedPerMonth(String eventgrp, String date){
		return getCountLeaveUsedPerMonth(eventgrp, date, "");
	}
	
	/* ֧Ũӹǹ駡Ңͧʹ */
	public int getCountLeaveUsedPerMonth(String eventgrp, String date, String mode){
		int count = 0;
		try {
			CscCalendar cscLeaveStart = new CscCalendar(date);
            CscCalendar cscLeaveEnd = new CscCalendar(date);
            cscLeaveStart.setDate(1);
            cscLeaveEnd.setDate(cscLeaveStart.getEndDateOfMonth());
            
            /* leave format (0:full day, 1:hour, 2;first half, 3:second half */
            String lvformat = "";
            if(!mode.equals("")){	/* full day */
            	if(mode.equals("5")){ /* thaipbs only */
            		/* no need to check */
            	}else{
            		lvformat = " and leave_format = '" + mode + "'";
            	}
            }
        
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("Tabsent_nstda");
			leave.setColumn("*");
			String filter = "type_absent = '" + eventgrp + "' and employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and start_date between '" + cscLeaveStart.getYYYYMMDD() 
					+ "' and '"+ cscLeaveEnd.getYYYYMMDD() +"'" + lvformat;
			
			if(!this.exc_absentid.equals("")){ /* Ţ͡÷˹͡¡ Ҥӹǳʹ  */
				filter += " and absentid != '" + this.exc_absentid + "'";
			}
			
			leave.setFilter(filter);
			leave.refresh();
			
			count = leave.recCount();
			
			if(!mode.equals("") && !mode.equals("5")){	/*  */
				lvcount[Integer.parseInt(mode)] = count;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return count;
	}
	
	/* . ӧҹѹ */
	public float getHour_Day(ManageEmpLeaveStat mg) {
        float value = 8;
        try {
            DbRecord inq1 = new InitialRecord(this.upf).getDbRecord("MTIME0");
            inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");    
            inq1.set("time0id", mg.empRec.getString("time0"));
            inq1.set("companyid", this.upf.get("companyid"));
            if (inq1.search()==1) {
                value = inq1.getFloat("hour_d");            
            } 
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return value;
    }
	
	public float getLvPastLimit(){
		try {
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		return grpRecBranch.getFloat("lvpastlimit");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
				return grpRec.getFloat("lvpastlimit");
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0 ;
	}
	
	/* ͹ѧԹ˹ */
	public boolean isPastLimit(CscCalendar date, String leave_amount){
		int MODE = 0; 	/* ͹ѧ */
		boolean result = false;
		try {
			float days = findLeaveDays(date.getYYYYMMDD(), leave_amount, MODE);	/* Ҩӹǹѹ͹ѧ */
			float lvpast = getLvPastLimit();
			
			/* ͹ѧԹ˹ */
			if(days > lvpast){
				result = true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	public float getBeyondLimit(){
		try {
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		return grpRecBranch.getInt("lvfuturelimit");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
				return grpRec.getInt("lvfuturelimit");
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0;
	}
	
	/* ǧ˹Թ˹ */
	public boolean isBeyondLimit(CscCalendar date, String leave_amount){
		int MODE = 1; 	/* ǧ˹ */
		boolean result = false;
		try {
			float days = findLeaveDays(date.getYYYYMMDD(), leave_amount, MODE);	/* Ҩӹǹѹǧ˹ */
			float lvfut = getBeyondLimit();
			
			/* ǧ˹Թ˹ */
			if(days > lvfut){
				result = true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	/* ͧǧ˹ҧ¡ѹ */
	public float getLvAdvPeriod(){
		try {
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		return grpRecBranch.getInt("datebeforerequest");
            		//return grpRecBranch.getInt("lvadvperiod");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
				return grpRec.getInt("datebeforerequest");
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0;
	}
	
	/* ǧ˹ҧµ˹ */
	public boolean isInAdvPeriod(CscCalendar date){
		int MODE = 1; 	/* ǧ˹ */
		boolean result = true;
		try {
			float days = date.subForDay(new CscCalendar());
			float lvadv = getLvAdvPeriod();
			
			/* ǧҧµ˹ */
			if(lvadv == 0 || days <= 0){	// ˹ ǧ˹  0 ¤ͧ
				result = false;
			}else if(days >= lvadv){	
				result = false;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	/* Ҩӹǹѹ Ѻѹش ҧҡѹѨغѹѹ Ѻ礨ӹǹѹ͹ѧ ǧ˹   mode  (0 ͹ѧ, 1 ǧ˹)*/
	public float findLeaveDays(String date, String leave_amount, int mode){
		int days = 0;    /* ӹǹѹӹǳҧҡѹѨѺѹ */
		int _BEFORE = 0; /* 0 is before current date */
		int _AFTER = 1;  /* 1 is after current date  */
		int _ERROR = 99; /* óշ͹ѧ 繡ҤѹѨغѹ 繡͹ѧ ֧絤ö (૵ӹǹѹ 99)*/
		int idxType;	 /* ͡ǧ˹ ͹ѧ 礨ҡѹ ѹѨغѹ */
		
		boolean isBefore = false;
		
		Vector vDays = new Vector(); /* ѹ Ἱѹش */
		
        CscCalendar stGenWorkingSF = null; /* ѹἹҧ */
        CscCalendar enGenWorkingSF = null; /* ѹشἹҧ */
        WorkingShift wkShf = null;
		try {
			/* ˹ҵõҧ  ҧἹ÷ӧҹ */
			String time0 = empRec.getDailyTime0id(new CscCalendar(date));
			
        	Mtime0 timeRec = (Mtime0) new InitialRecord(this.upf).getDbRecord("MTIME0");
            timeRec.set("time0id", time0); /* ʡ ͹Ҥ prop ͧ */
            timeRec.setColumn("*");
            timeRec.search();
            timeRec.setEmpRec(empRec);            
                
            /* ѹش ҧἹ÷ӧҹ ѹѨѺѹ֧ѹѹش㹡ҧἹ  */
            /*   11-11-2010 ֧ 13-11-2010 ѹѨغѹ 15-11-2010 */
            /* ҧἹѹ 13-11-2010 - 15-11-2010 */
            CscCalendar stDate = new CscCalendar(date);
            CscCalendar curDate = new CscCalendar();
            curDate.setCSCTime(0.00);
            curDate.setSecond(0);

            /* ˹ѹ ش 
             * ͹ѧ ѹ鹨ѹ ѹشѹѨغѹ
             * ǧ˹ ѹ鹨ѹѨغѹ ѹشἹѹ鹷 */
            if(stDate.afterEqualsDate(curDate)){
            	stGenWorkingSF = curDate;
               	enGenWorkingSF = stDate;
               	idxType = _AFTER;
               	isBefore = false;
            } else {
            	stGenWorkingSF = stDate;
               	enGenWorkingSF = curDate;
               	idxType = _BEFORE;
               	isBefore = true;
            }
			
            /* ҵçѺ mode  ͹䢡Ẻǡѹ  觤 mode 0 ͹ѧ 礨ҡѹ͹ѧԧ֧зӧҹ */
            if(idxType == mode){
	            /* ҧἹ */
	            wkShf = timeRec.genWorkingShift(new CscCalendar(stGenWorkingSF.getTimestamp()), new CscCalendar(enGenWorkingSF.getTimestamp())); //ѹش
	            wkShf.setUProfile(this.upf);
	            wkShf.setEmployeeid(this.empRec.getString("employeeid"));
	            wkShf.setEmpTimeCode(time0);
	            wkShf.adjust();    
	            Iterator IT = wkShf.keySet().iterator();
	
	            /* ѹἹŧ Vector */
	            while(IT.hasNext()){
	            	String dayKey = (String) IT.next();
	                DayShift dShift = (DayShift) wkShf.get(dayKey);
	                if (!dShift.isEmpty() || dShift.size()==1) {
	                	vDays.add(dayKey);
	                }
	            }
	            
	            /* ӹǳҨӹǹѹ ֧ѹѨغѹ 
	             * ҧ͹ѧ  13-11-2010 - 15-11-2010 ѹѨغѹ 18-11-2010 ӹǹѹҧҡѹѨغѹ  3 ѹ
	             * ҧǧ˹  20-11-2010 - 22-11-2010 ѹѨغѹ 18-11-2010 ӹǹѹҧҡѹѨغѹ  2 ѹ*/
	            if(idxType == _BEFORE){ /* ó͹ѧ Фӹǳѹش ֧ѹѨغѹ ѧ鹨Ѻѹ͹ѹش */
	            	/*  ͹ѧԧ ѹش¡ҵͧ͹ѹѨغѹ 礨ӹǹѹ ѺӹǹѹҧҡҧἹ 
	            	 * ӹǹѹҧҡἹ ͧҡ 
	            	 *   18-11-2010 - 21-11-2010 ѹѨغѹ 20-11-2010 
	            	 * Ἱ÷ӧҹ ١ҧѹ 18-11-2010 - 20-11-2010  3 ѹ
	            	 * ӹǹѹ 4 ѹ ҡҨӹǹѹҧҡἹ ֧ö */		 
	            	
	            	float daysCount = ((Float.parseFloat(leave_amount) == 0)?1:Float.parseFloat(leave_amount)); // ҧ¤ҵͧ 1  ( . Ҥѹ Ѻ 1 ѹ)
	            	
	            	if(daysCount <= vDays.size()){ 
		            	for(int i = 0; i < daysCount ; i++){
			            	if(vDays.size() > 0) vDays.remove(0);
		            	}
			            days = vDays.size(); 
		            }else{ /* ӹǹѹ ҡҨӹǹѹҧἹ÷ӧҹ */
		            	days = vDays.size();
		            	//days = _ERROR;
		            }
	            }else{ /* óǧ˹ͧ */
	            	/* ͹Ҥա¹͹ */
		            days = vDays.size();
	            }
            }else{
            	days = 0;
            }
		}catch(Exception e){
			MyLog.error("!! Error : Can't find leave days from tabsent_nstda !!",e);
		}
		return days;
	}
	
	/* ʶҹҾͧ  */
	public boolean isSexValid(){
		boolean result = false;
		try {
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		if (grpRecBranch.getString("sex_type").equals("1") && !empRec.getString("sex").equals("1")) {			/* к繪 ˭ԧ */
    	                return true;
    	            } else if (grpRecBranch.getString("sex_type").equals("2") && !empRec.getString("sex").equals("2")) {	/* к˭ԧ 繪 */
    	                return true;
    	            }
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
	            if (grpRec.getString("sex_type").equals("1") && !empRec.getString("sex").equals("1")) {			/* к繪 ˭ԧ */
	                return true;
	            } else if (grpRec.getString("sex_type").equals("2") && !empRec.getString("sex").equals("2")) {	/* к˭ԧ 繪 */
	                return true;
	            }
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	/* ҵͧǧ˹ ˹ */
	public boolean isRequireBeforeRequest(String date,String time){
		boolean result = false;
		try {
			CscCalendar csNow = new CscCalendar();
        	CscCalendar csStartLeave = new CscCalendar(date);
        	
			if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		if (csStartLeave.subForDay(csNow) < grpRecBranch.getFloat("datebeforerequest")) {
	            		return true;
	            	}
				}else{
					MyLog.error(" !! Can not find eventgrp : " + grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
				if (grpRec.getFloat("datebeforerequest") > 0) { 
	            	if (csStartLeave.subForDay(csNow) < grpRec.getFloat("datebeforerequest")) {
	            		return true;
	            	}
	            }
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result ;
	}
	
	/* Ǩͺاҹöѧ */
	public boolean isAllowForRequest(){
		try {
			CscCalendar today = new CscCalendar();			
            CscCalendar csc = new CscCalendar(empRec.getString("startdate"));  
            
            if(isLeaveLimitByBranch()){
            	if(initEventGrpBranch()){
            		/* need pass probation */
            		if(grpRecBranch.getString("needapprovedate").equals("1")){
            			CscCalendar appdate = empRec.getCscCalendar("approve_date");
            			
            			if(appdate.beforeEqualsDate(today)){ /* pass */
            				return true ;
            			}else{
            				return false ;
            			}
            		}else{ /* ignore probation */
            			if (csc.countDay(today) < grpRecBranch.getInt("service_year")) {
            				return false;
            			}
            		}
				}else{
					MyLog.error(" !! Can not find eventgrp : " + this.grpRec.getString("eventgrpid") + " by branch : " + this.empRec.getString("branch"));
				}
            }else{
	            if (csc.countDay(today) < grpRec.getInt("service_year")) {
	        		return false;
	            }
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return true;
	}
	
	/* 礨ӹǹ駡â */
	public boolean isOverLimitRequest(String eventgrp){
		boolean result = false;
		try {
			if(isLeaveLimitByBranch()){	/* ԷԡҵҢ */
				if(initEventGrpBranch()){
					if (grpRecBranch.getInt("limit_times") >0 && grpRecBranch.getInt("limit_times") <= getAmountLeaveUsed(eventgrp)) {
		           		return true;
		            }
				}else{
					MyLog.error(" !! Can not find eventgrp : " + eventgrp + " by branch : " + this.empRec.getString("branch"));
				}
			}else{
				if (grpRec.getInt("limit_times") >0 && grpRec.getInt("limit_times") <= getAmountLeaveUsed(eventgrp)) {
	           		return true;
	            }
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	public String getPrvEventDesc(){
		String desc = "";
		String event = "";
		try {
			if(isLeaveLimitByBranch()){	/* ԷԡҵҢ */
				if(initEventGrpBranch()){
					 event = grpRecBranch.getString("privilege_event");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + this.getEventGrp() + " by branch : " + this.empRec.getString("branch"));
				}
			}else{
				event = grpRec.getString("privilege_event");
			}
			
			if(!event.equals("")){
				DbRecord db = new InitialRecord(this.upf).getDbRecord("Meventgrp");
				db.setColumn("eventgrpid,tdesc,edesc");
				db.set("eventgrpid", event);
				db.set("companyid", this.upf.getComCode());
				if(db.search() == 1){
					if(((String)this.upf.get("lang")).equals("tha")){
						desc = db.getString("tdesc");
					}else{
						desc = db.getString("edesc");
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return desc;
	}
	
	public String getPrvEvent(){
		try {
			if(isLeaveLimitByBranch()){	/* ԷԡҵҢ */
				if(initEventGrpBranch()){
					return grpRecBranch.getString("privilege_event");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + this.getEventGrp() + " by branch : " + this.empRec.getString("branch"));
				}
			}else{
				return grpRec.getString("privilege_event");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	public String getEventDayType(){
		try {
			if(isLeaveLimitByBranch()){	/* ԷԡҵҢ */
				if(initEventGrpBranch()){
					return grpRecBranch.getString("daytype");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + this.getEventGrp() + " by branch : " + this.empRec.getString("branch"));
				}
			}else{
				return grpRec.getString("daytype");
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	/* 礡ҷǢͧѹ Ҩ繵ͧ͹һ */
	public boolean isRequireEvent(){
		boolean result = false;
		try {
			String prv_event = getPrvEvent();
			
			if(prv_event != null && !prv_event.equals("")){
				ManageEmpLeaveStat mels = new ManageEmpLeaveStat(this.upf, empRec.getString("employeeid"), prv_event);
	            String remain = mels.getRemainLeave(prv_event);
	            
	            if(remain.equals("00:00:00")) {	/* ʹ͡ */
	            	result = true;
	            }else{
	            	return false;
	            }
			}else{
				return true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	public boolean isLeaveLimitByBranch(){
		boolean result = false;
		try {
			String stat =  (String) StaticConfig.getConfigCompany(this.upf, "TALVSET");
			if(stat != null && stat.equals("Y")){
				result = true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result ;
	}
	
	/* ֧ͿŴ¡ѹ */
	private String getLeaveBranchField(){
		String fld = "";
		try {
			fld = (String) StaticConfig.getConfigCompany(this.upf, "TALVFD");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return fld ;
	}
	
	public boolean initEventGrpBranch(){
		try {
			if(this.grpRecBranch == null || 
					(this.grpRec.getString("eventgrpid").equals(this.grpRecBranch.getString("eventgrp")) && 
							this.grpRec.getString("branch").equals(getFieldBranchValue()))) {
				
				grpRecBranch = new InitialRecord(this.upf).getDbRecord("Meventgrp1");
				grpRecBranch.setColumn("*");
				grpRecBranch.set("eventgrpid", this.getEventGrp());
				grpRecBranch.set("companyid", (String) this.upf.get("companyid"));
				grpRecBranch.set("branchid", this.empRec.getString(getLeaveBranchField()));
				
				if(grpRecBranch.search() == 1){
					return true;
				}else{
					return false;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
			return false;
		}
		return true;
	}
	
	/* ֧Էԡ˹ѹ */
	public int getLimitByBranch(){
		int rtn = 0;
		try {
			if(initEventGrpBranch()){
				if(grpRecBranch.getString("sharelimit_event").equals("")){
					if(getFixFeneralLeave().equals(this.getEventGrp())){	
						rtn = getFuneralLeaveByMfamily();
					}else{	/* óջ ͧӹǳҡ㹤ͺǷʶҹªԵ */
						rtn = grpRecBranch.getInt("limit");
					}
				}else{
					if(getFixFeneralLeave().equals(this.getEventGrp())){	
						rtn = getFuneralLeaveByMfamily();
					}else{	/* óջ ͧӹǳҡ㹤ͺǷʶҹªԵ */
						DbRecord db = new InitialRecord(this.upf).getDbRecord("Meventgrp1");
						db.setColumn("*");
						db.set("eventgrpid", grpRecBranch.getString("sharelimit_event"));
						db.set("companyid", (String) this.upf.get("companyid"));
						db.set("branchid", grpRecBranch.getString("branchid"));
						if(db.search() == 1){
							rtn = db.getInt("limit");
						}
					}
					
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return rtn;
	}
	
	/* ੾ Nissan Ǩͺ㹤ͺǷʶҹªԵ͹ ͹Ҥӹǳ ԷԷö */
	private String getFixFeneralLeave(){
		try {
			String code =  (String) StaticConfig.getConfigCompany(this.upf, "TAFNLCODE");	/* ҧҹȾ*/
			if(code != null && !code.equals("")){
				return code;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	/* ੾ Nissan Ǩͺ㹤ͺǷʶҹªԵ͹ ͹Ҥӹǳ ԷԷö */
	private int getFuneralLeaveByMfamily(){
		int limit = 0;
		try {
			float hour_d = getHour_Day(this);
			CscCalendar lastdate = new CscCalendar();	/* ѹªԵشͧ㹤ͺ */
			limit = getCountPassAwayFamilay() * 5 ;	/* ԷԷѺ͹ѧ 120 ѹ */
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return limit ;
	}
	
	/* ֧ӹǹ㹤ͺǷªԵ */
	private int getCountPassAwayFamilay(){
		int MAXPASTDATE = 120 ;	/* ͹ѧ 120 ѹ */
		int count = 0;
		try {
			HashMap keydate = new HashMap();
			CscCalendar cs = new CscCalendar();
			cs.decDate(MAXPASTDATE);
			
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry("MEMPL_FAMILY");
			inq.setColumn("employeeid,companyid,relationid,line_no,pass_away_date");
			inq.setFilter("status = '0' and employeeid = '"+ this.getEmployeeid() +"' and pass_away_date >= '" + cs.getYYYYMMDD() + "' and relationid in ('01','02','03','04','09','10','11','12','13','14','15') ");	/* ѹẺ  (99)*/
			inq.setOrderBy("pass_away_date desc");
			inq.refresh();
			
			while(inq.next()){
				if(!keydate.containsKey(inq.getString("pass_away_date"))){
					keydate.put(inq.getString("pass_away_date"), "");
					count++;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return count ;
	}
	
	/* ѹªԵͧ㹤ͺش */
	private CscCalendar getLastPassAwayMfamily(){
		CscCalendar cs = new CscCalendar();
		try {
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry("MEMPL_FAMILY");
			inq.setColumn("employeeid,companyid,relationid,line_no,pass_away_date");
			inq.setFilter("pass_away_date >= '" + cs.getYYYYMMDD() + "' and relationid != '99' ");	/* ѹẺ  (99)*/
			inq.setOrderBy("pass_away_date desc");
			inq.refresh();
			
			while(inq.next()){
				cs = new CscCalendar(inq.getString("pass_away_date"));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return cs ;
	}
	
	/* ֧ӹǹѹҬһԨ 觤ҡѺ繹ҷ */
	private float getHisFuneralLeave(){
		CscTime sumlv = new CscTime();
		try {
			CscCalendar lastdate = getLastPassAwayMfamily();	/* ѹªԵشͧ㹤ͺ*/
			
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry("Tleave_summary");
			inq.setColumn("employeeid,companyid,dateid,m_lv,hour_s");
			inq.setFilter("dateid >= '" + lastdate.getYYYYMMDD() + "' and lv_type = '"+ this.getEventGrp() +"' ");	
			inq.setOrderBy("dateid desc");
			inq.refresh();
			
			while(inq.next()){
				sumlv.add(Float.parseFloat(inq.getString("m_lv")));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sumlv.getFloat();
	}
	
	/* ֧Էԡ˹ . */
	public String getLimitHoursByBranch(){
		String rtn = "00:00";
		DecimalFormat df = new DecimalFormat("00.00");
		try {
			if(initEventGrpBranch()){
				rtn = df.format(Double.parseDouble(grpRecBranch.getString("limit_hours"))).replace(".", ":");
			}
		}catch(Exception e){
			MyLog.error("Time output is not in format ##:##, system will change value to 00:00 automatically !! ");
			//MyLog.error(this,e);
		}
		return rtn;
	}
	
	public int getLimitAmountByBranch(){
		int rtn = 0;
		try {
			if(initEventGrpBranch()){
				rtn = grpRecBranch.getInt("limit_times");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return rtn;
	}
	
	/* ͡ŴҢҨҡ Ŵ branch ͨҡ branchid  ҧ memployee */
	private String getFieldBranchValue(){
		String fld = "";
		try {
			fld =  (String) StaticConfig.getConfigCompany(this.upf, "TALVFD");
			
			if(fld != null){
				this.empRec.getString(fld);
			}else{
				this.empRec.getString("branch");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return fld ;
	}
	
	/* ֧ʻѴ .  */
	public String getRoundingCode(){
		try {
			if(isLeaveLimitByBranch()){	/* ԷԡҵҢ */
				if(initEventGrpBranch()){
					return grpRecBranch.getString("leaverounding");
				}else{
					MyLog.error(" !! Can not find eventgrp : " + this.getEventGrp() + " by branch : " + this.empRec.getString("branch"));
				}
			}else{
				return grpRec.getString("leaverounding");
			}
		}catch(Exception e){
			MyLog.error("Rounding not found for eventgrp " + this.getEventGrp());
			MyLog.error(this,e);
		}
		return "";
	}
	
	/* Ѵ .  */
	public float getRoudingValue(double value) {
		float result = (float) value;
		try {
			String code = getRoundingCode();
			
			if(!code.equals("")){
				RoundingTime rt = new RoundingTime(code, value);
				rt.setUProfile(this.upf);
				result = (float) rt.getRounding();		
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return result;
	}
	
	/* ֧ʹѡ͹ ǧö͡¡  */
	public String getAnnualLeaveOnV0Period(String eventgrp){
		String lv = "00:00:00";
		try {
            CscTime lv_hour = new CscTime();
			
			DbInquiry leave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			leave.setColumn("*");
			leave.setFilter("employeeid = '" + this.empRec.getString("employeeid") 
					+ "' and dateid between '" + normalLeaveStart.getYYYYMMDD() 
					+ "' and '"+ getVacationLast().getYYYYMMDD() +"'" 
					+ " and lv_type = '" + eventgrp + "'");
			leave.refresh();
			
			used_count = leave.recCount();
			while(leave.next()){
				lv_hour.add(Float.parseFloat(leave.getString("m_lv")));
			}
			
			DHMConvert dhm = new DHMConvert();
			float hour_d = getHour_Day(this);
			int minV0 = dhm.DHMToMin(this.empRec.getString("vacation0"), Float.toString(hour_d));
			int usedOnV0 = (lv_hour.getHour() * 60) + lv_hour.getMinute();
			
			// if used on v0 period less than v0 then set v0 = used 
			if(usedOnV0 < minV0){
				dhm = new DHMConvert(lv_hour.getFloat(), getHour_Day(this));
				lv = dhm.parseDHM();
			}else{
				lv = this.empRec.getString("vacation0");
			}
			
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return lv;
	}
	
	/* get date config from mconfig */
	/* 
	 * ҧ 
	 * էҳ 01-11 ---------------------------- 31-10
	 * ѹ 04-12-2012 (ǧ˹ էҳ˹)
	 * ˹ ͹Ѻѹ  01-11-2012 ----------------------- 31-10-2012
	 * 		ѹشէҳ¡ʴ繤 ˹ 01-11-2011 ------------------- 31-10-2012
	 * ººѹ㹪ǧէҳ   04-12-2012 ҡ 31-10-2012 ѧͧѺէҳѹ
	 * 		 01-11-2012 -------------------- 31-10-2013 ѹǨ㹻ǡѺѹ
	 */
	private void initialDateConfig(ManageEmpLeaveStat mel){
		try {
			/* ҷ */
			normalLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));	/* ѹ鹻էҳ */
            normalLeaveEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1002"));	/* ѹشէҳ */
			
            /* Ҿѡ͹ */
            vacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));	/* ѹ鹻էҳ */
            vacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));		/* ѹشէҳ */
            
            /* ҪǧէҳẺ  ش㹻ǡѹ ˹˹»ѹش١ͧ */
            normalLeaveStart.setYear(this.reqdate_st.getYear());
            normalLeaveEnd.setYear(this.reqdate_st.getYear());
            
            vacationStart.setYear(this.reqdate_st.getYear());
            vacationEnd.setYear(this.reqdate_st.getYear());
            
            /* ҡ˹բͧѹ Ѻ ѹ ش ͧէҳ ѹش¡ ѹʴһէҳẺ */
            if(normalLeaveEnd.beforeDate(normalLeaveStart)){
            	normalLeaveStart.decYear(1);
            }
            
            /* ѹ 繡ҢͧնѴѺէҳçѺѹ */
        	if(this.reqdate_st.afterDate(normalLeaveEnd)){
        		normalLeaveStart.incYear(1);
        		normalLeaveEnd.incYear(1);
        	}
            
            if(vacationEnd.beforeDate(vacationStart)){
            	vacationStart.decYear(1);
            }
            
            /* ѹ 繡ҢͧնѴѺէҳçѺѹ */
        	if(this.reqdate_st.afterDate(vacationEnd)){
        		vacationStart.incYear(1);
        		vacationEnd.incYear(1);
        	}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/* check today is in budget period */
	private boolean isCurDateInCurYear(){
		try {
			CscCalendar today = new CscCalendar();
			if(today.afterEqualsDate(normalLeaveStart) && today.beforeEqualsDate(normalLeaveEnd)){
				return true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* 礡 . 鹵 ҹ¡ҡ˹Ң鹵 */
	public float chkMinHourReq(float hour){
		try {
			if(grpRec.getFloat("min_limit_hours") > hour){
				return grpRec.getFloat("min_limit_hours") ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return hour ;
	}
}
