package com.csc.library.timeattendance;

import com.csc.library.utilities.CscCalendar;

public class MyTimeZone extends TimeZone1 {

	private CscCalendar m_bg = null;
	private CscCalendar m_en = null;
	
	public MyTimeZone() {
		super.clear();
	}
	
	public MyTimeZone(CscCalendar st , CscCalendar en){
		super.clear();
		super.setBeginZone(st);
		super.setEndZone(en);
	}
	
	public void setDateTimeIn(CscCalendar dtin){
		this.m_bg = dtin;
	}
	
	public void setDateTimeOut(CscCalendar dtout){
		this.m_en = dtout;
	}
	
	public CscCalendar getDateTimeIn(){
		return this.m_bg;
	}
	
	public CscCalendar getDateTimeOut(){
		return this.m_en;
	}
	
	public void ClearTime(){
		this.m_bg = null;
		this.m_en = null;
	}
	
	public float getDiffTimeZone(){
		return this.getEndZone().subForHour(this.getBeginZone());
	}
	
	public float getDiffIntersectZone(TimeZone1 tz){
		PropertiesTimeZone prop = null;
		return this.getDiffIntersectZone(tz, prop);
	}
	
	public float getDiffIntersectZone(TimeZone1 tz , PropertiesTimeZone prop){
		boolean bgin = this.inZone(tz.getBeginZone()) , enin = this.inZone(tz.getEndZone());
		CscCalendar st = null , en = null;
		if( bgin && enin ){
			st = tz.getBeginZone();
			en = tz.getEndZone();
		}else if( bgin ){
			st = tz.getBeginZone();
			en = this.getEndZone();
		}else if( enin ){
			st = this.getBeginZone();
			en = tz.getEndZone();
		}else{
			boolean vbgin = tz.inZone(this.getBeginZone()) , venin = tz.inZone(this.getEndZone());
			if( vbgin && venin ){
				st = this.getBeginZone();
				en = this.getEndZone();
			}else if( vbgin ){
				st = this.getBeginZone();
				en = tz.getEndZone();
			}else if( venin ){
				st = tz.getBeginZone();
				en = this.getEndZone();
			}else{
				return 0;
			}
		}
			
		if( prop != null ){
			prop.setTimeZone( st , en );
		}
		return en.subForHour(st);
	}
	
}
