package com.csc.library.timeattendance;

import java.text.DecimalFormat;
import java.util.Hashtable;

import std.library.DataTable;
import std.library.TimeSpan;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.UProfile;

/**
 *@author _NUISS
 *@since 29/07/2552
 *@see ӹǹ OT  ѡ 
 *<br>mtime0.breaktype =="0"
 */
public class OTBreak {
	private boolean isError = false;
	private UProfile userProFile = null;
	private String employeeId =null;
	private String time0Id =null;
	
	private String stDateBreak =null;
	private double stTimeBreak =0.0d;
	private String endDateBreak=null;
	private double endTimeBreak=0.0d;
	
	private String dateSwipeOut=null;
	private double timeSwipeOut=0.0d;
 	
	private Hashtable hsOTBVar = null;
	private double otbHour= 0.0d;
	
	public OTBreak(UProfile userProFile,String employeeid ,String time0Id 
			, String stDateBreak, float stTimeBreak
			, String endDateBreak, float endTimeBreak
			, String dateSwipeOut, float timeSwipeOut){
		// TODO Auto-generated constructor stub
		this.isError = false;
		this.userProFile =userProFile;
		this.employeeId =employeeid;
		this.time0Id =time0Id;
		this.stDateBreak =stDateBreak;
		this.stTimeBreak =stTimeBreak;
		this.endDateBreak =endDateBreak;
		this.endTimeBreak =endTimeBreak;

		this.dateSwipeOut =dateSwipeOut;
		this.timeSwipeOut =timeSwipeOut;
	}//end constructor

	public double calulateOTBreak(){
		this.getOtBreakVar();	
		this.findSwipeAtBreakTime();
		return this.otbHour;
	}//end method calulateOTBreak
	
	private void getOtBreakVar(){
		DecimalFormat dc = new DecimalFormat();
		dc.applyPattern("#0.00");
		this.hsOTBVar = new Hashtable();
		TimeSpan tsZoneIn = new TimeSpan();
		TimeSpan tsZoneOut = new TimeSpan();
		try{
			DbInquiry inqMtime0= new InitialInquiry(this.userProFile).getDbInquiry();		
			inqMtime0.initMyTable("MTIME0", "breaktype='0' and time0id ='"+this.time0Id+"' ", "");
			inqMtime0.setColumn("TIME0ID,COMPANYID,TDESC,MINOTBREAK" +
					",MAXOTBREAK,BZIN,BZOUT");
			inqMtime0.refresh();
			if(inqMtime0.next()){
				this.hsOTBVar.put("MINOTBREAK", inqMtime0.getString("MINOTBREAK"));
				this.hsOTBVar.put("MAXOTBREAK", inqMtime0.getString("MAXOTBREAK"));
				this.hsOTBVar.put("BZIN", inqMtime0.getString("BZIN"));
				this.hsOTBVar.put("BZOUT", inqMtime0.getString("BZOUT"));
				//ZoneIn
				tsZoneIn.setSignSeperateOfDate("-");
				tsZoneIn.cnvrtToTimeSpan(this.stDateBreak,this.stTimeBreak);
				tsZoneIn =tsZoneIn.timeSubtract(tsZoneIn, Double.valueOf(inqMtime0.getString("BZIN")));
				this.hsOTBVar.put("DTZIN",tsZoneIn);
				//ZoneOut
				tsZoneOut.setSignSeperateOfDate("-");
				tsZoneOut.cnvrtToTimeSpan(this.endDateBreak,this.endTimeBreak);
				tsZoneOut =tsZoneOut.timeAdd(tsZoneOut, Double.valueOf(inqMtime0.getString("BZOUT")));
				this.hsOTBVar.put("DTZOUT",tsZoneOut);
			}else{
				this.isError = true;
			}//end if
		}catch(Exception ex){
			System.out.print("Error on OTBreak.getOtBreakVar()...");
			this.isError = true;
		}//end try
	}//end method getOtBreakVar

	private void findSwipeAtBreakTime(){ 
		if(this.isError==true){
			return ;
		}//end if 
		TimeSpan dateStart =(TimeSpan)this.hsOTBVar.get("DTZIN");
		dateStart.setSignSeperateOfDate("-");
		TimeSpan dateEnd =(TimeSpan)this.hsOTBVar.get("DTZOUT");
		dateEnd.setSignSeperateOfDate("-");
		try{
			DbInquiry inqSWT= new InitialInquiry(this.userProFile).getDbInquiry();		
			inqSWT.initMyTable("TTIMETEMP"
					, "EMPLOYEEID='"+this.employeeId+"' "+
					  " AND SWIPEDATE >='"+dateStart.getCurDate()+"'"+
					  " AND SWIPEDATE <='"+dateEnd.getCurDate()+"'" +
					  " AND SWIPETIME >="+dateStart.getHourOfDay()+"." +dateStart.getMinute()+
					  " AND SWIPETIME <="+dateEnd.getHourOfDay()+"." +dateEnd.getMinute()
					  , "EMPLOYEEID ASC,SWIPEDATE ASC,SWIPETIME ASC");
			inqSWT.setColumn("COMPANYID,EMPLOYEEID,SWIPEDATE,SWIPETIME");
			inqSWT.refresh();
			int item = 0 ;
			TimeSpan breakStart = new TimeSpan();
			TimeSpan breakEnd = new TimeSpan();
			TimeSpan dateTimeSwipeOut = new TimeSpan();
			dateTimeSwipeOut.setSignSeperateOfDate("-");
			dateTimeSwipeOut.cnvrtToTimeSpan(this.dateSwipeOut, this.timeSwipeOut);
			String[] columnName = {"SWIPEDATE","SWIPETIME"};
			String[] columnType ={"varchar","varchar"};
			DataTable dtbSwipeData = new DataTable(columnName,columnType);
			//ͧաٴѵ㹪ǧ break ҧ 2 
			if(inqSWT.recCount()>=2){
				while(inqSWT.next()){
					item++;
					String swipeDate = inqSWT.getString("SWIPEDATE");
					String swipeTime = inqSWT.getString("SWIPETIME").replace(".", ":");
					
					//storage swipeDate ,swipeTime
					dtbSwipeData.insertRow(1);
					dtbSwipeData.setItem(dtbSwipeData.rowCount(), columnName[0], swipeDate);
					dtbSwipeData.setItem(dtbSwipeData.rowCount(), columnName[1], swipeTime);
					//ҷշش 2 
					if(item==1){
						breakStart.setSignSeperateOfDate("-");
						breakStart.cnvrtToTimeSpan(swipeDate, swipeTime);
					}else{
						breakEnd.setSignSeperateOfDate("-");
						breakEnd.cnvrtToTimeSpan(swipeDate, swipeTime);
						/**
						 * ٴѵҾѡѹ >= ҷٴ͡ ͧл (¡ǧ break Ѻ ҷӧҹ ͡ҡѹ logic)
						 *  ҧҹ 8.00-17.00 ѡ 12.00-13.00
						 * 
						 * Case Study:
						 * աٴ 8.00,12.01,12.51,13.00
						 * ͧ ٴ 13.00 繡ٴͧ͡л 
						 *  ٴ 12.01 ,12.51 繡ٴ -͡ ͧѡ 
						 *   ٴ ͡  17.01  ͧ  13.00 ͡ٴͧ͡ѡ§
						 * 
						 * Case Study:
						 * աٴ 8.00,12.01,13.00
						 * ͧ ٴ 13.00 繡ٴͧ͡л 
						 *  ٴ 12.01 繡ٴ աٴͧ͡ѡ
						 */
						int cmprValue =breakEnd.compareDateTime(breakEnd, dateTimeSwipeOut);
						if(cmprValue>=0){
							// ٴѵèҡ Row ͹˹ҹ  ش
							breakEnd.cnvrtToTimeSpan(dtbSwipeData.getItemString((item-1), columnName[0])
							                                         ,dtbSwipeData.getItemString((item-1), columnName[1]));
							break;
						}//end if
					}//end if 
				}//end while
		
				TimeSpan ts = new TimeSpan();
				double breakTime = ts.timeDiff(breakStart, breakEnd);
				double minOtBreak = Double.valueOf((String) this.hsOTBVar.get("MINOTBREAK"));
				double maxOtBreak = Double.valueOf((String) this.hsOTBVar.get("MAXOTBREAK"));
				if(breakTime<minOtBreak){
					this.otbHour  =0.0d;
				}else if ((breakTime>minOtBreak) && (breakTime<maxOtBreak)){
					this.otbHour =breakTime;
				}else if (breakTime>maxOtBreak){
					this.otbHour =maxOtBreak;
				}//end if
			}//end if 
		}catch(Exception ex){
			System.out.print("Error on OTBreak.findSwipeAtBreakTime()...");
			this.isError = true;
		}//end try
	}//end method findSwipeAtBreakTime
	
}//end class OTBreak
