package com.csc.library.timeattendance;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Tabsent_nstda;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ReAdjustAlignment {
	
		private String strEmp;
		private String strDate;
		private String endDate;
		private UProfile upf;
		private HashMap param;
		
		public ReAdjustAlignment(){
			
		}
		
		public void setParam(HashMap param){
			this.param = param;
		}
		
		private void setEmp(String emp){
			this.strEmp = emp;
		}
		
		private void setStartDate(String startDate){
			this.strDate = startDate;
		}

		private void setEndDate(String endDate){
			this.endDate = endDate;
		}

		private void setUProfile(UProfile upf){
			if(upf != null){
				this.upf = upf;
			} else {
				MyLog.debug("!! Uprofile is null in ReAdjustAlignment.setUProfile() !!"); 
			}
		}
		
		public void setProp(String emp,String startDate,String endDate,UProfile upf) {
			this.setEmp(emp);
			this.setStartDate(startDate);
			this.setEndDate(endDate);
			this.setUProfile(upf);
		}
		
		/* ֧Ҩҡ TABSENT_NSTDA  SAVE ա Adjust  Flow ͧк */
		private void reAdjAbsent(){ 
			StringBuffer filter = new StringBuffer();
            DbInquiry inq = null;
			try{
				/* ź Tadjtime0 ͧѹ ҧἹ ѹ */
				//this.removeOldAdjust();
				
				/* ҧ͹䢡ä ´֧੾͡÷ʶҹҹԧҹ  wf_status = '6' ( HR) ,'4' (͹ѵ) */
				filter.append("employeeid = '").append(this.strEmp).append("' ");
				filter.append("and start_date >= '").append(this.strDate).append("' ");
				filter.append("and end_date <= '").append(this.endDate).append("' ");
				filter.append("and wf_status in ('6','4')");

				inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setSchemaName(this.upf.getSchemaName());
	            inq.initMyTable("Tabsent_nstda", filter.toString(), "");
	            inq.setColumn("*");
	            inq.setOrderBy("start_time,end_time");
	            inq.refresh();
	            while (inq.next()) {
	                Tabsent_nstda rec = (Tabsent_nstda) inq.getCurrentDbRecord();
	                rec.setParam(this.param);
	                //rec.delDataAdjTime0(); /* ź Tadjtime0 ͹ШѴἹ  */
	                rec.genRecord(true); /* ѴἹ */
	            }
            } catch(Exception ex) {
            	MyLog.error("!! Error in ReAdjustAlignment.setAbsentList !!");
            } finally {
            	try {
            		inq.closeConnection();
            	} catch(Exception e) {
            		MyLog.error("!! Error : can't close inq in ReAdjustAlignment.setAbsentList() !!");
            	}
            }
		}
		
		/**
		 *  ź Tadjtime0 ͹ ҧ
		 *  ˵ؼŷ MyInquiry ֧Ţ͹  rec.delete 
		 *  ͧҡͧ价㹢鹵͹ PreDelete or PostDelete Trigger
		 *  Ҩ觼ŷԴ infinite recursive 
		 **/
		private void removeOldAdjust(){
			PreparedStatement stm = null;
			CscConnection con = null;
			StringBuffer sql = new StringBuffer();
	    	boolean autoCommit=true;
			
			try {
				sql.append("delete tadjtime0 where employeeid = '").append(this.strEmp).append("' ");
				sql.append("and docdate <= '").append(this.strDate).append("' ");
				sql.append("and docdate >= '").append(this.endDate).append("' ");
				sql.append("and doctype = 'A'");
				
				con = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(), this.upf);
				autoCommit = con.getAutoCommit();
				con.setAutoCommit(false);
				con.setTransactionIsolation(con.TRANSACTION_READ_UNCOMMITTED);

				stm = con.prepareStatement(sql.toString());
				stm.executeUpdate();
				
				con.commit();
			} catch (SQLException e) {
				MyLog.error("!! Error in ReAdjustAlignment.removeOldAdjust, can't delete record in TADJTIME0 !!");
				MyLog.error(this,e);
			}
			finally {
				try {
				    if(stm!=null){
				      stm.close();
				    }
		    		if(con!=null){
		    			con.setAutoCommit(autoCommit);
		    			con.close();
		    		}
				} catch (SQLException e1) {
					MyLog.error("!! Error in ReAdjustAlignment.removeOldAdjust, can't close connection !!");
				}
			}
		}
		
		public void reAdjust(){
			this.removeOldAdjust();
			this.reAdjAbsent();
		}
}
