package com.csc.library.timeattendance;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.SortedMap;
import java.util.Vector;

import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeinterface.SwipeRecord;
import com.csc.library.timeinterface.SwipeTrans;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

/*
 * Ѻ ҧŴšٴѵâͧѡҹ
 */
public class SwipeData implements SwipeTrans {

	private MyTreeMap newReserve = new MyTreeMap();
	private MyTreeMap keyDate = new MyTreeMap();
	private MyTreeMap keyRecordNo = new MyTreeMap();
	private MyTreeMap keyReserveCode = new MyTreeMap();
	private Vector tminList = new Vector();
	private Vector tmoutList = new Vector();
	private TimeZone tminNear = new TimeZone();
	private TimeZone tmoutNear = new TimeZone();
	private UProfile up;
	private long minRecordNo = 999999999; 
	private long maxRecordNo = 0;
	private String empRecID="";
	
	private DbInquiry inqSwipeTime = null;
	private DbInquiry inqEmp = null;
	private DbRecord recReserve = null;
	private float timesLength = 0;
	
	private String isNarrow="";
	private boolean isUseSwipeType = false;	/* flag ¡ٴ ٴ͡㹡èѺ */
	private boolean is2loop = false;		/* flag ͺͧ ͺá */
	
	private MyTreeMap keyDateIn = new MyTreeMap();		/* ੾ٴ 01 */
	private MyTreeMap keyDateOut = new MyTreeMap();		/* ੾ٴ͡ 04 */
	private MyTreeMap keyRecordNoIn = new MyTreeMap();
	private MyTreeMap keyRecordNoOut = new MyTreeMap();
	
	private Shift cur = null;				/* лѨغѹѧӧҹ */
	/*
	 * ҧŷ
	 */
	public void clear(){
		this.minRecordNo = 999999999;
		this.maxRecordNo = 0;
		this.newReserve.clear();
		this.keyDate.clear();
		this.keyRecordNo.clear();
		this.keyReserveCode.clear();
		this.tminList.clear();
		this.tmoutList.clear();
	}
	
	public void setTimesLength(float times) {
		this.timesLength = times;
	}
	
	/**
	 * @author _NUISS
	 * @since 24/03/2009
	 * @return
	 * 		-all swipe data
	 */
	public Hashtable getkeyRecordNo(){
		Hashtable hsTbl = new Hashtable();
		String keys = "";
		float values = 0f;
		
		try{
			Iterator it = this.keyDate.keySet().iterator();
			while (it.hasNext()) {
				keys = ((SwipeRecord) this.keyDate.get((String) it.next())).getDate().getYYYYMMDD();
				values = ((SwipeRecord) this.keyDate.get((String) it.next())).getTime();
				if(hsTbl.containsKey(keys)){
					 String oldValues = String.valueOf(hsTbl.get(keys));
					 hsTbl.put(keys, oldValues+","+String.valueOf(values));
				}else{
					hsTbl.put(keys, String.valueOf(values));
				}//end if 
			}//end while
		}catch(Exception ex){
	  		 System.out.print(">>>> PROCESS BY NUISS ERROR in SwipeData.getkeyRecordNo() "+ ex.getStackTrace().toString() + "<<<<");
		}//end try 
		
		return hsTbl;
	}//end method getkeyRecordNo
		
public long findTimeIn(TimeZone tz) { //ҡٴѵáش
		
		long result = 0;
		CscCalendar beg, end;
		SwipeRecord SR, SR1;
		this.tminList.clear();
		this.tminNear = new TimeZone();
		
		setFlagFindTimeMethod(); 	/* flag èѺ N Ѻҧ, Y Ѻ᤺ */
		setFlagUseSwipeType();
		
		beg = new CscCalendar(tz.getBeginZone().getTimeInMillis());
		end = new CscCalendar(tz.getEndZone().getTimeInMillis());
		end.incMinute();
		if (this.timesLength>0) {
			end.decTime(this.timesLength);
		}
		
		SortedMap SM;
		try {
			SM = this.getKeyDateSwipeIn().subMap(beg.getYYYYMMDDHHMMSS(), end.getYYYYMMDDHHMMSS());
		} catch (Exception e) {
			SM = new MyTreeMap();
		}
		
		SortedMap head = this.getKeyDateSwipeIn().headMap(beg.getYYYYMMDDHHMMSS());
		if (head.size() > 0l) {
			SR1 = (SwipeRecord) this.getKeyDateSwipeIn().get(head.lastKey());
			tminNear.setBeginZone(SR1.getDate());
		} else {
			tminNear.setBeginZone(new CscCalendar("1900-01-01 00:00:00"));
		}

		SortedMap tail = this.getKeyDateSwipeIn().tailMap(end.getYYYYMMDDHHMMSS());
		if (tail.size() > 0) {
			SR1 = (SwipeRecord) this.getKeyDateSwipeIn().get(tail.firstKey());
			tminNear.setEndZone(SR1.getDate());
		} else {
			tminNear.setEndZone(new CscCalendar("2900-01-01 00:00:00"));
		}

		if (SM.size() > 0) {
			if (this.isNarrow.equals("N")) { 
				SR = (SwipeRecord) this.keyDate.get(SM.firstKey());
				if (SM.size() == 1) {
					result = SR.getRecordNo();
					//tminList.add(SR.getStringRecordNo()); ----> is Record found
				} else {
					Iterator it = SM.keySet().iterator();
					SwipeRecord srtmp = SR;
					
					while (it.hasNext()) {
						String st = (String) it.next();
						
						SR1 = (SwipeRecord) this.getKeyDateSwipeIn().get(st);
						tminList.add(SR1.getStringRecordNo());
						//if (SR1.getDate().subForDecimal(SR.getDate()) <= 4){
						if (SR1.getDate().subForDecimal(SR.getDate()) <= 4 && SR1.getDate().beforeEqualsDateTime(this.getCurShift().get_c_dt_in())) {
							srtmp = SR1;
							break;	/* ͡ҷ㹪ǧáش */
						}else{
							break;
						}
					}
					result = srtmp.getRecordNo();
					/*
					SR1 = (SwipeRecord) this.keyDate.get(SM.lastKey());
					if (SR1.getDate().subForDecimal(SR.getDate()) <= 4) {
						result = SR.getRecordNo();
					} else {
						result = -1; // ӹǹҷٴ¤ ҧѹҡ 1 
					}*/
				}
			} else { // ٻʴҵͧҷش (this.isNarrow = "Y") Kom modified 06-05-2010
				result = ((SwipeRecord) this.getKeyDateSwipeIn().get(SM.lastKey())).getRecordNo();
			}
		} else {
			result = 0; // 
		}
		return result;
	}

	public long findTimeOut(TimeZone tz) { //ҡٴѵ÷ش
		long result = 0;
		CscCalendar beg, end;
		SwipeRecord SR, SR1;
		this.tmoutList.clear();
		this.tmoutNear = new TimeZone();
		
		setFlagFindTimeMethod(); 	/* flag èѺ N Ѻҧ, Y Ѻ᤺ */
		setFlagUseSwipeType();		/* flag ŵٴ ͡  */
	
		beg = new CscCalendar(tz.getBeginZone().getTimeInMillis());
		end = new CscCalendar(tz.getEndZone().getTimeInMillis());
		end.incMinute();
		if (this.timesLength>0) {
			beg.incTime(this.timesLength);
		}
		SortedMap SM;
		try {
			SM = this.getKeyDateSwipeOut().subMap(beg.getYYYYMMDDHHMMSS(), end.getYYYYMMDDHHMMSS());
		} catch (Exception e) {
			SM = new MyTreeMap();
		}
	
		SortedMap head = this.getKeyDateSwipeOut().headMap(beg.getYYYYMMDDHHMMSS());
		if (head.size() > 0l) {
			SR1 = (SwipeRecord) this.getKeyDateSwipeOut().get(head.lastKey());
			tmoutNear.setBeginZone(SR1.getDate());
		} else {
			tmoutNear.setBeginZone(new CscCalendar("1900-01-01 00:00:00"));
		}
	
		SortedMap tail = this.getKeyDateSwipeOut().tailMap(end.getYYYYMMDDHHMMSS());
		if (tail.size() > 0) {
			SR1 = (SwipeRecord) this.getKeyDateSwipeOut().get(tail.firstKey());
			tmoutNear.setEndZone(SR1.getDate());
		} else {
			tmoutNear.setEndZone(new CscCalendar("2900-01-01 00:00:00"));
		}
	
		if (SM.size() > 0) {
			SR = (SwipeRecord) this.getKeyDateSwipeOut().get(SM.firstKey());
			if (SM.size() == 1  ) {
				SR = (SwipeRecord) this.getKeyDateSwipeOut().get(SM.lastKey());
				result = SR.getRecordNo();
				//tmoutList.add(SR.getStringRecordNo());  ----> is Record found
			} else {
				if (this.isNarrow.equals("N")) { // ҵͧҷշش (Kom last modified 06-05-2010
					Iterator it = SM.keySet().iterator();
					SwipeRecord srtmp = SR;
					
					while (it.hasNext()) {
						String st = (String) it.next();
						
						SR1 = (SwipeRecord) this.keyDate.get(st);
						tminList.add(SR1.getStringRecordNo());
						
						if (SR1.getDate().subForDecimal(SR.getDate()) <= getSwipeTimeOutHourZone()){
						//if (SR1.getDate().subForDecimal(SR.getDate()) <= 4 && SR1.getDate().afterEqualsDateTime(this.getCurShift().get_c_dt_out())) {
							srtmp = SR1;
						}else{
							break;
						}
					}
					result = srtmp.getRecordNo();
					
					/*
					SR1 = (SwipeRecord) this.keyDate.get(SM.lastKey());
					if (SR1.getDate().subForDecimal(SR.getDate()) <= 99) {
						SR = (SwipeRecord) this.keyDate.get(SM.lastKey());
						result = SR.getRecordNo();
					} else {
						result = -1; // ӹǹҷٴ¤ ҧѹҡ 1 
					}
					*/
				}else{ // ٻʴҵͧҷش (this.isNarrow = "Y") Kom modified 06-05-2010
					result = ((SwipeRecord) this.keyDate.get(SM.firstKey())).getRecordNo();
				}
			}
		} else {
			result = 0; // 
		}
		return result;
	}
	
	public long findTimeBeforeLast(TimeZone tz) { //ҡٴѵá͹ش
		long result = 0;
		CscCalendar beg, end;
		SwipeRecord SR, SR1;
		this.tmoutList.clear();
		this.tmoutNear = new TimeZone();

		beg = new CscCalendar(tz.getBeginZone().getTimeInMillis());
		end = new CscCalendar(tz.getEndZone().getTimeInMillis());
		end.incMinute();
		SortedMap SM = this.keyDate.subMap(beg.getYYYYMMDDHHMMSS(), end.getYYYYMMDDHHMMSS());

		SortedMap head = this.keyDate.headMap(beg.getYYYYMMDDHHMMSS());
		if (head.size() > 0l) {
			SR1 = (SwipeRecord) this.keyDate.get(head.lastKey());
			tmoutNear.setBeginZone(SR1.getDate());
		} else {
			tmoutNear.setBeginZone(new CscCalendar("1900-01-01 00:00:00"));
		}

		SortedMap tail = this.keyDate.tailMap(end.getYYYYMMDDHHMMSS());
		if (tail.size() > 0) {
			SR1 = (SwipeRecord) this.keyDate.get(tail.firstKey());
			tmoutNear.setEndZone(SR1.getDate());
		} else {
			tmoutNear.setEndZone(new CscCalendar("2900-01-01 00:00:00"));
		}

		if (SM.size() > 0) {
			SR = (SwipeRecord) this.keyDate.get(SM.firstKey());
			if (SM.size() == 1) {
				SR = (SwipeRecord) this.keyDate.get(SM.lastKey());
				result = SR.getRecordNo();
				//tmoutList.add(SR.getStringRecordNo());  ----> is Record found
			} else {
				Iterator it = SM.keySet().iterator();
				String beforeLast, st;
				st = "";
				beforeLast = "";
				while (it.hasNext()) {
					beforeLast = st; 
					st =  (String) it.next();
					SR = (SwipeRecord) this.keyDate.get(st);
					tmoutList.add(SR.getStringRecordNo());
				}
				SR1 = (SwipeRecord) this.keyDate.get(beforeLast);
				if (SR1.getDate().subForDecimal(SR.getDate()) <= 1) {
					SR = (SwipeRecord) this.keyDate.get(beforeLast);
					result = SR.getRecordNo();
				} else {
					result = -1; // ӹǹҷٴ¤ ҧѹҡ 1 
				}
			}
		} else {
			result = 0; // 
		}
		return result;
	}

	public int getSwipeCount(TimeZone tz) { //ҡٴѵ÷ش
		return this.getSwipeList(tz).size();
	}

	public Vector getSwipeList(TimeZone tz) { //ҡٴѵ÷ش
		CscCalendar beg, end;
		SwipeRecord SR;
		Vector result = new Vector();
		beg = new CscCalendar(tz.getBeginZone().getTimeInMillis());
		end = new CscCalendar(tz.getEndZone().getTimeInMillis());
		end.incMinute();
		SortedMap SM = this.keyDate.subMap(beg.getYYYYMMDDHHMMSS(), end.getYYYYMMDDHHMMSS());

		if (SM.size() > 0) {
			Iterator it = SM.keySet().iterator();
			while (it.hasNext()) {
				String st = (String) it.next();
				SR = (SwipeRecord) this.keyDate.get(st);
				result.add(SR.getStringRecordNo());
			}
		}
		return result;
	}

	public TimeZone getTimeInNear() {
		return this.tminNear;
	}

	public TimeZone getTimeOutNear() {
		return this.tmoutNear;
	}

	/*
	 * ӡèͧšٴѵ ҡ§Ѻҡ÷ӧҹ
	 * 㹵ҧ÷ӧҹ 蹹ҷͧ
	 * ա
	 */
	public void reserve(long recordNo, String reserveCode) {
		SwipeRecord SR = this.getSwipeRecord(recordNo);
		if (SR != null) {
			if (this.getSwipeRecord(reserveCode) == null) {
				this.keyReserveCode.put(reserveCode, SR);
				this.newReserve.put(reserveCode, SR);
			}
		} else {
			MyLog.debug(this, "Can not record reservation!  "	+ String.valueOf(recordNo));
		}
	}

	public Vector getTimeInList() { //get šٴѵ÷
		return (Vector) this.tminList.clone();
	}

	public Vector getTimeOutList() { //get šٴѵ÷
		return (Vector) this.tmoutList.clone();
	}

	/*
	 * ֧šŧҷӡèͧ 
	 * (§Ѻҡ÷ӧҹ)
	 */
	public SwipeRecord getSwipeRecord(long recordNo) {
		SwipeRecord SR = (SwipeRecord) this.keyRecordNo.get(String	.valueOf(recordNo));
		return SR;
	}

	public SwipeRecord getSwipeRecord(String reserveCode) {
		SwipeRecord SR = (SwipeRecord) this.keyReserveCode.get(reserveCode);
		return SR;
	}

	/*
	 * ӡšٴѵ
	 * Ŵ 㹵 ͹
	 */
	public void addRecord(SwipeRecord SR) {
		try {
			this.keyDate.put(SR.getDate().getYYYYMMDDHHMMSS(), SR);
	    	this.keyRecordNo.put(String.valueOf(SR.getRecordNo()), SR);
	    	
	    	/* ¡ٴ͡ ͹͹Ѻ (੾ٴ) ШѺ͡ (੾ٴ͡) */
	    	if(SR.getSwipeType().equals("0") || SR.getSwipeType().equals("")){
	    		this.keyDateIn.put(SR.getDate().getYYYYMMDDHHMMSS(), SR);
		    	this.keyRecordNoIn.put(String.valueOf(SR.getRecordNo()), SR);
	    	}else if(SR.getSwipeType().equals("1")) {
	    		this.keyDateOut.put(SR.getDate().getYYYYMMDDHHMMSS(), SR);
		    	this.keyRecordNoOut.put(String.valueOf(SR.getRecordNo()), SR);
			}else{
				MyLog.error("!! Swipe type is null or empty [" + SR + "]");
			}
	    	
	    	Vector rsCode = SR.getReserveCode();
	    	Iterator it = rsCode.iterator();
	        while (it.hasNext()){
	        	String s = (String)it.next();
	        	this.keyReserveCode.put(s, SR);
		    }
	        if (SR.getRecordNo()<=this.minRecordNo) {
	        	this.minRecordNo = SR.getRecordNo()-1; 
	        }
	        if (SR.getRecordNo()>=this.maxRecordNo) {
	        	this.maxRecordNo = SR.getRecordNo()+1; 
	        }
		}catch(Exception e){
			MyLog.error(this,e);
		}
    }

	/*
	 * ӡšٴѵ
	 * ҡҧѵѵԨҡк   ͡еԴ
	 *  㹵 ͹
	 */
    public long addRecord(SwipeVirtual SV) {
    	SV.setRecordNo(this.maxRecordNo);
    	this.maxRecordNo++;
    	this.addRecord((SwipeRecord) SV);
    	return SV.getRecordNo();
    }

    /*
     * ӡô֧šٴѵâͧѡҹ ǧҷ
     * ŧ class ͧ 㹡èѺٴѵõ
     */
	public void loadData(String employee, CscCalendar beg, CscCalendar end) {
		this.empRecID = employee;
		beg.decDate();
		end.incDate();
		try {			 
			String filter = "employeeid='"+employee
				+"' and (swipedate between '"+beg.getYYYYMMDD()
				+"' and '"+end.getYYYYMMDD()+"')";
			if (this.inqSwipeTime == null) {
				this.inqSwipeTime = new InitialInquiry(up).getDbInquiry();		
				this.inqSwipeTime.setSchemaName(up.getSchemaName());
				this.inqSwipeTime.initMyTable("Ttimetemp", "", "");
				this.inqSwipeTime.setColumn("swipedate, swipetime, swipetype, source, machinno, jobcode, time0id, runno, companyid ");
			}
			this.inqSwipeTime.setFilter(filter);
			this.inqSwipeTime.refresh();
			while (this.inqSwipeTime.next()) {
				SwipeRecord rec = (SwipeRecord) this.inqSwipeTime.getCurrentDbRecord().cloneRecord(false);
				MyLog.debug(this.inqSwipeTime.getCurrentDbRecord().getString("swipedate")+" : "+
						this.inqSwipeTime.getCurrentDbRecord().getString("swipetime")+" : "+
						this.inqSwipeTime.getCurrentDbRecord().getString("time0id")+" : "+
						this.inqSwipeTime.getCurrentDbRecord().getString("runno"));
				this.addRecord(rec);		
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public Vector loadDataToVector(String employee, CscCalendar beg, CscCalendar end) {
		Vector v = new Vector();
		this.empRecID = employee;
		beg.decDate();
		end.incDate();
		try {			 
			String filter = "employeeid='"+employee
				+"' and (swipedate between '"+beg.getYYYYMMDD()
				+"' and '"+end.getYYYYMMDD()+"')";
			if (this.inqSwipeTime == null) {
				this.inqSwipeTime = new InitialInquiry(up).getDbInquiry();		
				this.inqSwipeTime.setSchemaName(up.getSchemaName());
				this.inqSwipeTime.initMyTable("Ttimetemp", "", "");
				this.inqSwipeTime.setColumn("swipedate, swipetime, swipetype, source, machinno, jobcode, time0id, runno, companyid ");
			}
			this.inqSwipeTime.setFilter(filter);
			this.inqSwipeTime.refresh();
			while (this.inqSwipeTime.next()) {
				v.add(this.inqSwipeTime.getCurrentDbRecord().cloneRecord(false));
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void setSwipeTime(Vector v) {
		for (int i=0;i<=v.size();i++) {
			try {
				DbRecord rec = (DbRecord) v.elementAt(i);
				this.addRecord((SwipeRecord) rec);
				//this.addRecord((SwipeRecord) rec.cloneRecord(false));
			} catch (Exception e) { }
		}
	}
	
	
	//edit method  by aGazin 11/03/2553
	/*
	public void setSwipeTime(Vector v) {
		String[] swipeList = null;
		for (int i=0;i<=v.size();i++) {
			try {
				DbRecord rec = (DbRecord) v.elementAt(i);
				swipeList = rec.getString("swipetime").split(",");
				for(int j=0;j<swipeList.length;j++){ 
					rec.set("swipetime", swipeList[j]);
					this.addRecord((SwipeRecord) rec.cloneRecord(false));
				}
				
			} catch (Exception e) { }
		}
	}*/


	/*
	 * ӡúѹ֡èѺٴѵŧ Ttimereserve
	 */
	public void updateData() {
		DbRecord empRec = this.initalEmployee();
		
		if (this.recReserve == null) {
			this.recReserve = new InitialRecord(this.up).getDbRecord("Ttimereserve");
		} 
		
		String reserve = "";
		String valueString = "";		
		Iterator it = this.newReserve.keySet().iterator();
		while (it.hasNext()) {		
			reserve = it.next().toString();
			SwipeRecord value = (SwipeRecord) this.newReserve.get(reserve);
			valueString = value.toString();		 
			
			long start=System.currentTimeMillis();	
			try {				
				this.recReserve.clearField();				
				this.recReserve.set("companyid", this.up.get("companyid"));
				this.recReserve.set("employeeid", this.empRecID);
				this.recReserve.set("reservecode", reserve);
				this.recReserve.set("ttimetemp", value.getRecordNo());
				this.setEmployeeDetail(this.recReserve, empRec);
				this.recReserve.save();
			} catch (Exception e) {
				MyLog.error(this, e);
			}
			long end=System.currentTimeMillis();				
			MyLog.debug(this, "SwipeData >>> Save Reserve Record  "+reserve+" :>>> time  : "+(end-start)/100);
		} 
	}
	
	private DbRecord initalEmployee(){
		try {
			if (this.inqEmp == null) {
				this.inqEmp = new InitialInquiry(this.up).getDbInquiry();			
				this.inqEmp.setSchemaName(this.up.getSchemaName());
				this.inqEmp.initMyTable("Memployee", "", "");
				this.inqEmp.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level," +
						"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid");
			} 
			this.inqEmp.setFilter("employeeid='"+this.empRecID+"'");
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				return this.inqEmp.getCurrentDbRecord();
			} 
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return null;
	}
	
	private void setEmployeeDetail(DbRecord rec, DbRecord empRec){
		try {	
			rec.set("emp_position",empRec.getString("emp_position"));
			rec.set("emp_group",empRec.getString("emp_group"));				
			rec.set("branch",empRec.getString("branch"));
			rec.set("job",empRec.getString("job"));
			rec.set("bu1",empRec.getString("bu1"));
			rec.set("bu2",empRec.getString("bu2"));
			rec.set("bu3",empRec.getString("bu3"));
			rec.set("bu4",empRec.getString("bu4"));
			rec.set("bu5",empRec.getString("bu5"));
			rec.set("bossid",empRec.getString("bossid"));
			rec.set("emp_level",empRec.getString("emp_level"));
			rec.set("costcenter",empRec.getString("costcenter"));
			rec.set("salatype",empRec.getString("salatype"));
			rec.set("currency",empRec.getString("costcenter"));
			rec.set("salary",empRec.getString("salary"));
			rec.set("every",empRec.getString("emp_every"));		
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}

	public String toString() {
		String result = "";
		Iterator it = this.keyRecordNo.keySet().iterator();
		while (it.hasNext()) {
			result += ((SwipeRecord) this.keyRecordNo.get((String) it.next())).toString();
		}
		return result;
	}

	public String getStringOrderDate() {
		String result = "";
		Iterator it = this.keyDate.keySet().iterator();
		while (it.hasNext()) {
			result += ((SwipeRecord) this.keyDate.get((String) it.next()))	.toString();
		}
		return result;
	}
	
	public void setUProfile(UProfile up) {
		this.up = up;
		try{
			isNarrow = StaticConfig.getConfigCompany(this.up, "TA1026");
		}catch(Exception ex){
			isNarrow ="N";
			ex.printStackTrace();
		}
	}

	public UProfile getUProfile() {
		return this.up;
	}
	
	public Shift getCurShift(){
		return this.cur;
	}
	
	public void setCurShift(Shift shift){
		this.cur = shift;
	}
	
	/* flag ¡èѺҵٴ ٴ͡ */
	private void setFlagUseSwipeType(){
		try{
			String flag = StaticConfig.getConfigCompany(this.getUProfile(), "TASWTYPE");	
			if(flag.equals("Y")){
				this.isUseSwipeType = true;
			}
		}catch(Exception ex){
			this.isUseSwipeType = false;
			ex.printStackTrace();
		}
	}
	
	/* кҵͧ¡Ѻҵٴ ੾зٴ  (͡) */
	private MyTreeMap getKeyDateSwipeIn(){
		MyTreeMap mt = null;
		try {
			if(this.isUseSwipeType){
				mt = this.keyDateIn;
			}else{
				mt = this.keyDate;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return mt;
	}
	
	/* кҵͧ¡Ѻҵٴ͡ ੾зٴ͡  (͡) */
	private MyTreeMap getKeyDateSwipeOut(){
		MyTreeMap mt = null;
		try {
			if(this.isUseSwipeType){
				mt = this.keyDateOut;
			}else{
				mt = this.keyDate;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return mt;
	}
	
	public float getSwipeTimeOutHourZone(){
		float DEFAULT = 20;
		float val = 0;
		try{
			String s_val = StaticConfig.getConfigCompany(this.getUProfile(), "TAOUTZ");
			val = Float.parseFloat(s_val);
			return val;
		}catch(Exception ex){
			MyLog.error("!! Can't find TAOUTZ in Mconfig table or data is not number !!");
			return DEFAULT;
		}
	}
	
	/* flag èѺ N Ѻҧ, Y Ѻ᤺ */
	private void setFlagFindTimeMethod(){
		try{
			this.isNarrow = StaticConfig.getConfigCompany(this.getUProfile(), "TA1026");	
			if(this.isNarrow.equals("")){
				this.isNarrow ="N";
			}
		}catch(Exception ex){
			this.isNarrow ="N";
			ex.printStackTrace();
		}
	}
	
	public void addKeyDateIn(String key, SwipeRecord sr){
		try {
			this.keyDateIn.put(key, sr);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void addKeyDateOut(String key, SwipeRecord sr){
		try {
			this.keyDateOut.put(key, sr);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}	
}