package com.csc.library.utility;

import java.text.DecimalFormat;

import com.csc.library.utilities.MyLog;

public class DHMConvert{

	private String strDay;
	private String strHour;
	private String strMin;
	
	public DHMConvert(){
		
	}
	
	public DHMConvert(String dTime,String dHour){
		this.DHMConvert(Double.parseDouble(dTime),Double.parseDouble(dHour));
	}

	public DHMConvert(double dTime,double dHour){
		this.DHMConvert(dTime,dHour);
	}

	public DHMConvert(double dTime,float dHour){
		this.DHMConvert(dTime,Double.parseDouble(Float.toString(dHour)));
	}
	
	public DHMConvert(float dTime,float dHour){
		this.DHMConvert(Double.parseDouble(Float.toString(dTime)),Double.parseDouble(Float.toString(dHour)));
	}
	
	/* ŧ  ҷ  ѹ  ҷ */
	public void DHMConvert(double dTime,double dHour) {
		int minTime = 0;
		int minHour = 0;

		try {
			/* convert time to mins*/
			minTime = timeToMin(dTime);
			minHour = timeToMin(dHour);
			
			strDay = parseDay(minTime,minHour);
			strHour = parseHour(minTime,minHour);
			strMin = parseMin(minTime,minHour);
			
		} catch(Exception e){
			System.out.print("!! Error : DHMConvert from input --> [" + dTime + "," + dHour + "]");
		}
	}
	
	/* ŧ ҷ  ѹ  ҷ */
	public String MinToDHM(int min, double hour_d){
		int minHour = 0;

		try {
			/* convert time to mins*/
			minHour = timeToMin(hour_d);
			
			strDay = parseDay(min,minHour);
			strHour = parseHour(min,minHour);
			strMin = parseMin(min,minHour);
			
		} catch(Exception e){
			System.out.print("!! Error : DHMConvert from input --> [" + min + "," + hour_d + "]");
		}
		
		return this.parseDHM();
	}
	
	/* return Day:Hour:Min */
	public String parseDHM(){
		StringBuffer sbDHM = new StringBuffer();
		sbDHM.append(this.strDay).append(":").append(this.strHour).append(":").append(this.strMin);
		return sbDHM.toString();
	}
	
	/* convert into minute where input always in hour format ( 4.53 -> 4hr 53mins )*/
	public static int timeToMin(double dTime){
		int intTotal = 0;
		int before = 0;
		int after = 0;
		DecimalFormat df = new DecimalFormat("#00.00"); 

		try{
			String strHour = df.format(dTime);
			
			before = Integer.parseInt(strHour.substring(0,strHour.indexOf("."))) * 60 ;
			after = Integer.parseInt(strHour.substring(strHour.indexOf(".")+1,strHour.length()));
			intTotal = before + after;
		} catch(Exception e) {
			System.out.print("!! Error : parseMin from input --> [" + dTime + "]");
		}
		return intTotal;
	}

	/* calculate minute */ 
	public static String parseMin(int dTimes,int dHour) {
		DecimalFormat df = new DecimalFormat("00"); 
		String strMin = "00";
		int intTemp = 0;
		try {
			if(dTimes == 0 || dHour == 0){ return strMin; }
			intTemp = dTimes%dHour;
			strMin = df.format(intTemp%60);
		} catch(Exception e){
			System.out.print("!! Error : parseMin from input --> [" + dTimes + "," + dHour + "]");
		}
		return strMin;
	}
	
	/* calculate hour */ 
	public static String parseHour(int dTimes,int dHour) {
		DecimalFormat df = new DecimalFormat("#00.00"); 
		String strHour = "00";
		int intTemp = 0;
		try {
			if(dTimes == 0 || dHour == 0){ return strHour; }
			intTemp = dTimes%dHour;
			strHour = df.format(intTemp/60);
			strHour = strHour.substring(0,strHour.indexOf("."));
		} catch(Exception e){
			System.out.print("!! Error : parseHour from input --> [" + dTimes + "," + dHour + "]");
		}
		return strHour;
	}

	/* calculate day */ 
	public static String parseDay(int dTimes,int dHour) {
		String strDay = "00";
		DecimalFormat df = new DecimalFormat("#00.00"); 

		try {
			if(dTimes == 0 || dHour == 0){ return strDay; }
	
			double dTemp = dTimes/dHour;
			String strResult = df.format(dTemp);
			if(dTemp >= 1){
				strDay = strResult.substring(0,strResult.indexOf("."));
			} else {
				strDay = "00";
			}
		} catch (Exception e){
			System.out.print("!! Error : parseDay from input --> [" + dTimes + "," + dHour + "]");
		}
		
		return strDay;
	}

	/* ŧ DHM to mins */
	public int DHMToMin(String dhm, String hour_d){
		int minOfDHM = 0;
		int minOfHourd = 0;
		String items[] = {"00","00","00"};
		try {
			minOfHourd = this.timeToMin(Double.parseDouble(hour_d));	/* ŧ . ѹ ҷ */
			
			if(checkDHMFormat(dhm)){
				items = dhm.split(":");
				int day = DayToMin(Integer.parseInt(items[0]),minOfHourd);
				int hour = HourToMin(Integer.parseInt(items[1]));
				int min = Integer.parseInt(items[2]);
				minOfDHM = day + hour + min;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return minOfDHM;
	}
	
	/* ŧѹ繹ҷ */
	private int DayToMin(int day, int min_d){
		int min = 0;
		try {
			min = (day * min_d);
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return min;
	}
	
	/* ŧ . 繹ҷ */
	private int HourToMin(int hour){
		try {
			return hour * 60;
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0;
	}
	
	/* ͧٻẺҹ 00:00:00 */
	private boolean checkDHMFormat(String dhm){
		try {
			//if(dhm.length() == 8){
				if(dhm.split(":").length == 3){
					return true;
				}else{
					MyLog.error("ٻẺ ѹ..ҷ ͧ : ҧ ѹ  ҷ");
				}
			//}else{
			//	MyLog.error("ٻẺ ѹ..ҷ ú 8 ѡ (00:00:00)");
			//}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
}
