package com.csc.library.utility;
 
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;
 
import com.csc.library.databean.Ttime_current;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable; 
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift; 
import com.csc.library.timeattendance.SwipeData;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.SwipeRecord; 
import com.csc.library.timeinterface.TimeResult; 
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;

import std.library.DataTable;

public class NRepairTtimeCurrent1 { 
	//========== time performance variable============
	private CscCalendar tStRepair;
	private CscCalendar tEndRepair;
	private CscCalendar tStUpdate;
	private CscCalendar tEndUpdate;
	//=======================================

	private String[] TC1ColumnName = this.getColumnName();
	private String[] TC1ColumnType =this.getColumnType();
	private DataTable dataTableTC1 = new DataTable(TC1ColumnName,TC1ColumnType);
	
	private Hashtable<String,String> shsKeyFilter;
	private DbTable dbTCurrent1 = null;
	private DbRecord recTCurrent = null;
	private Hashtable SwData;
	private Hashtable mEventGrpData;
	private Hashtable mHoliday1Data;
	private Hashtable hstIsWorkDay;
	
	private void checkIsWorkDay(WorkingShift wsWorkDay, DbRecord empRec){
		hstIsWorkDay = new Hashtable();
		String value;
		for (Iterator<?> IT = wsWorkDay.keySet().iterator(); IT.hasNext();) {  
			String key = (String) IT.next();
            DayShift dShift = (DayShift) wsWorkDay.get(key);
            if (dShift.isEmpty() || dShift.size()==1) {
            	if(mHoliday1Data.containsKey(key)){
            		value = "I" ;	
                }else{
                	value ="H" ;	
                }//end if       
            }else{
            	value = "T";
            }//end if 
            
            if(!hstIsWorkDay.containsKey(key)){
            	hstIsWorkDay.put(key, value);	
            }//end if        
		}//end for  
	}//end getPreviousAndNextShift
	
	/**
	 * @param wsAllDay
	 * @param empRec
	 * @param wsWorkDay
	 * @return
	 */
	public DataTable repair(WorkingShift wsAllDay, DbRecord empRec,WorkingShift wsWorkDay){
		this.checkIsWorkDay(wsWorkDay,empRec);
	 	//========== time performance ============
		tStRepair = new CscCalendar();
		tStRepair.getDDMMYYHHMMSS(); 
		//==================================
		
		shsKeyFilter = new Hashtable<String,String>();
		int row = 0;
		
   	 	try{
   	 		for (Iterator<?> IT = wsAllDay.keySet().iterator(); IT.hasNext();) {      
		    	 String keyWs= (String) IT.next();
		         DayShift dShift = (DayShift) wsAllDay.get(keyWs);
		         
		         int sequence = 0 ;	         
		         String strRow ="";
		             
		         for (Iterator<?> IT1 = dShift.keySet().iterator(); IT1.hasNext();) { 	        	
	 
		        	 String keyAllDay= (String) IT1.next();
	                 TimeResult trAllDay = (TimeResult) dShift.get(keyAllDay);
	                 
	                 String lastDateid ="";
	                 float lastTMOut=0.00f;	      
	                 float currentTMIn=0.00f;
	                 String currentDateid ="";
	                 String trType ="";
		                 
	                 if(!trAllDay.getResultTR_Type().equals("M")){
	                	 
	                	 if(dataTableTC1.rowCount()>0){
	                		 lastDateid =dataTableTC1.getItemString(dataTableTC1.rowCount(), "DATEID");
	                		 lastTMOut = Float.valueOf(String.valueOf(dataTableTC1.getItem(dataTableTC1.rowCount(), "C_TM_EN"))).floatValue();                		 
	                		 currentDateid=trAllDay.getResultShiftCalendar().getYYYYMMDD();      		 
	                		 currentTMIn =trAllDay.getResult_c_dt_in().getCSCTime();
	                		 trType = trAllDay.getResultTR_Type().substring(0, 1);
	                	 }//end if 
	                	 
	                	 if(dataTableTC1.rowCount()>0 && 
	                		lastDateid.equals(currentDateid) &&
	                		trType.equals("T") &&
	                		currentTMIn<lastTMOut){
	                	 }else{
	                		 sequence++;
	                		 row++;
	                		 if(strRow.equals("")){
	                			 strRow = String.valueOf(row);
	                		 }else{
	                			 strRow +="," +row;
	                		 }//end if 
	                		 
	                		 //insert row
		        			 dataTableTC1.insertRow(1);
		        			 
		        			 //"EMPLOYEEID","COMPANYID","DATEID","DOCTYPE","DOCNO"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[0], empRec.getString(TC1ColumnName[0]));
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[1], empRec.getString(TC1ColumnName[1]));
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[2], trAllDay.getResultShiftCalendar().getYYYYMMDD());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[3], trAllDay.getResultDocType());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[4], trAllDay.getResultDocNo());
			        		 
			          		 //"TIME0ID","OLD_TIME0","SEQUENCE","C_TM_BG","C_TM_EN"	
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[5], trAllDay.getResultTimeCode());
			          		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[6], trAllDay.getResultOldTimeCode()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[7], "0"+sequence);
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[8], trAllDay.getResult_c_dt_in().getCSCTime());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[9], trAllDay.getResult_c_dt_out().getCSCTime());
 		        		 
			        		 //"M_TM_BG","M_TM_EN" 		        	
			        		 /**
			        		  * Logic : Ѻ ZoneIn ҡС͹˹ҹ 繡  
			        		  * ͧ set timeBg  = trAllDay.getResult_c_dt_in().getCSCTime() 
			        		  * ѹ šٴѵ  
			        		  * timeZoneIn   7.30-12.00
			        		  * բšҪǧҫ觨Сҵͧҧҹ 13.00-16.30
			        		  * šٴѵٴ͹ 13.00 ѹش timeZone 
			        		  * ѹҢšٴѵ
			        		  */
			         		  
			        		 TimeZone tzIn = ((Shift)trAllDay).getInZone(); 
			        		 if(dataTableTC1.rowCount()>1){
			        			  if(dataTableTC1.getItemString((dataTableTC1.rowCount()-1),"DATEID").equals(trAllDay.getResultShiftCalendar().getYYYYMMDD())
			        				  && dataTableTC1.getItemString((dataTableTC1.rowCount()-1),"DOCTYPE").equals("A")){
			        				  if(tzIn!=null){
			        					  CscCalendar newTz = new CscCalendar(String.valueOf(dataTableTC1.getItem((dataTableTC1.rowCount()-1),"C_DT_BG")));
			        					  newTz.setCSCTime(Float.valueOf(String.valueOf(dataTableTC1.getItem((dataTableTC1.rowCount()-1),"C_TM_BG"))));
			        					  tzIn.setBeginZone(newTz);
			        				  }//end if 
			        			  }//end if  
			        		 }//end if 
			        		 
			        		 if(tzIn!=null &&trAllDay.getResultMidDayStop() !=null ){
				        		 if(tzIn.getBeginZone().getCSCTime()>trAllDay.getResultMidDayStop().getBeginZone().getCSCTime()){
				        			 tzIn.setBeginZone(trAllDay.getResultMidDayStop().getBeginZone());
				        		 }//end if 
			        		 }//end if 
			        		 
			        		
			        		 TimeZone tzOut = ((Shift)trAllDay).getOutZone(); 
			        		 if(tzOut!=null &&trAllDay.getResultMidDayStop() !=null ){
				        		 if(tzOut.getBeginZone().getCSCTime()>trAllDay.getResultMidDayStop().getBeginZone().getCSCTime()){
				        			 tzOut.setBeginZone(trAllDay.getResultMidDayStop().getBeginZone());
				        		 }//end if 
			        		 }//end if 
			        		 
			        		 long recInNo;
			        		 long recOutNo;
			        		 float timeIn=0f;
			        		 float timeOut=0f;
			        		 
			        		 if(trAllDay.getResult_m_dt_in()==null){
			        			 if(tzIn!=null && dShift.getSwipeTrans().findTimeIn(tzIn)!=0){
				        			 recInNo = dShift.getSwipeTrans().findTimeIn(tzIn);
				        			 SwipeRecord recIn = (SwipeRecord) dShift.getSwipeTrans().getSwipeRecord(recInNo);
				        			 timeIn = recIn.getTime();
				        		 }//end if 
			        		 }else{
			        			 timeIn = trAllDay.getResult_m_dt_in().getCSCTime();
			        		 }//end if 
			        		 
			        		 if(trAllDay.getResult_m_dt_out()==null){
			        			  if(tzOut!=null && dShift.getSwipeTrans().findTimeOut(tzOut)!=0){
				        			 recOutNo = dShift.getSwipeTrans().findTimeOut(tzOut);
				        			 SwipeRecord recOut = (SwipeRecord) dShift.getSwipeTrans().getSwipeRecord(recOutNo);
				        			 timeOut = recOut.getTime();
			        			  }//end if 
			        		 }else{
			        			 timeOut = trAllDay.getResult_m_dt_out().getCSCTime();
			        		 }//end if 
			        		 
			        		 //==============================================
			        		 /**
			        		  * Logic: 
			        		  *   timeOut ͧ ǧҡ͹˹ = 0 ત 
			        		  * 	- ǧһѨغѹ ͡ ?  
			        		  * 	- ǧҡ͹˹ ѹǡѹ   ǧҷӧҹ  timeOut = 0
			        		  * 	- C_TM_BG ǧһѨغѹ == C_TM_EN ǧҡ͹˹ (зѺѹʹ)
			        		  * ʴҪǧѹͧѹ ѹաٴѵ ѹͧ  ѹ ͺҧͺҧ (-*-)
			        		  *  process ѹ ѹ   process ѹ (-*-!) 
			        		  * ӡä ٴѵ ա 
			        		  */
			        		  
			        		 if(dataTableTC1.rowCount()>1){
			        			 if(trAllDay.getResultDocType().equals("A") 
				        			&& Float.valueOf(String.valueOf(dataTableTC1.getItem((dataTableTC1.rowCount()-1),"M_TM_EN")))==0 				        			
				        			&& dataTableTC1.getItemString((dataTableTC1.rowCount()-1),"DATEID").equals(trAllDay.getResultShiftCalendar().getYYYYMMDD())
				        			&& trAllDay.getResult_c_dt_in().getCSCTime() ==  Float.valueOf(String.valueOf(dataTableTC1.getItem((dataTableTC1.rowCount()-1),"C_TM_EN")))
				        			&& dataTableTC1.getItemString((dataTableTC1.rowCount()-1),"DOCTYPE").trim().equals("")){
				        			
				        			SwipeData swData  =(SwipeData)dShift.getSwipeTrans();
				        			Hashtable swRec = swData.getkeyRecordNo();
				        			
				        			String strTimeList = String.valueOf(swRec.get(trAllDay.getResultShiftCalendar().getYYYYMMDD()));
				        			
				        			if(!strTimeList.equals("null")){
				        				String[] timeSpl = strTimeList.split(",");
				        				// ٴѵ÷ >= C_TM_BG ǧһѨغѹ ٴ C_TM_EN ǧҡ͹˹ 
					        			for(int ii=0;ii<timeSpl.length;ii++){
					        				if(Float.valueOf(timeSpl[ii])>=trAllDay.getResult_c_dt_in().getCSCTime()){
					        					dataTableTC1.setItem((dataTableTC1.rowCount()-1),"M_TM_EN",trAllDay.getResult_c_dt_in().getCSCTime());
					        					break;
					        				}
					        			}//end for ii
				        			}//end if 		        			
				        		 }//end if 
			        		 }//end if 
	 		        		 		  	        		 
			        		 if(trAllDay.getResultDocType().equals("A")){
			        			 //ǧ 
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[10], 0f);
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[11], 0f);
			        		 }else  if(trAllDay.getResultEventGroup().equals("H")||
			        				 		trAllDay.getResultEventGroup().equals("I")){
			        			//ǧ ѹشШѻ,ѡѵġ
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[10], timeIn);
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[11], timeOut);
			        		 }else{		
			        			 //ǧ ӧҹ
			        			dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[10], timeIn);
			        			dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[11], timeOut); 
			        		 }//end if 		        	
				          	//==============================================

			        		 //"C_DT_BG","C_DT_EN","M_DT_BG","M_DT_EN"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[12], trAllDay.getResult_c_dt_in().getYYYYMMDD());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[13], trAllDay.getResult_c_dt_out().getYYYYMMDD());
			          		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[14], trAllDay.getResult_c_dt_in().getYYYYMMDD()); 
			          		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[15], trAllDay.getResult_c_dt_out().getYYYYMMDD());	 
			          		 
			          		 //"LT","C_LV","M_LV"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[16], trAllDay.getResultLT());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[17], trAllDay.getResultC_LV());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[18], trAllDay.getResultM_LV());
			        		 
	 		        		 
			        		 //"SOURCE","TR_TYPE","AC_OT","AP_OT","FORGET_IN"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[20], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[21], trAllDay.getResultTR_Type());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[22], trAllDay.getResultAc_ot());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[23], trAllDay.getResultAp_ot());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[24], trAllDay.getResultForget_in());
			        		 
			        		 //"FORGET_OUT","ISWORK"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[25], trAllDay.getResultForget_out());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[26], trAllDay.getResultIsWork());
			        		
			        		 //"DT_IN_INZONE","TM_IN_INZONE"
			        		 if(trAllDay.getResult_Inzone_begin()==null){
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[27],trAllDay.getResult_c_dt_in().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[29],trAllDay.getResult_c_dt_in().getCSCTime());
			        		 }else{
			        		  	dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[27], trAllDay.getResult_Inzone_begin().getYYYYMMDD());
			        		  	dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[29], trAllDay.getResult_Inzone_begin().getCSCTime());
			        		 }//end if 
			        		 
			        		 //"DT_OUT_INZONE","TM_OUT_INZONE"
			        		 if(trAllDay.getResult_Inzone_end()==null){
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[28],trAllDay.getResult_c_dt_out().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[30],trAllDay.getResult_c_dt_out().getCSCTime());
			        		 }else{
			        			dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[28], trAllDay.getResult_Inzone_end().getYYYYMMDD());
			         		 	dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[30], trAllDay.getResult_Inzone_end().getCSCTime());
			        		 }
			        		 
			        		 //"DT_IN_OUTZONE","TM_IN_OUTZONE"
			        		 if(trAllDay.getResult_Outzone_begin()==null){
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[31],trAllDay.getResult_c_dt_in().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[33],trAllDay.getResult_c_dt_in().getCSCTime());
			        		 }else{
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[31], trAllDay.getResult_Outzone_begin().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[33], trAllDay.getResult_Outzone_begin().getCSCTime());
			        		 }
			        	   		 
			        		 //"DT_OUT_OUTZONE","TM_OUT_OUTZONE"
			        		 if(trAllDay.getResult_Outzone_end()==null){
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[32],trAllDay.getResult_c_dt_out().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[34],trAllDay.getResult_c_dt_out().getCSCTime());
			        		 }else{
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[32], trAllDay.getResult_Outzone_end().getYYYYMMDD());
			        			 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[34], trAllDay.getResult_Outzone_end().getCSCTime());       			 	   	 
			        		 }
			         		 
			        		 //"EVENTGRP","OLDEVENTGRP","UNUSED1","UNUSED2","UNUSED3"
			        		 String eventGrp = "";
 			        		 if(trAllDay.getResultDocType().equals("A")){
 			        			 // 
			        			 eventGrp = "A";
			        		 }else{        		 
		        			 	 if(trAllDay.getResultEventGroup().equals("O")){
		        			 		 String dayKey = trAllDay.getResultShiftCalendar().getYYYYMMDD();
		        			 		 /* ҷͷ ͧ˹ event Ἱ÷ӧҹͧѹ  ѹӧҹ T ѹش H or I */
		        			 		 if(trAllDay.getActualEvent().equals("H")||trAllDay.getActualEvent().equals("I")){
		        			 			 eventGrp = trAllDay.getActualEvent();
		        			 		 }else{
		        			 			 eventGrp = "T";
		        			 		 }
		        			 		 //eventGrp = this.hstIsWorkDay.get(dayKey).toString();	        			 		 
		        			 	 }else{
		        			 		 //T, H, I,ect
		        			 	 	eventGrp = trAllDay.getResultEventGroup();
		        			 	 }//end if 	  	
		        			 }//end if 
			        		 
			        		 //LV_TY[19]
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[19],eventGrp);
 			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[35],eventGrp);
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[36], trAllDay.getResultOldEventGroup());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[37], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[38], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[39], "0");
			        		 
			        		//"UNUSED4","UNUSED5","UNUSED6","UNUSED7","UNUSED8"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[40], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[41], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[42], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[43], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[44], "0"); 
			        		 
			 				//"UNUSED9","UNUSED10" ,"HOUR_D","DT_BREAKIN","TM_BREAKIN"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[45], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[46], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[47], "0");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[48], trAllDay.getResultMidDayStop().getBeginZone().getDDMMYYYY());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[49], trAllDay.getResultMidDayStop().getBeginZone().getCSCTime()); 
 
			 				//"DT_BREAKOUT","TM_BREAKOUT" 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[50], trAllDay.getResultMidDayStop().getEndZone().getDDMMYYYY());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[51], trAllDay.getResultMidDayStop().getEndZone().getCSCTime()); 

			 				//"PREVIOUSSHIFT","NEXTSHIFT"
			        		 /***
			        		  * set   method this.updateTtimecurrent1() 
			        		  *    ͹˹   Ѵ 
			        		  * ¡
			        		  */
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[52], "");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[53], ""); 
			        		 
			        		 //"STATUS","DAYTYPE","HOUR_S"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[54], trAllDay.getResultStatus());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[55], trAllDay.getResultShiftCalendar().getCSCDOW()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[56], trAllDay.getResultHour_s());
 
			 				//"DATE_ACTUAL","O_TM_BG","O_TM_EN","O_DT_BG","O_DT_EN"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[57], trAllDay.getResult_c_dt_in().getYYYYMMDD());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[58], trAllDay.getResult_o_dt_in().getCSCTime()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[59], trAllDay.getResult_o_dt_out().getCSCTime());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[60], trAllDay.getResult_o_dt_in().getYYYYMMDD()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[61], trAllDay.getResult_o_dt_out().getYYYYMMDD());
 
			 				//"SOURCE_IN","SOURCE_OUT","OT_BEFORE","OT_AFTER","SH_TM_BG"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[62], trAllDay.getResult_Sourcein());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[63], trAllDay.getResult_Sourceout()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[64], "");
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[65], ""); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[66], trAllDay.getResult_sh_dt_in().getCSCTime());

			 				//"SH_TM_EN","SH_DT_BG","SH_DT_EN","MACHINE_IN","MACHINE_OUT"
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[67], trAllDay.getResult_sh_dt_out().getCSCTime());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[68], trAllDay.getResult_sh_dt_in().getYYYYMMDD()); 
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[69], trAllDay.getResult_sh_dt_out().getYYYYMMDD());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[70], trAllDay.getResult_Machinein());
			        		 dataTableTC1.setItem(dataTableTC1.rowCount(),TC1ColumnName[71], trAllDay.getResult_Machineout());
			        		 
	                	 }//end if 
	                }//end if        
	        	 }//end for
		         
		         this.shsKeyFilter.put(keyWs, strRow);
	    	 }//end for
	   	}catch(Exception ex){
	  		 System.out.print(">>>> PROCESS BY NUISS ERROR in NRepairTtimeCurrent1.repair() "+ ex.getStackTrace().toString() + "<<<<");
	  	 }//end try 
	   	
	   	//========== time performance ============
	   	tEndRepair = new CscCalendar();
		tEndRepair.getDDMMYYHHMMSS(); 
		System.out.print("in NRepairTtimeCurrent1.repair() start at : "+tStRepair);
		System.out.print("in NRepairTtimeCurrent1.repair() finish at : "+tEndRepair);
		//==================================
		return this.dataTableTC1;
	}//end DataTable
	 
	 @Deprecated
	public void updateTtimecurrent1(UProfile upf ,WorkingShift wsAllDay, DbRecord empRec, HashMap<?, ?> hmParam,WorkingShift wsWorkDay){
	 	//========== time performance ============
		tStUpdate = new CscCalendar();
		tStUpdate.getDDMMYYHHMMSS(); 
		//==================================
		NTriger nTriger = new NTriger();
		this.repair(wsAllDay, empRec,wsWorkDay);
		
		Enumeration<String> e = this.shsKeyFilter.keys();
		String keys ="";
		Object values=null;
		String[] splValue =new String[0];
		float TC_hour_s = 0f;
		
		boolean isSetDesc = false ;
		String TC1_TDESC = ""; 
		String TC1_EDESC = "";
		
		try{
			while(e.hasMoreElements()){
				keys= (String) e.nextElement();
				values = this.shsKeyFilter.get(keys);
				if(values.equals("")){
					//Դ
				}else{
		 			splValue = values.toString().split(",");
					if (this.dbTCurrent1 != null) {
						this.dbTCurrent1.clear();
					}//end if 
					for(int ii=0;ii<splValue.length;ii++){
						
						if (this.dbTCurrent1 == null) {
		                 	this.dbTCurrent1 = new InitialTable(upf).getDbTable("Ttime_current1");
		                 	this.dbTCurrent1.setColumn("*");
		                 }//end if 
						
		             	 DbRecord recTC1 = this.dbTCurrent1.getNewRecord();
	 	 				 recTC1.setColumn("*");
		            	 
		 				 int row = Integer.valueOf(splValue[ii]);
		 				 
		 				//"EMPLOYEEID","COMPANYID","DATEID","DOCTYPE","DOCNO"
		 				recTC1.set(TC1ColumnName[0], dataTableTC1.getItemString(row, TC1ColumnName[0]));
		 				recTC1.set(TC1ColumnName[1], dataTableTC1.getItemString(row, TC1ColumnName[1]));
		 				recTC1.set(TC1ColumnName[2], dataTableTC1.getItemString(row, TC1ColumnName[2]));
		 				recTC1.set(TC1ColumnName[3], dataTableTC1.getItemString(row, TC1ColumnName[3]));
		 				recTC1.set(TC1ColumnName[4], dataTableTC1.getItemString(row, TC1ColumnName[4]));
		 				
		 				//"TIME0ID","OLD_TIME0","SEQUENCE","C_TM_BG","C_TM_EN"
		 				recTC1.set(TC1ColumnName[5], dataTableTC1.getItemString(row, TC1ColumnName[5]));
		 				recTC1.set(TC1ColumnName[6], dataTableTC1.getItemString(row, TC1ColumnName[6]));
		 				recTC1.set(TC1ColumnName[7], dataTableTC1.getItemString(row, TC1ColumnName[7]));		
		 				recTC1.set(TC1ColumnName[8], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[8]))).floatValue());
		 				recTC1.set(TC1ColumnName[9], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[9]))).floatValue());
		 				
		 				//"M_TM_BG","M_TM_EN","C_DT_BG","C_DT_EN","M_DT_BG"
		 				recTC1.set(TC1ColumnName[10], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[10]))).floatValue());
		 				recTC1.set(TC1ColumnName[11], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[11]))).floatValue());
		 				recTC1.set(TC1ColumnName[12], dataTableTC1.getItemString(row, TC1ColumnName[12]));
		 				recTC1.set(TC1ColumnName[13], dataTableTC1.getItemString(row, TC1ColumnName[13]));
		 				recTC1.set(TC1ColumnName[14], dataTableTC1.getItemString(row, TC1ColumnName[14]));
		 				 
		 				//"M_DT_EN","LT","C_LV","M_LV","LV_TY"
		 				recTC1.set(TC1ColumnName[15], dataTableTC1.getItemString(row, TC1ColumnName[15]));
		 				recTC1.set(TC1ColumnName[16], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[16]))).floatValue());
		 				recTC1.set(TC1ColumnName[17], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[17]))).floatValue());
		 				recTC1.set(TC1ColumnName[18], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[18]))).floatValue());
		  				recTC1.set(TC1ColumnName[19], dataTableTC1.getItemString(row, TC1ColumnName[19]));
		 				
		  				//"SOURCE","TR_TYPE","AC_OT","AP_OT","FORGET_IN"
		  				recTC1.set(TC1ColumnName[20], dataTableTC1.getItemString(row, TC1ColumnName[20]));
		 				recTC1.set(TC1ColumnName[21], dataTableTC1.getItemString(row, TC1ColumnName[21]));
		 				recTC1.set(TC1ColumnName[22], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[22]))).floatValue());
		 				recTC1.set(TC1ColumnName[23], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[23]))).floatValue());
		  				recTC1.set(TC1ColumnName[24], dataTableTC1.getItemString(row, TC1ColumnName[24]));
	
		  				//"FORGET_OUT","ISWORK","DT_IN_INZONE","DT_OUT_INZONE","TM_IN_INZONE"
		  				recTC1.set(TC1ColumnName[25], dataTableTC1.getItemString(row, TC1ColumnName[25]));
		 				recTC1.set(TC1ColumnName[26], dataTableTC1.getItemString(row, TC1ColumnName[26]));
		 				recTC1.set(TC1ColumnName[27], dataTableTC1.getItemString(row, TC1ColumnName[27]));
		 				recTC1.set(TC1ColumnName[28], dataTableTC1.getItemString(row, TC1ColumnName[28]));
		 				recTC1.set(TC1ColumnName[29], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[29]))).floatValue());
		 		
		 				//"TM_OUT_INZONE","DT_IN_OUTZONE","DT_OUT_OUTZONE","TM_IN_OUTZONE","TM_OUT_OUTZONE"
		 				recTC1.set(TC1ColumnName[30], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[30]))).floatValue());
		 				recTC1.set(TC1ColumnName[31], dataTableTC1.getItemString(row, TC1ColumnName[31]));
		 				recTC1.set(TC1ColumnName[32], dataTableTC1.getItemString(row, TC1ColumnName[32]));
		 				recTC1.set(TC1ColumnName[33], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[33]))).floatValue());
		 				recTC1.set(TC1ColumnName[34], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[34]))).floatValue());
		 				 
		 				//"EVENTGRP","OLDEVENTGRP","UNUSED1","UNUSED2","UNUSED3"
		 				recTC1.set(TC1ColumnName[35], dataTableTC1.getItemString(row, TC1ColumnName[35]));
		 				recTC1.set(TC1ColumnName[36], dataTableTC1.getItemString(row, TC1ColumnName[36]));
		 				recTC1.set(TC1ColumnName[37], dataTableTC1.getItemString(row, TC1ColumnName[37]));
		 				recTC1.set(TC1ColumnName[38], dataTableTC1.getItemString(row, TC1ColumnName[38]));
		 				recTC1.set(TC1ColumnName[39], dataTableTC1.getItemString(row, TC1ColumnName[39]));
		  
		 				//"UNUSED4","UNUSED5","UNUSED6","UNUSED7","UNUSED8"
		 				recTC1.set(TC1ColumnName[40], dataTableTC1.getItemString(row, TC1ColumnName[40]));
		 				recTC1.set(TC1ColumnName[41], dataTableTC1.getItemString(row, TC1ColumnName[41]));
		 				recTC1.set(TC1ColumnName[42], dataTableTC1.getItemString(row, TC1ColumnName[42]));
		 				recTC1.set(TC1ColumnName[43], dataTableTC1.getItemString(row, TC1ColumnName[43]));
		 				recTC1.set(TC1ColumnName[44], dataTableTC1.getItemString(row, TC1ColumnName[44]));
		  
		 				//"UNUSED9","UNUSED10","HOUR_D","DT_BREAKIN","TM_BREAKIN"
		 				recTC1.set(TC1ColumnName[45], dataTableTC1.getItemString(row, TC1ColumnName[45]));
		 				recTC1.set(TC1ColumnName[46], dataTableTC1.getItemString(row, TC1ColumnName[46]));
		 				recTC1.set(TC1ColumnName[47], dataTableTC1.getItemString(row, TC1ColumnName[47]));
		 				recTC1.set(TC1ColumnName[48], dataTableTC1.getItemString(row, TC1ColumnName[48]));
		 				recTC1.set(TC1ColumnName[49], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[49]))).floatValue());
		 				
		 				//"DT_BREAKOUT","TM_BREAKOUT"
		 				recTC1.set(TC1ColumnName[50], dataTableTC1.getItemString(row, TC1ColumnName[50]));
		 				recTC1.set(TC1ColumnName[51], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[51]))).floatValue());
		 		 	
		 				//"PREVIOUSSHIFT","NEXTSHIFT"
		 				String previousShift = "";
		 				String nextShift = "";
		 				if(row==1){
		 					//get previousShift
		          			previousShift = nTriger.getShift(hmParam, upf,1,"TR_TYPE","0");
		          			//get nextShift
		          			if(dataTableTC1.rowCount()==1){
		          				nextShift = nTriger.getShift(hmParam, upf,3,"TR_TYPE","0");
		          			}else{
		          				nextShift =this.getShift(dataTableTC1,(row+1),"TR_TYPE");
		          			}//end if  
		 				}else if(row==dataTableTC1.rowCount()){
		 					//get previousShift
		 					previousShift =this.getShift(dataTableTC1,(row-1),"TR_TYPE");
		 			 		//get nextShift
		          			nextShift = nTriger.getShift(hmParam, upf,3,"TR_TYPE","0");
		 				}else{
		 					//get previousShift
		 					previousShift =this.getShift(dataTableTC1,(row-1),"TR_TYPE");		
		 			 		//get nextShift
		 					nextShift =this.getShift(dataTableTC1,(row+1),"TR_TYPE");
		 				}//end if 
		 				
		 				recTC1.set(TC1ColumnName[52], previousShift);
		 				recTC1.set(TC1ColumnName[53], nextShift);
		 				
		 				//"STATUS","DAYTYPE","HOUR_S"
		 				recTC1.set(TC1ColumnName[54], dataTableTC1.getItemString(row, TC1ColumnName[54]));
		 				recTC1.set(TC1ColumnName[55], dataTableTC1.getItemInt(row, TC1ColumnName[55]));
		 				recTC1.set(TC1ColumnName[56], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[56]))).floatValue());
		 			
		 				//"DATE_ACTUAL","O_TM_BG","O_TM_EN","O_DT_BG","O_DT_EN"
		 				recTC1.set(TC1ColumnName[57], dataTableTC1.getItemString(row, TC1ColumnName[57]));
		 				recTC1.set(TC1ColumnName[58], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[58]))).floatValue());
		 				recTC1.set(TC1ColumnName[59], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[59]))).floatValue());
		 				recTC1.set(TC1ColumnName[60], dataTableTC1.getItemString(row, TC1ColumnName[60]));
		 				recTC1.set(TC1ColumnName[61], dataTableTC1.getItemString(row, TC1ColumnName[61]));
		 				
		 				//"SOURCE_IN","SOURCE_OUT","OT_BEFORE","OT_AFTER","SH_TM_BG"
		 				recTC1.set(TC1ColumnName[62], dataTableTC1.getItemString(row, TC1ColumnName[62]));
		 				recTC1.set(TC1ColumnName[63], dataTableTC1.getItemString(row, TC1ColumnName[63]));
		 				recTC1.set(TC1ColumnName[64], dataTableTC1.getItemString(row, TC1ColumnName[64]));
		 				recTC1.set(TC1ColumnName[65], dataTableTC1.getItemString(row, TC1ColumnName[65]));
		 				recTC1.set(TC1ColumnName[66], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[66]))).floatValue());
	
		 				//"SH_TM_EN","SH_DT_BG","SH_DT_EN","MACHINE_IN","MACHINE_OUT"
		 				recTC1.set(TC1ColumnName[67], Float.valueOf(String.valueOf(dataTableTC1.getItem(row, TC1ColumnName[67]))).floatValue());
		 				recTC1.set(TC1ColumnName[68], dataTableTC1.getItemString(row, TC1ColumnName[68]));
		 				recTC1.set(TC1ColumnName[69], dataTableTC1.getItemString(row, TC1ColumnName[69]));
		 				recTC1.set(TC1ColumnName[70], dataTableTC1.getItemString(row, TC1ColumnName[70]));
		 				recTC1.set(TC1ColumnName[71], dataTableTC1.getItemString(row, TC1ColumnName[71]));
					
		 				//
		 				this.dbTCurrent1.putNewRecord(recTC1);
		 				
		 				//data dot ttime_current
		 				TC_hour_s =  Float.valueOf(String.valueOf(dataTableTC1.getItem(row, "HOUR_S")));			
		 				
 						if(dataTableTC1.getItemString(row, "DOCTYPE").equals("A")){ 
 							isSetDesc = true ;
							String evengrpData =(String) this.mEventGrpData.get(dataTableTC1.getItemString(row, "LV_TY"));
							String[] evengrpDesc = evengrpData.split("###");
							String EVENTGRP =  dataTableTC1.getItemString(row, "LV_TY");
							float C_LV = Float.valueOf(String.valueOf(dataTableTC1.getItem(row, "C_LV")));
 							float C_TM_BG = Float.valueOf(String.valueOf(dataTableTC1.getItem(row, "C_TM_BG")));
							float C_TM_EN = Float.valueOf(String.valueOf(dataTableTC1.getItem(row, "C_TM_EN")));

							if(EVENTGRP.equals("L14")){
								//Ժѵԧҹ͡ʶҹ
								if(TC1_TDESC.equals("")){
			 						TC1_TDESC = evengrpDesc[0] + "("+String.valueOf(C_TM_BG)+"-"+String.valueOf(C_TM_EN)+")";
			 						TC1_EDESC = evengrpDesc[1] + "("+String.valueOf(C_TM_BG)+"-"+String.valueOf(C_TM_EN)+")";
			 					}else{
			 						TC1_TDESC += "/"+evengrpDesc[0]+ "("+String.valueOf(C_TM_BG)+"-"+String.valueOf(C_TM_EN)+")";
			 						TC1_EDESC += "/"+evengrpDesc[1]+ "("+String.valueOf(C_TM_BG)+"-"+String.valueOf(C_TM_EN)+")";
			 					}//end if 
							}else{
								if(C_LV>= 8.0f){
	 								//ѹ
									if(TC1_TDESC.equals("")){
				 						TC1_TDESC = evengrpDesc[0];
				 						TC1_EDESC = evengrpDesc[1];
				 					}else{
				 						TC1_TDESC += "/"+evengrpDesc[0];
				 						TC1_EDESC += "/"+evengrpDesc[1];
				 					}//end if 
	 							}else if(C_LV== 4.0f){ 
	 								if(C_TM_BG<13.0f){
	 									//Ҫǧá
	 									if(TC1_TDESC.equals("")){
	 				 						TC1_TDESC = evengrpDesc[0] + "(ǧá)";
	 				 						TC1_EDESC = evengrpDesc[1] + "(ǧá)";
	 				 					}else{
	 				 						TC1_TDESC += "/"+evengrpDesc[0] + "(First Part)";
	 				 						TC1_EDESC += "/"+evengrpDesc[1] + "(First Part)";
	 				 					}//end if 
	 								}else{
	 									//ǧѧ
	 									if(TC1_TDESC.equals("")){
	 				 						TC1_TDESC = evengrpDesc[0] + "(ǧѧ)";
	 				 						TC1_EDESC = evengrpDesc[1] + "(ǧѧ)";
	 				 					}else{
	 				 						TC1_TDESC += "/"+evengrpDesc[0] + "(Second Part)";
	 				 						TC1_EDESC += "/"+evengrpDesc[1] + "(Second Part)";
	 				 					}//end if 
	 								}//end if 
	 							}else if(C_LV < 4.0f){ 
	 								// .
	 								if(TC1_TDESC.equals("")){
	 			 						TC1_TDESC = evengrpDesc[0]+" (" + C_LV + " .)";
	 			 						TC1_EDESC = evengrpDesc[1]+" (" + C_LV + " .)";
	 			 					}else{
	 			 						TC1_TDESC += "/"+evengrpDesc[0]+" (" + C_LV + " Hour)";
	 			 						TC1_EDESC += "/"+evengrpDesc[1]+" (" + C_LV + " Hour)";
	 			 					}//end if 
	 							}//end if 
								
							}//end if 
 			 			}//end if
		 				
					}//end for ii
					
					
					if (this.recTCurrent == null) {
	            		this.recTCurrent = new InitialRecord(upf).getDbRecord("Ttime_current");
	            		this.recTCurrent.setColumn("*");
	            	}
	            	this.recTCurrent.clearField();
	            	this.recTCurrent.set("employeeid", empRec.getString("employeeid"));
	            	this.recTCurrent.set("companyid", empRec.getString("companyid"));
	            	this.recTCurrent.set("time0id", empRec.getString("time0"));
	            	this.recTCurrent.set("dateid", keys);
	            	this.recTCurrent.set("hour_s", TC_hour_s);
	            	
	            	if(isSetDesc){
		            	this.recTCurrent.set("tdesc", TC1_TDESC);
		            	this.recTCurrent.set("edesc", TC1_EDESC);
	            	}//end if 
	            	
	            	this.recTCurrent.putChild(this.dbTCurrent1);
	                Ttime_current t = (Ttime_current) this.recTCurrent;
					t.setEmpRecord(empRec);
					this.recTCurrent.save();
				}//end if
				
				//clear		
				isSetDesc = false ;
				TC1_TDESC ="";
				TC1_EDESC ="";
				
			}//end while			
	  		 System.out.print(">>>> PROCESS BY NUISS is COMPLETE...");
		}catch(Exception ex){
	  		 System.out.print(">>>> PROCESS BY NUISS ERROR in NRepairTtimeCurrent1.updateTtimecurrent1() "+ ex.getStackTrace().toString() + "<<<");
		}//end try
		//========== time performance ============
		tEndUpdate= new CscCalendar();
		tEndUpdate.getDDMMYYHHMMSS(); 
		System.out.print("in NRepairTtimeCurrent1.updateTtimecurrent1() start at : "+tStUpdate);
		System.out.print("in NRepairTtimeCurrent1.updateTtimecurrent1() finish at : "+tEndUpdate);
		//==================================
	}//end updateTtimecurrent1
	 
	
	private String[] getColumnName(){
		String[] columnName = {"EMPLOYEEID","COMPANYID","DATEID","DOCTYPE","DOCNO"
				,"TIME0ID","OLD_TIME0","SEQUENCE","C_TM_BG","C_TM_EN"
				,"M_TM_BG","M_TM_EN","C_DT_BG","C_DT_EN","M_DT_BG"
				,"M_DT_EN","LT","C_LV","M_LV","LV_TY"
				,"SOURCE","TR_TYPE","AC_OT","AP_OT","FORGET_IN"
				,"FORGET_OUT","ISWORK","DT_IN_INZONE","DT_OUT_INZONE","TM_IN_INZONE"
				,"TM_OUT_INZONE","DT_IN_OUTZONE","DT_OUT_OUTZONE","TM_IN_OUTZONE","TM_OUT_OUTZONE"
				,"EVENTGRP","OLDEVENTGRP","UNUSED1","UNUSED2","UNUSED3"
				,"UNUSED4","UNUSED5","UNUSED6","UNUSED7","UNUSED8"
				,"UNUSED9","UNUSED10","HOUR_D","DT_BREAKIN","TM_BREAKIN"
				,"DT_BREAKOUT","TM_BREAKOUT"
				,"PREVIOUSSHIFT","NEXTSHIFT","STATUS","DAYTYPE","HOUR_S"
				,"DATE_ACTUAL","O_TM_BG","O_TM_EN","O_DT_BG","O_DT_EN"
				,"SOURCE_IN","SOURCE_OUT","OT_BEFORE","OT_AFTER","SH_TM_BG"
				,"SH_TM_EN","SH_DT_BG","SH_DT_EN","MACHINE_IN","MACHINE_OUT"};		
		return columnName;
	}//end  getColumnName
	
	
	private String[] getColumnType(){
		String[] columnType = new String[this.getColumnName().length];
		for (int col=0;col<columnType.length;col++){
			columnType[col] = "varchar";
		}//end for 
		return columnType;
	}//end getColumnType
 	
	public String getShift(DataTable dataTbl,int row,String columnName){
		String shift ="";
		if(dataTbl.getItem(row,"DOCTYPE").equals("A")){
			shift = "A";
		}else{
			if(columnName.equals("TR_TYPE")){
				shift = dataTbl.getItemString(row,"TR_TYPE").substring(0,1);
			}else if(columnName.equals("EVENTGRP")){
				if(dataTbl.getItemString(row,"EVENTGRP").equals("")){
					shift = dataTbl.getItemString(row,"TR_TYPE").substring(0,1);
				}else{
					shift = dataTbl.getItemString(row,"EVENTGRP");
				}
			}else{
				shift = "X";			
			}//end if 			
		}//end if 
		return shift;
	}//end if 
	
	public void retrieveMHoliday1(UProfile upf,String employeeId) {
		this.mHoliday1Data = new Hashtable(); 
		String whereClause = "holidayid = (select holidaycode from mtime0 where time0id in (select time0 from memployee where employeeid ='"+employeeId+"'))";
		try {			 
 			DbInquiry inqMHoliday1 = new InitialInquiry(upf).getDbInquiry();		
 			inqMHoliday1.setSchemaName(upf.getSchemaName());
 			inqMHoliday1.initMyTable("mholiday1", whereClause, "");
 			inqMHoliday1.setColumn("hdate,tdesc");
 			inqMHoliday1.refresh();
 			String keys ="";
  			String values= "";
			while (inqMHoliday1.next()) {
				keys=  inqMHoliday1.getString("hdate");	 	
				values=  inqMHoliday1.getString("tdesc");	 		 	 
				this.mHoliday1Data.put(keys, values);	 
			}//end while 
		}catch(Exception ex){
	  		 System.out.print("Error in NRepairTtimeCurrent1.retrieveMHoliday1() "+ ex.getStackTrace().toString());
		}//end try 
	}//end 
	
	public void retrieveMEventGrp(UProfile upf) {
		this.mEventGrpData = new Hashtable();
		try {			 
 			DbInquiry inqMEventgrp = new InitialInquiry(upf).getDbInquiry();		
 			inqMEventgrp.setSchemaName(upf.getSchemaName());
 			inqMEventgrp.initMyTable("meventgrp", "", "");
 			inqMEventgrp.setColumn("eventgrpid,tdesc,edesc");
 			inqMEventgrp.refresh();
  			String values= "";
			while (inqMEventgrp.next()) {
				String keys =  inqMEventgrp.getString("eventgrpid");
				values= inqMEventgrp.getString("tdesc") +"###"+ inqMEventgrp.getString("edesc");		 		 	 
				this.mEventGrpData.put(keys, values);	 
			}//end while 
		}catch(Exception ex){
	  		 System.out.print("Error in NRepairTtimeCurrent1.retrieveSwipeCard() "+ ex.getStackTrace().toString());
		}//end try 
	}//end 
	
	
	private void retrieveSwipeCard(UProfile upf ,String employeeId, CscCalendar StDate, CscCalendar endDate) {
		this.SwData = new Hashtable();
		StDate.decDate();
		endDate.incDate();
		try {			 
			String filter = "employeeid='"+employeeId + "'"
				+" and swipedate >= '"+StDate.getYYYYMMDD()+ "'"
				+" and swipedate <= '"+endDate.getYYYYMMDD()+"'";
 
			DbInquiry inqSwipeTime = new InitialInquiry(upf).getDbInquiry();		
			inqSwipeTime.setSchemaName(upf.getSchemaName());
			inqSwipeTime.initMyTable("Ttimetemp", filter, "");
			inqSwipeTime.setColumn("swipedate, swipetime");
			inqSwipeTime.refresh();
			
			while (inqSwipeTime.next()) {
				String keys =  inqSwipeTime.getString("swipedate");
				String values = inqSwipeTime.getString("swipetime");;
				if(this.SwData.containsKey(keys)){
					 String oldValues = String.valueOf(this.SwData.get(keys));
					 this.SwData.put(keys, oldValues+","+String.valueOf(values));
				}else{
					this.SwData.put(keys, String.valueOf(values));
				}//end if 
			}//end while 
		}catch(Exception ex){
	  		 System.out.print("Error in NRepairTtimeCurrent1.retrieveSwipeCard() "+ ex.getStackTrace().toString());
		}//end try 
	}//end method retrieveSwipeCard
		
}//end class NReEditTtimeCurrent1