package com.csc.library.utility;

import java.text.DecimalFormat;
import java.util.Hashtable;

import com.csc.library.database.StaticProperties;
import com.csc.library.database.SystemCode;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.LoadStaticProperties;
import com.csc.library.utilities.UProfile;

public class NUtils {
	
	public static void main(String args[]){
		NUtils nn = new NUtils();
		//String bb = nn.addDayTime("00:69:20", "00:00:00",8, ":");
		//String bb = nn.subDayTime("12:00:00", "02:04:20",8, ":");
		//boolean bb = nn.isOverFlowDayTime("12:01:10", "22:04:20",8, ":");
/*		String bb = nn.addDayTime("00:00:00", "00:08:40",8.40f, ":",true);
		  bb = nn.addDayTime(bb, "00:07:40",8.40f, ":",true);
		  bb = nn.addDayTime(bb, "00:10:10",8.40f, ":",true);
	*/	  
		String bb = nn.cnvrtMinute2DDHHMM(615,8.0f, ":");
		System.out.print(bb);
 		System.exit(0);
	}//end main 
	/**
	 * 
	 * @param minute
	 * @param hourPerDay
	 * @param signSeperate
	 * @return Format : Day+signSeperate+Hour+signSeperate+Minute
	 * <br>Example : this.cnvrtMinute2DDHHMM(615,8.0f, ":");
	 * <br>Return : 01:02:15 
	 */
	public String cnvrtMinute2DDHHMM(int minute,float hourPerDay,String signSeperate){
		int ddReturn = 0; int hhReturn = 0; int mmReturn = 0; 
		if(hourPerDay<=0){
			return "00:00:00";
		}//end if 
		DecimalFormat dc = new DecimalFormat();
		dc.applyPattern("#0.00");
		String[] timePerDay = dc.format(hourPerDay).replace(".", ":").split(":");
		int mmPerDay =  (Integer.valueOf(timePerDay[0])*60)+Integer.valueOf(timePerDay[1]);
		ddReturn = minute/mmPerDay;
		if((minute%mmPerDay)>=60){
			hhReturn = (minute%mmPerDay)/60;
			mmReturn = (minute%mmPerDay)%60;
		}else{
			mmReturn = (minute%mmPerDay);
		}//end if 
		return convertTo2Digit(ddReturn)+":"+convertTo2Digit(hhReturn)+":"+convertTo2Digit(mmReturn);
	}//end method cnvrtMinute2DDHHMM
	
	/**
	 * Site used : NSTDA 
	 * Web Page : PWF002.jsp
	 * @param upf : UProfile
	 * @param startDate : ѹ
	 * @param dayAdd : ӹǹѹ 
	 * @param isIgnoreHoliday : true = Ѻѹش 
	 * @param holidayCode : ѹش  table mholiday ͧºº
	 * @return
	 */
	public CscCalendar getDateSpan(UProfile upf,String startDate,int dayAdd,boolean isIgnoreHoliday , String holidayCode){
 		CscCalendar stDate = new CscCalendar(startDate);
		Hashtable hshHoliday = new Hashtable();
		
		//======== Retrieve Holiday ===============
		String whereClause = "holidayid='"+holidayCode+ "'";
		try{
			DbInquiry inqHoliday= new InitialInquiry(upf).getDbInquiry();		
			inqHoliday.setSchemaName(upf.getSchemaName());
			inqHoliday.initMyTable("mholiday1", whereClause, "");
			inqHoliday.setColumn("holidayid, hdate,tdesc");
			inqHoliday.refresh();
			while (inqHoliday.next()) {
				String keys =  inqHoliday.getString("hdate");
				String values = inqHoliday.getString("tdesc");
				hshHoliday.put(keys, values);
			}//end while 
		}catch(Exception ex){
			System.out.print("ERROR in NUtils.getDateSpan() at Step Retrieve Holiday List...");
		}//end try		
		
		//========= Compare Holiday==============
		int holidayCount = 0 ;
		while(dayAdd>1){
			if(hshHoliday.containsKey(stDate.getYYYYMMDD())||stDate.chkStopDate()==1){
				holidayCount++;
			}else{
				dayAdd--;
			}//end if 
			stDate.incDate(1);
		}//end for ii
		//==================================
		return stDate;
	}//end
	
	/**
	 * @param dayTime1 -example : "12:00:00"
	 * @param dayTime2 -example : "02:15:00"
	 * @param hourPerDay -example : 24 [1 day = 24 hour]
	 * @param signSeperate -example : ":"
	 * @return "day:hour:minute" -example : "14:15:00"
	 */
	public String addDayTime(String dayTime1 ,String dayTime2 , int hourPerDay ,String signSeperate){
		String dayTimeRtn ="";
		
		String splDay0[] =new String[3] ;
		String splTmpDay0[] = dayTime1.split(signSeperate);
		System.arraycopy(splTmpDay0, 0, splDay0, 0,splTmpDay0.length);
	
		String splDay1[] = new String[3] ;
		String splTmpDay1[] = dayTime2.split(signSeperate);
		System.arraycopy(splTmpDay1, 0, splDay1, 0,splTmpDay1.length);
					
		for (int ii =0 ;ii<3;ii++){
			if(splDay0[ii]==null || splDay0[ii].equals("")){
 				splDay0[ii]="00";
 			}//end if 
		}//end if 
 		for (int ii =0 ;ii<3;ii++){
 			if(splDay1[ii]==null || splDay1[ii].equals("")){
 				splDay1[ii]="00";
 			}//end if 
		}//end if 
	 
		int day0 = Integer.valueOf(splDay0[0]);
		int hour0 = Integer.valueOf(splDay0[1]);
		int minute0 = Integer.valueOf(splDay0[2]);
		
		int day1 = Integer.valueOf(splDay1[0]);
		int hour1 = Integer.valueOf(splDay1[1]);
		int minute1 = Integer.valueOf(splDay1[2]);
		
		boolean overFlow =true;
		int hourOverflow = 0;
		int dayOverflow = 0;
		
		//calculate minute
		int minuteReturn = minute0+minute1;
		while (overFlow){
			if((minuteReturn)>=60){
				minuteReturn -= 60 ;
				hourOverflow ++;
			}else{
				overFlow = false;
			}//end if 
		}//end while
		
		//calculate hour
		int hourReturn = hourOverflow+hour0+hour1;
		overFlow =true;
		while (overFlow){
			if((hourReturn)>=hourPerDay){
				hourReturn -= hourPerDay ;
				dayOverflow ++;
			}else{
				overFlow = false;
			}//end if 
		}//end while
		
		//calculate day
		int dayReturn = dayOverflow+day0+day1;
		dayTimeRtn =  convertTo2Digit(dayReturn)+signSeperate
								+ convertTo2Digit(hourReturn)+signSeperate
								+ convertTo2Digit(minuteReturn);
								
		return dayTimeRtn;
	} //end addDayTime
	
	public String addDayTime(String dayTime1 ,String dayTime2 
			, float hourPerDay ,String signSeperate
			, boolean isConvertTo2Digit){
		String dayTimeRtn ="";	
		if(hourPerDay<=0.0f){
			return "00:00:00";
		}//end if 
		try{	
			DecimalFormat dc = new DecimalFormat();
			dc.applyPattern("#0.00");
			String[] strHourPerDay = dc.format(hourPerDay).replace(".", ":").split(":");
			int minutePerDay = (Integer.valueOf(strHourPerDay[0])*60)+Integer.valueOf(strHourPerDay[1]);
			
			String splDay0[] =new String[3] ;
			String splTmpDay0[] = dayTime1.split(signSeperate);
			System.arraycopy(splTmpDay0, 0, splDay0, 0,splTmpDay0.length);
		
			String splDay1[] = new String[3] ;
			String splTmpDay1[] = dayTime2.split(signSeperate);
			System.arraycopy(splTmpDay1, 0, splDay1, 0,splTmpDay1.length);
						
			for (int ii =0 ;ii<3;ii++){
				if(splDay0[ii]==null || splDay0[ii].equals("")){
	 				splDay0[ii]="00";
	 			}//end if 
			}//end if 
	 		for (int ii =0 ;ii<3;ii++){
	 			if(splDay1[ii]==null || splDay1[ii].equals("")){
	 				splDay1[ii]="00";
	 			}//end if 
			}//end if 
		 
			int day0 = Integer.valueOf(splDay0[0]);
			int hour0 = Integer.valueOf(splDay0[1]);
			int minute0 = Integer.valueOf(splDay0[2]);
			
			int day1 = Integer.valueOf(splDay1[0]);
			int hour1 = Integer.valueOf(splDay1[1]);
			int minute1 = Integer.valueOf(splDay1[2]);
			
			boolean overFlow =true;	
			int totalMinute0 = (hour0*60)+minute0;
			int totalMinute1 = (hour1*60)+minute1;
			
			//calculate
			int dayReturn = day0+day1;
			int hourReturn = 0 ;
			int minuteReturn = totalMinute0+totalMinute1;
			while (overFlow){
				if((minuteReturn)>=minutePerDay){
					dayReturn++;
					minuteReturn -= minutePerDay ;	
				}else{
					if(minuteReturn>=60){
						hourReturn=minuteReturn/60 ;
						minuteReturn =minuteReturn%60;
					}else{
						overFlow = false;
					}//end if 			
				}//end if 
			}//end while
			 
			//return Value
			if(isConvertTo2Digit){
				dayTimeRtn =  convertTo2Digit(dayReturn)+signSeperate
									+ convertTo2Digit(hourReturn)+signSeperate
									+ convertTo2Digit(minuteReturn);
			}else{
				dayTimeRtn =  dayReturn+signSeperate
									+ hourReturn+signSeperate
									+ minuteReturn;
			}//end if 
		}catch(Exception ex){
			System.out.print(">>>Nuiss Debug : Error in NUtils.addDayTime()...");
		}//end try
		
		return dayTimeRtn;
	} //end addDayTime
	
	/**
	 * @param dayTime1 -example : "12:00:00"
	 * @param dayTime2 -example : "02:04:00"
	 * @param hourPerDay -example : 8 [1 day =8 hour]
	 * @param signSeperate -example : ":"
	 * @return "day:hour:minute" -example : "09:04:00"
	 */
	public String subDayTime(String dayTime1,String dayTime2
			,int hourPerDay,String signSeperate
			,boolean isConvertTo2Digit){
		String dayTimeRtn ="";
		
		String splDay0[] =new String[3] ;
		String splTmpDay0[] = dayTime1.split(signSeperate);
		System.arraycopy(splTmpDay0, 0, splDay0, 0,splTmpDay0.length);
	
		String splDay1[] = new String[3] ;
		String splTmpDay1[] = dayTime2.split(signSeperate);
		System.arraycopy(splTmpDay1, 0, splDay1, 0,splTmpDay1.length);
					
		for (int ii =0 ;ii<3;ii++){
			if(splDay0[ii]==null || splDay0[ii].equals("")){
 				splDay0[ii]="00";
 			}//end if 
		}//end if 
 		for (int ii =0 ;ii<3;ii++){
 			if(splDay1[ii]==null || splDay1[ii].equals("")){
 				splDay1[ii]="00";
 			}//end if 
		}//end if 
	 
		int day0 = Integer.valueOf(splDay0[0]);
		int hour0 = Integer.valueOf(splDay0[1]);
		int minute0 = Integer.valueOf(splDay0[2]);
		
		int day1 = Integer.valueOf(splDay1[0]);
		int hour1 = Integer.valueOf(splDay1[1]);
		int minute1 = Integer.valueOf(splDay1[2]);
 
		int minuteReturn = 0;
		int hourReturn = 0;
		int dayReturn =0;
		
		//calculate day
		if(day0>=day1){
			dayReturn = day0-day1;
		}else{
			//Դ 
			dayReturn=0;
		}//end if 
		
		//calculate hour
		boolean isBorrow= true;
		if(hour0>=hour1){
			hourReturn = hour0-hour1;
		}else{
			//ͧ  ҡ ѹ 
			while (isBorrow){
				// .  ?
				if(dayReturn<1){
					hourReturn=0;
					break;
				}else{
					//Ŵѹ价 1
					dayReturn-=1;
					// .  Ѵǹ /ѹ
					hour0 +=hourPerDay;
					if(hour0>=hour1){
						hourReturn = hour0-hour1;
						isBorrow = false;
					}//end if 
				}//end if 
			}//end while
		}//end if 
		
		//calculate minute
		isBorrow= true;
		if(minute0>=minute1){
			minuteReturn = minute0-minute1;
		}else{
			//ͧ ҷ ҡ . 
			while (isBorrow){
				// ҷ  ?
				if(hourReturn<1){
					minuteReturn=0;
					break;
				}else{
					//Ŵ . 价 1
					hourReturn-=1;
					//  ҷ  60
					minute0 +=60;
					if(minute0>=minute1){
						minuteReturn = minute0-minute1;
						isBorrow = false;
					}//end if 
				}//end if 
				
			}//end while
		}//end if 
		if(isConvertTo2Digit){
			dayTimeRtn =  convertTo2Digit(dayReturn)+signSeperate
								+ convertTo2Digit(hourReturn)+signSeperate
								+ convertTo2Digit(minuteReturn);
		}else{
			dayTimeRtn =  dayReturn+signSeperate
								+hourReturn+signSeperate
								+minuteReturn;
		}//end if 
		
		return dayTimeRtn;
	}//end  subDayTime
	
	public boolean isOverFlowDayTime(String dayTime1 ,String dayTime2  
													,String signSeperate){
			boolean isOverFlow =false;
			
 			String splDay0[] =new String[3] ;
			String splTmpDay0[] = dayTime1.split(signSeperate);
			System.arraycopy(splTmpDay0, 0, splDay0, 0,splTmpDay0.length);
		
			String splDay1[] = new String[3] ;
			String splTmpDay1[] = dayTime2.split(signSeperate);
			System.arraycopy(splTmpDay1, 0, splDay1, 0,splTmpDay1.length);
						
			for (int ii =0 ;ii<3;ii++){
				if(splDay0[ii]==null || splDay0[ii].equals("")){
	 				splDay0[ii]="00";
	 			}//end if 
			}//end if 
	 		for (int ii =0 ;ii<3;ii++){
	 			if(splDay1[ii]==null || splDay1[ii].equals("")){
	 				splDay1[ii]="00";
	 			}//end if 
			}//end if 
		 
			int day0 = Integer.valueOf(splDay0[0]);
			int hour0 = Integer.valueOf(splDay0[1]);
			int minute0 = Integer.valueOf(splDay0[2]);
			
			int day1 = Integer.valueOf(splDay1[0]);
			int hour1 = Integer.valueOf(splDay1[1]);
			int minute1 = Integer.valueOf(splDay1[2]);
	 
			//check overFlow
			if(day0>day1){
				isOverFlow = false; 
			}else if(day0<day1){
				isOverFlow = true; 
			}else if(day0==day1){
				if(hour0>hour1){
					isOverFlow = false; 
				}else if (hour0<hour1){
					isOverFlow = true; 
				}else if(hour0==hour1){					
					if(minute0>=minute1){
						isOverFlow = false; 
					}else if(minute0<minute0){
						isOverFlow = true; 
					}//end if minute overFlow
				}//end if hour overFlow ?
			}//end if day overFlow ?
			
			return isOverFlow;
	}//end getOverFlow
	
	/**
	 * @author Nuiss
	 * @since 03/04/2552
	 * @param hourListSplitWithComma
	 * 			<br>Example "10.30,2.25,0.12,1.02"
	 * 			<br>all value is base60
	 * @return
	 * 			<br>10.30 +
	 * 			<br>  2.25 
	 * 			<br>  0.12
	 * 			<br>  1.02
	 * 			<br>---------
	 * 			<br> 14.09   [HH.MM]
	 * 			<br>=====
	 */
	public String addHourBase60(String hourListSplitWithComma){
		String[] hours = hourListSplitWithComma.split(",");
		float totalHour100 = 0.00f;
		String[] HHMM = new String[2]; 
		int HH = 0 ;
		int MM = 0 ;
		int totalMM =0;
		for (int ii=0;ii<hours.length;ii++){
			//split hour and minute
			HHMM = String.valueOf(Float.valueOf(hours[ii])).replace(".", ":").split(":");
			HH =Integer.valueOf(HHMM[0])*60; 
			if(HHMM[1].length()==1){
				HHMM[1] =HHMM[1]+"0";
			}//end if 
			MM =Integer.valueOf(HHMM[1]); 
			//sum minute
			totalMM += (HH+MM);
		}//end for ii
		HH = totalMM/60;
		MM = totalMM%60;
	  	return HH+"."+convertTo2Digit(MM);
	}//end addTime
	
	//============================ PRIVATE =============================
	private String convertTo2Digit(int number){
		String rtnValue="";
		if(String.valueOf(number).length()==0){
			rtnValue="00";
		}else if(String.valueOf(number).length()==1){
			rtnValue = "0"+String.valueOf(number);
		}else{
			rtnValue =String.valueOf(number);
		}//end if 
		return rtnValue;
	}//end convertTo2Digit
	
}//end class NUtils
